#include "mc-util.h"
#include "mc-math.h"
#include "mc-physics.h"
#include "common.h"

using namespace std;
using namespace util;
using namespace math;
using namespace physics;
using namespace common;

// Constructors
FrequencyBin::FrequencyBin(const double& _min, const double& _max, bool _edge, bool _minorEdge) : min(_min), max(_max), edge(_edge), minorEdge(_minorEdge) { }
FrequencyBin::FrequencyBin() : min(), max(), edge(false), minorEdge(false) {}

FrequencyBinIterator FrequencyBinList::find(const double& _nu, int iGuess) const {
  vector<FrequencyBin>& nu = *((vector<FrequencyBin>*)this);
  long iBegin,iMiddle,iEnd;

  if (iGuess!=noBin and iGuess<nu.size())
    if (_nu>=nu[iGuess].min and _nu<nu[iGuess].max) return nu.begin()+iGuess;
  
  if (nu.size()!=0) {
    iBegin=0; iEnd=nu.size()-1; iMiddle=(iBegin+iEnd)/2;
    if (_nu>=nu[iBegin].min && _nu<nu[iEnd].max) {
      while (iBegin!=iEnd) {
	if (_nu<nu[iMiddle].max) {
	  iEnd=iMiddle;
	  iMiddle=(iBegin+iEnd)/2;
	}
	else {
	  iBegin=iMiddle+1;
	  iMiddle=(iBegin+iEnd)/2;
	}
      }
      return nu.begin()+iBegin;
    }
  }
  
  return nu.end();
}

// Constructors
AngleBin::AngleBin(const double& _min, const double& _max) : min(_min), max(_max) { }
AngleBin::AngleBin() : min(), max() {}

AngleBinIterator AngleBinList::find(const double& _mu, int iGuess) const {
  vector<AngleBin>& mu = *((vector<AngleBin>*)this);
  long iBegin,iMiddle,iEnd;

  if (iGuess!=noBin and iGuess<mu.size())
    if (_mu>=mu[iGuess].min and _mu<mu[iGuess].max) return mu.begin()+iGuess;
  
  if (mu.size()!=0) {
    iBegin=0; iEnd=mu.size()-1; iMiddle=(iBegin+iEnd)/2;
    if (_mu>=mu[iBegin].min && _mu<mu[iEnd].max) {
      while (iBegin!=iEnd) {
	if (_mu<mu[iMiddle].max) {
	  iEnd=iMiddle;
	  iMiddle=(iBegin+iEnd)/2;
	}
	else {
	  iBegin=iMiddle+1;
	  iMiddle=(iBegin+iEnd)/2;
	}
      }
      return mu.begin()+iBegin;
    }
  }
  
  return mu.end();
}
