#include <iostream>
#include <omp.h>
using namespace std;

int main (int argc, char** argv) {
  int i,j;
  int n1=2,n2=2;

  omp_set_nested(1);
  omp_set_num_threads(4);

  cout<<"Before: num_threads: "<<omp_get_num_threads()<<"; thread_num: "<<omp_get_thread_num()<<"\n";

  sleep(1);

  #pragma omp parallel for
  for (i=0;i<n1;i++) {

    sleep(i*(n1+1));
    
    omp_set_num_threads(omp_get_num_threads()/n1);

    cout<<"Base loop: i: "<<i<<", num_threads: "<<omp_get_num_threads()<<"; thread_num: "<<omp_get_thread_num()<<"\n";

    #pragma omp parallel for
    for (j=0;j<n2;j++) {

      sleep(j+1);

      cout<<"Nested loop: i: "<<i<<", j: "<<j<<", num_threads: "<<omp_get_num_threads()<<"; thread_num: "<<omp_get_thread_num()<<"\n";
    }
  }

  sleep(1)

  cout<<"After: num_threads: "<<omp_get_num_threads()<<"; thread_num: "<<omp_get_thread_num()<<"\n";
}
