#include "atom.cpp"

// Constructor - Add this, or?
//transPList::TransPList() : vector<TransP>() { }

// Copy constructor - Add this, or?
//TransPList::TransPList(const TransPList& transPList) : vector<TransP>(transPList) { }

// Assignment operator - Add this, or?
//TransPList& TransPList::operator=(const transPList& transPList) { vector<TransP>::operator=(transPList); }

bool TransPList::compare(TransP transP1, TransP transP2) {
  return (transP1.P>transP2.P);
}

void TransPList::sort() {
  std::sort((*this).begin(),(*this).end(),compare);
}

// Get memory allocated - New!
double TransPList::mem() const { 
  return sizeof(*this)+size()*sizeof(TransP); 
}

// Constructor - Is this necessary?
MarkovPList::MarkovPList() : vector<MarkovP>() { }

// Copy constructor - Is this necessary?
MarkovPList::MarkovPList(const MarkovPList& markovPList) : vector<MarkovP>(markovPList) { }

// Assignment operator - Is this necessary?
MarkovPList& MarkovPList::operator=(const MarkovPList& markovPList) { vector<MarkovP>::operator=(markovPList); }

bool MarkovPList::compare(MarkovP markovP1, MarkovP markovP2) {
  return (markovP1.P>markovP2.P);
}

void MarkovPList::sort() {
  std::sort((*this).begin(),(*this).end(),compare);
}

// Get memory allocated - New!
double MarkovPList::mem() const { 
  return sizeof(*this)+size()*sizeof(MarkovP); 
}

// Constructors
LineSelector::LineSelector() : nu(0,1e99), tauLim(0) { }
LineSelector::LineSelector(const FrequencyBin& _nu, const double& _tauLim) : nu(_nu), tauLim(_tauLim) { } 

// Get tauLim
double LineSelector::getTauLim() {
  return tauLim;
}

// Use line
bool LineSelector::use(TransBB* trans, const double& lineTau) {
  //cout<<"LineSelector::use: tauLim: "<<tauLim<<", lineTau: "<<lineTau<<"\n";
  if (trans->Xi()/h>=nu.min && trans->Xi()/h<=nu.max && lineTau>=tauLim) return true;
  return false;
}

// Contructors
OnTheSpot::OnTheSpot() { }
OnTheSpot::OnTheSpot(const string& specifier) {
  stringstream list;
  string item;

  list.str(specifier);
  while (getline(list,item,',')) {
    atomName.push_back(item);
    cout<<"OnTheSpot::OnTheSpot: Added atom: "<<item<<"\n";
  }
}

// Use on-the-spot approximation
bool OnTheSpot::operator() (Atom& atom) const {
  int i;
  if (atomName.size()==0) return false;
  for (i=0;i<atomName.size();i++) if (atom.name().compare(atomName[i])==0 or atomName[i].compare("all")==0) return true;

  return false;
}

// Contructors
OnTheSpotNew::OnTheSpotNew() { }
OnTheSpotNew::OnTheSpotNew(const string& specifier) {
  stringstream list,subList,subSubList;
  string item,subItem,subSubItem;
  TransBFIdentifier _transID;
  int i=0;

  // Convert to string stream
  list.str(specifier);

  // For each item
  while (getline(list,item,',')) {

    // Convert to string stream
    subList.clear();
    subList.str(item);

    // Get lower-state sub-item
    getline(subList,subItem,'-');
    // Convert to string stream
    subSubList.clear();
    subSubList.str(subItem);

    // Get lower-state name and index
    getline(subSubList,subSubItem,':');
    _transID.lowerStateName=subSubItem;
    getline(subSubList,subSubItem,':');
    _transID.lowerStateIndex=atoi(subSubItem.c_str());

    // Get upper-state sub-item
    subItem="";
    getline(subList,subItem,'-');

    // If provided
    if (subItem.compare("")!=0) {

      // Convert to string stream
      subSubList.clear();
      subSubList.str(subItem);

      // Get upper-state name and index
      getline(subSubList,subSubItem,':');
      _transID.upperStateName=subSubItem;
      getline(subSubList,subSubItem,':');
      _transID.upperStateIndex=atoi(subSubItem.c_str());
    }

    // Append transition to list
    transID.push_back(_transID);

    i++;

    if (_transID.upperStateName.compare("")!=0) cout<<"OnTheSpotNew::OnTheSpotNew: Added transition: "<<_transID.lowerStateName<<":"<<_transID.lowerStateIndex<<"->"<<_transID.upperStateName<<":"<<_transID.upperStateIndex<<"\n";
    else cout<<"OnTheSpotNew::OnTheSpotNew: Added transition: "<<_transID.lowerStateName<<":"<<_transID.lowerStateIndex<<"->*\n";
  }
}

// Use on-the-spot approximation (new)
bool OnTheSpotNew::operator() (TransBF* trans) const {
  int i;

  // For each transition
  for (i=0;i<transID.size();i++) {

    
    // If match on lower state
    if (transID[i].lowerStateName.compare(trans->lowerState->iState()->name())==0 and transID[i].lowerStateIndex==trans->lowerState->getIndex()) {

      // If upper-state not specified - Return true
      if (transID[i].upperStateName.compare("")==0) return true;
      // Else - If match on upper state - Return true
      else if (transID[i].upperStateName.compare(trans->upperState->iState()->name())==0 and transID[i].upperStateIndex==trans->upperState->getIndex()) return true;
    }
  }

  // Return false
  return false;
}

// Contructors
FFOnTheSpot::FFOnTheSpot() : apply(false), tauLim(10.0) { }
FFOnTheSpot::FFOnTheSpot(const bool& _apply, const double& _tauLim) : apply(_apply), tauLim(_tauLim) { }

// Constructors
Processes::Processes() { push_back(pAny); }
Processes::Processes(unsigned int type, unsigned int subType) { push_back(type|subType); }

// Contains process
bool Processes::operator () (unsigned int type, unsigned int subType) const {
  int i;
  for (i=0;i<size();i++) if (((*this)[i] & type)!=0 and ((*this)[i] & subType)!=0) return true;
  return false;
}

// Get type from name
ProcessType Processes::type(const string& name) {
  if (name.compare("eScatter")==0) return pEScatter;
  else if (name.compare("cScatter")==0) return pCScatter;
  else if (name.compare("gScatter")==0) return pGScatter; // New!
  else if (name.compare("boundBound")==0) return pBoundBound;
  else if (name.compare("boundFree")==0) return pBoundFree;
  else if (name.compare("freeFree")==0) return pFreeFree;
  else if (name.compare("collisional")==0) return pCollisional;
  else if (name.compare("radiative")==0) return pRadiative;
  else if (name.compare("nonThermal")==0) return pNonThermal;
  else if (name.compare("twoPhoton")==0) return pTwoPhoton; // New!
  else if (name.compare("chargeTransfer")==0) return pChargeTransfer; // New!
  else return pNone;
}

// Get name from type
string Processes::name(const ProcessType& type) {
  if (type==pEScatter) return "eScatter";
  else if (type==pCScatter) return "cScatter";
  else if (type==pGScatter) return "gScatter"; // New!
  else if (type==pBoundBound) return "boundBound";
  else if (type==pBoundFree) return "boundFree";
  else if (type==pFreeFree) return "freeFree";
  else if (type==pCollisional) return "collisional";
  else if (type==pRadiative) return "radiative";
  else if (type==pNonThermal) return "nonThermal";
  else if (type==pTwoPhoton) return "twoPhoton"; // New!
  else if (type==pChargeTransfer) return "chargeTransfer"; // New!
  else if (type==pNone) return "none";
  else return "";
}

// Load data
void Processes::load(const YAML::Node& data) {
  YAML::Node entry,subEntry;
  int i,j;

  // Resize
  resize(0);

  // If scalar add process to list
  if (data.Type()==YAML::NodeType::Scalar) push_back(type(data.as<string>()));
  else {
    // For each entry
    for (i=0;i<data.size();i++) {
      // Copy entry
      entry=data[i];
      // If scalar add process to list
      if (entry.Type()==YAML::NodeType::Scalar) push_back(type(entry.as<string>()));
      // Else if map
      else if (entry.Type()==YAML::NodeType::Map) {
	// Add process to list
	if (entry["eScatter"]) { push_back(pEScatter); subEntry=entry["eScatter"]; }
	else if (entry["cScatter"]) { push_back(pCScatter); subEntry=entry["cScatter"]; }
	else if (entry["boundBound"]) { push_back(pBoundBound); subEntry=entry["boundBound"]; }
	else if (entry["boundFree"]) { push_back(pBoundFree); subEntry=entry["boundFree"]; }
	else if (entry["freeFree"]) { push_back(pFreeFree); subEntry=entry["freeFree"]; }
	else if (entry["nonThermal"]) { push_back(pNonThermal); subEntry=entry["nonThermal"]; }
	// For each sub-entry
	for (j=0;j<subEntry.size();j++) {
	  // Add sub-type to process
	  (*this)[size()-1] |= type(subEntry[j].as<string>());
	}
      }
    }
  }
}

// Log data
void Processes::log() {
  unsigned int type;
  int i,j;
  for (i=0;i<size();i++) {
    type=(*this)[i];
    if (type==0) { cout<<" "<<name(pNone); return; }
    j=0;
    while(type!=0) {
      if (j==1) cout<<": [";
      if ((type & pEScatter)!=0) { cout<<" "<<name(pEScatter); type &= (~pEScatter); }
      else if ((type & pCScatter)!=0) { cout<<" "<<name(pCScatter); type &= (~pCScatter); }
      else if ((type & pGScatter)!=0) { cout<<" "<<name(pGScatter); type &= (~pGScatter); } // New!
      else if ((type & pBoundBound)!=0) { cout<<" "<<name(pBoundBound); type &= (~pBoundBound); }
      else if ((type & pBoundFree)!=0) { cout<<" "<<name(pBoundFree); type &= (~pBoundFree); }
      else if ((type & pFreeFree)!=0) { cout<<" "<<name(pFreeFree); type &= (~pFreeFree); }
      else if ((type & pCollisional)!=0) { cout<<" "<<name(pCollisional); type &= (~pCollisional); }
      else if ((type & pRadiative)!=0) { cout<<" "<<name(pRadiative); type &= (~pRadiative); }
      else if ((type & pNonThermal)!=0) { cout<<" "<<name(pNonThermal); type &= (~pNonThermal); }
      else if ((type & pTwoPhoton)!=0) { cout<<" "<<name(pTwoPhoton); type &= (~pTwoPhoton); } // New!
      else if ((type & pChargeTransfer)!=0) { cout<<" "<<name(pChargeTransfer); type &= (~pChargeTransfer); } // New!
      if (j>0) 
	if (type!=0) cout<<","; 
	else cout<<" ]";
      j++;
    }
    if (i<size()-1) cout<<",";
  }
}

// Pack non-thermal bound-bound transitions
void NTTransBBListMPI::pack(vector<TransBB*>& transBB) {
  int i;
  NTTransMPI ntTrans;

  // Reset transition list
  ntTransList.resize(0);
  
  // For each transition
  for (i=0;i<transBB.size();i++) {
    // If non-thermal processes active
    if (transBB[i]->active(pNonThermal)) {
      // Pack into list
      ntTrans.index=i;
      ntTrans.CNU=transBB[i]->CNU();
      ntTransList.push_back(ntTrans);
    }
  }
}

// Unpack non-thermal bound-bound transitions
void NTTransBBListMPI::unpack(vector<TransBB*>& transBB) const {
  int i;

  // Unpack each transition
  for (i=0;i<ntTransList.size();i++) transBB[ntTransList[i].index]->CNU(ntTransList[i].CNU);
}

// Pack non-thermal bound-free transitions
void NTTransBFListMPI::pack(vector<TransBF*>& transBF) {
  int i;
  NTTransMPI ntTrans;

  // Reset transition list
  ntTransList.resize(0);

  // For each transition
  for (i=0;i<transBF.size();i++) {
    // If non-thermal processes active
    if (transBF[i]->active(pNonThermal)) {
      // Pack into list
      ntTrans.index=i;
      ntTrans.CNU=transBF[i]->CNU();
      ntTransList.push_back(ntTrans);
    }
  }
}

// Unpack non-thermal bound-free transitions
void NTTransBFListMPI::unpack(vector<TransBF*>& transBF) const {
  int i;

  // Unpack each transition
  for (i=0;i<ntTransList.size();i++) transBF[ntTransList[i].index]->CNU(ntTransList[i].CNU);
}

// Pack non-thermal (matter) state
void NTStateMPI::pack(Cell* cell) {
  int i,j,k;

  // Pack non-thermal heating
  nonThermalHeating=cell->nonThermalHeating();
  // Pack (total) non-thermal excitation
  nonThermalExcitation=cell->nonThermalExcitation();
  // Pack (total) non-thermal ionization
  nonThermalIonization=cell->nonThermalIonization();
  // Resize vectors
  ntTransBB.resize(cell->atom.size());
  ntTransBF.resize(cell->atom.size());
  // For each atom
  for (i=0;i<cell->atom.size();i++) {
    // Resize vectors
    ntTransBB[i].resize(cell->atom[i].iState.size());
    ntTransBF[i].resize(cell->atom[i].iState.size());
    // For each ionization state
    for (j=0;j<cell->atom[i].iState.size();j++) {
      // Resize vectors
      ntTransBB[i][j].resize(cell->atom[i].iState[j].bState.size());
      ntTransBF[i][j].resize(cell->atom[i].iState[j].bState.size());
      // For each bound state
      for (k=0;k<cell->atom[i].iState[j].bState.size();k++) {
	// Pack non-thermal excitation rates
	ntTransBB[i][j][k].pack(cell->atom[i].iState[j].bState[k].upTransBB);
	// Pack non-thermal ionization rates
	ntTransBF[i][j][k].pack(cell->atom[i].iState[j].bState[k].upTransBF);
      }
    }
  }
}

// Unpack non-thermal (matter) state
void NTStateMPI::unpack(Cell* cell) const {
  int i,j,k;

  // Unpack non-thermal heating
  cell->nonThermalHeating(nonThermalHeating);
  // Unpack (total) non-thermal excitation
  cell->nonThermalExcitation(nonThermalExcitation);
  // Unpack (total) non-thermal ionization
  cell->nonThermalIonization(nonThermalIonization);
  // For each atom
  for (i=0;i<cell->atom.size();i++) {
    // For each ionization state
    for (j=0;j<cell->atom[i].iState.size();j++) {
      // For each bound state
      for (k=0;k<cell->atom[i].iState[j].bState.size();k++) {
	// Unpack non-thermal excitation rates
	ntTransBB[i][j][k].unpack(cell->atom[i].iState[j].bState[k].upTransBB);
	// Unpack non-thermal ionization rates
	ntTransBF[i][j][k].unpack(cell->atom[i].iState[j].bState[k].upTransBF);
      }
    }
  }
}

// Pack matter state
void MStateMPI::pack(Cell* cell) {
  int i,j,k;

  //cout<<"MStateMPI::pack, cell: "<<cell->index()<<", Enter\n";

  // Pack temperature
  T=cell->T();
  // Pack density
  rho=cell->rho();
  // Pack electron density
  ne=cell->ne();
  // Pack non-thermal state - New!
  ntState.pack(cell);
  // Resize vectors
  XIsotope.resize(cell->atom.size());
  XIon.resize(cell->atom.size());
  XBound.resize(cell->atom.size());
  // For each atom
  for (i=0;i<cell->atom.size();i++) {
    XIsotope[i].resize(cell->atom[i].isotope.size());
    // For each isotope
    for (j=0;j<cell->atom[i].isotope.size();j++) {
      // Pack mass-fraction
      XIsotope[i][j]=cell->atom[i].isotope[j].X();
    }
    // Resize vectors
    XIon[i].resize(cell->atom[i].iState.size());
    XBound[i].resize(cell->atom[i].iState.size());
    // For each ionization state
    for (j=0;j<cell->atom[i].iState.size();j++) {
      // Pack number-fraction
      XIon[i][j]=cell->atom[i].iState[j].X();
      // Resize vectors
      XBound[i][j].resize(cell->atom[i].iState[j].bState.size());
      // For each bound state
      for (k=0;k<cell->atom[i].iState[j].bState.size();k++) {
	// Pack number-fraction
	XBound[i][j][k]=cell->atom[i].iState[j].bState[k].X();
      }
    }
  }
}

// Unpack matter state
void MStateMPI::unpack(Cell* cell) const {
  int i,j,k;

  // Unpack temperature
  cell->T(T);
  // Unack density
  cell->rho(rho);
  // Unack electron density
  cell->ne(ne);
  // Unpack non-thermal state - New!
  ntState.unpack(cell);
  // For each atom
  for (i=0;i<cell->atom.size();i++) {
    // For each isotope
    for (j=0;j<cell->atom[i].isotope.size();j++) {
      // Unpack mass-fraction
      cell->atom[i].isotope[j].X(XIsotope[i][j]);
    }
    // For each ionization state
    for (j=0;j<cell->atom[i].iState.size();j++) {
      // Unpack number-fraction
      cell->atom[i].iState[j].X(XIon[i][j]);
      // For each bound state
      for (k=0;k<cell->atom[i].iState[j].bState.size();k++) {
	// Unpack number-fraction
	cell->atom[i].iState[j].bState[k].X(XBound[i][j][k]);
      }
    }
  }
}

// Sum MC statistics
void MCStatMPI::operator+=(const MCStatMPI& mCStat) {
  int i,j;

  // Sum mean intensity per bin
  for (i=0;i<Jnu.size();i++) Jnu[i]+=mCStat.Jnu[i];

  // Sum H per bin
  for (i=0;i<Hnu.size();i++) Hnu[i]+=mCStat.Hnu[i];

  // Sum K per bin
  for (i=0;i<Knu.size();i++) Knu[i]+=mCStat.Knu[i];

  // Sum intensity per bin
  for (i=0;i<Inu.size();i++) 
    for (j=0;j<Inu[i].size();j++) Inu[i][j]+=mCStat.Inu[i][j];
  
  // Sum mean emissivity per bin
  for (i=0;i<etaNu.size();i++) etaNu[i]+=mCStat.etaNu[i];

  // Sum mean opacity-intensity product per bin
  for (i=0;i<kappaJNu.size();i++) kappaJNu[i]+=mCStat.kappaJNu[i]; // New!
  for (i=0;i<kappaBFJNu.size();i++) kappaBFJNu[i]+=mCStat.kappaBFJNu[i]; // New!
  for (i=0;i<kappaFFJNu.size();i++) kappaFFJNu[i]+=mCStat.kappaFFJNu[i]; // New!
  for (i=0;i<kappaBBJNu.size();i++) kappaBBJNu[i]+=mCStat.kappaBBJNu[i]; // New!
  for (i=0;i<kappaESJNu.size();i++) kappaESJNu[i]+=mCStat.kappaESJNu[i]; // New!

  // Sum mean opacity-H product per bin
  for (i=0;i<kappaHNu.size();i++) kappaHNu[i]+=mCStat.kappaHNu[i]; // New!
  for (i=0;i<kappaBFHNu.size();i++) kappaBFHNu[i]+=mCStat.kappaBFHNu[i]; // New!
  for (i=0;i<kappaFFHNu.size();i++) kappaFFHNu[i]+=mCStat.kappaFFHNu[i]; // New!
  for (i=0;i<kappaBBHNu.size();i++) kappaBBHNu[i]+=mCStat.kappaBBHNu[i]; // New!
  for (i=0;i<kappaESHNu.size();i++) kappaESHNu[i]+=mCStat.kappaESHNu[i]; // New!

  /*// Sum pathlength
  for (i=0;i<lNu.size();i++) lNu[i]+=mCStat.lNu[i]; // New!

  // Sum absorption events
  for (i=0;i<nAbsNu.size();i++) nAbsNu[i]+=mCStat.nAbsNu[i]; // New!
  for (i=0;i<nAbsBFNu.size();i++) nAbsBFNu[i]+=mCStat.nAbsBFNu[i]; // New!
  for (i=0;i<nAbsFFNu.size();i++) nAbsFFNu[i]+=mCStat.nAbsFFNu[i]; // New!
  for (i=0;i<nAbsBBNu.size();i++) nAbsBBNu[i]+=mCStat.nAbsBBNu[i]; // New!
  for (i=0;i<nAbsESNu.size();i++) nAbsESNu[i]+=mCStat.nAbsESNu[i]; // New!*/

  // Sum mean frequency per bin
  for (i=0;i<nuMeanNu.size();i++) nuMeanNu[i]+=mCStat.nuMeanNu[i];

  // Sum line mean intensity
  for (i=0;i<JLine.size();i++) JLine[i]+=mCStat.JLine[i];

  // Sum radioactive heating
  eRadio+=mCStat.eRadio;

  // Sum mean intensity events
  for (i=0;i<nJ.size();i++) nJ[i]+=mCStat.nJ[i];

  // Sum line intensity events
  for (i=0;i<nJLine.size();i++) nJLine[i]+=mCStat.nJLine[i];

  // Sum radioactive heating events - New!
  neRadio+=mCStat.neRadio;
}

// Pack MC statistics
void MCStatMPI::pack(Cell* cell) {
  Jnu=cell->Jnu;
  Hnu=cell->Hnu;
  Knu=cell->Knu;
  Inu=cell->Inu;
  etaNu=cell->etaNu;
  kappaJNu=cell->kappaJNu; // New!
  kappaBFJNu=cell->kappaBFJNu; // New!
  kappaFFJNu=cell->kappaFFJNu; // New!
  kappaBBJNu=cell->kappaBBJNu; // New!
  kappaESJNu=cell->kappaESJNu; // New!
  kappaHNu=cell->kappaHNu; // New!
  kappaBFHNu=cell->kappaBFHNu; // New!
  kappaFFHNu=cell->kappaFFHNu; // New!
  kappaBBHNu=cell->kappaBBHNu; // New!
  kappaESHNu=cell->kappaESHNu; // New!
  /*nAbsNu=cell->nAbsNu; // New!
  nAbsBFNu=cell->nAbsBFNu; // New!
  nAbsFFNu=cell->nAbsFFNu; // New!
  nAbsBBNu=cell->nAbsBBNu; // New!
  nAbsESNu=cell->nAbsESNu; // New!
  lNu=cell->lNu; // New!*/
  nuMeanNu=cell->nuMeanNu;
  JLine=cell->JLine;
  eRadio=cell->peRadio;
  nJ=cell->nJ;
  nJLine=cell->nJLine;
  neRadio=cell->neRadio; // New!
}

// Unpack MC statistics
void MCStatMPI::unpack(Cell* cell) const {
  cell->Jnu=Jnu;
  cell->Hnu=Hnu;
  cell->Knu=Knu;
  cell->Inu=Inu;
  cell->etaNu=etaNu;
  cell->kappaJNu=kappaJNu; // New!
  cell->kappaBFJNu=kappaBFJNu; // New!
  cell->kappaFFJNu=kappaFFJNu; // New!
  cell->kappaBBJNu=kappaBBJNu; // New!
  cell->kappaESJNu=kappaESJNu; // New!
  cell->kappaHNu=kappaHNu; // New!
  cell->kappaBFHNu=kappaBFHNu; // New!
  cell->kappaFFHNu=kappaFFHNu; // New!
  cell->kappaBBHNu=kappaBBHNu; // New!
  cell->kappaESHNu=kappaESHNu; // New!
  /*cell->nAbsNu=nAbsNu; // New!
  cell->nAbsBFNu=nAbsBFNu; // New!
  cell->nAbsFFNu=nAbsFFNu; // New!
  cell->nAbsBBNu=nAbsBBNu; // New!
  cell->nAbsESNu=nAbsESNu; // New!
  cell->lNu=lNu; // New!*/
  cell->nuMeanNu=nuMeanNu;
  cell->JLine=JLine;
  cell->peRadio=eRadio;
  cell->nJ=nJ;
  cell->nJLine=nJLine;
  cell->neRadio=neRadio; // New!
}

// Sum g-packet MC statistics - New!
void GMCStatMPI::operator+=(const GMCStatMPI& gMCStat) {
  int i,j;

  // Sum radioactive heating
  eRadio+=gMCStat.eRadio;

  // Sum radioactive heating events
  neRadio+=gMCStat.neRadio;
}

// Pack g-packet MC statistics - New!
void GMCStatMPI::pack(Cell* cell) {
  eRadio=cell->peRadio;
  neRadio=cell->neRadio;
}

// Unpack g-packet MC statistics - New!
void GMCStatMPI::unpack(Cell* cell) const {
  cell->peRadio=eRadio;
  cell->neRadio=neRadio;
}

// Pack bound-free opacity table - New!
void BoundFreeAbsKappaMPI::pack(Cell* cell) {
  cell->pBoundFreeAbsKappaTable.pack(boundFreeAbsKappaTable,cell->nuOld);
  boundFreeTableUpdate=cell->boundFreeTableUpdate;
}

// Unpack bound-free opacity table - New!
void BoundFreeAbsKappaMPI::unpack(Cell* cell) {
  cell->pBoundFreeAbsKappaTable.unpack(boundFreeAbsKappaTable,cell->nuOld,BoundFreeKappa(cell));
  cell->boundFreeTableUpdate=boundFreeTableUpdate;
}

// Pack bound-free cutoff - New!
void BoundFreeCutOffMPI::pack(Cell* cell) {
  int i,j,k,l;
  minorEdge.resize(cell->nu.size());
  minorEdgeOld.resize(cell->nuOld.size());
  for (i=0;i<cell->nu.size();i++) minorEdge[i]=cell->nu[i].minorEdge;
  for (i=0;i<cell->nuOld.size();i++) minorEdgeOld[i]=cell->nuOld[i].minorEdge;
  nuCutOffTransBF.resize(cell->atom.size());
  for (i=0;i<cell->atom.size();i++) {
    nuCutOffTransBF[i].resize(cell->atom[i].iState.size());
    for (j=0;j<cell->atom[i].iState.size();j++) {
      nuCutOffTransBF[i][j].resize(cell->atom[i].iState[j].bState.size());
      for (k=0;k<cell->atom[i].iState[j].bState.size();k++) {
	nuCutOffTransBF[i][j][k].resize(cell->atom[i].iState[j].bState[k].upTransBF.size());
	for (l=0;l<cell->atom[i].iState[j].bState[k].upTransBF.size();l++) {
	  nuCutOffTransBF[i][j][k][l]=cell->atom[i].iState[j].bState[k].upTransBF[l]->nuCutOff();
	}
      }
    }
  }
  boundFreeCutOffUpdate=cell->boundFreeCutOffUpdate; // New!
}

// Unpack bound-free cutoff - New!
void BoundFreeCutOffMPI::unpack(Cell* cell) {
  int i,j,k,l;
  for (i=0;i<cell->nu.size();i++) cell->nu[i].minorEdge=minorEdge[i];
  for (i=0;i<cell->nuOld.size();i++) cell->nuOld[i].minorEdge=minorEdgeOld[i];
  for (i=0;i<cell->atom.size();i++) {
    for (j=0;j<cell->atom[i].iState.size();j++) {
      for (k=0;k<cell->atom[i].iState[j].bState.size();k++) {
	for (l=0;l<cell->atom[i].iState[j].bState[k].upTransBF.size();l++) {
	  cell->atom[i].iState[j].bState[k].upTransBF[l]->nuCutOff(nuCutOffTransBF[i][j][k][l]);
	}
      }
    }
  }
  cell->boundFreeCutOffUpdate=boundFreeCutOffUpdate; // New!
}

// Pack bound-state ID
void BStateIDMPI::pack(BState*& bState, Cell* cell) {

  if (bState!=NULL) {
    atomIndex=bState->iState()->atom()->index();
    iStateIndex=bState->iState()->index();
    bStateIndex=bState->getIndex();
  }
  else { atomIndex=0; iStateIndex=0; bStateIndex=noIndex; }

  //unsigned int atomIndex=bState->iState()->atom()->index();
  //unsigned int iStateIndex=bState->iState()->index();
  //unsigned int bStateIndex=bState->getIndex();

  //index=0;
  //index+=atomIndex;
  //index<<=8;
  //index+=iStateIndex;
  //index<<=16;
  //index+=bStateIndex;
}

// Unpack bound-state ID
void BStateIDMPI::unpack(BState*& bState, Cell* cell) {

  //unsigned int bStateIndex=index&0x0000FFFF;
  //index>>=8;
  //unsigned int iStateIndex=index&Ox000000FF;
  //index>>=4;
  //unsigned int bStateIndex=index&0x000000FF;

  if (bStateIndex!=noIndex) {
    Atom* atom=&(cell->atom[atomIndex]);
    IState* iState=&(atom->iState[iStateIndex]);
    bState=&(iState->bState[bStateIndex]);
    //cout<<"BStateIDMPI::unpack: atom.index:"<<atom->index()<<", iState.index: "<<iState->index()<<", bState.index:"<<bState->getIndex()<<"\n";
  }
  else bState=NULL;

  //cout<<"BStateIDMPI::unpack: bState: "<<bState<<", atomIndex:"<<((int) atomIndex)<<", iStateIndex: "<<((int) iStateIndex)<<", bStateIndex:"<<bStateIndex<<"\n";
}

// Pack transition ID
void TransIDMPI::pack(Trans*& trans, unsigned short& _index, bool& _upward, Cell* cell) {

  if (_upward) bState.pack(trans->lowerState,cell);
  else bState.pack(trans->upperState,cell);
  if (trans->type()==transClassBF) boundFree=true;
  else boundFree=false;
  index=_index;
  upward=_upward;
}

// Unpack transition ID
void TransIDMPI::unpack(Trans*& trans, unsigned short& _index, bool& _upward, Cell* cell) {
  BState* _bState;

  _index=index;
  _upward=upward;
  bState.unpack(_bState,cell);
  if (upward) {
    if (boundFree) {
      trans=_bState->upTransBF[index];
      //cout<<"TransIDMPI::unpack: upTransBF.size:  "<<_bState->upTransBF.size()<<"\n";
    }
    else {
      trans=_bState->upTransBB[index];
      //cout<<"TransIDMPI::unpack: upTransBB.size:  "<<_bState->upTransBB.size()<<"\n";
    }
  }
  else {
    if (boundFree) {
      trans=_bState->downTransBF[index];
      //cout<<"TransIDMPI::unpack: downTransBF.size:  "<<_bState->downTransBF.size()<<"\n";
    }
    else {
      trans=_bState->downTransBB[index];
      //cout<<"TransIDMPI::unpack: downTransBB.size:  "<<_bState->downTransBB.size()<<"\n";
    }
  }
  //cout<<"TransIDMPI::unpack: trans: "<<trans<<", index:"<<index<<"/"<<_index<<", upward: "<<upward<<"/"<<_upward<<"\n";
}

// Pack Markov transition probability list
void MarkovPListMPI::pack(vector<MarkovP>& markovPList, Cell* cell) {
  int i;

  // Resize Markov transition probability list
  markovPListMPI.resize(markovPList.size());

  // Pack each Markov transition
  for (i=0;i<markovPList.size();i++) {
    markovPListMPI[i].P=markovPList[i].P;
    markovPListMPI[i].nextState.pack(markovPList[i].nextState,cell);
  }
}

// Unpack Markov transition probability list
void MarkovPListMPI::unpack(vector<MarkovP>& markovPList, Cell* cell) {
  int i;

  // Resize Markov transition probability list
  markovPList.resize(markovPListMPI.size());

  // Unpack each Markov transition
  for (i=0;i<markovPListMPI.size();i++) {
    markovPList[i].P=markovPListMPI[i].P;
    markovPListMPI[i].nextState.unpack(markovPList[i].nextState,cell);
  }
}

// Pack Markov transition probability list
// Does not work right now - see below!
void TransPListMPI::pack(vector<TransP>& transPList, Cell* cell) {
  int i;

  // Resize transition probability list
  transPListMPI.resize(transPList.size());

  // Pack each transition
  for (i=0;i<transPList.size();i++) {
    transPListMPI[i].P=transPList[i].P;
    transPListMPI[i].trans.pack(transPList[i].trans,transPList[i].index,transPList[i].upward,cell); // Temporarily removed!!!
    transPListMPI[i].type=transPList[i].type;
  }
}

// Unpack Markov transition probability list
// Does not work right now - see below!
void TransPListMPI::unpack(vector<TransP>& transPList, Cell* cell) {
  int i;

  // Resize transition probability list
  transPList.resize(transPListMPI.size());

  //cout<<"TransPLIstMPI::unpack: transPList.size: "<<transPList.size()<<"\n";

  // Unpack each transition
  for (i=0;i<transPListMPI.size();i++) {
    transPList[i].P=transPListMPI[i].P;
    transPListMPI[i].trans.unpack(transPList[i].trans,transPList[i].index,transPList[i].upward,cell);  // Temporarily removed!!!
    transPList[i].type=transPListMPI[i].type;
    //cout<<"TransPLIstMPI::unpack: i: "<<i<<", index: "<<transPList[i].index<<", upward: "<<transPList[i].upward<<", trans: "<<transPList[i].trans<<", P: "<<transPList[i].P<<", type: "<<transPList[i].type<<"\n";
  }
}

// Pack emission probaility tables
void EtaPTableTransListMPI::pack(vector<TransBF*>& transBF) {
  int i;
  EtaPTableTransMPI etaPTableTrans;

  // Reset transition list
  etaPTableTransList.resize(0);

  // For each transition
  for (i=0;i<transBF.size();i++) {
    // If emission probability table present
    if (transBF[i]->etaPTable.size()!=0) {
      // Pack into list
      etaPTableTrans.index=i;
      etaPTableTrans.etaPTable=transBF[i]->etaPTable;
      etaPTableTransList.push_back(etaPTableTrans);
    }
  }
}

// Unpack emission probability tables
void EtaPTableTransListMPI::unpack(vector<TransBF*>& transBF) {
  int i;

  // Unpack each emission probability table
  for (i=0;i<etaPTableTransList.size();i++) transBF[etaPTableTransList[i].index]->etaPTable=etaPTableTransList[i].etaPTable;
}

// Pack bound-bound transition boost quantities
void BoostTransBBMPI::pack(TransBB* transBB) {
  eta1Boost=transBB->pEta1Boost;
  eta2Boost=transBB->pEta2Boost;
  eta2P=transBB->eta2P;
}

// Unpack bound-bound transition boost quantities
void BoostTransBBMPI::unpack(TransBB* transBB){
  transBB->pEta1Boost=eta1Boost;
  transBB->pEta2Boost=eta2Boost;
  transBB->eta2P=eta2P;
};

// Pack bound-free transition boost quantities
void BoostTransBFMPI::pack(TransBF* transBF) {
  kappaBoost=transBF->pKappaBoost;
  etaBoost=transBF->pEtaBoost;
  etaP=transBF->etaP;
}

// Unpack bound-free transition boost quantities
void BoostTransBFMPI::unpack(TransBF* transBF){
  transBF->pKappaBoost=kappaBoost;
  transBF->pEtaBoost=etaBoost;
  transBF->etaP=etaP;
};

// Pack bound-state boost quantities
void BoostBStateMPI::pack(BState* bState) {
  transPRBoost=bState->pTransPRBoost;
  transPCBoost=bState->pTransPCBoost;
  transPBoost=bState->pTransPBoost;
  markovPBoost=bState->pMarkovPBoost;
}

// Unpack bound-state boost quantities
void BoostBStateMPI::unpack(BState* bState){
  bState->pTransPRBoost=transPRBoost;
  bState->pTransPCBoost=transPCBoost;
  bState->pTransPBoost=transPBoost;
  bState->pMarkovPBoost=markovPBoost;
};

// Pack (cell) boost quantities
void BoostMPI::pack(Cell* cell) {
  int i,j,k,l;

  boost=cell->boost;
  freeFreeEtaBoost=cell->pFreeFreeEtaBoost;
  freeFreeKappaBoost=cell->pFreeFreeKappaBoost;
  boundFreeKappaBoostTable=cell->pBoundFreeKappaBoostTable;
  comptonKappaBoost=cell->pComptonKappaBoost;
  boundFreeCoolingBoost=cell->pBoundFreeCoolingBoost;
  freeFreeCoolingBoost=cell->pFreeFreeCoolingBoost;
  collCoolingBoost=cell->pCollCoolingBoost;
  radCoolingBoost=cell->pRadCoolingBoost;
  coolingBoost=cell->pCoolingBoost;
  nonThermalHeatingBoost=cell->pNonThermalHeatingBoost;
  nonThermalExcIonBoost=cell->pNonThermalExcIonBoost;
  nonThermalBoost=cell->pNonThermalBoost;
  markovPThermBoost=cell->pMarkovPThermBoost;
  markovPCTBoost=cell->markovPCTBoost;
  freeFreeEtaP=cell->freeFreeEtaP;
  // Resize vectors
  boostBState.resize(cell->atom.size());
  boostTransBB.resize(cell->atom.size());
  boostTransBF.resize(cell->atom.size());
  // For each atom
  for (i=0;i<cell->atom.size();i++) {
    // Resize vectors
    boostBState[i].resize(cell->atom[i].iState.size());
    boostTransBB[i].resize(cell->atom[i].iState.size());
    boostTransBF[i].resize(cell->atom[i].iState.size());
    // For each ionization state
    for (j=0;j<cell->atom[i].iState.size();j++) {
      // Resize vectors
      boostBState[i][j].resize(cell->atom[i].iState[j].bState.size());
      boostTransBB[i][j].resize(cell->atom[i].iState[j].bState.size());
      boostTransBF[i][j].resize(cell->atom[i].iState[j].bState.size());
      // For each bound state
      for (k=0;k<cell->atom[i].iState[j].bState.size();k++) {
	// Resize vectors
	boostTransBB[i][j][k].resize(cell->atom[i].iState[j].bState[k].upTransBB.size());
	boostTransBF[i][j][k].resize(cell->atom[i].iState[j].bState[k].upTransBF.size());
	// Pack bound-state boost quantities
	boostBState[i][j][k].pack(&(cell->atom[i].iState[j].bState[k]));
	// For each (upward) bound-bound
	for (l=0;l<cell->atom[i].iState[j].bState[k].upTransBB.size();l++)
	  // Pack bound-bound transition boost quantities
	  boostTransBB[i][j][k][l].pack(cell->atom[i].iState[j].bState[k].upTransBB[l]);
	// For each (upward) bound-free
	for (l=0;l<cell->atom[i].iState[j].bState[k].upTransBF.size();l++)
	  // Pack bound-free transition boost quantities
	  boostTransBF[i][j][k][l].pack(cell->atom[i].iState[j].bState[k].upTransBF[l]);
      }
    }
  }
}

// Unpack (cell) boost quantities
void BoostMPI::unpack(Cell* cell) {
  int i,j,k,l;

  cell->boost=boost;
  cell->pFreeFreeEtaBoost=freeFreeEtaBoost;
  cell->pFreeFreeKappaBoost=freeFreeKappaBoost;
  cell->pBoundFreeKappaBoostTable=boundFreeKappaBoostTable;
  cell->pComptonKappaBoost=comptonKappaBoost;
  cell->pBoundFreeCoolingBoost=boundFreeCoolingBoost;
  cell->pFreeFreeCoolingBoost=freeFreeCoolingBoost;
  cell->pCollCoolingBoost=collCoolingBoost;
  cell->pRadCoolingBoost=radCoolingBoost;
  cell->pCoolingBoost=coolingBoost;
  cell->pNonThermalHeatingBoost=nonThermalHeatingBoost;
  cell->pNonThermalExcIonBoost=nonThermalExcIonBoost;
  cell->pNonThermalBoost=nonThermalBoost;
  cell->pMarkovPThermBoost=markovPThermBoost;
  cell->markovPCTBoost=markovPCTBoost;
  cell->freeFreeEtaP=freeFreeEtaP;
  // For each atom
  for (i=0;i<cell->atom.size();i++) {
    // For each ionization state
    for (j=0;j<cell->atom[i].iState.size();j++) {
      // For each bound state
      for (k=0;k<cell->atom[i].iState[j].bState.size();k++) {
	// Unpack bound-state boost quantities
	boostBState[i][j][k].unpack(&(cell->atom[i].iState[j].bState[k]));
	// For each (upward) bound-bound
	for (l=0;l<cell->atom[i].iState[j].bState[k].upTransBB.size();l++)
	  // Unpack bound-bound transition boost quantities
	  boostTransBB[i][j][k][l].unpack(cell->atom[i].iState[j].bState[k].upTransBB[l]);
	// For each (upward) bound-free
	for (l=0;l<cell->atom[i].iState[j].bState[k].upTransBF.size();l++)
	  // Unpack bound-free transition boost quantities
	  boostTransBF[i][j][k][l].unpack(cell->atom[i].iState[j].bState[k].upTransBF[l]);
      }
    }
  }
}

// Pack derived MC quantities
void MCDerivedMPI::pack(Cell* cell) {
  int i,j,k;

  // If necessary - Pack boost quantities
  if (cell->config->boost) boost.pack(cell);

  // Pack thermal-pool Markov probability list
  markovPListTherm.pack(cell->markovPListTherm,cell);
  // Resize charge-transfer Markov probability list
  markovPListCT.resize(cell->markovPListCT.size());
  // Pack charge-transfer Markov probability list
  for (i=0;i<cell->markovPListCT.size();i++) markovPListCT[i].pack(cell->markovPListCT[i],cell);
  // Pack collisional excitation probability list
  collExcitePList.pack(cell->collExcitePList,cell);
  // Pack charge-transfer excitation probability list
  //CTExcitePList.pack(cell->CTExcitePList,cell);
  // Packet non-thermal exctitation/ionization probability list
  nonThermalExcitePList.pack(cell->nonThermalExcitePList,cell);
  // Resize vectors
  markovPList.resize(cell->atom.size());
  transPList.resize(cell->atom.size());
  PRTot.resize(cell->atom.size());
  PCTot.resize(cell->atom.size());
  etaPTableTransBF.resize(cell->atom.size());
  // For each atom
  for (i=0;i<cell->atom.size();i++) {
    // Resize vectors
    markovPList[i].resize(cell->atom[i].iState.size());
    transPList[i].resize(cell->atom[i].iState.size());
    PRTot[i].resize(cell->atom[i].iState.size());
    PCTot[i].resize(cell->atom[i].iState.size());
    etaPTableTransBF[i].resize(cell->atom[i].iState.size());
    // For each ionization state
    for (j=0;j<cell->atom[i].iState.size();j++) {
      // Resize vectors
      markovPList[i][j].resize(cell->atom[i].iState[j].bState.size());
      transPList[i][j].resize(cell->atom[i].iState[j].bState.size());
      PRTot[i][j].resize(cell->atom[i].iState[j].bState.size());
      PCTot[i][j].resize(cell->atom[i].iState[j].bState.size());
      etaPTableTransBF[i][j].resize(cell->atom[i].iState[j].bState.size());
      // For each bound state
      for (k=0;k<cell->atom[i].iState[j].bState.size();k++) {
	// Pack Markov transition probability list
	markovPList[i][j][k].pack(cell->atom[i].iState[j].bState[k].markovPList,cell);
	// Pack transition probability list
	transPList[i][j][k].pack(cell->atom[i].iState[j].bState[k].transPList,cell);
	// Pack radiative and collisional de-activation probabilities
	PRTot[i][j][k]=cell->atom[i].iState[j].bState[k].PRTot;
	PCTot[i][j][k]=cell->atom[i].iState[j].bState[k].PCTot;
	// Pack emission probability tables
	etaPTableTransBF[i][j][k].pack(cell->atom[i].iState[j].bState[k].upTransBF);
      }
    }
  }
}

// Unpack derived MC quantities
void MCDerivedMPI::unpack(Cell* cell) {
  int i,j,k;
  int l; // Testing!
  TransP* transP; // Testing!

  //cout<<"MCDerivedMPI::unpack: cell: "<<cell->index()<<"Enter\n";

  // If necessary - Unpack boost quantities
  if (cell->config->boost) boost.unpack(cell);

  // Unpack thermal-pool Markov probability list
  markovPListTherm.unpack(cell->markovPListTherm,cell);
  // Resize charge-transfer Markov probability list
  cell->markovPListCT.resize(markovPListCT.size());
  // Unpack charge-transfer Markov probability list
  for (i=0;i<markovPListCT.size();i++) markovPListCT[i].unpack(cell->markovPListCT[i],cell);
  // Unpack collisional excitation probability list
  collExcitePList.unpack(cell->collExcitePList,cell);
  // Unpack charge-transfer excitation probability list
  //CTExcitePList.unpack(cell->CTExcitePList,cell);
  // Unpacket non-thermal exctitation/ionization probability list
  nonThermalExcitePList.unpack(cell->nonThermalExcitePList,cell);
  // For each atom
  for (i=0;i<cell->atom.size();i++) {
    // For each ionization state
    for (j=0;j<cell->atom[i].iState.size();j++) {
      //cout<<"MCDerivedMPI::unpack: cell: "<<cell->index()<<", "<<cell->atom[i].iState[j].name()<<"\n";
      // For each bound state
      for (k=0;k<cell->atom[i].iState[j].bState.size();k++) {
	//cout<<"MCDerivedMPI::unpack: cell: "<<cell->index()<<", "<<cell->atom[i].iState[j].name()<<":"<<cell->atom[i].iState[j].bState[k].getIndex()<<"\n";
	// Unpack Markov transition probability list
	markovPList[i][j][k].unpack(cell->atom[i].iState[j].bState[k].markovPList,cell);
	// Unpack transition probability list
	transPList[i][j][k].unpack(cell->atom[i].iState[j].bState[k].transPList,cell);
	// Unpack radiative and collisional de-activation probabilities
	cell->atom[i].iState[j].bState[k].PRTot=PRTot[i][j][k];
	cell->atom[i].iState[j].bState[k].PCTot=PCTot[i][j][k];
	// Unpack emission probability tables
	etaPTableTransBF[i][j][k].unpack(cell->atom[i].iState[j].bState[k].upTransBF);
	// Testing
	//cout<<"MCDerivedMPI::unpack: cell: "<<cell->index()<<", "<<cell->atom[i].iState[j].name()<<":"<<cell->atom[i].iState[j].bState[k].getIndex()<<", transPList.size: "<<cell->atom[i].iState[j].bState[k].transPList.size()<<"\n";
	for (l=0;l<cell->atom[i].iState[j].bState[k].transPList.size();l++) {
	  //cout<<"MCDerivedMPI::unpack: cell: "<<cell->index()<<", "<<cell->atom[i].iState[j].name()<<":"<<cell->atom[i].iState[j].bState[k].getIndex()<<", l: "<<l<<"\n";
	  transP=&(cell->atom[i].iState[j].bState[k].transPList[l]);
	  if (transP->trans!=NULL) {
	    if (transP->type==radiativeBF and transP->trans->type()!=transClassBF) cout<<"MCDerivedMPI::unpack: cell: "<<cell->index()<<", "<<transP->trans->upperState->iState()->name()<<":"<<transP->trans->upperState->getIndex()<<"->"<<transP->trans->lowerState->iState()->name()<<":"<<transP->trans->lowerState->getIndex()<<", Error: (BF) Transition type mismatch\n";
	    if (transP->type==radiativeBB and transP->trans->type()!=transClassBB) cout<<"MCDerivedMPI::unpack: cell: "<<cell->index()<<", "<<transP->trans->upperState->iState()->name()<<":"<<transP->trans->upperState->getIndex()<<"->"<<transP->trans->lowerState->iState()->name()<<":"<<transP->trans->lowerState->getIndex()<<", Error: (BB) Transition type mismatch\n";
	  }
	  else cout<<"MCDerivedMPI::unpack: cell: "<<cell->index()<<", "<<cell->atom[i].iState[j].name()<<":"<<cell->atom[i].iState[j].bState[k].getIndex()<<", Error: NULL transition\n";
	}
      }
    }
  }
  //cout<<"MCDerivedMPI::unpack: cell: "<<cell->index()<<"Return\n";
}

// Constructor
MCUpdateInfo::MCUpdateInfo() : nuBin(noBin), muBin(noBin), nuBinLine(noBin) {} // Changed!

// Constructors
CellConfig::CellConfig() : steadyState(true), iMethod(neIteration), lineSelector(new LineSelector), updateMethod(urPacketHistory), boundFreeTable(false), boundFreeTableMax(1), boundFreeTableMin(1e5), boundFreeTableNBin(1e4), boundFreeTableEdgeWidth(2e-6), boundFreeSTable(false), boundFreeSTableNBin(1e3), boundFreeSTableEdgeWidth(2e-6), radEstimator(rfDBB), radEstimatorBB(rfDBB), radEstimatorExp(false), transTable(false), markovTable(false), markovTableExt(false), markovTableExtSplit(false), markovTableLim(0.0), markovTableThermLim(0.0), markovTableCTLim(0.0), collExciteTable(false), collExciteTableLim(0.0), nonThermalExciteTable(false), freeFreeMacro(false), boundFreeMacro(false), collMacro(false), nonThermalMacro(false), twoPhotonMacro(false), chargeTransferMacro(false), onTheSpot(), onTheSpotNew(), ffOnTheSpot(), continuumBB(false), boundFreeBB(false), freeFreeBB(false), continuumBBTauLim(1e3), boundFreeBBTauLim(1e3), continuumBBT(bbTCur), exportEta(false), transformRay(false), limitFreeFreeCRange(false), JLineFallback(false), JLineFallbackFactor(1.1), JLineFallbackCount(3), JLineFallbackDBB(false), trackI(false), trackHK(false), boundFreeCutOff(0.0), boundFreeCutOffRoss(0.0), boost(false), alfaCorrect(false), alfaCorrectEmit(false), alfaSimpleEmit(false), alfaSPH(false), forceDBalance(false), forceDBalanceOSP(false), chargeTransferEmit(false), etaTable(false), exportSBF(false), boundFreeTableOSPOnly(false), nuMin(c/(25000*AA)), nuMax(c/(1*AA)), nNuBin(5000), nMuBin(20), LTEGroupMacro(false), exportKappaMC2(true) { } // Changed!
CellConfig::CellConfig(const bool& _steadyState, const IMethod& _iMethod, LineSelector* _lineSelector, const UpdateMethod& _updateMethod, const bool& _boundFreeTable, const double& _boundFreeTableMin, const double& _boundFreeTableMax, const int& _boundFreeTableNBin, const bool& _boundFreeSTable, const int& _boundFreeSTableNBin, const RadEstimator& _radEstimator, const RadEstimator& _radEstimatorBB, const bool& _radEstimatorExp, const bool& _transTable, const bool& _markovTable, const bool& _markovTableExt, const bool& _markovTableExtSplit, const double& _markovTableLim, const double& _markovTableThermLim, const double& _markovTableCTLim, const bool& _collExciteTable, const double& _collExciteTableLim, const bool& _nonThermalExciteTable, const bool& _freeFreeMacro, const bool& _boundFreeMacro, const bool& _collMacro, const bool& _nonThermalMacro, const bool& _twoPhotonMacro, const bool& _chargeTransferMacro, const OnTheSpot& _onTheSpot, const OnTheSpotNew& _onTheSpotNew, const FFOnTheSpot& _ffOnTheSpot, const bool& _continuumBB, const bool& _boundFreeBB, const double& _continuumBBTauLim, const double& _boundFreeBBTauLim, const BBTType& _continuumBBT, const bool& _exportEta, const bool& _transformRay, const bool& _limitFreeFreeCRange, const bool& _JLineFallback, const double& _JLineFallbackFactor, const int& _JLineFallbackCount, const bool& _JLineFallbackDBB, const bool& _trackI, const bool& _trackHK, const double& _boundFreeCutOff, const double& _boundFreeCutOffRoss, const bool& _boost, const bool& _alfaCorrect, const bool& _alfaCorrectEmit, const bool& _alfaSimpleEmit, const bool& _alfaSPH, const bool& _forceDBalance, const bool& _forceDBalanceOSP, const bool& _chargeTransferEmit, const bool& _etaTable, const bool& _exportSBF, const double& _nuMin, const double& _nuMax, const int& _nNuBin, const int& _nMuBin, const bool& _LTEGroupMacro, const bool& _exportKappaMC2) : steadyState(_steadyState), iMethod(_iMethod), lineSelector(_lineSelector), updateMethod(_updateMethod), boundFreeTable(_boundFreeTable), boundFreeTableMin(_boundFreeTableMin), boundFreeTableMax(_boundFreeTableMax), boundFreeTableNBin(_boundFreeTableNBin), boundFreeTableEdgeWidth(2e-6), boundFreeSTable(_boundFreeSTable), boundFreeSTableNBin(_boundFreeSTableNBin), boundFreeSTableEdgeWidth(2e-6), radEstimator(_radEstimator), radEstimatorBB(_radEstimatorBB), radEstimatorExp(_radEstimatorExp), transTable(_transTable), markovTable(_markovTable), markovTableExt(_markovTableExt), markovTableExtSplit(_markovTableExtSplit), markovTableLim(_markovTableLim), markovTableThermLim(_markovTableThermLim), markovTableCTLim(_markovTableCTLim), collExciteTable(_collExciteTable), collExciteTableLim(_collExciteTableLim), nonThermalExciteTable(_nonThermalExciteTable), freeFreeMacro(_freeFreeMacro), boundFreeMacro(_boundFreeMacro), collMacro(_collMacro), nonThermalMacro(_nonThermalMacro), twoPhotonMacro(_twoPhotonMacro), chargeTransferMacro(_chargeTransferMacro), onTheSpot(_onTheSpot), onTheSpotNew(_onTheSpotNew), ffOnTheSpot(_ffOnTheSpot), continuumBB(_continuumBB), boundFreeBB(_boundFreeBB), freeFreeBB(false), continuumBBTauLim(_continuumBBTauLim), boundFreeBBTauLim(_boundFreeBBTauLim), continuumBBT(_continuumBBT), exportEta(_exportEta), transformRay(_transformRay), limitFreeFreeCRange(_limitFreeFreeCRange), JLineFallback(_JLineFallback), JLineFallbackFactor(_JLineFallbackFactor), JLineFallbackCount(_JLineFallbackCount), JLineFallbackDBB(_JLineFallbackDBB), trackI(_trackI), trackHK(_trackHK), boundFreeCutOff(_boundFreeCutOff), boundFreeCutOffRoss(_boundFreeCutOffRoss), boost(_boost), alfaCorrect(_alfaCorrect), alfaCorrectEmit(_alfaCorrectEmit), alfaSimpleEmit(_alfaSimpleEmit), alfaSPH(_alfaSPH), forceDBalance(_forceDBalance), forceDBalanceOSP(_forceDBalanceOSP), chargeTransferEmit(_chargeTransferEmit), etaTable(_etaTable), exportSBF(_exportSBF), boundFreeTableOSPOnly(false), nuMin(_nuMin), nuMax(_nuMax), nNuBin(_nNuBin), nMuBin(_nMuBin), LTEGroupMacro(_LTEGroupMacro), exportKappaMC2(_exportKappaMC2) { } // Changed!

// Log cell type
string mc::logCellType(const CellType& cellType) {
  switch(cellType) {
  case cellNormal : return "cellNormal";
  case cellContainer : return "cellContainer";
  case cellSub : return "cellSub";
  default : return "unknown";
  }
}

// Conctructor
CellVirtual::CellVirtual() {
}

// Constructor - Changed!
CellVirtual::CellVirtual(CellBase* cell, CellBase* subCell, const Vector3D& position, const Vector3D& direction, const CellLocation& cellLocation, double t) { // Changed!
  double r,theta,phi;
  Vector3D positionVirtual;

  // Set cell
  pCell=cell;
  // Set cell containter
  pSubCell=subCell;

  // Select a random virtual position (assuming virtual z-axis and direction aligned)
  positionVirtual=subCell->randomPosition(cellLocation,t,true);

  // Testing!!!
  //if (index()==6 and grid()->master() and omp_get_thread_num()==0) cout<<"CellVirtual::CellVirtual: 1, index: "<<index()<<", r: "<<position.norm()<<", rVirtual: "<<positionVirtual.norm()<<", t: "<<t<<", rMaxVirtual: "<<((CellSS*) subCell)->rMaxT(t,true)<<"\n";

  // If cell-border location
  if (cellLocation==cellBorder) {

    // Get polar and equatorial angles for the direction
    direction.coords(r,theta,phi,spherical);

    // Rotate virtual position to align virtual z-axis with direction
    positionVirtual.rotate(theta,phi);
  }
    
  // Set position offset
  positionOffset=positionVirtual-position;

  // Testing!!!
  //if (index()==6 and grid()->master() and omp_get_thread_num()==0) cout<<"CellVirtual::CellVirtual: 2, index: "<<index()<<", r: "<<position.norm()<<", rVirtual: "<<positionVirtual.norm()<<", t: "<<t<<", rMaxVirtual: "<<((CellSS*) subCell)->rMaxT(t,true)<<"\n";

  // return
  return;
}

// Constructor - New!
CellVirtual::CellVirtual(CellBase* _cell, CellBase* _subCell, const Vector3D& _positionOffset) : pCell(_cell), pSubCell(_subCell), positionOffset(_positionOffset), thetaOffset(0), phiOffset(0) { }

// Copy constructor
CellVirtual::CellVirtual(const CellVirtual& cellVirtual) : pCell(cellVirtual.pCell), pSubCell(cellVirtual.pSubCell), positionOffset(cellVirtual.positionOffset), thetaOffset(cellVirtual.thetaOffset), phiOffset(cellVirtual.phiOffset) { };

// Asigment operator
CellVirtual& CellVirtual::operator=(const CellVirtual& cellVirtual) {
  pCell=cellVirtual.pCell;
  pSubCell=cellVirtual.pSubCell;
  positionOffset=cellVirtual.positionOffset;
  thetaOffset=cellVirtual.thetaOffset;
  phiOffset=cellVirtual.phiOffset;
}

// Destructor
CellVirtual::~CellVirtual() { }

// Get cell index
int CellVirtual::index() const {
  return pCell->index();
}

// Get sub cell index
int CellVirtual::subIndex() const {
  return pSubCell->index();
}

// In cell - Changed!
bool CellVirtual::inCell(const Vector3D& position, double t, bool virtualCell) { 
  Vector3D positionVirtual;

  // Calculate virtuall position
  positionVirtual=position+positionOffset;

  // Return in (cell and sub cell)
  return (pCell->inCell(position,t) and pSubCell->inCell(positionVirtual,t,true)); // Changed!
  //return pCell->inCell(position,t,virtualCell);
}
  
// Calculate border distance - Changed!
double CellVirtual::borderDistance(const Vector3D& position, const Vector3D& direction, BorderType& borderType, double t, bool virtualCell, bool log) {
  Vector3D positionVirtual,directionVirtual;
  double _borderDistance,cellBorderDistance,subCellBorderDistance; // New!
  BorderType cellBorderType,subCellBorderType; // New!

  // Calculate virtual position and direction
  positionVirtual=position+positionOffset;
  directionVirtual=direction;
  //directionVirtual.rotate(thetaOffset,phiOffset); // Removed!

  // Get cell and sub cell border distance (and corresponding type) - New!
  cellBorderDistance=pCell->borderDistance(position,direction,cellBorderType,t,false,log);
  subCellBorderDistance=pSubCell->borderDistance(positionVirtual,directionVirtual,subCellBorderType,t,true,log);

  // Return minimum of cell and sub cell border distance (and corresponding type) - Changed!
  if (cellBorderDistance<=subCellBorderDistance) { _borderDistance=cellBorderDistance; borderType=cellBorderType; }
  else { _borderDistance=subCellBorderDistance; borderType=subCellBorderType; }

  // Testing!!!
  //if (index()==6 and grid()->master() and omp_get_thread_num()==0) {
  /*if (index()==6) {
    Vector3D step=direction*_borderDistance;
    Vector3D newPosition=position+step;
    Vector3D newPositionVirtual=positionVirtual+step;
    double mu=direction*position/position.norm();
    if (newPosition.norm()<((CellSS*) pCell)->rMinT(t,false) and borderType==btSubCellBorder) cout<<"CellVirtual::borderDistance: index: "<<index()<<", subIndex: "<<subIndex()<<", r: "<<position.norm()<<", rVirtual: "<<positionVirtual.norm()<<", rNew: "<<newPosition.norm()<<", rNewVirtual: "<<newPositionVirtual.norm()<<", rMin: "<<((CellSS*) pCell)->rMinT(t,false)<<", rMaxVirtual: "<<((CellSS*) pSubCell)->rMinT(t,true)<<", mu: "<<mu<<", t: "<<t<<", subCellBorderDistance: "<<subCellBorderDistance<<", cellBorderDistance: "<<cellBorderDistance<<", borderType: "<<borderType<<"\n";
    }*/
  
  return _borderDistance;
}

// Select cell - Changed!
CellBase* CellVirtual::selectCell(const Vector3D& position, const Vector3D& direction, double t) {
  CellBase* cell=pCell;
  // Is this OK?
  delete this;
  return cell->selectCell(position,direction,t); // Changed!
}

// Select cell neighbour
CellBase* CellVirtual::selectCellNeighbour(const Vector3D& entryPosition, const Vector3D& entryDirection, const double& entryTime) {
  CellBase* cell=pCell;
  // Is this OK?
  delete this;
  return cell->selectCellNeighbour(entryPosition,entryDirection,entryTime);
}
  
// Select next cell
CellBase* CellVirtual::selectNextCell(const Vector3D& position, const Vector3D& direction, const double& t) {
  CellBase* cell=pCell;
  // Is this OK?
  delete this;
  return cell->selectNextCell(position,direction,t);
}

// Constructor
CellVirtualState::CellVirtualState(CellVirtual* cell) {
  index=cell->index();
  subIndex=cell->subIndex();
  positionOffset=cell->positionOffset;
}

// Load cell type
CellType mc::loadCellType(const YAML::Node& data) {
  CellType cellType;

  if (data.as<string>().compare("container")==0) return cellContainer;
  else if (data.as<string>().compare("subcell")==0) return cellSub;
  else return cellNormal;
}

// Save cell type
string mc::saveCellType(const CellType& cellType) {

  switch(cellType) {
  case cellContainer : return "container";
  case cellSub : return "subcell";
  default : return "normal";
  }
}

// Constructor
BoundFreeS::BoundFreeS(Cell* _cell) : cell(_cell) {};

// Bound-free source function
double BoundFreeS::operator()(double nu) const { 
  return cell->boundFreeSCalc(nu);
}

// Bound-free source function
vector<double> BoundFreeS::operator()(FrequencyBinIterator nuBegin, FrequencyBinIterator nuEnd, EdgeType edgeType) const { 
  return cell->boundFreeSOMP(nuBegin,nuEnd,edgeType);
}

// Constructor - New!
BoundFreeKappa::BoundFreeKappa(Cell* _cell) : cell(_cell) {};

// Bound-free opacity - New!
double BoundFreeKappa::operator()(double nu) const { 
  return cell->boundFreeAbsKappaCalc(nu);
}

// Bound-free opacity - New!
vector<double> BoundFreeKappa::operator()(FrequencyBinIterator nuBegin, FrequencyBinIterator nuEnd, EdgeType edgeType) const { 
  return cell->boundFreeAbsKappaOMP(nuBegin,nuEnd,edgeType);
}

// Blackbody factor
double BBFactor::operator()(double nu) const { 
  return 2*h*pow(nu,3)*pow(c,-2);
  //return 2*pysics::h*pow(nu,3)*pow(pysics::c,-2);
}

// Constructor
BMFactor::BMFactor(double _T) : T(_T) {};

// Blackbody factor
double BMFactor::operator()(double nu) const { 
  return exp(-(h*nu)/(k*T));
  //return exp(-(pysics::h*nu)/(pysics::k*T));
}

// Check if cell border
bool mc::isCellBorder(const BorderType& borderType) {
  switch(borderType) {
  case btCellBorder :
  case btCellBorderInner :
  case btCellBorderOuter : return true;
  default : return false;
  }
}

// Constructor
// Subcells: Works
// Containers: Works
Cell::Cell(MStateSolver* _mStateSolver, EOS* _eos, CellConfig* _config, boost::mpi::communicator* _mpiCom) : pFillFactor(1.0), pFreeFreeOnTheSpotNu(0), bBFactorUpdate(true), bMFactorUpdate(true), peRadio(0), peRadioOld(0), pNonThermalHeating(1e-99), pNonThermalIonization(0), pNonThermalExcitation(0), pFreeFreeEtaBoost(1.0), pFreeFreeKappaBoost(1.0), pComptonKappaBoost(1.0), pBoundFreeCoolingBoost(1.0), pFreeFreeCoolingBoost(1.0), pCollCoolingBoost(1.0), pRadCoolingBoost(1.0), pCoolingBoost(1.0), pNonThermalHeatingBoost(1.0), pNonThermalExcBoost(1.0), pNonThermalIonBoost(1.0), pNonThermalExcIonBoost(1.0), pNonThermalBoost(1.0), pMarkovPThermBoost(1.0), markovPCTBoost(0), pGreyScatterKappa(0.0), pDustAbsKappa(0.0), pKappaFloor(0.0), radUpdated(false), pTDiff(noT) { // Changed!
  if (_config==NULL) config = new CellConfig();
  else config=_config;
  //mStateSolver=_mStateSolver;
  // Changed - Each cell need a separate solver
  // But should be like this, right?
  // if (mStateSolver!=NULL)  mStateSolver=_mStateSolver->copy();
  mStateSolver=_mStateSolver->copy();
  //if (_mStateSolver!=NULL) mStateSolver=_mStateSolver->copy();
  //else mStateSolver==NULL;
  eos=_eos;
  mpiCom=_mpiCom;
  omp_init_lock(&boundFreeTableLock);
  omp_init_lock(&boundFreeSTableLock);
  omp_init_lock(&bBFactorLock);
  omp_init_lock(&bMFactorLock);
  return;
}

// Copy constructor
// packetHistory is currently not owned by the cell so only copy pointers
// config and eos are currently not owned by the cell so only copy pointers
// cellNeighbour is owned by the grid so have to be updated elsewhere if needed
// line, edge, majorEdge, collExctitePList, nonThermalExcitePList and markovPListTherm are reset - Have to be updated elsewhere
// pBoundFreeAbsKappaTable and pBoundFreeSTable are reset and marked for update (as they contain frequency bin iterators)
// pBBFactorTable and pBMFactorpTable are reset and marked for update (as they contain frequency bin iterators)
// Only copy subCell pointers. The actual cells needs to be copied elsewhere - Not a good solution - Fix!
// Subcells: Works
// Containers: Works
Cell::Cell(const Cell& cell) : pType(cell.pType), pIndex(cell.pIndex), pGrid(cell.pGrid), ptMin(cell.ptMin), ptMax(cell.ptMax), pfExp(cell.pfExp), cellNeighbour(cell.cellNeighbour), prho(cell.prho), pT(cell.pT), pTOld(cell.pTOld), pTDiff(cell.pTDiff), pne(cell.pne), eos(cell.eos), J(cell.J), nuMean(cell.nuMean), pTR(cell.pTR), pW(cell.pW), pFillFactor(cell.pFillFactor), pNCells(cell.pNCells), pFreeFreeCooling(cell.pFreeFreeCooling), pFreeFreeOnTheSpotNu(cell.pFreeFreeOnTheSpotNu), pBoundFreeCoolingSP(cell.pBoundFreeCoolingSP), pCollCooling(cell.pCollCooling), pCTCooling(cell.pCTCooling), mpiCom(cell.mpiCom), pBoundFreeAbsKappaTable(), boundFreeTableUpdate(true), boundFreeTableLock(cell.boundFreeTableLock), pBoundFreeSTable(), boundFreeSTableUpdate(true), boundFreeSTableLock(cell.boundFreeSTableLock), pBBFactorTable(), bBFactorUpdate(true), bBFactorLock(cell.bBFactorLock), pBMFactorTable(), bMFactorUpdate(true), bMFactorLock(cell.bMFactorLock), boundFreeCutOffUpdate(true), collExcitePList(), CTExcitePList(), nonThermalExcitePList(), markovPListTherm(), markovPListCT(), peRadio(cell.peRadio), peRadioOld(cell.peRadioOld), pNonThermalHeating(cell.pNonThermalHeating), pNonThermalIonization(cell.pNonThermalIonization), pNonThermalExcitation(cell.pNonThermalExcitation), mStateSolver(NULL), atom(cell.atom), ctReaction(cell.ctReaction), subCell(cell.subCell), line(0), edge(0), packetHistory(cell.packetHistory), config(cell.config), responsible(cell.responsible), nu(cell.nu), mu(cell.mu), Jnu(cell.Jnu), Inu(cell.Inu), etaNu(cell.etaNu), kappaJNu(cell.kappaJNu), kappaBFJNu(cell.kappaBFJNu), kappaFFJNu(cell.kappaFFJNu), kappaBBJNu(cell.kappaBBJNu), kappaESJNu(cell.kappaESJNu), kappaNu(cell.kappaNu), kappaBFNu(cell.kappaBFNu), kappaFFNu(cell.kappaFFNu), kappaBBNu(cell.kappaBBNu), kappaESNu(cell.kappaESNu), kappaHNu(cell.kappaHNu), kappaBFHNu(cell.kappaBFHNu), kappaFFHNu(cell.kappaFFHNu), kappaBBHNu(cell.kappaBBHNu), kappaESHNu(cell.kappaESHNu), nuMeanNu(cell.nuMeanNu), nuLine(cell.nuLine), JLine(cell.JLine), nuBB(cell.nuBB), nJ(cell.nJ), nJLine(cell.nJLine), radUpdated(cell.radUpdated), nuOld(cell.nuOld), muOld(cell.muOld), JnuOld(cell.JnuOld), InuOld(cell.InuOld), etaNuOld(cell.etaNuOld), kappaJNuOld(cell.kappaJNuOld), kappaBFJNuOld(cell.kappaBFJNuOld), kappaFFJNuOld(cell.kappaFFJNuOld), kappaBBJNuOld(cell.kappaBBJNuOld), kappaESJNuOld(cell.kappaESJNuOld), kappaHNuOld(cell.kappaHNuOld), kappaBFHNuOld(cell.kappaBFHNuOld), kappaFFHNuOld(cell.kappaFFHNuOld), kappaBBHNuOld(cell.kappaBBHNuOld), kappaESHNuOld(cell.kappaESHNuOld), nuMeanNuOld(cell.nuMeanNuOld), JLineOld(cell.JLineOld), nuLineOld(cell.nuLineOld), nuBBOld(cell.nuBBOld), nJOld(cell.nJOld), nJLineOld(cell.nJLineOld), pOnTheSpotNu(cell.pOnTheSpotNu), nuBoost(cell.nuBoost), boost(cell.boost), pFreeFreeEtaBoost(cell.pFreeFreeEtaBoost), pFreeFreeKappaBoost(cell.pFreeFreeKappaBoost), pBoundFreeKappaBoostTable(cell.pBoundFreeKappaBoostTable), pComptonKappaBoost(cell.pComptonKappaBoost), pBoundFreeCoolingBoost(cell.pBoundFreeCoolingBoost),  pFreeFreeCoolingBoost(cell.pFreeFreeCoolingBoost), pCollCoolingBoost(cell.pCollCoolingBoost), pRadCoolingBoost(cell.pRadCoolingBoost), pCoolingBoost(cell.pCoolingBoost), pNonThermalHeatingBoost(cell.pNonThermalHeatingBoost), pNonThermalExcBoost(cell.pNonThermalExcBoost), pNonThermalIonBoost(cell.pNonThermalIonBoost), pNonThermalExcIonBoost(cell.pNonThermalExcIonBoost), pNonThermalBoost(cell.pNonThermalBoost), pMarkovPThermBoost(cell.pMarkovPThermBoost), markovPCTBoost(cell.markovPCTBoost), freeFreeEtaP(cell.freeFreeEtaP), pGreyScatterKappa(cell.pGreyScatterKappa), pDustAbsKappa(cell.pDustAbsKappa), pKappaFloor(cell.pKappaFloor), majorEdge(0) { // Changed!
  int i;

  // Update transition probability lists
  // Removed this - so has to be explicitly updated
  //if (config->transTable) { for (i=0;i<atom.size();i++) atom[i].updateTransPList(); }

  // Copy matter state solver
  if (cell.mStateSolver!=NULL) mStateSolver=cell.mStateSolver->copy();

  // For each charge-transfer reaction - New!
  for (i=0;i<ctReaction.size();i++) {
    // Re-construct reaction (i.e. update the bound-free transition pointers)
    ctReaction[i].construct(ctReaction[i].data,atom);
    // Add reaction to corresponding bound-free transitions
    ctReaction[i].downTrans->CTDReaction.push_back(&(ctReaction[i]));
    ctReaction[i].upTrans->CTUReaction.push_back(&(ctReaction[i]));
  }
}

// Assignment operator
// packetHistory is currently not owned by the cell so only copy pointers
// config and eos are currently not owned by the cell so only copy pointers
// cellNeighbour is owned by the grid so have to be updated elsewhere if needed
// line, edge, majorEdge, collExctitePList, nonThermalExcitePList and markovPListThermare reset - Have to be updated elsewhere
// pBoundFreeAbsKappaTable and pBoundFreeSTable are reset and marked for update (as they contain frequency bin iterators)
// pBBFactorTable and pBMFactorpTable are reset and marked for update (as they contain frequency bin iterators)
// Only copy subCell pointers. The actual cells needs to be copied elsewhere - Not a good solution - Fix!
// Subcells: works
// Containers: works
Cell& Cell::operator=(const Cell& cell) {
  int i;

  if (&cell!=this) {
    pType=cell.pType;
    pIndex=cell.pIndex;
    pGrid=cell.pGrid;
    ptMin=cell.ptMin;
    ptMax=cell.ptMax;
    pfExp=cell.pfExp;
    cellNeighbour=cell.cellNeighbour;
    prho=cell.prho;
    pT=cell.pT;
    pTOld=cell.pTOld;
    pTDiff=cell.pTDiff;
    pne=cell.pne;
    eos=cell.eos;
    J=cell.J;
    nuMean=cell.nuMean;
    pTR=cell.pTR;
    pW=cell.pW;
    pFillFactor=cell.pFillFactor;
    pNCells=cell.pNCells;
    pFreeFreeCooling=cell.pFreeFreeCooling;
    pFreeFreeOnTheSpotNu=cell.pFreeFreeOnTheSpotNu;
    pBoundFreeCoolingSP=cell.pBoundFreeCoolingSP;
    pCollCooling=cell.pCollCooling; 
    pCTCooling=cell.pCTCooling;
    mpiCom=cell.mpiCom;
    //pBoundFreeAbsKappaTable=cell.pBoundFreeAbsKappaTable; // Removed!
    pBoundFreeAbsKappaTable=NuInterpolator<BoundFreeKappa>(); // Changed!
    boundFreeTableUpdate=true;
    boundFreeTableLock=cell.boundFreeTableLock;
    pBoundFreeSTable=NuTabulator<BoundFreeS>();
    boundFreeSTableUpdate=true;
    boundFreeSTableLock=cell.boundFreeSTableLock;
    pBBFactorTable=NuTabulator<BBFactor>();
    bBFactorUpdate=true;
    bBFactorLock=cell.bBFactorLock;
    pBMFactorTable=NuTabulator<BMFactor>();
    bMFactorUpdate=true;
    bMFactorLock=cell.bMFactorLock;
    //boundFreeCutOffUpdate=cell.boundFreeCutOffUpdate;
    boundFreeCutOffUpdate=true; // Testing!!!
    collExcitePList.resize(0);
    CTExcitePList.resize(0);
    nonThermalExcitePList.resize(0);
    markovPListTherm.resize(0);
    markovPListCT.resize(0); // New!
    peRadio=cell.peRadio;
    peRadioOld=cell.peRadioOld;
    pNonThermalHeating=cell.pNonThermalHeating;
    pNonThermalIonization=cell.pNonThermalIonization;
    pNonThermalExcitation=cell.pNonThermalExcitation;
    //mStateSolver=cell.mStateSolver;
    atom=cell.atom;
    ctReaction=cell.ctReaction;
    subCell=cell.subCell;
    line.resize(0);
    edge.resize(0);
    packetHistory=cell.packetHistory;
    config=cell.config;
    responsible=cell.responsible;
    nu=cell.nu;
    mu=cell.mu;
    Jnu=cell.Jnu;
    Inu=cell.Inu;
    etaNu=cell.etaNu;
    kappaJNu=cell.kappaJNu; // New!
    kappaBFJNu=cell.kappaBFJNu; // New!
    kappaFFJNu=cell.kappaFFJNu; // New!
    kappaBBJNu=cell.kappaBBJNu; // New!
    kappaESJNu=cell.kappaESJNu; // New!
    kappaNu=cell.kappaNu; // New!
    kappaBFNu=cell.kappaBFNu; // New!
    kappaFFNu=cell.kappaFFNu; // New!
    kappaBBNu=cell.kappaBBNu; // New!
    kappaESNu=cell.kappaESNu; // New!
    kappaHNu=cell.kappaHNu; // New!
    kappaBFHNu=cell.kappaBFHNu; // New!
    kappaFFHNu=cell.kappaFFHNu; // New!
    kappaBBHNu=cell.kappaBBHNu; // New!
    kappaESHNu=cell.kappaESHNu; // New!
    /*lNu=cell.lNu; // New!
    nAbsNu=cell.nAbsNu; // New!
    nAbsBFNu=cell.nAbsBFNu; // New!
    nAbsFFNu=cell.nAbsFFNu; // New!
    nAbsBBNu=cell.nAbsBBNu; // New!
    nAbsESNu=cell.nAbsESNu; // New!*/
    nuMeanNu=cell.nuMeanNu;
    nuLine=cell.nuLine;
    JLine=cell.JLine;
    nuBB=cell.nuBB;
    nJ=cell.nJ;
    nJLine=cell.nJLine;
    radUpdated=cell.radUpdated;
    nuOld=cell.nuOld;
    muOld=cell.muOld;
    JnuOld=cell.JnuOld;
    InuOld=cell.InuOld;
    etaNuOld=cell.etaNuOld; // Bug fix!
    kappaJNuOld=cell.kappaJNuOld; // New!
    kappaBFJNuOld=cell.kappaBFJNuOld; // New!
    kappaFFJNuOld=cell.kappaFFJNuOld; // New!
    kappaBBJNuOld=cell.kappaBBJNuOld; // New!
    kappaESJNuOld=cell.kappaESJNuOld; // New!
    kappaHNuOld=cell.kappaHNuOld; // New!
    kappaBFHNuOld=cell.kappaBFHNuOld; // New!
    kappaFFHNuOld=cell.kappaFFHNuOld; // New!
    kappaBBHNuOld=cell.kappaBBHNuOld; // New!
    kappaESHNuOld=cell.kappaESHNuOld; // New!
    /*lNuOld=cell.lNuOld; // New!
    nAbsNuOld=cell.nAbsNuOld; // New!
    nAbsBFNuOld=cell.nAbsBFNuOld; // New!
    nAbsFFNuOld=cell.nAbsFFNuOld; // New!
    nAbsBBNuOld=cell.nAbsBBNuOld; // New!
    nAbsESNuOld=cell.nAbsESNuOld; // New!*/
    nuMeanNuOld=cell.nuMeanNuOld;
    JLineOld=cell.JLineOld;
    nuLineOld=cell.nuLineOld;
    nuBBOld=cell.nuBBOld;
    nJOld=cell.nJOld;
    nJLineOld=cell.nJLineOld;
    pOnTheSpotNu=cell.pOnTheSpotNu;
    nuBoost=cell.nuBoost;
    boost=cell.boost;
    pFreeFreeEtaBoost=cell.pFreeFreeEtaBoost;
    pFreeFreeKappaBoost=cell.pFreeFreeKappaBoost;
    pBoundFreeKappaBoostTable=cell.pBoundFreeKappaBoostTable;
    pComptonKappaBoost=cell.pComptonKappaBoost;
    pBoundFreeCoolingBoost=cell.pBoundFreeCoolingBoost;
    pFreeFreeCoolingBoost=cell.pFreeFreeCoolingBoost;
    pCollCoolingBoost=cell.pCollCoolingBoost;
    pRadCoolingBoost=cell.pRadCoolingBoost;
    pCoolingBoost=cell.pCoolingBoost;
    pNonThermalHeatingBoost=cell.pNonThermalHeatingBoost;
    pNonThermalExcBoost=cell.pNonThermalExcBoost;
    pNonThermalIonBoost=cell.pNonThermalIonBoost;
    pNonThermalExcIonBoost=cell.pNonThermalExcIonBoost;
    pNonThermalBoost=cell.pNonThermalBoost;
    pMarkovPThermBoost=cell.pMarkovPThermBoost;
    markovPCTBoost=cell.markovPCTBoost; // New!
    freeFreeEtaP=cell.freeFreeEtaP;
    pGreyScatterKappa=cell.pGreyScatterKappa; // New!
    pDustAbsKappa=cell.pDustAbsKappa; // New!
    pKappaFloor=cell.pKappaFloor; // New!
    majorEdge.resize(0); // New!

    // Update transition probability lists
    // Removed this - so has to be explicitly updated
    //if (config->transTable) { for (i=0;i<atom.size();i++) atom[i].updateTransPList(); }

    // Copy matter state solver
    if (mStateSolver!=NULL) delete mStateSolver;
    if (cell.mStateSolver!=NULL) mStateSolver=cell.mStateSolver->copy();

    // For each charge-transfer reaction - New!
    for (i=0;i<ctReaction.size();i++) {
      // Re-construct reaction (i.e. update the bound-free transition pointers)
      ctReaction[i].construct(ctReaction[i].data,atom);
      // Add reaction to corresponding bound-free transitions
      ctReaction[i].downTrans->CTDReaction.push_back(&(ctReaction[i]));
      ctReaction[i].upTrans->CTUReaction.push_back(&(ctReaction[i]));
    }
  }
}

// Destructor
// Subcells: Works
// Containers: Works
Cell::~Cell() {
  int i;

  //if (master()) cout<<"Cell::~Cell, index: "<<index()<<"\n";

  // Delete sub cells
  for (i=0;i<subCell.size();i++) {
    delete(subCell[i]);
  }

  // Delete matter state solver
  if (mStateSolver!=NULL) delete mStateSolver;

  // Destroy locks (openmp)
  omp_destroy_lock(&boundFreeTableLock);
  omp_destroy_lock(&boundFreeSTableLock);
  omp_destroy_lock(&bBFactorLock);
  omp_destroy_lock(&bMFactorLock);
}

// Set atom data references
// Used during cell copy or assigment - The source cell needs to be provided as an argument
// Subcells: Works
// Containers: Works
void Cell::setAtomDataReferences(AtomDataList& atomDataList, Cell* cell) {
  int i,j,k;

  // If container for each sub cell set atom data references
  if (pType==cellContainer) for (i=0;i<subCell.size();i++) subCell[i]->setAtomDataReferences(atomDataList,cell->subCell[i]);
  // For each atom
  for (i=0;i<atom.size();i++) {
    // Set data pointer
    atom[i].data=&(atomDataList.atom[cell->atom[i].data->index]);
    // For each ionization state
    for (j=0;j<atom[i].iState.size();j++) {
      // Set data pointer
      atom[i].iState[j].data=&(atom[i].data->iState[cell->atom[i].iState[j].data->index]);
      // For each bound state
      for (k=0;k<atom[i].iState[j].bState.size();k++) {
	// Set data pointer
	atom[i].iState[j].bState[k].data=&(atom[i].iState[j].data->bState[cell->atom[i].iState[j].bState[k].data->index]);
      }
    }
    // For each isotope
    for (j=0;j<atom[i].isotope.size();j++) {
      // Set data pointer
      atom[i].isotope[j].data=&(atom[i].data->isotope[cell->atom[i].isotope[j].data->index]);
    }
  }
  // For each charge-transfer reaction - New!
  for (i=0;i<ctReaction.size();i++) {
    // Set data pointer
    ctReaction[i].data=&(atomDataList.ctReaction[cell->ctReaction[i].data->index]);
  }
}

// Get grid back reference pointer
// Subcells: Works
// Containers: Works
Grid* Cell::grid() const {
  return pGrid;
}

// Get cell type
// Subcells: Works
// Containers: Works
int Cell::type() const {
  return pType;
}

// Get cell index
// Subcells: Works
// Containers: Works
int Cell::index() const {
  return pIndex;
}

// Set cell index
// Subcells: Works
// Containers: Works
void Cell::index(const int& _index) {
  pIndex=_index;
}

// Get sub cell index
// Subcells: Not applicable
// Containers: Not applicable
int Cell::subIndex() const {
  return noCell;
}

// Get minimum time
// Subcells: Works
// Containers: Works
double Cell::tMin() const {
  return ptMin;
}

// Set minimum time
// Subcells: Works
// Containers: Works
void Cell::tMin(const double& _tMin) {
  ptMin=_tMin;
}

// Get maximum time
// Subcells: Works
// Containers: Works
double Cell::tMax() const {
  return ptMax;
}

// Set maximum time
// Subcells: Works
// Containers: Works
void Cell::tMax(const double& _tMax) {
  ptMax=_tMax;
}

// Get (centered) time
// Subcells: Works
// Containers: Works
double Cell::t() const {
  return (ptMin+ptMax)/2;
}

// Get fExp
// Subcells: Works
// Containers: Works
double Cell::fExp() const {
  return pfExp;
}

// Get rho
// Subcells: Works
// Containers: Works
double Cell::rho() const {
  int i; // New!

  // If container - Volume-average density over subcells and return - New!
  if (type()==cellContainer) { double _rho=0; for (i=0;i<subCell.size();i++) _rho+=subCell[i]->rho()*subCell[i]->fillFactor(); return _rho; }

  return prho;
}

// Set rho
// Subcells: Works
// Containers: Not applicable
void Cell::rho(const double& _rho) {
  prho=_rho;
}

// Get number density
// Subcells: Works
// Containers: Works
double Cell::n() const {
  double pn=0;
  int i;

  // If container - Volume-average number density over subcells and return - New!
  if (type()==cellContainer) { for (i=0;i<subCell.size();i++) pn+=subCell[i]->n()*subCell[i]->fillFactor(); return pn; }

  for (i=0;i<atom.size();i++) pn+=atom[i].n();

  return pn;
}

// Get T
// Subcells: Works
// Containers: Works
double Cell::T() const {
  int i; // New!

  // If container - Number-average temperature over subcells and return - New!
  //if (type()==cellContainer) { double _T=0; for (i=0;i<subCell.size();i++) _T+=subCell[i]->T()*(subCell[i]->n()+subCell[i]->ne())*subCell[i]->fillFactor(); _T=_T/(n()+ne()); return _T; }  

  // If container - Radiation-energy-average temperature over subcells and return - New!
  if (type()==cellContainer) { double _T=0; double fillTot=0; for (i=0;i<subCell.size();i++) fillTot+=subCell[i]->fillFactor(); for (i=0;i<subCell.size();i++) _T+=pow(subCell[i]->T(),4.0)*subCell[i]->fillFactor()/fillTot; _T=pow(_T,1.0/4.0); return _T; }

  return pT;
}

// Set T
// Subcells: Works
// Containers: Not applicable
void Cell::T(const double& _T) {
  pT=_T;
}

// Get TDiff - Testing!
// Subcells: Works
// Containers: Works
double Cell::TDiff() const {
  int i; // New!

  // If container - Radiation-energy-average diffusion temperature over subcells and return - New!
  if (type()==cellContainer) { double _TDiff=0; double fillTot=0; for (i=0;i<subCell.size();i++) fillTot+=subCell[i]->fillFactor(); for (i=0;i<subCell.size();i++) _TDiff+=pow(subCell[i]->TDiff(),4.0)*subCell[i]->fillFactor()/fillTot; _TDiff=pow(_TDiff,1.0/4.0); return _TDiff; }

  return pTDiff;
}

// Set TDiff - Testing!
// Subcells: Works
// Containers: Not applicable
void Cell::TDiff(const double& _TDiff) {
  pTDiff=_TDiff;
}

// Get energy (per mass)
// Subcells: Works
// Containers: Works
double Cell::E(double _T) {
  int i; // New!

  // If container - Mass-average energy over subcells and return - New!
  if (type()==cellContainer) { double _E=0; for (i=0;i<subCell.size();i++) _E+=subCell[i]->E(_T)*subCell[i]->rho()*subCell[i]->fillFactor(); _E=_E/rho(); return _E; }

  return eos->E(this,_T);
}

// Get pressure
// Subcells: Works
// Containers: Works
double Cell::P(double _T) {
  int i; // New!

  // If container - Volume-average pressure over subcells and return - New!
  if (type()==cellContainer) { double _P=0; for (i=0;i<subCell.size();i++) _P+=subCell[i]->P(_T)*subCell[i]->fillFactor(); return _P; }

  return eos->P(this,_T);
}

// Get electron number density
// Subcells: Works
// Containers: Works
double Cell::ne() const {
  int i; // New!

  // If container - Volume-average number density over subcells and return - New!
  if (type()==cellContainer) { double _ne=0; for (i=0;i<subCell.size();i++) _ne+=subCell[i]->ne()*subCell[i]->fillFactor(); return _ne; }
  
  return pne;
}

// Set electron number density
// Subcells: Works
// Containers: Not applicable
void Cell::ne(const double& _ne) {
  pne=_ne;
}

// Get electron number density number derivative
double Cell::dNedN(IState* iState) {
  return abs(iState->C());
}

// Get electron number density number derivative
double Cell::dNedN(BState* bState) {
  return abs(bState->iState()->C());
}

// Get electron fraction
// Subcells: Works
// Containers: Works
double Cell::xe() const {
  double pxe;
  pxe=ne()/n(); // Changed!
  return pxe;
}

// Get filling factor
// Subcells: Works
// Containers: Not applicable
double Cell::fillFactor() const {
  return pFillFactor;
}

// Get number of (virtual) cells
// Subcells: Works
// Containers: Not applicable
unsigned int Cell::nCells() const {
  return pNCells;
}

// Get total mass
// Subcells: Works
// Containers: Works
double Cell::M() {
  double pM=0;
  int i;
  // If cell container sum total masses of sub cells
  if (type()==cellContainer) for (i=0;i<subCell.size();i++) pM+=subCell[i]->M();
  // Else calculate total mass
  else pM=rho()*V(); // Changed!

  return pM;
}

// Get total mass of atom
// Subcells: Works
// Containers: Works
double Cell::M(const double& Z) {
  double pM=0;
  int i;
  // If cell container sum total masses of sub cells
  if (type()==cellContainer) for (i=0;i<subCell.size();i++) pM+=subCell[i]->M(Z);
  // Else
  else {
    // For each atom
    for (i=0;i<atom.size();i++)
	// If atom found
	if (atom[i].Z()==Z) {
	  // Calculate total mass of isotope
	  pM=atom[i].rho()*V(); // Changed!
	  // Break loop;
	  break;
	}
  }

  return pM;
}

// Get total mass of isotope
// Subcells: Works
// Containers: Works
double Cell::M(const double& Z, const double& N) {
  double pM=0;
  int i,j;
  // If cell container sum total masses of sub cells
  if (type()==cellContainer) for (i=0;i<subCell.size();i++) pM+=subCell[i]->M(Z,N);
  // Else
  else {
    // For each atom
    for (i=0;i<atom.size();i++)
      // For each isotope
      for (j=0;j<atom[i].isotope.size();j++)
	// If isotope found
	if (atom[i].Z()==Z and atom[i].isotope[j].N()==N) {
	  // Calculate total mass of isotope
	  pM=atom[i].isotope[j].rho()*V(); // Changed!
	  // Break loop;
	  break;
	}
  }

  return pM;
}

// Calculate velocity (assuming homologoues expansion)
// Subcells: Works
// Containers: Works
double Cell::v(const Vector3D& position, double _t) const {
  if (config->steadyState or _t==noTime) _t=t();
  // Calculate radial distance
  double r=position.norm();
  return r*pfExp/_t;
}

// Calculate velocity gradient
// Subcells: Works
// Containers: Works
double Cell::dvdr(double _t) const {
  if (config->steadyState or _t==noTime) _t=t();
  return 1/_t;
}

// Get radiation temperature 
// Subcells: Works
// Containers: Not applicable
double Cell::TR() const {
  return pTR;
}

// Set radiation temperature 
// Subcells: Works
// Containers: Not applicable
void Cell::TR(const double& _TR) {
  pTR=_TR;
}

// Get dilution factor
// Subcells: Works
// Containers: Not applicable
double Cell::W() const {
  return pW;
}

// Set dilution factor
// Subcells: Works
// Containers: Not applicable
void Cell::W(const double& _W) {
  pW=_W;
}

// Get (radition) energy density temperature
// Subcells: Works
// Containers: Not applicable
double Cell::TJ() const {
  return pTJ;
}

// Set (radition) energy density temperature - New!
// Subcells: Works
// Containers: Not applicable
void Cell::TJ(const double& _TJ) {
  pTJ=_TJ;
}

// Get (radiation) energy density temperature (based on the blackbody regions)
// Subcells: Works
// Containers: Not applicable
double Cell::TJBB() const {
  return pTJBB;
}

// Get radioactive energy deposition (per mass)
// Subcells: Works
// Containers: Works
double Cell::eRadio() const {
  return peRadioOld;
}

// Set radioacive energy deposition (per mass)
// Subcells: Works
// Containers: Not applicable
void Cell::eRadio(const double& _eRadio) {
  peRadioOld=_eRadio;
}

// In cell (to be implemented by derived class) - Changed!
bool Cell::inCell(const Vector3D& position, double t, bool virtualCell) {
  return false;
}

// Calculate border distance (to be implemented by derived class) - Changed!
double Cell::borderDistance(const Vector3D& position, const Vector3D& direction, BorderType& borderType, double t, bool virtualCell, bool log) {
  return 0;
}

// Get volume (to be implement by derived class)
double Cell::V(double t) {
  return 0;
}

// Get random direction
Vector3D Cell::randomDirection(const CellLocation& cellLocation) {
  return Vector3D(0,0,0);
}

// Get random position - Changed!
Vector3D Cell::randomPosition(const CellLocation& cellLocation, double _t, bool virtualCell) {
  return Vector3D(0,0,0);
}
 
// Select cell - Changed!
// Subcells: Not applicable
// Containers: Works
CellBase* Cell::selectCell(const Vector3D& position, const Vector3D& direction, double t) {
  CellBase* cell=NULL;
  double fillTot=0,fillSum=0,fillChoice;
  int i;
  // If cell container
  if (pType==cellContainer) {
    // Calculate total fill factor
    for (i=0; i<subCell.size(); i++) fillTot+=pow(subCell[i]->fillFactor(),(2.0/3.0));
    // Get random fill choice
    fillChoice=randomize(0,fillTot);
    // For each subcell
    for (i=0; i<subCell.size(); i++) {
      // If fill choice in fill intervall
      if (fillChoice>=fillSum and fillChoice<=fillSum+pow(subCell[i]->fillFactor(),(2.0/3.0))) {
	// Create virtual cell and set cell pointer
	cell=new CellVirtual(this,subCell[i],position,direction,cellBorder,t); // Changed!
	// Break loop
	break;
      }
      // Increase fill sum with fill factor
      else fillSum+=pow(subCell[i]->fillFactor(),(2.0/3.0));
    }
  }
  // Set cell pointer to this cell
  else cell=this;

  // Return cell pointer
  return cell;
}

// Select cell neighbour
// Subcells: Not applicable
// Containers: Works
CellBase* Cell::selectCellNeighbour(const Vector3D& entryPosition, const Vector3D& entryDirection, const double& entryTime) {
  int i;
  // For each neighbour cell
  for (i=0;i<cellNeighbour.size();i++) {
    // If inside border
    if ((*cellNeighbour[i])->inCell(entryPosition,entryTime)) {
      // Select cell and return cell pointer
      return (*cellNeighbour[i])->selectCell(entryPosition,entryDirection,entryTime); // Changed!
    }
  }
  
  return NULL;
}

// Select next cell
// Subcells: Not applicable
// Containers: Does not work as we want! Use selectCellNeighbour.
CellBase* Cell::selectNextCell(const Vector3D& position, const Vector3D& direction, const double& t) {
  Vector3D entryPosition;
  BorderType borderType; // New!
  double distance,entryTime,smallStep=1E-99;
  // Calculate distance to next cell
  distance=borderDistance(position,direction,borderType,t); // Changed!
  // Calculate entry position in next cell
  entryPosition=position+direction*(distance+smallStep)/pfExp;
  // Calculate entry time in next cell
  entryTime=t+(distance+smallStep)/c;
  // Select cell neighbour
  CellBase* cell=selectCellNeighbour(entryPosition,direction,entryTime);

  return cell;
}

// Update line list
// Subcells: Works (except subcell indices in logging)
// Containers: Not applicable
void Cell::updateLineList() {
  int i,j,k,l;
  line.resize(0);
  // Select list list
  for (i=0;i<atom.size();i++)
    for (j=0;j<atom[i].iState.size();j++)
      for (k=0;k<atom[i].iState[j].bState.size();k++)
	for (l=0;l<atom[i].iState[j].bState[k].downTransBB.size();l++) {
	  if (config->lineSelector->use(atom[i].iState[j].bState[k].downTransBB[l],lineTau(atom[i].iState[j].bState[k].downTransBB[l]))) {
	    line.push_back(atom[i].iState[j].bState[k].downTransBB[l]);
	  }
	}

  if (master()) cout<<"Cell::updateLineList: index: "<<index()<<", Selected "<<line.size()<<" lines\n";

  // Sort line list
  line.sort();
}

// Update edge list
// Subcells: Works (except subcell indices in logging)
// Containers: Not applicable
void Cell::updateEdgeList() {
  int i,j,k,l;
  edge.resize(0);
  // Select list list
  for (i=0;i<atom.size();i++)
    for (j=0;j<atom[i].iState.size();j++)
      for (k=0;k<atom[i].iState[j].bState.size();k++)
	for (l=0;l<atom[i].iState[j].bState[k].downTransBF.size();l++) {
	  edge.push_back(atom[i].iState[j].bState[k].downTransBF[l]);
	}

  if (master()) cout<<"Cell::updateEdgeList: index: "<<index()<<", Selected "<<edge.size()<<" ionization edges\n";

  // Sort ionization edge list
  edge.sort();
}

// Update matter state
// Subcells: Works (except subcell indices in logging)
// Containers: Not applicable
void Cell::updateMatterState(bool initiate, bool initiateState, bool updateMCDerived) { // Changed!

  int nCells;
  bool calculate;

  // Update matter state
  cout<<"Cell::updateMatterState: index: "<<index()<<", Update matter state\n";
  mStateSolver->update(this,initiate,initiateState);

  // Update derived matter quantities
  //updateMatterDerived(initiate);
  updateMatterDerived(updateMCDerived); // Changed!
}

// Update derived matter quantities
// Subcells: Works (except subcell indices in logging)
// Containers: Not applicable
void Cell::updateMatterDerived(bool updateMCDerived) { // Changed!

  // Update line list
  updateLineList();

  // Update ionization edge list (only needs to be done once - fix)
  updateEdgeList();

  // Update recombinarion correction - New! - Testing!!!
  //updateAlfaCorr();

  // Reset derived quantities
  reset();

  // Update transition probability lists
  if (config->transTable and updateMCDerived) { updateTransPList(); if (master()) cout<<"Cell::updateMatterDerived: index: "<<index()<<", Updated transition probability tables\n"; }
  // Update emission probability tables - New!
  if (config->etaTable and updateMCDerived) { updateEtaPTable(); if (master()) cout<<"Cell::updateMatterDerived: index: "<<index()<<", Updated emission probability tables\n"; }
  // Boost MC probabilities
  if (config->boost and updateMCDerived) { boostMC(); if (master()) cout<<"Cell::updateMatterDerived: index: "<<index()<<", Boosted MC probabilities\n"; }
  // Update collisional excitation probability list
  if (config->collExciteTable and updateMCDerived) { updateCollExcitePList(); if (master()) cout<<"Cell::updateMatterDerived: index: "<<index()<<", Updated collisional excitation probability table\n"; }
  // Update charge-transfer excitation probability list
  if (updateMCDerived) { updateCTExcitePList(); if (master()) cout<<"Cell::updateMatterDerived: index: "<<index()<<", Updated charge-transfer excitation probability table\n"; } // New!
  // Update non-thermal excitation probability list
  if (config->nonThermalExciteTable and updateMCDerived) { updateNonThermalExcitePList(); if (master()) cout<<"Cell::updateMatterDerived: index: "<<index()<<", Updated non-thermal excitation probability table\n"; }

  // Backup temperature
  pTOld=pT;
}

// Synchronize matter state (MPI)
// Subcells: Works (but relies on the uniqueness of index - see Grid::load)
// Containers: Not applicable
void Cell::syncMatterState() {
  //boost::mpi::request request[mpiCom->size()];
  int nRequest=(mpiCom->rank()==responsible)?(mpiCom->size()-1):1; // New!
  boost::mpi::request request[nRequest]; // Changed!
  MStateMPI mState;
  int i,j=0;

  // If responsible - Pack matter state
  if (mpiCom->rank()==responsible) mState.pack(this);

  // If responsible
  if (mpiCom->rank()==responsible) {

    // For each process
    for (i=0;i<mpiCom->size();i++) {
      // If not self
      if (i!=mpiCom->rank()) {
	// Deliver matter state (non-blocking)
	request[j]=mpiCom->isend(i,index(),mState);
	j++;
      }
    }
  }
  // Else (i.e. not responsible)
  else {

    // Collect matter state (non-blocking)
    //request[j]=mpiCom->irecv(responsible,index(),mState);
    request[0]=mpiCom->irecv(responsible,index(),mState); // Changed!
  }

  // Wait for all MPI requests to complete
  //boost::mpi::wait_all(request,request+mpiCom->size());
  boost::mpi::wait_all(request,request+nRequest); // Changed!

  // If not responsible
  if (mpiCom->rank()!=responsible) {

    // Unpack matter state
    mState.unpack(this);
  }
}

// Synchronize derived matter quantities (MPI)
// Subcells: Works
// Containers: Not applicable
void Cell::syncMatterDerived(bool syncMCDerived) {
  MCDerivedMPI mcDerived;

  //if (master()) cout<<"Cell::syncMatterDerived: index: "<<index()<<", Enter\n";

  // Update line list - Hack!
  updateLineList();

  // Update ionization edge list - Hack!
  updateEdgeList();

  // Reset derived quantities
  reset();

  // If synchronization of derived MC quantities requested
  if (syncMCDerived) {

    //if (master() and mpiCom->rank()==responsible) cout<<"Cell::syncMatterDerived: index: "<<index()<<", Pack begin, etaP.size: "<<atom[0].iState[0].bState[0].upTransBF[0]->etaP.size()<<"\n";
    //if (mpiCom->rank()==responsible) cout<<"Cell::syncMatterDerived: Process: "<<mpiCom->rank()<<", index: "<<index()<<", Pack begin, etaP.size: "<<atom[0].iState[0].bState[0].upTransBF[0]->etaP.size()<<"\n";
    
    // If responsible - Pack derived MC quantities
    if (mpiCom->rank()==responsible) mcDerived.pack(this);
    
    //if (master() and mpiCom->rank()==responsible) cout<<"Cell::syncMatterDerived: index: "<<index()<<", Pack end\n";
    //if (mpiCom->rank()==responsible) cout<<"Cell::syncMatterDerived: Process: "<<mpiCom->rank()<<", index: "<<index()<<", Pack end\n";
    
    //if (master()) cout<<"Cell::syncMatterDerived: index: "<<index()<<", Broadcast begin\n";
    
    // Broadcast derived MC quantities
    boost::mpi::broadcast(*mpiCom,mcDerived,responsible);
    
    //if (master()) cout<<"Cell::syncMatterDerived: index: "<<index()<<", Broadcast end\n";
    
    //if (master() and mpiCom->rank()!=responsible) cout<<"Cell::syncMatterDerived: index: "<<index()<<", Unpack begin\n";
    //if (mpiCom->rank()!=responsible) cout<<"Cell::syncMatterDerived: Process: "<<mpiCom->rank()<<", index: "<<index()<<", Unpack begin\n";
    
    // If not responsible - Unpack derived MC quantities
    if (mpiCom->rank()!=responsible) mcDerived.unpack(this);
    
    //if (master() and mpiCom->rank()!=responsible) cout<<"Cell::syncMatterDerived: index: "<<index()<<", Unpack end, etaP.size: "<<atom[0].iState[0].bState[0].upTransBF[0]->etaP.size()<<"\n";
    //if (mpiCom->rank()!=responsible) cout<<"Cell::syncMatterDerived: Process: "<<mpiCom->rank()<<", index: "<<index()<<", Unpack end, etaP.size: "<<atom[0].iState[0].bState[0].upTransBF[0]->etaP.size()<<"\n";
    
    // Update charge-transfer excitation probability list - Hack!
    updateCTExcitePList(); 

    //if (master()) cout<<"Cell::syncMatterDerived: index: "<<index()<<", Updated charge-transfer excitation probability table\n";
  }

  // Backup temperature - Hack!
  pTOld=pT;

  // Testing!
  /*int i,j,k,l;
  TransP* transP;
  for (i=0;i<atom.size();i++) {
    for (j=0;j<atom[i].iState.size();j++) {
      for (k=0;k<atom[i].iState[j].bState.size();k++) {
	for (l=0;l<atom[i].iState[j].bState[k].transPList.size();l++) {
	  transP=&(atom[i].iState[j].bState[k].transPList[l]);
	  if (transP->trans!=NULL) {
	    if (transP->type==radiativeBF and transP->trans->type()!=transClassBF) cout<<"Cell::syncMatterDerived: cell: "<<index()<<", "<<transP->trans->upperState->iState()->name()<<":"<<transP->trans->upperState->getIndex()<<"->"<<transP->trans->lowerState->iState()->name()<<":"<<transP->trans->lowerState->getIndex()<<", Error: (BF) Transition type mismatch\n";
	    if (transP->type==radiativeBB and transP->trans->type()!=transClassBB) cout<<"Cell::syncMatterDerived: cell: "<<index()<<", "<<transP->trans->upperState->iState()->name()<<":"<<transP->trans->upperState->getIndex()<<"->"<<transP->trans->lowerState->iState()->name()<<":"<<transP->trans->lowerState->getIndex()<<", Error: (BB) Transition type mismatch\n";
	  }
	  else cout<<"Cell::syncMatterDerived:  cell: "<<index()<<", "<<atom[i].iState[j].name()<<":"<<atom[i].iState[j].bState[k].getIndex()<<", Error: NULL transition\n";
	}
      }
    }
    }*/

  //if (master()) cout<<"Cell::syncMatterDerived: index: "<<index()<<", Return\n";
}

// Select next resonant line 
// Subcells: Works
// Containers: Not applicable
LineIterator Cell::selectNextLine(const double& nu, const Vector3D& position, const Vector3D& direction, const double& t) const {
  LineIterator lineIterator;
  double mu,nuCMF;

  // Calculate polar angle (about the radius vector)
  mu=direction*position/position.norm();
  // Calculate frequency in the comoving frame
  nuCMF=nu*(1-mu*(v(position,t)/c));
  // Select line from list
  lineIterator=line.find(h*nuCMF);

  return lineIterator;
}

// Check if end of line list
// Subcells: Works
// Containers: Not applicable
bool Cell::endOfLineList(const LineIterator& lineIterator) const {
  if (lineIterator==line.end()) return true;
  return false;
}

// Calculate distance to next resonant line (knowing the line)
// Subcells: Works
// Containers: Not applicable
double Cell::lineDistance(const LineIterator& lineIterator, const double& nu, const Vector3D& position, const Vector3D& direction, const double& t) const {
  double d,mu,nuCMF,nuLine,vLine;
  // Calculate polar angle (about the radius vector)
  mu=direction*position/position.norm();
  // Calculate packet frequency in the comoving frame
  nuCMF=nu*(1-mu*(v(position,t)/c));
  // Get line frequency
  nuLine=(*lineIterator)->Xi()/h;
  // Calculate line velocity distance
  vLine=(1-nuLine/nuCMF)*c;
  // Calculate line distance
  if (config->steadyState) d=vLine/dvdr();
  else d=(vLine/dvdr(t))/(1-vLine/c);

  return d;
}

// Calculate distance to next resonant line (knowing the line and the frequency
// in the comoving frame
// Subcells: Works
// Containers: Not applicable
double Cell::lineDistance(const LineIterator& lineIterator, const double& nuCMF, double _t) {
  double nuLine,vLine,d;
  // Get line frequeny
  nuLine=(*lineIterator)->Xi()/h;
  // Calculate line velocity distance
  vLine=(1-nuLine/nuCMF)*c;
  // Calculate line distance
  if (config->steadyState) d=vLine/dvdr();
  else d=(vLine/dvdr(_t))/(1-vLine/c);
  
  return d;
}

// Select next ionization edge
// Subcells: Works
// Containers: Not applicable
EdgeIterator Cell::selectNextEdge(const double& nu, const Vector3D& position, const Vector3D& direction, const double& t) const {
  EdgeIterator edgeIterator;
  double mu,nuCMF;

  // Calculate polar angle (about the radius vector)
  mu=direction*position/position.norm();
  // Calculate frequency in the comoving frame
  nuCMF=nu*(1-mu*(v(position,t)/c));
  // Select edge from list
  edgeIterator=edge.find(h*nuCMF);

  return edgeIterator;
}

// Check if end of ionization edge list
// Subcells: Works
// Containers: Not applicable
bool Cell::endOfEdgeList(const EdgeIterator& edgeIterator) const {
  if (edgeIterator==edge.end()) return true;
  return false;
}

// Calculate distance to next ionization edge (knowing the edge)
// Subcells: Works
// Containers: Not applicable
double Cell::edgeDistance(const EdgeIterator& edgeIterator, const double& nu, const Vector3D& position, const Vector3D& direction, const double& t) const {
  double d,mu,nuCMF,nuEdge,vEdge;
  // Calculate polar angle (about the radius vector)
  mu=direction*position/position.norm();
  // Calculate packet frequency in the comoving frame
  nuCMF=nu*(1-mu*(v(position,t)/c));
  // Get edge frequency
  nuEdge=(*edgeIterator)->Xi()/h;
  // Calculate edge velocity distance
  vEdge=(1-nuEdge/nuCMF)*c;
  // Calculate edge distance
  if (config->steadyState) d=vEdge/dvdr();
  else d=(vEdge/dvdr(t))/(1-vEdge/c);

  return d;
}

// Calculate distance to next ionization edge (knowing the edge and the frequency)
// in the comoving frame
// Subcells: Works
// Containers: Not applicable
double Cell::edgeDistance(const EdgeIterator& edgeIterator, const double& nuCMF, double _t) {
  double nuEdge,vEdge,d;
  // Get edge frequeny
  nuEdge=(*edgeIterator)->Xi()/h;
  // Calculate edge velocity distance
  vEdge=(1-nuEdge/nuCMF)*c;
  // Calculate edge distance
  if (config->steadyState or _t==noTime) d=vEdge/dvdr();
  else d=(vEdge/dvdr(_t))/(1-vEdge/c);

  return d;
}

// Select next boost bin - New!
// Subcells: Works
// Containers: Not applicable
FrequencyBinIterator Cell::selectNextBoostBin(const double& nu, const Vector3D& position, const Vector3D& direction, const double& t) const {
  FrequencyBinIterator boostBinIterator;
  double mu,nuCMF;

  // Calculate polar angle (about the radius vector)
  mu=direction*position/position.norm();
  // Calculate frequency in the comoving frame
  nuCMF=nu*(1-mu*(v(position,t)/c));
  // Select boost bin from list
  boostBinIterator=nuBoost.find(nuCMF);

  return boostBinIterator;
}

// Check if end of boost bin list - New
// Subcells: Works
// Containers: Not applicable
bool Cell::endOfBoostBinList(const FrequencyBinIterator& boostBinIterator) const {
  if (boostBinIterator==nuBoost.end()) return true;
  return false;
}

// Get end of boost bin list - New
// Subcells: Works
// Containers: Not applicable
FrequencyBinIterator Cell::endOfBoostBinList() {
  return nuBoost.end();
}

// Check if beginning of boost bin list - New
// Subcells: Works
// Containers: Not applicable
bool Cell::beginOfBoostBinList(const FrequencyBinIterator& boostBinIterator) const {
  if (boostBinIterator==nuBoost.begin()) return true;
  return false;
}

// Calculate distance to next boost bin (knowing the boost bin) - New!
// Subcells: Works
// Containers: Not applicable
double Cell::boostBinDistance(const FrequencyBinIterator& boostBinIterator, const double& nu, const Vector3D& position, const Vector3D& direction, const double& t) const {
  double d,mu,nuCMF,nuBoostBin,vBoostBin;
  // Calculate polar angle (about the radius vector)
  mu=direction*position/position.norm();
  // Calculate packet frequency in the comoving frame
  nuCMF=nu*(1-mu*(v(position,t)/c));
  // Get boost bin (red egde) frequency
  nuBoostBin=boostBinIterator->min;
  // Calculate boost bin velocity distance
  vBoostBin=(1-nuBoostBin/nuCMF)*c;
  // Calculate boost bin distance
  if (config->steadyState) d=vBoostBin/dvdr();
  else d=(vBoostBin/dvdr(t))/(1-vBoostBin/c);

  return d;
}

// Calculate distance to next boost bin (knowing the boost bin and the frequency) - New!
// in the comoving frame
// Subcells: Works
// Containers: Not applicable
double Cell::boostBinDistance(const FrequencyBinIterator& boostBinIterator, const double& nuCMF, double _t) {
  double nuBoostBin,vBoostBin,d;
  // Get boost bin (red edge) frequency
  nuBoostBin=boostBinIterator->min;
  // Calculate boost bin velocity distance
  vBoostBin=(1-nuBoostBin/nuCMF)*c;
  // Calculate boost bin distance
  if (config->steadyState or _t==noTime) d=vBoostBin/dvdr();
  else d=(vBoostBin/dvdr(_t))/(1-vBoostBin/c);

  return d;
}

// Calculate the opacity for electron scattering
// Subcells: Works
// Containers: Works
double Cell::electronScatterKappa() const {
  double kappa;
  int i; // New!

  // If container - Mass-average opacity over subcells and return - New!
  if (type()==cellContainer) { kappa=0; for (i=0;i<subCell.size();i++) kappa+=subCell[i]->electronScatterKappa()*subCell[i]->rho()*subCell[i]->fillFactor(); kappa=kappa/rho(); return kappa; }

  // If container - New! - Testing!!!
  //if (type()==cellContainer) { vector<double> kk(subCell.size()); for (i=0;i<subCell.size();i++) kk[i]=subCell[i]->electronScatterKappa()*subCell[i]->rho(); double l=meanFreePathContainer(kk,50000); kappa=(1/l)/rho(); return kappa; }

  // Calculate the opacity
  kappa=sigmaT*ne()/rho();

  return kappa;
}

// Calculate the opacity for compton scattering
// Subcells: Works
// Containers: Not applicable
double Cell::comptonScatterKappa(const double& nu) const {
  double x,f1,f2,f3,f4,kappa=0;

  x=(h*nu)/(me*pow(c,2)); f1=2*x; f2=1+x; f3=1+f1; f4=log(f3);
  kappa=electronScatterKappa()*(3.0/4.0)*((f2/pow(x,3))*(f1*f2/f3-f4)+f4/f1-(1+3*x)/pow(f3,2));

  return kappa;
}

// Get the opacity for grey scattering - New!
double Cell::greyScatterKappa() const {

  return pGreyScatterKappa;
}

// Set the opacity for grey scattering - New!
void Cell::greyScatterKappa(const double _greyScatterKappa) {

  pGreyScatterKappa=_greyScatterKappa;
}


// Get the opacity for dust absorption - New!
double Cell::dustAbsKappa() const {

  return pDustAbsKappa;
}

// Set the opacity for dust absorption - New!
void Cell::dustAbsKappa(const double _dustAbsKappa) {

  pDustAbsKappa=_dustAbsKappa;
}

// Get opacity floor - New!
double Cell::kappaFloor() const {

  return pKappaFloor;
}

// Set opacity floor - New!
void Cell::kappaFloor(const double _kappaFloor) {

  pKappaFloor=_kappaFloor;
}

// Calculate the opacity for free-free absorption
// This routine could be speeded up by calculating and storing the effective n*Z^2
// Subcells: Works
// Containers: Not applicable
double Cell::freeFreeAbsKappa(const double& nu) const {
  double kappa=0;
  int i,j;

  // For each atom
  for (i=0; i<atom.size(); i++)
    // For each ion
    for (j=0; j<atom[i].iState.size(); j++)
      // Add free-free opacity
      kappa+=atom[i].iState[j].freeFreeKappa(nu);

  return kappa;
}

// Calculate the emissivity for free-free emission
// This routine could be speeded up by calculating and storing the effective n*Z^2
// Subcells: Works
// Containers: Not applicable
double Cell::freeFreeEta(const double& nu) const {
  double eta=0;
  int i,j;

  // For each atom
  for (i=0; i<atom.size(); i++)
    // For each ion
    for (j=0; j<atom[i].iState.size(); j++)
      // Add free-free emissivity
      eta+=atom[i].iState[j].freeFreeEta(nu);

  return eta;
}

// Calculate free-free cooling rate
// This routine could be speeded up by calculating and storing the effective n*Z^2
// Subcells: Works
// Containers: Works
double Cell::freeFreeCooling(double _T) {
  double _freeFreeCooling;
  int i,j; // Moved!

  // If container - Volume-average cooling over subcells and return - New!
  if (type()==cellContainer) { _freeFreeCooling=0; for (i=0;i<subCell.size();i++) _freeFreeCooling+=subCell[i]->freeFreeCooling(_T)*subCell[i]->fillFactor(); return _freeFreeCooling; }

  // If update requested or temperature supplied
  if (pFreeFreeCooling==update or (_T!=noT and _T!=T())) {

    // Get temperature if not supplied
    if (_T==noT) _T=T();

    // Initiate free-free cooling rate
    _freeFreeCooling=0;

    // For each atom
    for (i=0; i<atom.size(); i++)
      // For each ion
      for (j=0; j<atom[i].iState.size(); j++)
	// Add free-free cooling rate
	_freeFreeCooling+=atom[i].iState[j].freeFreeCooling(_T);

    // If requested - Update
    if (pFreeFreeCooling==update) pFreeFreeCooling=_freeFreeCooling;
  }
  // Else - Get free-free cooling rate
  else _freeFreeCooling=pFreeFreeCooling;

  return _freeFreeCooling;
}

// Calculate free-free heating rate
// This routine could be speeded up by calculating and storing the effective n*Z^2
// Subcells: Works
// Containers: Works
double Cell::freeFreeHeating(double _T) {
  double H=0;
  int i,j;

  // If container - Volume-average heating over subcells and return - New!
  if (type()==cellContainer) { for (i=0;i<subCell.size();i++) H+=subCell[i]->freeFreeHeating(_T)*subCell[i]->fillFactor(); return H; }

  // Get temperature if not supplied
  if (_T==noT) _T=T();

  // For each atom
  for (i=0; i<atom.size(); i++)
    // For each ion
    for (j=1; j<atom[i].iState.size(); j++)
      // Add free-free heating rate
      H+=atom[i].iState[j].freeFreeHeating(_T);

  return H;
}

// Draw free-free emission frequency
// Subcells: Works
// Containers: Not applicable
double Cell::freeFreeNu() const {

  // If boost mode - Use boost version
  if (config->boost) return freeFreeNuBoost();
  // Else (i.e. normal mode) - Use normal version
  else return freeFreeNuNormal();
}

// Draw free-free emission frequency (intervall version) - New!
// Subcells: Works
// Containers: Not applicable
double Cell::freeFreeNu(double nuMin, double nuMax) const {
  double _nu,z;

  // Pick a random number between 0 and 1
  z=randomize(0,1);

  if (radUpdated) nuMin=MAX(MAX(nuMin,freeFreeOnTheSpotNu()),nuOld[0].min);
  else nuMin=MAX(nuMin,freeFreeOnTheSpotNu());

  if (radUpdated) nuMax=MIN(nuMax,nuOld[nuOld.size()-1].max);
  else nuMax=MIN(nuMax,nuInf);

  _nu=FreeFree::etaNu(z,T(),nuMin,nuMax);

  return _nu;
}

// Draw free-free emission frequency (normal version) - New!
// Subcells: Works
// Containers: Not applicable
double Cell::freeFreeNuNormal() const {
  double nu,z;

  // Pick a random number between 0 and 1
  z=randomize(0,1);
  
  // Draw free-free emission frequency
  //nu=FreeFree::etaNu(z,T());
  //if (radUpdated) nu=FreeFree::etaNu(z,T(),nuOld[0].min,nuOld[nuOld.size()-1].max);
  //else nu=FreeFree::etaNu(z,T());
  if (radUpdated) nu=FreeFree::etaNu(z,T(),MAX(nuOld[0].min,freeFreeOnTheSpotNu()),nuOld[nuOld.size()-1].max);
  //if (radUpdated) nu=FreeFree::etaNu(z,T(),MAX(mCStat.nu[0].min,freeFreeOnTheSpotNu()),mCStat.nu[mCStat.nu.size()-1].max);
  else nu=FreeFree::etaNu(z,T(),freeFreeOnTheSpotNu(),nuInf);
  
  return nu;
}

// Draw free-free emission frequency (boost version) - New!
// Subcells: Works
// Containers: Not applicable
double Cell::freeFreeNuBoost() const {
  double z,PTot=0;
  int i;

  // Draw random number betwen 0 and 1
  z=randomize(0,1);

  // For each boost bin
  for (i=0;i<nuBoost.size();i++) {

    // If bin drawn - Return emission frequency
    if (z<=PTot+freeFreeEtaP[i]) return freeFreeNu(nuBoost[i].min,nuBoost[i].max);
    // Else increase accumulated probability
    else PTot+=freeFreeEtaP[i];
  }

  cout<<"Cell::freeFreeNuBoost: Error: No frequency drawn\n";
  cout<<"Cell::freeFreeNuBoost: z: "<<z<<", PTot: "<<PTot<<"\n";

  // This should never happen!
  return 0.0;
}

// Get free-free on-the-spot (minumum) frequency
// Subcells: Works
// Containers: Not applicable
double Cell::freeFreeOnTheSpotNu() const {
  return pFreeFreeOnTheSpotNu;
}

// Get the opacity for bound-free absorption
// Subcells: Works
// Containers: Not applicable
double Cell::boundFreeAbsKappa(const double& _nu, EdgeType edgeType) {
  double kappa=0,deltaNu=0;
  double nuMinTable=(nu.size()>0)?nu[0].min:nuInf,nuMaxTable=(nu.size()>0)?nu[nu.size()-1].max:0.0;
  int i,j;

  // If OSP table only - reset nuMinTable
  if (config->boundFreeTableOSPOnly) { nuMinTable=MAX(onTheSpotNu().min,nuMinTable); }

  if (config->boundFreeTable and _nu>=nuMinTable and _nu<=nuMaxTable) {
    if (boundFreeTableUpdate) {
      omp_set_lock(&boundFreeTableLock);
      // Testing!
      if (master()) cout<<"Cell::boundFreeAbsKappa(1): index: "<<index()<<", boundFreeTableUpdate: "<<boundFreeTableUpdate<<"\n";
      // Testing!!!
      //if (mpiCom!=NULL) cout<<"Cell::boundFreeAbsKappa: Process: "<<mpiCom->rank()<<", index: "<<index()<<", Locked\n";
      if (boundFreeTableUpdate) { boundFreeAbsKappaTable(); boundFreeTableUpdate=false; }
      // Testing!!!
      //if (mpiCom!=NULL) cout<<"Cell::boundFreeAbsKappa: Process: "<<mpiCom->rank()<<", index: "<<index()<<", Unlock\n";
      // Testing!
      if (master()) cout<<"Cell::boundFreeAbsKappa(2): index: "<<index()<<", boundFreeTableUpdate: "<<boundFreeTableUpdate<<"\n";
      omp_unset_lock(&boundFreeTableLock);
    }
    return pBoundFreeAbsKappaTable(nuEdge(_nu,edgeType));
  }
  else return boundFreeAbsKappaCalc(nuEdge(_nu,edgeType));
  
  return kappa;
}

// Get the opacity for bound-free absorption - New!
// Subcells: Works
// Containers: Not applicable
double Cell::boundFreeAbsKappa(FrequencyBinIterator _nu, EdgeType edgeType) {
  double nuMinTable=0.0; // New!

  // If OSP table only - Set lower frequency for table
  if (config->boundFreeTableOSPOnly) { nuMinTable=MAX(onTheSpotNu().min,nuMinTable); }
  
  if (config->boundFreeTable and nuEdge(_nu,edgeType)>nuMinTable) { // Changed!
    if (boundFreeTableUpdate) {
      omp_set_lock(&boundFreeTableLock);
      // Testing!
      if (master()) cout<<"Cell::boundFreeAbsKappa(1): index: "<<index()<<", boundFreeTableUpdate: "<<boundFreeTableUpdate<<"\n";
      // Testing!!!
      //if (mpiCom!=NULL) cout<<"Cell::boundFreeAbsKappa: Process: "<<mpiCom->rank()<<", index: "<<index()<<", Locked\n";
      if (boundFreeTableUpdate) { boundFreeAbsKappaTable(); boundFreeTableUpdate=false; }
      // Testing!!!
      //if (mpiCom!=NULL) cout<<"Cell::boundFreeAbsKappa: Process: "<<mpiCom->rank()<<", index: "<<index()<<", Unlock\n";
      // Testing!
      if (master()) cout<<"Cell::boundFreeAbsKappa(2): index: "<<index()<<", boundFreeTableUpdate: "<<boundFreeTableUpdate<<"\n";
      omp_unset_lock(&boundFreeTableLock);
    }
    return pBoundFreeAbsKappaTable(_nu,edgeType);
  }
  else return boundFreeAbsKappaCalc(nuEdge(_nu,edgeType));
}

// Calculate the opacity for bound-free absorption
// Subcells: Works
// Containers: Not applicable
double Cell::boundFreeAbsKappaCalc(const double& nu, bool cutOff) {
  double kappa=0;
  int i,j;

  // If needed - Update bound-free cut-off
  if (cutOff and boundFreeCutOffUpdate) { updateBoundFreeCutOff(); boundFreeCutOffUpdate=false; }

  // For each major bound-free edge - Testing!!!
  // What if majorEdge not updated (through a call to updateBoudFreeCutoff)? - Fix!
  for (i=0; i<majorEdge.size(); i++) kappa+=majorEdge[i]->kappa(nu,cutOff);

  // For each atom
  /*for (i=0; i<atom.size(); i++) {
    // For each ion
    for (j=0; j<atom[i].iState.size(); j++) {
      // Add bound-free opacity
      kappa+=atom[i].iState[j].boundFreeKappa(nu,cutOff);
    }
    }*/
 
  return kappa;
}

// Calculate the opacity for bound-free absorption (openmp version)
// Subcells: Works
// Containers: Not applicable
// Not threadsafe! Add explicit updateAlfaCorr?
vector<double> Cell::boundFreeAbsKappaOMP(FrequencyBinIterator nuBegin, FrequencyBinIterator nuEnd, EdgeType edgeType, bool cutOff) {
  vector<double> kappa(nuEnd-nuBegin,0);
  int i,j,k;

  // If needed - Update bound-free cut-off
  if (cutOff and boundFreeCutOffUpdate) { updateBoundFreeCutOff(); boundFreeCutOffUpdate=false; }

  // Testing!
  //vector<TransBF*> majorEdgeUse(0);
  //for (i=0; i<majorEdge.size(); i++) if (majorEdge[i]->nuCutOff()>nuEdge(nuBegin,noEdge)) majorEdgeUse.push_back(majorEdge[i]);
 
  // For each frequency
  #pragma omp parallel for private(i,j) schedule(dynamic,50)
  for (k=0;k<(nuEnd-nuBegin);k++) {
    // If opacity needs to be calculated
    if (edgeType==noEdge or (nuBegin+k)->edge) {
    // Ignore minor edges - Testing!
    //if ((edgeType==noEdge or (nuBegin+k)->edge) and (not (nuBegin+k)->minorEdge)) {
      // For each major bound-free edge - Testing!!!
      // What if majorEdge not updated (through a call to updateBoudFreeCutoff)? - Fix!
      //for (i=0; i<majorEdge.size(); i++) kappa[k]+=majorEdge[i]->kappa(nuEdge(nuBegin+k,edgeType),cutOff);
      for (i=0; i<majorEdge.size(); i++) kappa[k]+=majorEdge[i]->kappa(nuBegin+k,edgeType,cutOff);
      // Testing!
      //for (i=0; i<majorEdgeUse.size(); i++) kappa[k]+=majorEdgeUse[i]->kappa(nuBegin+k,edgeType,cutOff);
      // For each atom
      /*for (i=0; i<atom.size(); i++) {
	// For each ion
	for (j=0; j<atom[i].iState.size(); j++) {
	  // Add bound-free opacity
	  kappa[k]+=atom[i].iState[j].boundFreeKappa(nuEdge(nuBegin+k,edgeType),cutOff);
	  }
	  }*/
    }
  }
 
  return kappa;
}

// Calculate the opacity for bound-free absorption (openmp version)
// Subcells: Works
// Containers: Not applicable
// Not threadsafe! Add explicit updateAlfaCorr?
/*vector<double> Cell::boundFreeAbsKappaOMP(const vector<double>& _nu, bool cutOff) {
  vector<double> kappa(_nu.size(),0);
  int i,j,k;

  // If needed - Update bound-free cut-off
  if (cutOff and boundFreeCutOffUpdate) { updateBoundFreeCutOff(); boundFreeCutOffUpdate=false; }

  // For each frequency
  #pragma omp parallel for private(i,j) schedule(static,10)
  for (k=0;k<_nu.size();k++) {
    // For each major bound-free edge - Testing!!!
    for (i=0; i<majorEdge.size(); i++) kappa[k]+=majorEdge[i]->kappa(_nu[k],cutOff);*/
    // For each atom
    /*for (i=0; i<atom.size(); i++) {
      // For each ion
      for (j=0; j<atom[i].iState.size(); j++) {
	// Add bound-free opacity
	kappa[k]+=atom[i].iState[j].boundFreeKappa(_nu[k],cutOff);
      }
      }*/
/*  }

  return kappa;
  }*/

// Create bound-free opacity interpolation table
// Subcells: Works
// Containers: Not applicable
// Old version!
/*void Cell::boundFreeAbsKappaTable(bool useOMP) {
  vector<double> nuWork;
  vector<double> f;
  vector<FunctionValue> table(0);
  int i;

  // If no sampling frequencies - Reset table and return
  if (nu.size()==0) { pBoundFreeAbsKappaTable.init(table); return; }  
  
  // For each sampling frequency
  for (i=0; i<nu.size(); i++) {
    // If edge
    if (nu[i].edge) {
      // If major edge
      if (not nu[i].minorEdge) {
	// Add sampling frequencies on each side of the edge
	nuWork.push_back(nuEdge(nu[i].min,redEdge));
	nuWork.push_back(nuEdge(nu[i].min,blueEdge));
      }
    }
    // Else - add the sampling frequency
    else nuWork.push_back(nu[i].min);
  }

  // Add the last sampling frequency
  nuWork.push_back(nu[nu.size()-1].max);

  // Sort the sampling frequencies (to be on the safe side)
  sort(nuWork.begin(),nuWork.end());

  // Resize the opacity table
  table.resize(nuWork.size());

  // Calculate the bound-free opacities at the sampling frequencies
  if (useOMP) f=boundFreeAbsKappaOMP(nuWork);
  for (i=0; i<nuWork.size(); i++) {
    table[i].x=nuWork[i];
    if (useOMP) table[i].f=f[i];
    else table[i].f=boundFreeAbsKappaCalc(nuWork[i]);
  }
  
  // Create the source-function table
  pBoundFreeAbsKappaTable.init(table);
  }*/

// Create bound-free opacity interpolation table
// Subcells: Works
// Containers: Not applicable
// New version!
void Cell::boundFreeAbsKappaTable(bool useOMP) {
  double nuMin,nuMax;
  FrequencyBinIterator nuBegin,nuEnd;
  int i;

  if (master()) cout<<"Cell::boundFreeAbsKappaTable: index: "<<index()<<", Enter\n";

  // If no frequencies bins - Reset table and return
  if (nuOld.size()==0) { pBoundFreeAbsKappaTable.init(nuOld.end(),nuOld.end(),BoundFreeKappa(this)); return; }  

  // Select first and last frequency bin
  nuBegin=nuOld.begin();
  nuEnd=nuOld.end()-1; // Hmm!!!

  // If OSP table only - Reset first frequency - Testing!
  if (config->boundFreeTableOSPOnly) nuBegin=nuOld.find(MAX(nuOld[0].min,onTheSpotNu().min));

  // If no frequency range - Reset table and return
  if (nuBegin>=nuEnd) { pBoundFreeAbsKappaTable.init(nuOld.end(),nuOld.end(),BoundFreeKappa(this)); return; }  

  // Create the bound-free opacity interpolation table
  if (useOMP) pBoundFreeAbsKappaTable.initOMP(nuBegin,nuEnd,BoundFreeKappa(this));
  else pBoundFreeAbsKappaTable.init(nuBegin,nuEnd,BoundFreeKappa(this));

  if (master()) cout<<"Cell::boundFreeAbsKappaTable: index: "<<index()<<", Return\n";
}

// Synchronize bound-free opacity table (MPI) - New!
// Subcells: Works
// Containers: Not applicable
void Cell::syncBoundFreeAbsKappaTable() {
  BoundFreeAbsKappaMPI boundFreeAbsKappaMPI;

  //if (master()) cout<<"Cell::syncBoundFreeAbsKappaTable: index: "<<index()<<", Enter\n";

  //cout<<"Cell::syncBoundFreeAbsKappaTable: Process: "<<mpiCom->rank()<<", index: "<<index()<<", responsible: "<<responsible<<", Enter\n";

  // If responsible - Pack bound-free opacity table
  if (mpiCom->rank()==responsible) boundFreeAbsKappaMPI.pack(this);

  // Broadcast bound-free opacity table
  boost::mpi::broadcast(*mpiCom,boundFreeAbsKappaMPI,responsible);

  // If not responsible - Unpack bound-free opacity table
  if (mpiCom->rank()!=responsible) boundFreeAbsKappaMPI.unpack(this);

  //cout<<"Cell::syncBoundFreeAbsKappaTable: Process: "<<mpiCom->rank()<<", index: "<<index()<<", responsible: "<<responsible<<", Return\n";

  //if (master()) cout<<"Cell::syncBoundFreeAbsKappaTable: index: "<<index()<<", Return\n";
}

// Calculate the emissivity for bound-free emission
// Subcells: Works
// Containers: Not applicable
double Cell::boundFreeEta(const double& nu, bool cutOff) {
  double eta=0;
  int i,j;

  // If needed - Update bound-free cut-off
  if (cutOff and boundFreeCutOffUpdate) { updateBoundFreeCutOff(); boundFreeCutOffUpdate=false; }

  // For each major bound-free edge - Testing!!!
  // What if majorEdge not updated (through a call to updateBoudFreeCutoff)? - Fix!
  for (i=0; i<majorEdge.size(); i++) eta+=majorEdge[i]->eta(nu,cutOff);

  // For each atom
  /*for (i=0; i<atom.size(); i++) {
    // For each ion
    for (j=0; j<atom[i].iState.size(); j++) {
      // Add bound-free emissivity
      eta+=atom[i].iState[j].boundFreeEta(nu,cutOff);
    }
    }*/

  return eta;
}

// Calculate the emissivity for bound-free emission (openmp version)
// Subcells: Works
// Containers: Not applicable
// Not threadsafe! Add explicit updateAlfaCorr?
vector<double> Cell::boundFreeEtaOMP(FrequencyBinIterator nuBegin, FrequencyBinIterator nuEnd, EdgeType edgeType, bool cutOff) {
  vector<double> eta(nuEnd-nuBegin,0);
  int i,j,k;

  // If needed - Update bound-free cut-off
  if (cutOff and boundFreeCutOffUpdate) { updateBoundFreeCutOff(); boundFreeCutOffUpdate=false; }

  // Testing!
  //vector<TransBF*> majorEdgeUse(0);
  //for (i=0; i<majorEdge.size(); i++) if (majorEdge[i]->nuCutOff()>nuEdge(nuBegin,noEdge)) majorEdgeUse.push_back(majorEdge[i]);
  
  // For each frequency
  #pragma omp parallel for private(i,j) schedule(dynamic,50)
  for (k=0;k<(nuEnd-nuBegin);k++) {
    // If emissivity needs to be calculated
    if (edgeType==noEdge or (nuBegin+k)->edge) {
    // Ignore minor edges - Testing!
    //if ((edgeType==noEdge or (nuBegin+k)->edge) and (not (nuBegin+k)->minorEdge)) {
      // For each major bound-free edge - Testing!!!
      // What if majorEdge not updated (through a call to updateBoudFreeCutoff)? - Fix!
      //for (i=0; i<majorEdge.size(); i++) eta[k]+=majorEdge[i]->eta(nuEdge(nuBegin+k,edgeType),cutOff);
      for (i=0; i<majorEdge.size(); i++) eta[k]+=majorEdge[i]->eta(nuBegin+k,edgeType,cutOff);
      // Testing!
      //for (i=0; i<majorEdgeUse.size(); i++) eta[k]+=majorEdgeUse[i]->eta(nuBegin+k,edgeType,cutOff);
      // For each atom
      /*for (i=0; i<atom.size(); i++) {
	// For each ion
	for (j=0; j<atom[i].iState.size(); j++) {
	  // Add bound-free emissivity
	  eta[k]+=atom[i].iState[j].boundFreeEta(nuEdge(nuBegin+k,edgeType),cutOff);
	}
	}*/
    }
  }

  return eta;
}

// Get the source-function for bound-free absorption
// Subcells: Works
// Containers: Not applicable
double Cell::boundFreeS(const double& _nu, EdgeType edgeType) {
  double nuMinTable=nuInf,nuMaxTable=0.0;
  
  // Calculate interpolation range
  if (nu.size()>0) {
    nuMinTable=MAX(nu[0].min,onTheSpotNu().min);
    nuMaxTable=MIN(nu[nu.size()-1].max,onTheSpotNu().max);
  }
  
  if (config->boundFreeSTable and _nu>=nuMinTable and _nu<=nuMaxTable) {
    if (boundFreeSTableUpdate) {
      omp_set_lock(&boundFreeSTableLock);
      // Testing!!!
      //if (mpiCom!=NULL) cout<<"Cell::boundFreeS: Process: "<<mpiCom->rank()<<", thread_num: "<<omp_get_thread_num()<<", index: "<<index()<<", update: "<<boundFreeSTableUpdate<<", Locked\n";
      if (boundFreeSTableUpdate) { boundFreeSTable(); boundFreeSTableUpdate=false; }
      // Testing!!!
      //if (mpiCom!=NULL) cout<<"Cell::boundFreeS: Process: "<<mpiCom->rank()<<", thread_num: "<<omp_get_thread_num()<<", index: "<<index()<<", update: "<<boundFreeSTableUpdate<<", Unlock\n";
      omp_unset_lock(&boundFreeSTableLock);
    }
    return pBoundFreeSTable(_nu,edgeType);
    //double x=pBoundFreeSTable(_nu,edgeType); if (x==0) cout<<"Cell::boundFreeS(1): index: "<<index()<<", pBoundFreeSTable("<<nuEdge(_nu,edgeType)<<") returned zero\n"; return x;
  }
  else return boundFreeSCalc(nuEdge(_nu,edgeType));
}

// Get the source-function for bound-free absorption
// Subcells: Works
// Containers: Not applicable
double Cell::boundFreeS(FrequencyBinIterator _nu, EdgeType edgeType) {
  
  if (config->boundFreeSTable) {
    if (boundFreeSTableUpdate) {
      omp_set_lock(&boundFreeSTableLock);
      // Testing!!!
      //if (mpiCom!=NULL) cout<<"Cell::boundFreeS: Process: "<<mpiCom->rank()<<", thread_num: "<<omp_get_thread_num()<<", index: "<<index()<<", update: "<<boundFreeSTableUpdate<<", Locked\n";
      if (boundFreeSTableUpdate) { boundFreeSTable(); boundFreeSTableUpdate=false; }
      // Testing!!!
      //if (mpiCom!=NULL) cout<<"Cell::boundFreeS: Process: "<<mpiCom->rank()<<", thread_num: "<<omp_get_thread_num()<<", index: "<<index()<<", update: "<<boundFreeSTableUpdate<<", Unlock\n";
      omp_unset_lock(&boundFreeSTableLock);
    }
    return pBoundFreeSTable(_nu,edgeType);
    //double x=pBoundFreeSTable(_nu,edgeType); if (x==0) cout<<"Cell::boundFreeS(2): index: "<<index()<<", pBoundFreeSTable("<<nuEdge(_nu,edgeType)<<") returned zero\n"; return x;
  }
  else return boundFreeSCalc(nuEdge(_nu,edgeType));
}

// Calculate the source-function for bound-free absorption
// Subcells: Works
// Containers: Not applicable
double Cell::boundFreeSCalc(const double& _nu) {

  // Testing!!!
  /*double STest,etaTest=0,kappaTest=0;
  int j;
  for (j=0;j<majorEdge.size();j++) {
    //if (majorEdge[j]->upperState->iState()->atom()->name().compare("C")!=0 or index()<3) {
    if (majorEdge[j]->upperState->iState()->atom()->name().compare("H")==0 or majorEdge[j]->upperState->iState()->atom()->name().compare("He")==0 or index()<3) {
      etaTest+=majorEdge[j]->eta(_nu);
      kappaTest+=majorEdge[j]->kappa(_nu);
    }
  }
  STest=etaTest/(kappaTest*rho());
  return STest;*/
  
  double S=boundFreeEta(_nu)/(boundFreeAbsKappaCalc(_nu)*rho());

  if (!isnumber(S)) cout<<"Cell::boundFreeSCalc: Warning: Invalid source function: "<<S<<", boundFreeEta: "<<boundFreeEta(_nu)<<", boundFreeKappa: "<<boundFreeAbsKappaCalc(_nu)<<", nu: "<<_nu<<"\n";

  return S;
}

// Calculate the source-function for bound-free absorption (omp version)
// Subcells: Works
// Containers: Not applicable
// Not threadsafe! Add explicit updateAlfaCorr?
vector<double> Cell::boundFreeSOMP(FrequencyBinIterator nuBegin, FrequencyBinIterator nuEnd, EdgeType edgeType) {
  vector<double> eta=boundFreeEtaOMP(nuBegin,nuEnd,edgeType);
  vector<double> kappa=boundFreeAbsKappaOMP(nuBegin,nuEnd,edgeType);
  vector<double> S(nuEnd-nuBegin,0);
  int i;

  // Testing!!!
  /*double etaTest,kappaTest;
  int j;
  #pragma omp parallel for private(j,etaTest,kappaTest) schedule(dynamic,50)
  for (i=0;i<(nuEnd-nuBegin);i++) 
    if (edgeType==noEdge or (nuBegin+i)->edge) {
      etaTest=0;kappaTest=0;
      for (j=0;j<majorEdge.size();j++) {
	//if (majorEdge[j]->upperState->iState()->atom()->name().compare("C")!=0 or index()<3) {
	if (majorEdge[j]->upperState->iState()->atom()->name().compare("H")==0 or majorEdge[j]->upperState->iState()->atom()->name().compare("He")==0 or index()<3) {
	  etaTest+=majorEdge[j]->eta(nuBegin+i,edgeType);
	  kappaTest+=majorEdge[j]->kappa(nuBegin+i,edgeType);
	}
      }
      S[i]=etaTest/(kappaTest*rho());
    }
    return S;*/

  for (i=0;i<(nuEnd-nuBegin);i++) 
    if (edgeType==noEdge or (nuBegin+i)->edge) S[i]=eta[i]/(kappa[i]*rho());
    // Ignore minor edges - Testing!
    //if ((edgeType==noEdge or (nuBegin+i)->edge) and (not (nuBegin+i)->minorEdge)) S[i]=eta[i]/(kappa[i]*rho());
         
  return S;
}

// Create bound-free sorce-function table
// Subcells: Works
// Containers: Not applicable
void Cell::boundFreeSTable(bool useOMP) {
  double nuMin,nuMax;
  FrequencyBinIterator nuBegin,nuEnd;
  int i;

  // If no sampling frequencies - Reset table and return
  if (nuOld.size()==0) { pBoundFreeSTable.init(nuOld.end(),nuOld.end(),BoundFreeS(this)); return; }  

  // Calculate table range
  nuMin=MAX(nuOld[0].min,onTheSpotNu().min);
  nuMax=MIN(nuOld[nu.size()-1].max,onTheSpotNu().max);

  // If no table range - Reset table and return
  if (nuMin>=nuMax) { pBoundFreeSTable.init(nuOld.end(),nuOld.end(),BoundFreeS(this)); return; }

  // Find the first and last sampling frequencies within the table range
  nuBegin=nuOld.find(nuMin); nuEnd=nuOld.find(nuMax);

  
  // Create the source-function table
  if (useOMP) pBoundFreeSTable.initOMP(nuBegin,nuEnd,BoundFreeS(this));
  else pBoundFreeSTable.init(nuBegin,nuEnd,BoundFreeS(this));
}

// Calculate the source-function for bound-free absorption
// Subcells: Works
// Containers: Not applicable
double Cell::boundFreedSdN(const double& _nu, BState* bState, EdgeType edgeType) {

  double S,kappa,dEtadN=0,dKappadN=0,dSdN;
  int i,j,k,l;

  // Get bound-free source-function
  S=boundFreeS(_nu,edgeType);

  // Get bound-free opacity
  kappa=boundFreeAbsKappa(nuEdge(_nu,edgeType));

  // Calculate emissivity derivative
  dEtadN=bState->boundFreedEtadN(nuEdge(_nu,edgeType));
  // Calculate opacity derivative
  dKappadN=bState->boundFreedKappadN(nuEdge(_nu,edgeType));

  if (kappa!=0) dSdN=(dEtadN/rho()-dKappadN*S)/kappa;
  else dSdN=0.0;

  if (!isnumber(dSdN)) cout<<"Cell::boundFreedSdN: Warning: Invalid source function derivative: "<<dSdN<<", nu: "<<nuEdge(_nu,edgeType)<<"\n";

  return dSdN;
}

// Calculate the source-function for bound-free absorption - New!
// Subcells: Works
// Containers: Not applicable
double Cell::boundFreedSdN(FrequencyBinIterator _nu, BState* bState, EdgeType edgeType) {

  double S,kappa,dEtadN=0,dKappadN=0,dSdN;
  int i,j,k,l;

  // Get bound-free source-function
  S=boundFreeS(_nu,edgeType);

  // Get bound-free opacity
  kappa=boundFreeAbsKappa(_nu,edgeType);

  // Calculate emissivity derivative
  dEtadN=bState->boundFreedEtadN(nuEdge(_nu,edgeType));
  // Calculate opacity derivative
  dKappadN=bState->boundFreedKappadN(nuEdge(_nu,edgeType));

  if (kappa!=0) dSdN=(dEtadN/rho()-dKappadN*S)/kappa;
  else dSdN=0.0;

  if (!isnumber(dSdN)) cout<<"Cell::boundFreedSdN: Warning: Invalid source function derivative: "<<dSdN<<", nu: "<<nuEdge(_nu,edgeType)<<"\n";

  return dSdN;
}

// Calculate the source-function for bound-free absorption (ionization state version)
// Subcells: Works
// Containers: Not applicable
double Cell::boundFreedSdN(const double& _nu, IState* iState, EdgeType edgeType) {

  double S,kappa,dEtadN=0,dKappadN=0,dSdN;
  int i,j,k,l;

  // Get bound-free source-function
  S=boundFreeS(_nu,edgeType);

  // Get bound-free opacity
  kappa=boundFreeAbsKappa(nuEdge(_nu,edgeType));

  // Calculate emissivity derivative
  dEtadN=iState->boundFreedEtadN(nuEdge(_nu,edgeType));
  // Calculate opacity derivative
  dKappadN=iState->boundFreedKappadN(nuEdge(_nu,edgeType));

  if (kappa!=0) dSdN=(dEtadN/rho()-dKappadN*S)/kappa;
  else dSdN=0.0;

  if (!isnumber(dSdN)) cout<<"Cell::boundFreedSdN: Warning: Invalid source function derivative: "<<dSdN<<", nu: "<<nuEdge(_nu,edgeType)<<"\n";

  return dSdN;
}

// Calculate the source-function for bound-free absorption (ionization state version) - New!
// Subcells: Works
// Containers: Not applicable
double Cell::boundFreedSdN(FrequencyBinIterator _nu, IState* iState, EdgeType edgeType) {

  double S,kappa,dEtadN=0,dKappadN=0,dSdN;
  int i,j,k,l;

  // Get bound-free source-function
  S=boundFreeS(_nu,edgeType);

  // Get bound-free opacity
  kappa=boundFreeAbsKappa(_nu,edgeType);

  // Calculate emissivity derivative
  dEtadN=iState->boundFreedEtadN(nuEdge(_nu,edgeType));
  // Calculate opacity derivative
  dKappadN=iState->boundFreedKappadN(nuEdge(_nu,edgeType));

  if (kappa!=0) dSdN=(dEtadN/rho()-dKappadN*S)/kappa;
  else dSdN=0.0;

  if (!isnumber(dSdN)) cout<<"Cell::boundFreedSdN: Warning: Invalid source function derivative: "<<dSdN<<", nu: "<<nuEdge(_nu,edgeType)<<"\n";

  return dSdN;
}

// Calculate bound-free cooling rate
// Subcells: Works
// Containers: Works
double Cell::boundFreeCooling(double _T) const {
  double C=0;
  int i,j;

  // If container - Volume-average cooling over subcells and return - New!
  if (type()==cellContainer) { for (i=0;i<subCell.size();i++) C+=subCell[i]->boundFreeCooling(_T)*subCell[i]->fillFactor(); return C; }

  // Get temperature if not supplied
  if (_T==noT) _T=T();

  // For each atom
  for (i=0; i<atom.size(); i++) {
    // For each ion
    for (j=0; j<atom[i].iState.size(); j++) {
      // Add bound-free cooling rate
      C+=atom[i].iState[j].boundFreeCooling(_T);
    }
  }

  return C;
}

// Calculate (spontaneous) bound-free cooling rate
// Subcells: Works
// Containers: Not applicable
double Cell::boundFreeCoolingSP(double _T) {
  double _boundFreeCoolingSP;

  // If update requested or temperature supplied
  if (pBoundFreeCoolingSP==update or (_T!=noT and _T!=T())) {
    int i,j;

    // Get temperature if not supplied
    if (_T==noT) _T=T();

    // Initiate bound-free cooling rate
    _boundFreeCoolingSP=0;

    // For each atom
    for (i=0; i<atom.size(); i++) {
      // For each ion
      for (j=0; j<atom[i].iState.size(); j++) {
	// Add bound-free cooling rate
	_boundFreeCoolingSP+=atom[i].iState[j].boundFreeCoolingSP(_T);
      }
    }

    // If requested - Update
    if (pBoundFreeCoolingSP==update) pBoundFreeCoolingSP=_boundFreeCoolingSP;
  }
  // Else - Get bound-free cooling rate
  else _boundFreeCoolingSP=pBoundFreeCoolingSP;

  return _boundFreeCoolingSP;
}

// Calculate bound-free heating rate
// Subcells: Works
// Containers: Works
double Cell::boundFreeHeating(double _T) const {
  double H=0;
  int i,j;

  // If container - Volume-average heating over subcells and return - New!
  if (type()==cellContainer) { for (i=0;i<subCell.size();i++) H+=subCell[i]->boundFreeHeating(_T)*subCell[i]->fillFactor(); return H; }

  // Get temperature if not supplied
  if (_T==noT) _T=T();

  // For each atom
  for (i=0; i<atom.size(); i++) {
    // For each ion
    for (j=0; j<atom[i].iState.size(); j++) {
      // Add bound-free heating rate
      H+=atom[i].iState[j].boundFreeHeating(_T);
    }
  }

  return H;
}

// Bound-free heating integrand
// Subcells: Works
// Containers: Not applicable
class HBFIntegrand : public NuIntegrand {
public:
  Cell* cell;
  const double T;
  HBFIntegrand(Cell* _cell, const double& _T) : cell(_cell), T(_T) {};
  double operator()(double nu) const {
    double H=0;
    TransBF* trans;
    int i,j,k,l;
    for (i=0;i<cell->atom.size();i++)
      for (j=0;j<cell->atom[i].iState.size();j++)
	for (k=0;k<cell->atom[i].iState[j].bState.size();k++)
	  for (l=0;l<cell->atom[i].iState[j].bState[k].upTransBF.size();l++) {
	    trans=cell->atom[i].iState[j].bState[k].upTransBF[l];
	    H+=(trans->gammaNu(nu,true)*trans->lowerState->n()-trans->alfaSTNu(nu,T,true)*cell->ne()*trans->upperState->n())*trans->Xi();
	  }
    return H;
  }
  double operator()(FrequencyBinIterator nu, EdgeType edgeType=noEdge) const { return 0.0; };
};

// Bound-free cooling integrand
// Subcells: Works
// Containers: Not applicable
class CBFIntegrand : public NuIntegrand {
public:
  Cell* cell;
  const double T;
  CBFIntegrand(Cell* _cell, const double& _T) : cell(_cell), T(_T) {};
  double operator()(double nu) const {
    double C=0;
    TransBF* trans;
    int i,j,k,l;
    for (i=0;i<cell->atom.size();i++)
      for (j=0;j<cell->atom[i].iState.size();j++)
	for (k=0;k<cell->atom[i].iState[j].bState.size();k++)
	  for (l=0;l<cell->atom[i].iState[j].bState[k].upTransBF.size();l++) {
	    trans=cell->atom[i].iState[j].bState[k].upTransBF[l];
	    C+=trans->alfaSPNu(nu,T,true)*cell->ne()*trans->upperState->n()*trans->Xi();
	  }
    return C;
  }
  double operator()(FrequencyBinIterator nu, EdgeType edgeType=noEdge) const { return 0.0; };
};

// Calculate net bound-free heating rate (as a single integral)
// Subcells: Works
// Containers: Not applicable
double Cell::boundFreeG(double _T) {
  double G;
  if (_T==noT) _T=T();

  double relTol=1e-2,absTol=0.0;
  double nuMin=0,nuMax=nuInf;
  HBFIntegrand HIntegrand(this,_T);
  CBFIntegrand CIntegrand(this,_T);
  // Testing
  int nIter;
  
  // Calculate net radiative rate in the on-the-spot range
  G=NetIntegrate(HIntegrand,CIntegrand,nuMin,nuMax,nIter,relTol,absTol,false);

  if (!isnumber(G)) cout<<"Cell::boundFreeG: index: "<<index()<<", Warning: Invalid rate: "<<G<<"\n";

  return G;
}

// Draw bound-free emission frequency
// Subcells: Works
// Containers: Not applicable
double Cell::boundFreeNu() {
  double totalCooling,z,P,PTot=0;
  int i,j,k,l;

  // Pick random number between 0 and 1
  z=randomize(0,1);

  // Get total cooling from (spontaneous) bound-free emission
  totalCooling=boundFreeCoolingSP();

  // For each atom
  for (i=0; i<atom.size(); i++) {
    // For each ion
    for (j=0; j<atom[i].iState.size(); j++) {
      // For each bound state
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {
	// For each (downward) bound-free transition
	for (l=0; l<atom[i].iState[j].bState[k].downTransBF.size(); l++) {
	  
	  // Calculate transition probability
	  P=atom[i].iState[j].bState[k].downTransBF[l]->coolingSP()/totalCooling;
	  
	  // If boost - Adjust transition probability - New!
	  if (config->boost) P=P*atom[i].iState[j].bState[k].downTransBF[l]->etaBoost()/boundFreeCoolingBoost();
	  
	  // If selected draw and return emission frequency
	  if (z<PTot+P) return atom[i].iState[j].bState[k].downTransBF[l]->etaNu();
	  // Else
	  else PTot+=P;
	}
      }
    }
  }

  // This should not happen
  return 0.0;
}

// Draw bound-free (downward) transition
// Subcells: Works
// Containers: Not applicable
Trans* Cell::boundFreeDeExcite() {
  double totalCooling,z,P,PTot=0;
  int i,j,k,l;

  // Pick random number between 0 and 1
  z=randomize(0,1);

  // Get total cooling from (spontaneous) bound-free emission
  totalCooling=boundFreeCoolingSP();

  // For each atom
  for (i=0; i<atom.size(); i++) {
    // For each ion
    for (j=0; j<atom[i].iState.size(); j++) {
      // For each bound state
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {
	// For each (downward) bound-free transition
	for (l=0; l<atom[i].iState[j].bState[k].downTransBF.size(); l++) {
	  
	  // Calculate transition probability
	  P=atom[i].iState[j].bState[k].downTransBF[l]->coolingSP()/totalCooling;
	  
	  // If boost - Adjust transition probability - New!
	  if (config->boost) P=P*atom[i].iState[j].bState[k].downTransBF[l]->etaBoost()/boundFreeCoolingBoost();
	  
	  // If selected draw and return transition
	  if (z<PTot+P) return atom[i].iState[j].bState[k].downTransBF[l];
	  // Else
	  else PTot+=P;
	}
      }
    }
  }

  cout<<"Cell::boundFreeDeExcite: Error: No transition drawn\n";
  cout<<"Cell::boundFreeDeExcire: z: "<<z<<", PTot: "<<PTot<<"\n";

  // This should not happen
  return NULL;
}

// Draw bound-free (upward) transition
// Subcells: Works
// Containers: Not applicable
Trans* Cell::boundFreeExcite(const double& nu) {
  double totalKappa,z,P,PTot=0,nTry=0;
  int i,j,k,l;

  // Pick random number between 0 and 1
  z=randomize(0,1);

  // Get total bound-free opacity
  totalKappa=boundFreeAbsKappa(nu);
  if (totalKappa==0) { cout<<"Cell::boundFreeExcite: Error: Zero total opacity, nu: "<<nu<<", lambda: "<<(c/nu)/AA<<"\n"; return NULL; }

  // If boost mode - Adjust total bound-free opacity - New!
  if (config->boost) totalKappa=totalKappa*boundFreeKappaBoost(nu);

  // Loop to adjust total opacity (in a possible case of interpolation error)
  while(nTry<2) {

    // For each atom
    for (i=0; i<atom.size(); i++) {
      // For each ion
      for (j=0; j<atom[i].iState.size(); j++) {
	// For each bound state
	for (k=0; k<atom[i].iState[j].bState.size(); k++) {
	  // For each (upward) bound-free transition
	  for (l=0; l<atom[i].iState[j].bState[k].upTransBF.size(); l++) {
	    
	    // Calculate transition probability
	    P=atom[i].iState[j].bState[k].upTransBF[l]->kappa(nu)/totalKappa;
	    
	    // If boost mode - Adjust transition probability - New!
	    if (config->boost) P=P*atom[i].iState[j].bState[k].upTransBF[l]->kappaBoost();
	    
	    // If selected return transition
	    if (z<PTot+P) return atom[i].iState[j].bState[k].upTransBF[l];
	    // Else
	    else PTot+=P;
	  }
	}
      }
    }

    // Increase try counter
    nTry++;

    // Supress this warning - Most probably not an error
    //cout<<"Cell::boundFreeExcite: Warning: No transition drawn - Normalizing probabilities\n";
    //cout<<"Cell::boundFreeExcite: z: "<<z<<", PTot: "<<PTot<<", nu: "<<nu<<", lambda: "<<(c/nu)/AA<<"\n";

    // If first try
    if (nTry<2) {
      // Adjust total opacity
      totalKappa=PTot*totalKappa;
      // Reset accumulated probability
      PTot=0;
    }
  }

  // This should not happen
  return NULL;
}

// Update bound-free cut-off frequencies
// Subcells: Works
// Containers: Not applicable
// New version
// This function needs work. Cut-off algorithm not safe for non-nu^3 cross-sections!
void Cell::updateBoundFreeCutOff(bool checkEta, double boundFreeCutOff) {
  vector<double> kappaEdge(nu.size(),0),etaEdge(nu.size(),0);
  vector<TransBF*> transBF(nu.size(),NULL);
  FrequencyBinIterator nuBin;
  int i,j,k,l,n,m,nEdge=0,nMinorEdge=0,nEdgeAll=0;

  // If not provided - Get default cut-off value
  if (boundFreeCutOff<0) boundFreeCutOff=config->boundFreeCutOff;

  // Reset major edge list
  majorEdge.resize(0);

  // If no cut-off - New!
  if (boundFreeCutOff<=0) {
    // Reset frequency cut-off for each (upward) bound-free transition
    for (i=0; i<atom.size(); i++)
      for (j=0; j<atom[i].iState.size(); j++)
	for (k=0; k<atom[i].iState[j].bState.size(); k++)
	  for (l=0; l<atom[i].iState[j].bState[k].upTransBF.size(); l++) {
	    atom[i].iState[j].bState[k].upTransBF[l]->nuCutOff(1e99);
	    majorEdge.push_back(atom[i].iState[j].bState[k].upTransBF[l]); // New!
	  }
    // Unset minor edge flag for each frequency bin
    for (n=0; n<nu.size(); n++) { nu[n].minorEdge=false; nuOld[n].minorEdge=false; } // Bug fixed!
    // Return
    return;
  }

  // For each atom
  for (i=0; i<atom.size(); i++) {
    // For each ion
    for (j=0; j<atom[i].iState.size(); j++) {
      // For each bound state
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {
	// For each (upward) bound-free transition
	for (l=0; l<atom[i].iState[j].bState[k].upTransBF.size(); l++) {
	  // Reset frequency cut-off
	  atom[i].iState[j].bState[k].upTransBF[l]->nuCutOff(1e99);
	  // Find corresponding frequency bin
	  nuBin=nu.find(atom[i].iState[j].bState[k].upTransBF[l]->nu());
	  // If found - Add to transition map
	  if (nuBin!=nu.end()) {
	    transBF[nuBin-nu.begin()]=atom[i].iState[j].bState[k].upTransBF[l];
	  }
	  // What to do otherwise - Solve !!!
	  // And how about multiple entries - Solve !!!
	}
      }
    }
  }

  // For each frequency bin
  for (n=0; n<nu.size(); n++) {
    // Unset minor edge flag
    nu[n].minorEdge=false; nuOld[n].minorEdge=false;
    // Testing
    if (nu[n].edge) nEdgeAll++;
    // If edge bin
    if (nu[n].edge and transBF[n]!=NULL) {
      nEdge++;
      // For each lower frequency bin
      for (m=0;m<=n;m++) {
	// If (major) edge bin
	if (nu[m].edge and (not nu[m].minorEdge) and transBF[m]!=NULL) { 
	  // Skip transitions with simple treatment - New!
	  //if transBF[m]->alfaSimple() continue;
	  // Sum opacity and emissivity
	  kappaEdge[n]+=transBF[m]->kappa(nuEdge(nu[n].min,blueEdge)); 
	  // Possible bug! Should be transBF[m]->eta, right? Fixed!
	  etaEdge[n]+=transBF[m]->eta(nuEdge(nu[n].min,blueEdge));
	}
      }
      // If opacity and (optionally) emissivity below cut-off value
      if (transBF[n]->kappa(nuEdge(nu[n].min,blueEdge))<boundFreeCutOff*kappaEdge[n] and ((not checkEta) or transBF[n]->eta(nuEdge(nu[n].min,blueEdge))<boundFreeCutOff*etaEdge[n])) { 
	// Set minor edge flag
	nu[n].minorEdge=true; nuOld[n].minorEdge=true;
	nMinorEdge++;
	// Set transition cut-off
	transBF[n]->nuCutOff(nu[n].min);
      }
    }
  }

  // For each (upward) bound-free transition - New!
  for (i=0; i<atom.size(); i++)
    for (j=0; j<atom[i].iState.size(); j++)
      for (k=0; k<atom[i].iState[j].bState.size(); k++)
	for (l=0; l<atom[i].iState[j].bState[k].upTransBF.size(); l++)
	  // If major edge - Add to list
	  if (atom[i].iState[j].bState[k].upTransBF[l]->nuCutOff()==1e99) majorEdge.push_back(atom[i].iState[j].bState[k].upTransBF[l]);

  // For each frequency bin
  for (n=0; n<nu.size(); n++) {
    // If (major) edge bin
    if (nu[n].edge and (not nu[n].minorEdge) and transBF[n]!=NULL) {
      // For each higher frequency bin
      for (m=n;m<nu.size();m++) {
	// If (major) edge bin
	if (nu[m].edge and (not nu[m].minorEdge) and transBF[m]!=NULL) {
	  // If opacity and (optionally) emissivity below cut-off value
	  if (transBF[n]->kappa(nuEdge(nu[m].min,blueEdge))<boundFreeCutOff*kappaEdge[m] and ((not checkEta) or transBF[n]->eta(nuEdge(nu[m].min,blueEdge))<boundFreeCutOff*etaEdge[m])) {
	    transBF[n]->nuCutOff(nu[m].min);
	    break;
	  }
	}
      }
    }
  }

  // Testing!
  cout<<"Cell::updateBoundFreeCutOff: index: "<<index()<<", Marked "<<nMinorEdge<<" out of "<<nEdge<<"/"<<nEdgeAll<<" edges as minor using a bound-free cut-off of "<<boundFreeCutOff<<"\n";
}

// Update bound-free cut-off frequencies
// Subcells: Works
// Containers: Not applicable
// Not threadsafe! Add explicit updateAlfaCorr?
// This function needs work. Cut-off algorithm not safe for non-nu^3 cross-sections!
void Cell::updateBoundFreeCutOffOMP(bool checkEta, double boundFreeCutOff) {
  vector<double> kappaEdge(nu.size(),0),etaEdge(nu.size(),0);
  vector<double> kappaEdgeEdge(nu.size(),0),etaEdgeEdge(nu.size(),0); // New! - Testing!
  vector<TransBF*> transBF(nu.size(),NULL);
  vector<bool> minorEdge(nu.size(),false); // New! - Testing!
  FrequencyBinIterator nuBin;
  int chunkSize=1000; // New! - Testing!
  int nChunk=int(ceil(float(nu.size())/float(chunkSize))); // New! - Testing!
  int i,j,k,l,n,m,nEdge=0,nMinorEdge=0;

  // Testing!
  if (index()==36) cout<<"Cell::updateBoundFreeCutOffOMP, Process: "<<mpiCom->rank()<<", index: "<<index()<<", 1\n";

  // If not provided - Get default cut-off value
  if (boundFreeCutOff<0) boundFreeCutOff=config->boundFreeCutOff;

  // Reset major edge
  majorEdge.resize(0);
  
  // If no cut-off - New!
  if (boundFreeCutOff<=0) {
    // Reset frequency cut-off for each (upward) bound-free transition
    for (i=0; i<atom.size(); i++)
      for (j=0; j<atom[i].iState.size(); j++)
	for (k=0; k<atom[i].iState[j].bState.size(); k++)
	  for (l=0; l<atom[i].iState[j].bState[k].upTransBF.size(); l++) {
	    atom[i].iState[j].bState[k].upTransBF[l]->nuCutOff(1e99);
	    majorEdge.push_back(atom[i].iState[j].bState[k].upTransBF[l]); // New!
	  }
    // Unset minor edge flag for each frequency bin
    for (n=0; n<nu.size(); n++) { nu[n].minorEdge=false; nuOld[n].minorEdge=false; } // Bug fixed!
    // Return
    return;
  }

  // Testing!
  if (index()==36) cout<<"Cell::updateBoundFreeCutOffOMP, Process: "<<mpiCom->rank()<<", index: "<<index()<<", 2\n";

  // Testing! - Does not work! - Remove!
  // For each atom
  //#pragma omp parallel for private(j)
  /*for (i=0; i<atom.size(); i++)
    // Update bound-free cutoff For each ion
    for (j=0; j<atom[i].iState.size(); j++) atom[i].iState[j].updateBoundFreeCutOff(checkEta,boundFreeCutOff);*/

  // For each atom
  #pragma omp parallel for private(j,k,l,nuBin)
  for (i=0; i<atom.size(); i++) {
    // For each ion
    for (j=0; j<atom[i].iState.size(); j++) {
      // Make sure recombination correction is updated - Hack to avoid race conditions below !!! - Testing!!!
      //atom[i].iState[j].updateAlfaCorr();
      // For each bound state
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {
	// For each (upward) bound-free transition
	for (l=0; l<atom[i].iState[j].bState[k].upTransBF.size(); l++) {
	  // Reset frequency cut-off
	  atom[i].iState[j].bState[k].upTransBF[l]->nuCutOff(1e99);
	  // Make sure phi is updated - Hack to avoid race conditions below !!!
	  atom[i].iState[j].bState[k].upTransBF[l]->phi();
	  // Find corresponding frequency bin
	  nuBin=nu.find(atom[i].iState[j].bState[k].upTransBF[l]->nu());
	  // If found - Add to transition map
	  // Atomic ?!
	  #pragma omp critical
	  if (nuBin!=nu.end()) transBF[nuBin-nu.begin()]=atom[i].iState[j].bState[k].upTransBF[l];
	  // What to do otherwise - Solve !!!
	  // And how about multiple entries - Solve !!!
	}
      }
    }
  }

  // Testing!
  if (index()==36) cout<<"Cell::updateBoundFreeCutOffOMP, Process: "<<mpiCom->rank()<<", index: "<<index()<<", 3\n";

  // If OSP region only - New! - Testing!
  /*if (config->boundFreeCutOffOSPOnly) {
    double kappaOSP=0,etaOSP=0;
    FrequencyBinIterator nuOSP=nu.find(onTheSpotNu().min);
    if (nuOSP==nu.end()) return;
    nMin=nuOSP-nu.begin();
    // For each frequency bin redwards the OSP region
    for (n=0;n<nMin;n++) {
      // If edge bin
      if (nu[n].edge and transBF[n]!=NULL) {
	// Sum opacity and emissivity
	kappaOSP+=transBF[n]->kappa(nuEdge(nuOSP,blueEdge)); 
	etOSP+=transBF[n]->eta(nuEdge(nuOSP,blueEdge));
      }
    }
    // For each frequency bin redwards the OSP region
    for (n=0;n<nMin;n++) {
      // If edge bin
      if (nu[n].edge and transBF[n]!=NULL) {
	// If opacity and (optionally) emissivity below cut-off value
	if (transBF[n]->kappa(nuEdge(nuOSP,blueEdge))<boundFreeCutOff*kappaOSP[n] and ((not checkEta) or transBF[n]->eta(nuEdge(nuOSP,blueEdge))<boundFreeCutOff*etaEdge[n])) { 
	  // Set minor edge flag
	  nu[n].minorEdge=true; nuOld[n].minorEdge=true;
	}
      }
    }
  }
  else nMin=0;*/

  // For each frequency bin
  //#pragma omp parallel for private(m) schedule(dynamic,50)
  //for (n=0; n<nu.size(); n++) {
  for (i=0;i<nChunk;i++) {
    #pragma omp parallel for private(m) schedule(dynamic,50)
    for (n=i*chunkSize;n<MIN((i+1)*chunkSize,int(nu.size()));n++) {
      // Unset minor edge flag
      nu[n].minorEdge=false; nuOld[n].minorEdge=false;
      // If edge bin
      if (nu[n].edge and transBF[n]!=NULL) {
	// For each lower frequency bin
	for (m=0;m<=n;m++) {
	  // If (major) edge bin
	  if (nu[m].edge and (not nu[m].minorEdge) and transBF[m]!=NULL) { 
	    // Skip transitions with simple treatment - New!
	    //if transBF[m]->alfaSimple() continue;
	    // Sum opacity and emissivity
	    kappaEdge[n]+=transBF[m]->kappa(nuEdge(nu[n].min,blueEdge)); 
	    // Possible bug! Should be transBF[m]->eta, right? Fixed!
	    etaEdge[n]+=transBF[m]->eta(nuEdge(nu[n].min,blueEdge));
	  }
	}
	// If opacity and (optionally) emissivity below cut-off value
	if (transBF[n]->kappa(nuEdge(nu[n].min,blueEdge))<boundFreeCutOff*kappaEdge[n] and ((not checkEta) or transBF[n]->eta(nuEdge(nu[n].min,blueEdge))<boundFreeCutOff*etaEdge[n])) { 
	  // Set minor edge flag
	  //nu[n].minorEdge=true; nuOld[n].minorEdge=true;
	  minorEdge[n]=true;
	  // Set transition cut-off
	  transBF[n]->nuCutOff(nu[n].min);
	}
      }
    }
    // Update frequency bin list minor edge flags
    for (n=i*chunkSize;n<MIN((i+1)*chunkSize,int(nu.size()));n++) { nu[n].minorEdge=minorEdge[n]; nuOld[n].minorEdge=minorEdge[n]; }
  }

  // Testing!
  if (index()==36) cout<<"Cell::updateBoundFreeCutOffOMP, Process: "<<mpiCom->rank()<<", index: "<<index()<<", 4\n";

  // For each (upward) bound-free transition - New!
  for (i=0; i<atom.size(); i++)
    for (j=0; j<atom[i].iState.size(); j++)
      for (k=0; k<atom[i].iState[j].bState.size(); k++)
	for (l=0; l<atom[i].iState[j].bState[k].upTransBF.size(); l++)
	  // If major edge - Add to list
	  if (atom[i].iState[j].bState[k].upTransBF[l]->nuCutOff()==1e99) majorEdge.push_back(atom[i].iState[j].bState[k].upTransBF[l]);

  // Testing!
  if (index()==36) cout<<"Cell::updateBoundFreeCutOffOMP, Process: "<<mpiCom->rank()<<", index: "<<index()<<", 5\n";

  // For each frequency bin
  #pragma omp parallel for private(m) schedule(dynamic,50)
  for (n=0; n<nu.size(); n++) {
    // If (major) edge bin
    if (nu[n].edge and (not nu[n].minorEdge) and transBF[n]!=NULL) {
      // For each higher frequency bin
      for (m=n;m<nu.size();m++) {
	// If (major) edge bin
	if (nu[m].edge and (not nu[m].minorEdge) and transBF[m]!=NULL) {
	  // If opacity and (optionally) emissivity below cut-off value
	  if (transBF[n]->kappa(nuEdge(nu[m].min,blueEdge))<boundFreeCutOff*kappaEdge[m] and ((not checkEta) or transBF[n]->eta(nuEdge(nu[m].min,blueEdge))<boundFreeCutOff*etaEdge[m])) {
	    transBF[n]->nuCutOff(nu[m].min);
	    break;
	  }
	}
      }
    }
  }

  // Count number of edges
  for (i=0;i<nu.size();i++) {
    if (nu[i].edge) {
      nEdge++;
      if (nu[i].minorEdge) nMinorEdge++;
    }
  }

  // Testing!
  cout<<"Cell::updateBoundFreeCutOffOMP: index: "<<index()<<", Marked "<<nMinorEdge<<" out of "<<nEdge<<" edges as minor using a bound-free cut-off of "<<boundFreeCutOff<<"\n";
  // Testing
  if(index()==36) cout<<"Cell::updateBoundFreeCutOffOMP: index: "<<index()<<", Marked "<<nMinorEdge<<" out of "<<nEdge<<" edges as minor using a bound-free cut-off of "<<boundFreeCutOff<<"\n";
}

// Synchronize bound-free cut-off (MPI) - New!
// Subcells: Works
// Containers: Not applicable
void Cell::syncBoundFreeCutOff() {
  BoundFreeCutOffMPI boundFreeCutOffMPI;
  int i,j,k,l;

  //if (master()) cout<<"Cell::syncBoundFreeCutOff: index: "<<index()<<", Enter\n";

  //cout<<"Cell::syncBoundFreeCutOff: Process: "<<mpiCom->rank()<<", index: "<<index()<<", responsible: "<<responsible<<", Enter\n";

  // If responsible - Pack bound-free cut-off
  if (mpiCom->rank()==responsible) boundFreeCutOffMPI.pack(this);

  //cout<<"Cell::syncBoundFreeCutOff: Process: "<<mpiCom->rank()<<", index: "<<index()<<", responsible: "<<responsible<<", 1\n";

  // Broadcast bound-free cut-off
  boost::mpi::broadcast(*mpiCom,boundFreeCutOffMPI,responsible);

  //cout<<"Cell::syncBoundFreeCutOff: Process: "<<mpiCom->rank()<<", index: "<<index()<<", responsible: "<<responsible<<", 2\n";

  // If not responsible - Unpack bound-free cut-off
  if (mpiCom->rank()!=responsible) boundFreeCutOffMPI.unpack(this);

  //cout<<"Cell::syncBoundFreeCutOff: Process: "<<mpiCom->rank()<<", index: "<<index()<<", responsible: "<<responsible<<", 3\n";

  // Reset major edge
  majorEdge.resize(0);

  // For each (upward) bound-free transition
  for (i=0; i<atom.size(); i++)
    for (j=0; j<atom[i].iState.size(); j++)
      for (k=0; k<atom[i].iState[j].bState.size(); k++)
	for (l=0; l<atom[i].iState[j].bState[k].upTransBF.size(); l++)
	  // If major edge - Add to list
	  if (atom[i].iState[j].bState[k].upTransBF[l]->nuCutOff()==1e99) majorEdge.push_back(atom[i].iState[j].bState[k].upTransBF[l]);

  //cout<<"Cell::syncBoundFreeCutOff: Process: "<<mpiCom->rank()<<", index: "<<index()<<", responsible: "<<responsible<<", Return\n";

  //if (master()) cout<<"Cell::syncBoundFreeCutOff: index: "<<index()<<", Return\n";
}

// Get blackbody factor (2hnu^3/c^2)
// Subcells: Works
// Containers: Not applicable
double Cell::bBFactor(FrequencyBinIterator _nu, EdgeType edgeType) {
  
  if (bBFactorUpdate) {
    omp_set_lock(&bBFactorLock);
    // Testing!!!
    //if (mpiCom!=NULL) cout<<"Cell::bBFactor: Process: "<<mpiCom->rank()<<", index: "<<index()<<", Locked\n";
    if (bBFactorUpdate) { bBFactorTable(); bBFactorUpdate=false; }
    // Testing!!!
    //if (mpiCom!=NULL) cout<<"Cell::bBFactor: Process: "<<mpiCom->rank()<<", index: "<<index()<<", Unlock\n";
    omp_unset_lock(&bBFactorLock);
    }
  return pBBFactorTable(_nu,edgeType);
  //double x=pBBFactorTable(_nu,edgeType); if (x==0) cout<<"Cell::bBFactor: index: "<<index()<<", pBBFactorTable("<<nuEdge(_nu,edgeType)<<") returned zero\n"; return x;

  //return 2*h*pow(nuEdge(_nu,edgeType),3)*pow(c,-2);
}

// Create blackbody factor (2hnu^3/c^2) table
// Subcells: Works
// Containers: Not applicable
void Cell::bBFactorTable() {

  //cout<<"Cell::bBFactorTable: index: "<<index()<<", Enter, nuOld.end()-nOld.begin(): "<<nuOld.end()-nuOld.begin()<<"\n";

  // Create the blackbody factor tabulator
  pBBFactorTable.init(nuOld.begin(),nuOld.end(),BBFactor());

  //cout<<"Cell::bBFactorTable: index: "<<index()<<", Return\n";
}

// Get Boltzmann factor (e^(-hnu/kT))
// Subcells: Works
// Containers: Not applicable
double Cell::bMFactor(FrequencyBinIterator _nu, EdgeType edgeType) {
  
  if (bMFactorUpdate) {
    omp_set_lock(&bMFactorLock);
    // Testing!
    //if (mpiCom!=NULL) cout<<"Cell::bMFactor: Process: "<<mpiCom->rank()<<", index: "<<index()<<", Locked\n";
    if (bMFactorUpdate) { bMFactorTable(); bMFactorUpdate=false; }
    // Testing
    //if (mpiCom!=NULL) cout<<"Cell::bMFactor: Process: "<<mpiCom->rank()<<", index: "<<index()<<", Unlock\n";
    omp_unset_lock(&bMFactorLock);
  }
  return pBMFactorTable(_nu,edgeType);
  //double x=pBMFactorTable(_nu,edgeType); if (x==0) cout<<"Cell::bMFactor: index: "<<index()<<", pBMFactorTable("<<nuEdge(_nu,edgeType)<<") returned zero\n"; return x;
  
  //return exp(-(h*nuEdge(_nu,edgeType))/(k*pT));
}

// Create Boltzman factor (e^(-hnu/kT)) table
// Subcells: Works
// Containers: Not applicable
void Cell::bMFactorTable() {  

  //cout<<"Cell::bMFactorTable: index: "<<index()<<", Enter, nuOld.end()-nOld.begin(): "<<nuOld.end()-nuOld.begin()<<"\n";

  // Create the blackbody factor tabulator
  pBMFactorTable.init(nuOld.begin(),nuOld.end(),BMFactor(T()));

  //cout<<"Cell::bMFactorTable: index: "<<index()<<", Return\n";
}

// Calculate the opacity for compton absorption
// Subcells: Works
// Containers: Not applicable
double Cell::comptonAbsKappa(const double& comptonAbsSigma) const {
  double kappa,sumA=0,sumZ=0;
  int i,j;

  // Calculate Z and A per volume
  for (i=0;i<atom.size();i++)
    for (j=0;j<atom[i].isotope.size();j++) {
      sumZ+=atom[i].isotope[j].n()*atom[i].Z();
      sumA+=atom[i].isotope[j].n()*(atom[i].Z()+atom[i].isotope[j].N());
    }

  // Calculate the opacity
  if (sumA!=0) kappa=comptonAbsSigma*(sumZ/sumA)/0.5;
  // Hacky solution
  else kappa=0.0;

  return kappa;
}

//Calculate optical depth for next resonant line (knowing the line)
// Pointer version
// Subcells: Works
// Containers: Not applicable
// Note: This function should call TransBB::tau!!! Fix!!!
double Cell::lineTau(TransBB* trans) const {
  double tau;
  tau=tauSobolev(trans->Xi(),trans->lowerState->n(),trans->upperState->n(),trans->A(),trans->upperState->g(),trans->lowerState->g(),1/dvdr());
  return tau;
}

//Calculate optical depth for next resonant line (knowing the line)
// Iterator version
// Subcells: Works
// Containers: Not applicable
double Cell::lineTau(const LineIterator& lineIterator) const {
  return lineTau(*lineIterator);
}

// Calculate escape fraction for next resonant line (knowing the line)
// Pointer version
// Subcells: Works
// Containers: Not applicable
// Note: This function should call TransBB::beta!!! Fix!!!
double Cell::lineBeta(TransBB* trans) const {
  double tau,beta;
  tau=lineTau(trans);
  beta=(1-exp(-tau))/tau;
  return beta;
}

//Calculate escape fraction for next resonant line (knowing the line)
// Iterator version
// Subcells: Works
// Containers: Not applicable
double Cell::lineBeta(const LineIterator& lineIterator) const {
  return lineBeta(*lineIterator);
}

// Calculate collisional cooling rate
// Subcells: Works
// Containers: Works
double Cell::collCooling(double _T) {
  double _collCooling;
  int i,j; // Moved!

  // If container - Volume-average cooling over subcells and return - New!
  if (type()==cellContainer) { _collCooling=0; for (i=0;i<subCell.size();i++) _collCooling+=subCell[i]->collCooling(_T)*subCell[i]->fillFactor(); return _collCooling; }

  // If update requested or temperature supplied
  if (pCollCooling==update or (_T!=noT and _T!=T())) {

    // Get temperature if not supplied
    if (_T==noT) _T=T();

    // Initiate collisional cooling rate
    _collCooling=0;

    // For each atom
    for (i=0; i<atom.size(); i++) {
      // For each ion
      for (j=0; j<atom[i].iState.size(); j++) {
	// Add collisional cooling rate
	_collCooling+=atom[i].iState[j].collCooling(_T);
      }
    }

    // If requested - Update
    if (pCollCooling==update) {
      pCollCooling=_collCooling;
    }
  }
  // Else - Get collisional cooling rate
  else _collCooling=pCollCooling;

  return _collCooling;
}

// Calculate collisional heating rate
// Subcells: Works
// Containers: Works
double Cell::collHeating(double _T) const {
  double H=0;
  int i,j;

  // If container - Volume-average heating over subcells and return - New!
  if (type()==cellContainer) { for (i=0;i<subCell.size();i++) H+=subCell[i]->collHeating(_T)*subCell[i]->fillFactor(); return H; }

  // Get temperature if not supplied
  if (_T==noT) _T=T();

  // For each atom
  for (i=0; i<atom.size(); i++) {
    // For each ion
    for (j=0; j<atom[i].iState.size(); j++) {
      // Add collisional heating rate
      H+=atom[i].iState[j].collHeating(_T);
    }
  }

  return H;
}

// Calculate charge-transfer cooling rate - New!
// Subcells: Works
// Containers: Works
double Cell::CTCooling(double _T) {
  double _CTCooling;
  int i,j;

  // If container - Volume-average cooling over subcells and return
  if (type()==cellContainer) { _CTCooling=0; for (i=0;i<subCell.size();i++) _CTCooling+=subCell[i]->CTCooling(_T)*subCell[i]->fillFactor(); return _CTCooling; }

  // If update requested or temperature supplied
  if (pCTCooling==update or (_T!=noT and _T!=T())) {

    // Get temperature if not supplied
    if (_T==noT) _T=T();

    // Initiate charge-transfer cooling rate
    _CTCooling=0;

    // Sum charge-transfer rate for all charge-transfer reactions
    for (i=0; i<ctReaction.size(); i++) _CTCooling+=ctReaction[i].cooling(_T);

    // If requested - Update
    if (pCTCooling==update) pCTCooling=_CTCooling;
  }
  // Else - Get collisional cooling rate
  else _CTCooling=pCTCooling;

  return _CTCooling;
}

// Calculate collisional heating rate - New!
// Subcells: Works
// Containers: Works
double Cell::CTHeating(double _T) {
  double H=0;
  int i,j;

  // If container - Volume-average heating over subcells and return
  if (type()==cellContainer) { for (i=0;i<subCell.size();i++) H+=subCell[i]->CTHeating(_T)*subCell[i]->fillFactor(); return H; }

  // Get temperature if not supplied
  if (_T==noT) _T=T();

  // Sum charge-transfer heating for all charge-transfer reactions
  for (i=0; i<ctReaction.size(); i++) H+=ctReaction[i].heating(_T);

  return H;
}

// Get non-thermal collisional heating rate
// Subcells: Works
// Containers: Works
double Cell::nonThermalHeating() const {
  int i; // New!

  // If container - Volume-average heating over subcells and return - New!
  if (type()==cellContainer) { double _nonThermalHeating=0; for (i=0;i<subCell.size();i++) _nonThermalHeating+=subCell[i]->nonThermalHeating()*subCell[i]->fillFactor(); return _nonThermalHeating; }

  //if (master()) cout<<"Cell::nonThermalHeating(get): index: "<<index()<<", rate: "<<pNonThermalHeating<<"\n";

  return pNonThermalHeating;
}

// Set non-thermal collisional heating rate
// Subcells: Works
// Containers: Not applicable
void Cell::nonThermalHeating(const double& _nonThermalHeating) {

  if (!isnumber(pNonThermalHeating) or pNonThermalHeating<0) cout<<"Cell::nonThermalHeating: cell: "<<index()<<", Warning: Invalid rate: "<<pNonThermalHeating<<"\n";
  
  pNonThermalHeating=_nonThermalHeating;

  //if (master()) cout<<"Cell::nonThermalHeating(set): index: "<<index()<<", rate: "<<pNonThermalHeating<<"\n";
}

// Get non-thermal collisional excitation rate
// Subcells: Works
// Containers: Not applicable
double Cell::nonThermalExcitation() const {

  return pNonThermalExcitation;
}

// Set non-thermal collisional excitation rate
// Subcells: Works
// Containers: Not applicable
void Cell::nonThermalExcitation(const double& _nonThermalExcitation) {

  pNonThermalExcitation=_nonThermalExcitation;
}

// Get non-thermal collisional ionization rate
// Subcells: Works
// Containers: Not applicable
double Cell::nonThermalIonization() const {

  return pNonThermalIonization;
}

// Set non-thermal collisional ionization rate
// Subcells: Works
// Containers: Not applicable
void Cell::nonThermalIonization(const double& _nonThermalIonization) {

  pNonThermalIonization=_nonThermalIonization;
}

// Calculate cooling rate
// Subcells: Works
// Containers: Works
double Cell::cooling(Processes& processes, double _T) {
  double C=0;
  if (_T==noT) _T=T();

  if (processes(pBoundBound|pBoundFree,pCollisional)) C+=collCooling(_T);
  if (processes(pFreeFree)) C+=freeFreeCooling(_T);
  if (processes(pBoundFree,pRadiative)) C+=boundFreeCooling(_T);
  if (processes(pBoundFree,pChargeTransfer)) C+=CTCooling(_T); // New!

  return C;
}

// Calculate heating rate
// Subcells: Works
// Containers: Works
//double Cell::heating(Processes& processes, double _T) const {
double Cell::heating(Processes& processes, double _T) {
  double H=0;
  if (_T==noT) _T=T();

  if (processes(pBoundBound|pBoundFree,pCollisional)) H+=collHeating(_T);
  if (processes(pFreeFree)) H+=freeFreeHeating(_T);
  if (processes(pBoundFree,pRadiative)) H+=boundFreeHeating(_T);
  if (processes(pNonThermal)) H+=nonThermalHeating();
  if (processes(pBoundFree,pChargeTransfer)) H+=CTHeating(_T); // New!

  return H;
}

// Update recombination correction - New!
void Cell::updateAlfaCorr() {
  int i;

  // If container - update recombination correction for each subcell and return
  if (type()==cellContainer) { for (i=0;i<subCell.size();i++) subCell[i]->updateAlfaCorr(); return; }

  // Update recombination correction for each atom
  for (i=0; i<atom.size(); i++) atom[i].updateAlfaCorr();
}

// Total continuum opacity (as a function of frequency)
// Subcells: Works
// Containers: Works
double Cell::contKappaNu(const double& nu, const Processes& processes) {
  double kappa=0;
  int i; // New! - Testing!  

  // If container - Mass-average opacity over subcells and return - New! - Testing!
  if (type()==cellContainer) {for (i=0;i<subCell.size();i++) kappa+=subCell[i]->contKappaNu(nu,processes)*subCell[i]->rho()*subCell[i]->fillFactor(); kappa=kappa/rho(); return kappa; }
  
  if (processes(pEScatter)) kappa+=electronScatterKappa();
  if (processes(pBoundFree)) kappa+=boundFreeAbsKappa(nu);
  if (processes(pFreeFree)) kappa+=freeFreeAbsKappa(nu);
  // Suspend this warning
  //if (kappa==0) cout<<"Cell::contKappaNu: index: "<<index()<<", Warning: Zero continuum opacity at "<<(c/nu)/AA<<" Angstrom\n";

  return kappa;
}

// Total continuum opacity (as a function of frequency) - New!
// Subcells: Works
// Containers: Works
double Cell::contKappaNu(FrequencyBinIterator nu, const Processes& processes, EdgeType edgeType) {
  double kappa=0;
  int i; // New! - Testing!

  // If container - Mass-average opacity over subcells and return - New! - Testing!
  // Note: Can not use iterator here as this refers to container frequency bin list
  if (type()==cellContainer) {for (i=0;i<subCell.size();i++) kappa+=subCell[i]->contKappaNu(nuEdge(nu,edgeType),processes)*subCell[i]->rho()*subCell[i]->fillFactor(); kappa=kappa/rho(); return kappa; }
  
  if (processes(pEScatter)) kappa+=electronScatterKappa();
  if (processes(pBoundFree)) kappa+=boundFreeAbsKappa(nu,edgeType);
  if (processes(pFreeFree)) kappa+=freeFreeAbsKappa(nuEdge(nu,edgeType));
  // Suspend this warning
  //if (kappa==0) cout<<"Cell::contKappaNu: index: "<<index()<<", Warning: Zero continuum opacity at "<<(c/nu)/AA<<" Angstrom\n";

  return kappa;
}

// Total MC opacity (as a function of frequency) - New!
// Subcells: Works
// Containers: Works
double Cell::kappaMCNu(const double& nu, const Processes& processes) {
  double kappa=0;
  int i; 

  // If container - Mass-average opacity over subcells and return - New! - Testing!
  if (type()==cellContainer) {for (i=0;i<subCell.size();i++) kappa+=subCell[i]->kappaMCNu(nu,processes)*subCell[i]->rho()*subCell[i]->fillFactor(); kappa=kappa/rho(); return kappa; }
  
  FrequencyBinIterator nuBin=nuOld.find(nu);

  if (nuBin!=nuOld.end()) {
    kappa=0;
    if (processes(pBoundFree)) kappa+=kappaBFNu[nuBin-nuOld.begin()];
    if (processes(pFreeFree)) kappa+=kappaFFNu[nuBin-nuOld.begin()];
    if (processes(pBoundBound)) kappa+=kappaBBNu[nuBin-nuOld.begin()];
    if (processes(pEScatter)) kappa+=kappaESNu[nuBin-nuOld.begin()];
  }
  else kappa=0; // Hmm ...

  // Suspend this warning
  //if (kappa==0) cout<<"Cell::kappaMCNu: index: "<<index()<<", Warning: Zero continuum opacity at "<<(c/nu)/AA<<" Angstrom\n";

  return kappa;
}

// Total MC opacity (as a function of frequency) - New!
// Subcells: Works
// Containers: Works
double Cell::kappaMCNu(FrequencyBinIterator nu, const Processes& processes, EdgeType edgeType) {
  double kappa=0;
  int i;

  // If container - Mass-average opacity over subcells and return - New! - Testing!
  // Note: Can not use iterator here as this refers to container frequency bin list
  if (type()==cellContainer) {for (i=0;i<subCell.size();i++) kappa+=subCell[i]->kappaMCNu(nuEdge(nu,edgeType),processes)*subCell[i]->rho()*subCell[i]->fillFactor(); kappa=kappa/rho(); return kappa; }

  if (nu!=nuOld.end()) {
    kappa=0;
    if (processes(pBoundFree)) kappa+=kappaBFNu[nu-nuOld.begin()];
    if (processes(pFreeFree)) kappa+=kappaFFNu[nu-nuOld.begin()];
    if (processes(pBoundBound)) kappa+=kappaBBNu[nu-nuOld.begin()];
    if (processes(pEScatter)) kappa+=kappaESNu[nu-nuOld.begin()];
  }
  else kappa=0; // Hmm ...

  // Suspend this warning
  //if (kappa==0) cout<<"Cell::kappaMCNu: index: "<<index()<<", Warning: Zero continuum opacity at "<<(c/nu)/AA<<" Angstrom\n";

  return kappa;
}

// Rosseland mean opacity (Monte-carlo version)
// Note: Currentely assumes nuMin==nuOld[0].min and nuMax==nuOld[nu.size()-1].max!!!
// Subcells and normal cells: Works
// Containers: Works
double Cell::rossKappaMC2(const Processes& processes, double nuMin, double nuMax, int nPacket) {
  if (type()==cellContainer) return rossKappaMC2Container(processes,nuMin,nuMax,nPacket);
  else return rossKappaMC2Normal(processes,nuMin,nuMax,nPacket);
}

// Rosseland mean opacity (Monte-carlo version for container cells)
// Note: Currentely assumes nuMin==nuOld[0].min and nuMax==nuOld[nu.size()-1].max!!!
// Subcells and normal cells: Not applicable
// Containers: Works
double Cell::rossKappaMC2Container(const Processes& processes, double nuMin, double nuMax, int nPacket) {
  double l,dl,tau,lClump,lMean=0,f23Tot=0,PTot,absTau,z,x,nuPacket,kk;
  bool absorbed;
  vector<double> f23(subCell.size()),R(subCell.size());
  vector<double> F(nuOld.size()+1);
  vector<FunctionValue> FInvTable(nuOld.size()+1);
  Interpolator1D FInv;
  LineIterator nextLine;
  int i,j,n=0,subCellIndex,nMax=10;

  // Hack!!!
  srand(getpid());

  // Get (and normalize) filling-factor to the power of 2/3
  for (i=0;i<subCell.size();i++) { f23[i]=pow(subCell[i]->fillFactor(),(2.0/3.0)); f23Tot+=f23[i]; }
  for (i=0;i<subCell.size();i++) f23[i]=f23[i]/f23Tot;

  // Get clump radius
  // Note: Cast to CellSS!! Hack!!!
  for (i=0;i<subCell.size();i++) R[i]=((CellSS*) subCell[i])->rMaxV(true);

  // Calculate blackbody temperature derivative CDF
  F[0]=0,0;
  for (i=0;i<nuOld.size();i++) F[i+1]=F[i]+BlackBody::dBdT(nuOld[i].min,nuOld[i].max,T(),1e-4);
  for (i=0;i<F.size();i++) F[i]=F[i]/F[F.size()-1];

  // If no frequency bin list present - exit with error
  if (nuOld.size()==0) { cout<<"Cell::rossContKappaMC: Error: Frequency bin list not initiated!\n"; exit(-1); }

  // Calculate inverse blackbody CDF table
  FInvTable[0].x=0.0; FInvTable[0].f=nuOld[0].min;
  for (i=0;i<nuOld.size();i++) { FInvTable[i+1].x=F[i]; FInvTable[i+1].f=nuOld[i].max; }

  // Initiate inverse blackbody CDF interpolator
  FInv.init(FInvTable);

  // For each MC packet
  for (i=0;i<nPacket;i++) {

    // Draw frequency
    //z=randomize(0,1));
    // Hack!!!
    z=double(rand())/RAND_MAX;
    nuPacket=FInv(z);
   
    // Draw optical depth for absorption
    //absTau=-log(randomize(0,1));
    // Hack!!!
    z=double(rand())/RAND_MAX;
    absTau=-log(z);
    
    // Initialize pathlength and optical depth
    l=0; tau=0;
    
    // While accumulated depth less than absorption depth
    // Remove last condition - n not updated!
    while (tau<absTau and n<nMax) {
      
      // Draw a subcell index for the clump
      //z=randomize(0,1);
      // Hack!!!
      z=double(rand())/RAND_MAX;
      PTot=0;
      for (subCellIndex=0;subCellIndex<f23.size();subCellIndex++) {
	PTot+=f23[subCellIndex];
	if (z<=PTot) break;
      }
      
      // Draw a pathlength through the clump
      //z=randomize(0,1);
      // Hack!!!
      z=double(rand())/RAND_MAX;
      x=sqrt(z);
      lClump=2*R[subCellIndex]*sqrt(1-pow(x,2));

      // Calculate continuum opacity (per volume)
      kk=subCell[subCellIndex]->contKappaNu(nuPacket,processes)*subCell[subCellIndex]->rho();

      // If bound-bound processes included - New! - Testing!
      if (processes(pBoundBound)) {

	// Find next line in list
	nextLine=subCell[subCellIndex]->line.find(h*nuPacket);

	// While end-of-linelist not reached
	while (not subCell[subCellIndex]->endOfLineList(nextLine)) {
	  // Calculate path-length to next line
	  dl=subCell[subCellIndex]->lineDistance(nextLine,nuPacket);
	  // If absorbtion occurs before - Break
	  if (dl>(absTau-tau)/kk) break;
	  // If clump-crossing occurs before - Break
	  if (dl>lClump) break;
	  // Update residual clump path-length
	  lClump-=dl;
	  // Update accumulated path-length
	  l+=dl;
	  // Update packet frequency
	  nuPacket=(*nextLine)->nu();
	  // Update accumulated optical depth
	  tau+=subCell[subCellIndex]->lineTau(nextLine)+dl*kk;
	  // If no optical depth left to travel - Break
	  if (tau>=absTau) break;
	  // Step to next line in list
	  nextLine++;
	}
      }

      // If optical depth left to travel - Changed! - Testing!
      if (tau<absTau) {
	// If clump path-length left to travel
	if (lClump>0) {
	  // Determine if absorbed in the clump
	  if (kk!=0) absorbed=((absTau-tau)/kk<lClump);
	  else absorbed=false;
	}
	// Else - Set absorbed to false
	else absorbed=false;
      }
      // Else - Set absorbed to true;
      else absorbed=true;
      
      // Determine if absorbed in the clump - Removed - Testing!
      //if (kk!=0) absorbed=((absTau-tau)/kk<lClump);
      //else absorbed=false;
      
      // If absorbed in the clump
      if (absorbed) {
	// Add pathlength and break
	l+=MAX(absTau-tau,0.0)/kk;
	break;
      }
      // Else
      else {
	// Add optical depth and pathlength
	tau+=lClump*kk;
	l+=lClump;
	// Calculate new frequency
	nuPacket*=(1-(lClump*dvdr())/c);
      }
    }
    
    // Calculate mean free path
    lMean+=l/nPacket;
  }
  
  return (1/lMean)/rho();
}

// Rosseland mean opacity (Monte-carlo version for normal cells and subcells)
// Note: Currentely assumes nuMin==nuOld[0].min and nuMax==nuOld[nu.size()-1].max!!!
// Subcells and normal cells: Works
// Containers: Not applicable
double Cell::rossKappaMC2Normal(const Processes& processes, double nuMin, double nuMax, int nPacket) {
  double l,dl,tau,lClump,lMean=0,PTot,absTau,z,x,nuPacket,kk;
  bool absorbed;
  vector<double> F(nuOld.size()+1);
  vector<FunctionValue> FInvTable(nuOld.size()+1);
  Interpolator1D FInv;
  LineIterator nextLine;
  int i,j,n=0,subCellIndex,nMax=10;

  // Hack!!!
  srand(getpid());

  // Calculate blackbody temperature derivative CDF
  F[0]=0,0;
  for (i=0;i<nuOld.size();i++) F[i+1]=F[i]+BlackBody::dBdT(nuOld[i].min,nuOld[i].max,T(),1e-4);
  for (i=0;i<F.size();i++) F[i]=F[i]/F[F.size()-1];

  // If no frequency bin list present - exit with error
  if (nuOld.size()==0) { cout<<"Cell::rossContKappaMC: Error: Frequency bin list not initiated!\n"; exit(-1); }

  // Calculate inverse blackbody CDF table
  FInvTable[0].x=0.0; FInvTable[0].f=nuOld[0].min;
  for (i=0;i<nuOld.size();i++) { FInvTable[i+1].x=F[i]; FInvTable[i+1].f=nuOld[i].max; }

  // Initiate inverse blackbody CDF interpolator
  FInv.init(FInvTable);

  // For each MC packet
  for (i=0;i<nPacket;i++) {

    // Draw frequency
    //z=randomize(0,1));
    // Hack!!!
    z=double(rand())/RAND_MAX;
    nuPacket=FInv(z);
   
    // Draw optical depth for absorption
    //absTau=-log(randomize(0,1));
    // Hack!!!
    z=double(rand())/RAND_MAX;
    absTau=-log(z);
    
    // Initialize pathlength and optical depth
    l=0; tau=0;
          
    // Calculate continuum opacity (per volume)
    kk=contKappaNu(nuPacket,processes)*rho();

    // If bound-bound processes included - New! - Testing!
    if (processes(pBoundBound)) {

      // Find next line in list
      nextLine=line.find(h*nuPacket);

      // While end-of-linelist not reached
      while (not endOfLineList(nextLine)) {
	// Calculate path-length to next line
	dl=lineDistance(nextLine,nuPacket);
	// If absorbtion occurs before - Break
	if (dl>(absTau-tau)/kk) break;
	// Update accumulated path-length
	l+=dl;
	// Update packet frequency
	nuPacket=(*nextLine)->nu();
	// Update accumulated optical depth
	tau+=lineTau(nextLine)+dl*kk;
	// If no optical depth left to travel - Break
	if (tau>=absTau) break;
	// Step to next line in list
	nextLine++;
      }
    }

    // If optical depth left to travel - Add path-length
    if (tau<absTau) l+=MAX(absTau-tau,0.0)/kk;
    
    // Calculate mean free path
    lMean+=l/nPacket;
  }
  
  return (1/lMean)/rho();
}

// Rosseland mean (continuum) opacity integrands
// Subcells: Works
// Containers: Not applicable
class RossIntegrand1 {
public:
  Cell* cell;
  const Processes processes;
  const double T;
  RossIntegrand1(Cell* _cell, const double& _T, const Processes& _processes) : cell(_cell), T(_T), processes(_processes) {};
  double operator()(double nu, EdgeType edgeType=noEdge) const { return BlackBody::dBdT(nuEdge(nu,edgeType),T)/cell->contKappaNu(nuEdge(nu,edgeType),processes); }
  double operator()(FrequencyBinIterator nu, EdgeType edgeType=noEdge) const { return BlackBody::dBdT(nuEdge(nu,edgeType),T)/cell->contKappaNu(nu,processes,edgeType); }
};
// Rosseland mean (continuum) opacity integrand
// Subcells: Works
// Containers: Not applicable
class RossIntegrand2 {
public:
  const Cell* cell;
  const double T;
  RossIntegrand2(const Cell* _cell, const double& _T, const Processes& _processes) : cell(_cell), T(_T) {};
  double operator()(double nu) const { return BlackBody::dBdT(nu,T); }
};

// Rosseland mean (continuum) opacity - Changed - Testing!
// Subcells: Works
// Containers: Works
double Cell::rossContKappa(const Processes& processes, double nuMin, double nuMax, double tol, bool containerMC) {
  double kappa=0; // Changed!
  RossIntegrand1 integrand1(this,T(),processes);
  RossIntegrand2 integrand2(this,T(),processes);
  //bool useIterator=false;
  // Testing!
  bool useIterator=true;
  //bool restoreBoundFreeCutOff=false;
  int i,j,k;
  // Testing
  int nIter1,nIter2;
  // Testing!
  int nIterMin=1,nIterMax=4,nBinMax=16;

  // If container - Mass-average opacity over subcells and return - New!
  // Removed - do the average before integrating! - Testing!
  //if (type()==cellContainer) { kappa=0; for (i=0;i<subCell.size();i++) kappa+=subCell[i]->rossContKappa(processes,nuMin,nuMax,tol)*subCell[i]->rho()*subCell[i]->fillFactor(); kappa=kappa/rho(); return kappa; }

  // If container and MC calculation requested - Return MC Rosseland mean opacity
  if (type()==cellContainer and containerMC) return rossKappaMC2(processes,nuMin,nuMax,100000);

  // If grey processes only - New!
  if (not (processes(pBoundFree) or processes(pFreeFree))) {
    // Add opacity
    if (processes(pEScatter)) kappa+=electronScatterKappa();
    if (processes(pGScatter)) kappa+=greyScatterKappa();
    // Return
    return kappa;
  }

  if (nuMin==-1) { if (nu.size()>0) nuMin=nu[0].min; else nuMin=c/(1e5*AA); }
  if (nuMax==-1) { if (nu.size()>0) nuMax=nu[nu.size()-1].max; else nuMax=c/(1e2*AA); }

  // Exclude frequency regions where on-the-spot approximation is used
  // Obsolete - Only applies to old OSP method!
  for (i=0;i<atom.size();i++)
    if (atom[i].onTheSpot())
      for (j=0;j<atom[i].iState.size();j++) 
	if (atom[i].iState[j].bState.size()>0)
	  for (k=0;k<atom[i].iState[j].bState[0].upTransBF.size();k++)
	    if (atom[i].iState[j].bState[0].upTransBF[k]->nu()<nuMax) nuMax=atom[i].iState[j].bState[0].upTransBF[k]->nu()*(1-0.5*config->boundFreeTableEdgeWidth);

  // If necessary - Update bound-free cut-off using Rosseland specific value
  //if ((not config->boundFreeTable) or boundFreeTableUpdate) { updateBoundFreeCutOff(false,MAX(config->boundFreeCutOffRoss,config->boundFreeCutOff)); boundFreeCutOffUpdate=false; restoreBoundFreeCutOff=true; }

  //if (master()) cout<<"Cell::rossContKappa: index: "<<index()<<", Integration started\n";
  
  if (nu.size()==0) kappa=Integrator<RossIntegrand2>::romberg(integrand2,nuMin,nuMax,nIter1,tol)/Integrator<RossIntegrand1>::romberg(integrand1,nuMin,nuMax,nIter2,tol);
  else kappa=Integrator<RossIntegrand2>::romberg(integrand2,nuMin,nuMax,nIter1,tol)/BFIntegrator<RossIntegrand1>::trapezoidalPW(integrand1,nuMin,nuMax,nuOld,nIter2,tol,0,useIterator,"",nIterMin,nIterMax,nBinMax);

  //if (master()) cout<<"Cell::rossContKappa: index: "<<index()<<", Integration finished\n";

  // If necessary - Make sure bound-free cut-off is subsequently updated using default value
  //if (restoreBoundFreeCutOff) { boundFreeTableUpdate=true; boundFreeCutOffUpdate=true; }

  if (!isnumber(kappa)) cout<<"Cell::rossContKappa: Invalid opacity: "<<kappa<<"\n";

  return kappa;
}

// Continuum opacity integrand
// Subcells: Works
// Containers: Not applicable
class ContKappaIntegrand : public JIntegrand {
public:
  Cell* cell;
  const Processes processes;
  ContKappaIntegrand(Cell* _cell, const Processes& _processes) : cell(_cell), processes(_processes) {};
  double operator()(double nu) const { return cell->contKappaNu(nu,processes); }
  double operator()(FrequencyBinIterator nu, EdgeType edgeType=noEdge) const { return 0.0; };
};

// Energy mean (continuum) opacity
// Subcells: Works
// Containers: Works
double Cell::energyContKappa(const Processes& processes) {
  double kappa=0,nuMin,nuMax,tol=1e-2; // Changed!
  ContKappaIntegrand integrand(this,processes);
  int i,j,k;
  // Testing
  int nIter;

  // If container - Mass-average opacity over subcells and return - New!
  if (type()==cellContainer) { kappa=0; for (i=0;i<subCell.size();i++) kappa+=subCell[i]->energyContKappa(processes)*subCell[i]->rho()*subCell[i]->fillFactor(); kappa=kappa/rho(); return kappa; }

  // If grey processes only - New!
  if (not (processes(pBoundFree) or processes(pFreeFree))) {
    // Add opacity
    if (processes(pEScatter)) kappa+=electronScatterKappa();
    if (processes(pGScatter)) kappa+=greyScatterKappa();
    // Return
    return kappa;
  }

  if (not radUpdated) {cout<<"Cell::energyContKappa: cell: "<<index()<<", Error: Radiation field not updated\n"; return 0.0; }

  nuMin=nu[0].min; nuMax=nu[nu.size()-1].max;

  // Exclude frequeny regions where on-the-spot approximation is used
  // Obsolete - Only applies to old OSP method!
  for (i=0;i<atom.size();i++)
    if (atom[i].onTheSpot())
      for (j=0;j<atom[i].iState.size();j++) 
	if (atom[i].iState[j].bState.size()>0)
	  for (k=0;k<atom[i].iState[j].bState[0].upTransBF.size();k++)
	    if (atom[i].iState[j].bState[0].upTransBF[k]->nu()<nuMax) nuMax=atom[i].iState[j].bState[0].upTransBF[k]->nu()*(1-0.5*config->boundFreeTableEdgeWidth);
  
  kappa=JIntegrate(integrand,nuMin,nuMax,nIter,tol)/J;
  
  //if (master()) cout<<"Cell::energyContKappa: index: "<<index()<<", Energy mean (continuum) opacity integrated over ("<<(c/nuMax)/AA<<","<<(c/nuMin)/AA<<"): "<<kappa<<"\n";
  
  return kappa;
}

// MC-based opacity integrand
// Subcells: Works
// Containers: Not applicable
/*class kappaMCIntegrand : public JIntegrand {
public:
  Cell* cell;
  kappaMCIntegrand(Cell* _cell) : cell(_cell) {};
  double operator()(double nu) const { return cell->kappaMCNu(nu); }
  double operator()(FrequencyBinIterator nu, EdgeType edgeType=noEdge) const { return cell->kappaMCNu(nu,edgeType); };
  };*/

// Energy mean (total) MC-based opacity
// Subcells: Works
// Containers: Works
double Cell::energyKappaMC(const Processes& processes) {
  double energyKappa=0;
  int i;

  if (not radUpdated) {cout<<"Cell::energyKappaMC: Error: Radiation field not updated\n"; return 0.0; }

  // For each frequency bin
  for (i=0;i<nuOld.size();i++) {
    if (processes(pBoundFree)) energyKappa+=kappaBFJNu[i];
    if (processes(pFreeFree)) energyKappa+=kappaFFJNu[i];
    if (processes(pBoundBound)) energyKappa+=kappaBBJNu[i];
    if (processes(pEScatter)) energyKappa+=kappaESJNu[i];
  }
  energyKappa=energyKappa/(J*rho());
  
  return energyKappa;
}

// Flux mean (total) MC-based opacity - New!
// Subcells: Works
// Containers: Works
double Cell::fluxKappaMC(const Processes& processes) {
  double fluxKappa=0;
  int i;

  if (not radUpdated) {cout<<"Cell::fluxKappaMC: Error: Radiation field not updated\n"; return 0.0; }

  // For each frequency bin
  for (i=0;i<nuOld.size();i++) {
    if (processes(pBoundFree)) fluxKappa+=kappaBFHNu[i];
    if (processes(pFreeFree)) fluxKappa+=kappaFFHNu[i];
    if (processes(pBoundBound)) fluxKappa+=kappaBBHNu[i];
    if (processes(pEScatter)) fluxKappa+=kappaESHNu[i];
  }
  fluxKappa=fluxKappa/(H*rho());
  
  return fluxKappa;
}

// Rosseland mean (total) MC-based opacity - New!
// Subcells: Works
// Containers: Works
double Cell::rossKappaMC(const Processes& processes) {
  double rossKappa,kappa,nuMid,dnu,weight,integral1=0,integral2=0;
  int i;

  if (not radUpdated) {cout<<"Cell::rossKappaMC: Error: Radiation field not updated\n"; return 0.0; }

  // For each frequency bin
  for (i=0;i<nuOld.size();i++) {
    kappa=0;
    if (processes(pBoundFree)) kappa+=kappaBFNu[i];
    if (processes(pFreeFree)) kappa+=kappaFFNu[i];
    if (processes(pBoundBound)) kappa+=kappaBBNu[i];
    if (processes(pEScatter)) kappa+=kappaESNu[i];
    // If non-zero MC-based opacity
    if (kappa!=0) {
      nuMid=(nuOld[i].max+nuOld[i].min)/2; dnu=nuOld[i].max-nuOld[i].min;
      weight=BlackBody::dBdT(nuMid,T());
      integral1+=(weight/kappa)*dnu;
      integral2+=weight*dnu;
    }
  }
  // Calculate Rosseland mean opacity
  rossKappa=integral2/integral1;
  
  return rossKappa;
}

// Rosseland mean (total) MC-based opacity - New version!
// Subcells: Works
// Containers: Works
/*double Cell::rossKappaMC(const Processes& processes) {
  double rossKappa,nAbs,lMean,nuMid,dnu,weight,integral1=0,integral2=0;
  int i;

  if (not radUpdated) {cout<<"Cell::rossKappaMC: Error: Radiation field not updated\n"; return 0.0; }

  // For each frequency bin
  for (i=0;i<nuOld.size();i++) {
    nAbs=0;
    if (processes(pBoundFree)) nAbs+=nAbsBFNu[i];
    if (processes(pFreeFree)) nAbs+=nAbsFFNu[i];
    if (processes(pBoundBound)) nAbs+=nAbsBBNu[i];
    if (processes(pEScatter)) nAbs+=nAbsESNu[i];
    lMean=lNu[i]/MAX(nAbs,1.0);
    nuMid=(nuOld[i].max+nuOld[i].min)/2; dnu=nuOld[i].max-nuOld[i].min;
    weight=BlackBody::dBdT(nuMid,T());
    integral1+=(weight*lMean)*dnu;
    integral2+=weight*dnu;
  }
  // Calculate Rosseland mean opacity
  rossKappa=integral2/integral1;

  return rossKappa;
}*/

// Calculate the heating-cooling difference
// Subcells: Works
// Containers: Not applicable
double Cell::G(Processes& processes, double _T) {
  double _G;
  if (_T==noT) _T=T();

  _G=heating(processes,_T)-cooling(processes,_T);

  return _G;
}

// Calculate derivative of the heating-cooling difference
// Subcells: Works
// Containers: Not applicable
double Cell::dGdT(Processes& processes) {
  double _dGdT,dTDerivative=1e-6;

  // Calculate derivative of the heating-cooling difference
  _dGdT=(G(processes,pT*(1+0.5*dTDerivative))-G(processes,pT*(1-0.5*dTDerivative)))/(pT*dTDerivative);

  return _dGdT;
}

// Update collisional excitation probability list
// Subcells: Works
// Containers: Not applicable
void Cell::updateCollExcitePList() {
  double z,totalCooling,PTot;
  TransP transP;
  BState* bState;
  TransPList collExcitePListWork;
  int i,j,k,l;

  // Reset collisional excitation probability list
  collExcitePList.resize(0);
  collExcitePListWork.resize(0);

  // Get total collisional cooling
  totalCooling=collCooling();

  // For each atom
  for (i=0; i<atom.size(); i++) {
    // For each ionization state
    for (j=0; j<atom[i].iState.size(); j++) {
      // For each bound state
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {
	
	// Set bound state pointer
	bState=&(atom[i].iState[j].bState[k]);
	
	// For each upward bound-bound transition
	for (l=0; l<bState->upTransBB.size(); l++) {
	  
	  transP.trans=bState->upTransBB[l];
	  transP.index=l; // New! - Removed!
	  transP.type=collisional;
	  transP.upward=true;
	  transP.P=bState->upTransBB[l]->CU()*bState->upTransBB[l]->Xi()/totalCooling;
	  
	  // If boost mode - Adjust transition probability - New!
	  if (config->boost) transP.P=transP.P*bState->upTransBB[l]->upperState->markovPBoost()/collCoolingBoost();
	  
	  // Add entry to list
	  collExcitePListWork.push_back(transP);
	}
	  
	// For each upward bound-free transition
	for (l=0; l<bState->upTransBF.size(); l++) {
	  
	  transP.trans=bState->upTransBF[l];
	  transP.index=l; // New! - Removed!
	  transP.type=collisional;
	  transP.upward=true;
	  transP.P=bState->upTransBF[l]->CU()*bState->upTransBF[l]->Xi()/totalCooling;
	  
	  // If boost mode - Adjust transition probability - New!
	  if (config->boost) transP.P=transP.P*bState->upTransBF[l]->upperState->markovPBoost()/collCoolingBoost();
	  
	  // Add entry to list
	  collExcitePListWork.push_back(transP);	  
	}
      }
    }
  }
  
  // Sort out collisional transitions above limit
  // May not work in boost mode!
  for (i=0; i<collExcitePListWork.size(); i++) 
    if (collExcitePListWork[i].P>config->collExciteTableLim) collExcitePList.push_back(collExcitePListWork[i]);
	
  // Renormalize collisional transition probability list
  // Unclear if muliple initializers work - Fix!
  PTot=0; for (i=0; i<collExcitePList.size(); i++) PTot+=collExcitePList[i].P; // Changed!
  for (i=0; i<collExcitePList.size(); i++)  collExcitePList[i].P=collExcitePList[i].P/PTot;

  // Sort collisional excitation probability list
  collExcitePList.sort();
}

// Draw collisional excitation transition
// Subcells: Works
// Containers: Not applicable
Trans* Cell::collExcite() {
  if (config->collExciteTable) return collExciteTable();
  else return collExciteCalc();
}

// Draw collisional excitation transition - Real time version
// Subcells: Works
// Containers: Not applicable
Trans* Cell::collExciteCalc() {
  double z,totalCooling,P,PTot=0;
  int i,j,k,l;

  // Pick a random number between 0 and 1
  z=randomize(0,1);

  // Get total collisional cooling
  totalCooling=collCooling();

  // For each atom
  for (i=0; i<atom.size(); i++) {
    // For each ionization state
    for (j=0; j<atom[i].iState.size(); j++) {
      // For each bound state
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {
	
	// For each upward bound-bound transition
	for (l=0; l<atom[i].iState[j].bState[k].upTransBB.size(); l++) {
	  // Calculate transition probability
	  P=atom[i].iState[j].bState[k].upTransBB[l]->CU()*atom[i].iState[j].bState[k].upTransBB[l]->Xi()/totalCooling;
	  // If boost mode - Adjust transition probability - New!
	  if (config->boost) P=P*atom[i].iState[j].bState[k].upTransBB[l]->upperState->markovPBoost()/collCoolingBoost();
	  // If drawn return transition
	  if (z<PTot+P) return atom[i].iState[j].bState[k].upTransBB[l];
	  // Else increase total probablility and continue
	  else PTot+=P;
	}
	
	// For each upward bound-free transition
	for (l=0; l<atom[i].iState[j].bState[k].upTransBF.size(); l++) {
	  // Calculate transition probability
	  P=atom[i].iState[j].bState[k].upTransBF[l]->CU()*atom[i].iState[j].bState[k].upTransBF[l]->Xi()/totalCooling;
	  // If boost mode - Adjust transition probability - New!
	  if (config->boost) P=P*atom[i].iState[j].bState[k].upTransBF[l]->upperState->markovPBoost()/collCoolingBoost();
	  // If drawn return transition
	  if (z<PTot+P) return atom[i].iState[j].bState[k].upTransBF[l];
	  // Else increase total probablility and continue
	  else PTot+=P;
	}
      }
    }
  }

  cout<<"Cell::collExciteCalc: Error: No transition drawn\n";
  cout<<"Cell::collExciteCalc: z: "<<z<<", PTot: "<<PTot<<"\n";
  //exit(-1);

  // This should not happen!
  return NULL;
}

// Draw collisional excitation transition - Table version
// Subcells: Works
// Containers: Not applicable
Trans* Cell::collExciteTable() {
  double z,PTot=0;
  int i;

  // Pick a random number between 0 and 1
  z=randomize(0,1);

  // For each entry in transition probability list
  for (i=0; i<collExcitePList.size(); i++) {

    // Update cumulative probability
    PTot+=collExcitePList[i].P;

    // If drawn return transition
    if (z<PTot) return collExcitePList[i].trans;
    //if (z<=PTot) return collExcitePList[i].trans; // Change to this?
  }

  cout<<"Cell::collExciteTable: Error: No transition drawn\n";
  cout<<"Cell::collExciteTable: z: "<<z<<", PTot: "<<PTot<<"\n";
  //exit(-1);

  // This should not happen!
  return NULL;
}

// Update charge-transfer excitation probability list - New!
// Subcells: Works
// Containers: Not applicable
void Cell::updateCTExcitePList() {
  double z,totalCooling,PTot;
  TransP transP;
  int i;

  // Reset charge-transfer excitation probability list
  CTExcitePList.resize(0);

  // Get total charge-transfer cooling
  totalCooling=CTCooling();

  // For each charge-transfer reaction
  for (i=0; i<ctReaction.size(); i++) {

    transP.trans=ctReaction[i].upTrans;
    transP.index=i; // New! - Removed! - Does not work! - Fix!!!
    transP.type=chargeTransferBF;
    transP.upward=true;
    //transP.P=ctReaction[i].cooling()/totalCooling;
    transP.P=ctReaction[i].forwardCooling()/totalCooling;

    // If boost mode - Adjust transition probability - New!
    // Boost does not work for charge-transfer yet! Fix!
    //if (config->boost) transP.P=transP.P*bState->upTransBB[l]->upperState->markovPBoost()/CTCoolingBoost();

    // Add entry to list
    CTExcitePList.push_back(transP);

    transP.trans=ctReaction[i].downTrans;
    transP.index=i; // New! - Removed! - Does not work! - Fix!!!
    transP.type=chargeTransferBF;
    transP.upward=true;
    transP.P=ctReaction[i].backwardCooling()/totalCooling;

    // If boost mode - Adjust transition probability - New!
    // Boost does not work for charge-transfer yet! Fix!
    //if (config->boost) transP.P=transP.P*bState->upTransBB[l]->upperState->markovPBoost()/CTCoolingBoost();
	    	    
    // Add entry to list
    CTExcitePList.push_back(transP);
  }

  // Sort charge-transfer excitation probability list
  CTExcitePList.sort();
}

// Draw charge-transfer excitation transition - New!
// Subcells: Works
// Containers: Not applicable
Trans* Cell::CTExcite() {
  return CTExciteTable();
}

// Draw charge-transfer excitation transition - Realtime version - New!
// Subcells: Works
// Containers: Not applicable
// No need for this function, right?

// Draw charge-transfer excitation transition - Table version - New!
// Subcells: Works
// Containers: Not applicable
Trans* Cell::CTExciteTable() {
  double z,PTot=0;
  int i;

  // Pick a random number between 0 and 1
  z=randomize(0,1);

  // For each entry in the transition probability list
  for (i=0; i<CTExcitePList.size(); i++) {

    // Update cumulative probability
    PTot+=CTExcitePList[i].P;

    // If drawn return transition
    if (z<=PTot) return CTExcitePList[i].trans;
  }

  cout<<"Cell::CTExciteTable: Error: No transition drawn\n";
  cout<<"Cell::CTExciteTable: z: "<<z<<", PTot: "<<PTot<<"\n";

  // This should not happen!
  return NULL;
}

// Update non-thermal excitation probability list
// Subcells: Works
// Containers: Not applicable
void Cell::updateNonThermalExcitePList() {
  double z,totalDeposition;
  TransP transP;
  BState* bState;
  int i,j,k,l;

  // Reset collisional excitation probability list
  nonThermalExcitePList.resize(0);

  // Get total non-thermal deposition going into excitation and ionization
  totalDeposition=nonThermalExcitation()+nonThermalIonization();

  // For each atom
  for (i=0; i<atom.size(); i++) {
    // For each ionization state
    for (j=0; j<atom[i].iState.size(); j++) {
      // For each bound state
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {
	
	// Set bound state pointer
	bState=&(atom[i].iState[j].bState[k]);
	
	// For each upward bound-bound transition
	for (l=0; l<bState->upTransBB.size(); l++) {
	  
	  // If non-zero non-thermal rate
	  if (bState->upTransBB[l]->CNU()!=0) {
	    transP.trans=bState->upTransBB[l];
	    transP.index=l; // New! - Removed!
	    transP.type=collisional;
	    transP.upward=true;
	    transP.P=bState->upTransBB[l]->CNU()*bState->upTransBB[l]->Xi()/totalDeposition;
	    
	    // If boost mode - Adjust transition probability - New!
	    // Testing
	    if (config->boost) transP.P=transP.P*bState->upTransBB[l]->upperState->markovPBoost()/nonThermalExcIonBoost();
	    
	    // Add entry to list
	    nonThermalExcitePList.push_back(transP);
	  }
	}
	
	// For each upward bound-free transition
	for (l=0; l<bState->upTransBF.size(); l++) {
	  
	  // If non-zero non-thermal rate
	  if (bState->upTransBF[l]->CNU()!=0) {
	    transP.trans=bState->upTransBF[l];
	    transP.index=l; // New! - Removed!
	    transP.type=collisional;
	    transP.upward=true;
	    transP.P=bState->upTransBF[l]->CNU()*bState->upTransBF[l]->Xi()/totalDeposition;
	    
	    // If boost mode - Adjust transition probability - New!
	    // Testing!
	    if (config->boost) transP.P=transP.P*bState->upTransBF[l]->upperState->markovPBoost()/nonThermalExcIonBoost();
	    
	    // Add entry to list
	    nonThermalExcitePList.push_back(transP);
	  }
	}
      }
    }
  }
  
  // Sort non-thermal excitation probability list
  nonThermalExcitePList.sort();
}

// Draw non-thermal excitation transition
// Subcells: Works
// Containers: Not applicable
Trans* Cell::nonThermalExcite() {
  if (config->nonThermalExciteTable) return nonThermalExciteTable();
  else return nonThermalExciteCalc();
}

// Draw non-thermal excitation transition - Real time version
// Subcells: Works
// Containers: Not applicable
Trans* Cell::nonThermalExciteCalc() {
  double z,totalDeposition,P,PTot=0;
  int i,j,k,l;

  // Pick a random number between 0 and 1
  z=randomize(0,1);

  // Get total non-thermal deposition going into exitation and ionization
  totalDeposition=nonThermalExcitation()+nonThermalIonization();

  // For each atom
  for (i=0; i<atom.size(); i++) {
    // For each ionization state
    for (j=0; j<atom[i].iState.size(); j++) {
      // For each bound state
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {
	
	// For each upward bound-bound transition
	for (l=0; l<atom[i].iState[j].bState[k].upTransBB.size(); l++) {
	  // Calculate transition probability
	  P=atom[i].iState[j].bState[k].upTransBB[l]->CNU()*atom[i].iState[j].bState[k].upTransBB[l]->Xi()/totalDeposition;
	  // If boost mode - Adjust transition probability - New!
	  // Testing!
	  if (config->boost) P=P*atom[i].iState[j].bState[k].upTransBB[l]->upperState->markovPBoost()/nonThermalExcIonBoost();
	  // If drawn return transition
	  if (z<PTot+P) return atom[i].iState[j].bState[k].upTransBB[l];
	  // Else increase total probablility and continue
	  else PTot+=P;
	}
	
	// For each upward bound-free transition
	for (l=0; l<atom[i].iState[j].bState[k].upTransBF.size(); l++) {
	  // Calculate transition probability
	  P=atom[i].iState[j].bState[k].upTransBF[l]->CNU()*atom[i].iState[j].bState[k].upTransBF[l]->Xi()/totalDeposition;
	  // If boost mode - Adjust transition probability - New!
	  // Testing!
	  if (config->boost) P=P*atom[i].iState[j].bState[k].upTransBF[l]->upperState->markovPBoost()/nonThermalExcIonBoost();
	  // If drawn return transition
	  if (z<PTot+P) return atom[i].iState[j].bState[k].upTransBF[l];
	  // Else increase total probablility and continue
	  else PTot+=P;
	}
      }
    }
  }

  cout<<"Cell::nonThermalExciteCalc: Error: No transition drawn\n";
  cout<<"Cell::nonThermalExciteCalc: z: "<<z<<", PTot: "<<PTot<<"\n";
  //exit(-1);

  // This should not happen!
  return NULL;
}

// Draw non-thermal excitation transition
// Subcells: Works
// Containers: Not applicable
Trans* Cell::nonThermalExciteTable() {
  double z,PTot=0;
  int i;

  // Pick a random number between 0 and 1
  z=randomize(0,1);

  // For each entry in transition probability list
  for (i=0; i<nonThermalExcitePList.size(); i++) {

    // Update cumulative probability
    PTot+=nonThermalExcitePList[i].P;

    // If drawn return transition
    if (z<PTot) return nonThermalExcitePList[i].trans;
  }

  cout<<"Cell::nonThermalExciteTable: Error: No transition drawn\n";
  cout<<"Cell::nonThermalExciteTable: z: "<<z<<", PTot: "<<PTot<<"\n";
  //exit(-1);

  // This should not happen!
  return NULL;
}

// Update emission probability tables - New!
void Cell::updateEtaPTable() {
  int i,j,k,l;

  // For each bound-free transition
  for (i=0;i<atom.size();i++) {
    for (j=0;j<atom[i].iState.size();j++) {
      for (k=0;k<atom[i].iState[j].bState.size();k++) {
	for (l=0;l<atom[i].iState[j].bState[k].upTransBF.size();l++) {
	  // Update emission probability tables
	  atom[i].iState[j].bState[k].upTransBF[l]->updateEtaPTable();
	}
      }
    }
  }
}

// Get line mean intensity 
// Using Lucy (2003) like estimators or a diluted blackbody field
// Subcells: Works
// Containers: Not applicable
double Cell::Jb(const double& _nu) {
  double _Jb,TBB;
  bool nuBinBBFound;
  double deltaNu=0,deltaJ=0,nuMax;
  int deltaN=0;
  int i;

  // If frequency within the on-the-spot range - Return bound-free source-function
  if (_nu>=onTheSpotNu().min and _nu<=onTheSpotNu().max) {
    // Testing
    FrequencyBinIterator nuBin=nuOld.find(_nu);
    double nu1,nu2,S,S1,S2;
    if (nuBin!=nuOld.end()) {
      nu1=nuBin->min; nu2=nuBin->max;
      S1=boundFreeS(nu1); S2=boundFreeS(nu2);
      S=S1+(_nu-nu1)*(S2-S1)/(nu2-nu1);
      return S;
    }
    else return boundFreeS(_nu);
    //return boundFreeS(_nu);
  }

  // If Lucy (2003) estimators and radiation field updated
  if (config->radEstimatorBB==rfLucy and radUpdated) {
    // If use continuum blackbody approximation
    if (config->continuumBB) {
      // Find blackbody range
      // Unclear if muliple initializers work - Fix!
      nuBinBBFound=false; // New!
      for (i=0;i<nuBBOld.size();i++) // Changed!
	if (_nu>nuBBOld[i].min and _nu<=nuBBOld[i].max) { nuBinBBFound=true; break; }
      // If blackbody range found return blackbody intensity
      if (nuBinBBFound) {
	// Switch on temperature type
	switch(config->continuumBBT) {
	case bbTCur : TBB=T(); break;
	//case bbTPrev : TBB=TPrev(); break;
	case bbTJ : TBB=TJ(); break;
	case bbTJBB : TBB=TJBB(); break;
	}
	return BlackBody::B(_nu,TBB);
      }
    }
    FrequencyBinIterator nuBinLine;
    // Find line frequency bin
    nuBinLine=nuLineOld.find(_nu);
    // Get intensity at line frequency
    if (nuBinLine!=nuLineOld.end()) {
      _Jb=JLineOld[nuBinLine-nuLineOld.begin()];
      if (_Jb<0) cout<<"Cell::Jb: Warning: Jb negative :  "<<_Jb<<", nuBin: ["<<nuBinLine->min<<","<<nuBinLine->max<<"]\n";
      // If number of packets in bin to small and fallback (this could/should be improved !!!)
      if ((nuBinLine-nuLineOld.begin())>=nJLineOld.size() or (nuBinLine-nuLineOld.begin())<0) cout<<"Cell::Jb: process: "<<mpiCom->rank()<<", index: "<<index()<<", nBinLine-nuLineOld.begin: "<<(nuBinLine-nuLineOld.begin())<<", nuLineOld.size: "<<nuLineOld.size()<<", nJLineOld.size: "<<nJLineOld.size()<<", nuLine.size: "<<nuLine.size()<<", nJLine.size: "<<nJLine.size()<<"\n";
      if (nJLineOld[nuBinLine-nuLineOld.begin()]<config->JLineFallbackCount and config->JLineFallback and config->radEstimator==rfLucy) {
	// Integrate blue-side intensity
	for (i=nuOld.find(_nu)-nuOld.begin();i<nuOld.size() and nuOld[i].min<_nu*config->JLineFallbackFactor;i++) {
	  deltaNu+=(nu[i].max-nu[i].min);
	  deltaJ+=JnuOld[i];
	  deltaN+=nJOld[i];
	}
	// If non-zero number of packets in bins - Calculate blue-side intensity
	if (deltaN>0) _Jb=deltaJ/deltaNu;
	// Else - If set - Fallback on diluted blackbody intensity
	else if (config->JLineFallbackDBB) _Jb=BlackBody::B(_nu,pTR)*pW;
      }
    }
    // If bin not found - Fallback on diluted blackbody intensity
    else _Jb=BlackBody::B(_nu,pTR)*pW;
    FrequencyBinIterator nuBin=nuOld.find(_nu);
  }
  // Else (i.e strict or diluted black-body field)
  //else _Jb=BlackBody::B(_nu,pTR)*pW; // Removed!
  else {
    double TUse=(config->radEstimatorBB==rfBB)?pTJ:pTR, WUse=(config->radEstimatorBB==rfBB)?1.0:pW; // New!
    _Jb=BlackBody::B(_nu,TUse)*WUse; // Changed!
  }
  
  return _Jb;
}

// Diluted blackbody field integrand
// Subcells: Works
// Containers: Not applicable
class DBBIntegrand {
public:
  const JIntegrand* integrand;
  const double TR;
  const double W;
  DBBIntegrand(const JIntegrand* _integrand, const double& _TR, const double& _W) : integrand(_integrand), TR(_TR), W(_W) {};
  double operator()(double nu, EdgeType edgeType=noEdge) const { return (*integrand)(nuEdge(nu,edgeType))*BlackBody::B(nuEdge(nu,edgeType),TR)*W; }
  double operator()(FrequencyBinIterator nu, EdgeType edgeType=noEdge) const { return (*integrand)(nu,edgeType)*BlackBody::B(nuEdge(nu,edgeType),TR)*W; }
};

// Bound-free source-function integrand
// Subcells: Works
// Containers: Not applicable
class SBFIntegrand {
public:
  const JIntegrand* integrand;
  Cell* cell;
  SBFIntegrand(const JIntegrand* _integrand, Cell* _cell) : integrand(_integrand), cell(_cell) {};
  double operator()(double nu, EdgeType edgeType=noEdge) const { 
    double value=(*integrand)(nuEdge(nu,edgeType))*cell->boundFreeS(nu,edgeType);
    if (!isnumber(value)) cout<<"SBFIntegrand::operator(): Warning: invalid value: "<<value<<", integrand: "<<(*integrand)(nuEdge(nu,edgeType))<<", boundFreeS: "<<cell->boundFreeS(nu,edgeType)<<", nu: "<<nu<<"\n";
    return value;
  }
  double operator()(FrequencyBinIterator nu, EdgeType edgeType=noEdge) const { 
    double value=(*integrand)(nu,edgeType)*cell->boundFreeS(nu,edgeType);
    if (!isnumber(value)) cout<<"SBFIntegrand::operator(): Warning: invalid value: "<<value<<", integrand: "<<(*integrand)(nu,edgeType)<<", boundFreeS: "<<cell->boundFreeS(nu,edgeType)<<", nu: "<<nuEdge(nu,edgeType)<<"\n";
    return value; 
  }
};

// MC field integrand
class MCIntegrand {
public:
  const JIntegrand* integrand;
  Cell* cell;
  double TBB;
  MCIntegrand(const JIntegrand* _integrand, Cell* _cell) : integrand(_integrand), cell(_cell), TBB(0) {
    if (cell->config->continuumBB) {
      // Switch on temperature type
      switch(cell->config->continuumBBT) {
      case bbTCur : TBB=cell->T(); break;
      case bbTJ : TBB=cell->TJ(); break;
      case bbTJBB : TBB=cell->TJBB(); break;
      }      
    }
  };
  double operator()(double nu, EdgeType edgeType=noEdge) const { 
    int i;
    // If use continuum blackbody approximation
    if (cell->config->continuumBB) {
      // Find blackbody range
      bool nuBinBBFound=false;
      for (i=0;i<cell->nuBBOld.size();i++)
	if (nu>cell->nuBBOld[i].min and nu<=cell->nuBBOld[i].max) { nuBinBBFound=true; break; }
      if (nuBinBBFound) return (*integrand)(nuEdge(nu,edgeType))*BlackBody::B(nuEdge(nu,edgeType),TBB);
    }
    double Jnu=0;
    i=cell->nuOld.find(nu)-cell->nuOld.begin();
    // Prevent division by zero - Hack!!!
    if (i>0 and i<cell->nuOld.size()) Jnu=(cell->JnuOld[i-1]+cell->JnuOld[i])/MAX(cell->nuOld[i].max-cell->nuOld[i-1].min,1e-99);
    else if (i==0) Jnu=cell->JnuOld[i]/MAX(cell->nuOld[i].max-cell->nuOld[i].min,1e-99);
    return (*integrand)(nuEdge(nu,edgeType))*Jnu;
  }
  double operator()(FrequencyBinIterator nu, EdgeType edgeType=noEdge) const { 
    int i;
    // If use continuum blackbody approximation
    if (cell->config->continuumBB) {
      // Find blackbody range
      bool nuBinBBFound=false;
      for (i=0;i<cell->nuBBOld.size();i++)
	if (nu->min>cell->nuBBOld[i].min and nu->min<=cell->nuBBOld[i].max) { nuBinBBFound=true; break; }
      if (nuBinBBFound) return (*integrand)(nu,edgeType)*BlackBody::B(nuEdge(nu,edgeType),TBB);
    }
    double Jnu=0;
    i=nu-cell->nuOld.begin();
    // Prevent division by zero - Hack!!!
    if (i>0 and i<cell->nuOld.size()) Jnu=(cell->JnuOld[i-1]+cell->JnuOld[i])/MAX(cell->nuOld[i].max-cell->nuOld[i-1].min,1e-99);
    else if (i==0) Jnu=cell->JnuOld[i]/MAX(cell->nuOld[i].max-cell->nuOld[i].min,1e-99);
    return (*integrand)(nu,edgeType)*Jnu;
  }
};

// Integrate quantity over the mean intensity
// Using Lucy (2003) like estimators or a diluted blackbody field
// Subcells: Works
// Containers: Not applicable
double Cell::JIntegrate(const JIntegrand& integrand, double nuMin, double nuMax, int& nIter, const double& relTol, double absTol, bool includeOSP, bool useIterator, bool onlyOSP, string test) { // Testing!
  double integral=0,nuMinOSP,nuMinOSPRed,nuMinOSPBlue,nuMaxOSP;
  //int nIterMin=1,nIterMax=4;
  int nIterMinOSP=1,nIterMaxOSP=1; // New!
  int nIterMinDBB=1,nIterMaxDBB=4; // New!
  int nIterMinMC=1,nIterMaxMC=1; // New!
  int nBinMaxOSP=64,nBinMaxDBB=16,nBinMaxMC=16; // New!
  int i,j,l;

  // Adjust integration range
  //if (radUpdated) {
  if (nuOld.size()>0) {
    nuMin=MAX(nuMin,nuOld[0].min);
    nuMax=MIN(nuMax,nuOld[nuOld.size()-1].max);
  }
  else {
    nuMin=MAX(nuMin,1e-3*k*MIN(pT,pTR)/h);
    nuMax=MAX(nuMin,MIN(nuMax,1e2*k*MAX(pT,pTR)/h));
  }

  // If no range to integrate return zero
  if (nuMin>=nuMax) return 0.0;

  // Calculate the on-the-spot range (overlap)
  nuMinOSP=onTheSpotNu().min;
  nuMinOSPRed=onTheSpotNu().min*(1-0.5*config->boundFreeSTableEdgeWidth);
  nuMinOSPBlue=onTheSpotNu().min*(1+0.5*config->boundFreeSTableEdgeWidth);
  nuMaxOSP=onTheSpotNu().max;

  // If use Lucy MC estimators and radiation field updated
  if (config->radEstimator==rfLucy and radUpdated) {
    // If part of the range does not overlap with the on-the-spot range
    if (nuMin<MIN(nuMax,nuMinOSPRed) and (not onlyOSP)) { // Testing!
      // Integrate over this range using Lucy MC estimators
      MCIntegrand mCIntegrand(&integrand,this);
      integral+=BFIntegrator<MCIntegrand>::trapezoidal(mCIntegrand,nuMin,MIN(nuMax,nuMinOSPRed),nuOld,nIter,relTol,absTol/2,useIterator,"",nIterMinMC,nIterMaxMC,nBinMaxMC); // Changed!
    }
  }
  // Else - Integrate using strict or diluted blackbody field
  else {
    // If part of the range does not overlap with the on-the-spot range
    if (nuMin<MIN(nuMax,nuMinOSPRed) and (not onlyOSP)) { // Testing!
      // Integrate over this range using strict or diluted blackbody field
      //DBBIntegrand dBBIntegrand(&integrand,pTR,pW); // Removed!
      double TUse=(config->radEstimator==rfBB)?pTJ:pTR, WUse=(config->radEstimator==rfBB)?1.0:pW; // New!
      DBBIntegrand dBBIntegrand(&integrand,TUse,WUse); //Changed!
      if (nuOld.size()==0) integral=Integrator<DBBIntegrand>::romberg(dBBIntegrand,nuMin,MIN(nuMax,nuMinOSPRed),nIter,relTol,absTol/2);
      else integral=BFIntegrator<DBBIntegrand>::trapezoidal(dBBIntegrand,nuMin,MIN(nuMax,nuMinOSPRed),nuOld,nIter,relTol,absTol/2,useIterator,"",nIterMinDBB,nIterMaxDBB,nBinMaxDBB); // Changed!
      if (nIter>nIterMaxDBB) cout<<"Cell::JIntegrate: cell: "<<index()<<", Warning: maximum number of DBB integral iterations exceeded\n"; // Changed!
    }
  }

  if (!isnumber(integral)) cout<<"IState::JIntegrate: cell: "<<index()<<", Warning: Invalid integral (no OSP): "<<integral<<", nu: ("<<nuMin<<","<<nuMax<<"), nuOSP: ("<<nuMinOSPRed<<","<<nuMinOSPBlue<<","<<nuMaxOSP<<")\n";

  // If include on-the-spot range
  if (includeOSP) {
    // If any on-the-spot range to integrate over
    if (MAX(nuMinOSPBlue,nuMin)<MIN(nuMaxOSP,nuMax)) {
      SBFIntegrand sBFIntegrand(&integrand,this);
      // This should be safe, right?
      absTol=MAX(absTol/2,fabs(integral)*relTol);
      // Integrate over the on-the-spot range using the bound-free sorce function
      if (nuOld.size()==0) integral+=Integrator<SBFIntegrand>::romberg(sBFIntegrand,MAX(nuMinOSPBlue,nuMin),MIN(nuMaxOSP,nuMax),nIter,relTol,absTol);
      //else integral+=BFIntegrator<SBFIntegrand>::trapezoidalPW(sBFIntegrand,MAX(nuMinOSP,nuMin),MIN(nuMaxOSP,nuMax),nuOld,nIter,relTol,absTol,useIterator,"",nIterMinOSP,nIterMaxOSP,nBinMaxOSP); // Changed!
      // Testing!!!
      else integral+=BFIntegrator<SBFIntegrand>::trapezoidalPW(sBFIntegrand,MAX(nuMinOSP,nuMin),MIN(nuMaxOSP,nuMax),nuOld,nIter,relTol,absTol,useIterator,test,nIterMinOSP,nIterMaxOSP,nBinMaxOSP);
      // Supress this warning - Testing!
      //if (nIter>nIterMaxOSP) cout<<"Cell::JIntegrate: cell: "<<index()<<", Warning: maximum number of OSP integral iterations exceeded\n"; // Changed!
    }
  }

  if (!isnumber(integral)) cout<<"IState::JIntegrate: cell: "<<index()<<", Warning: Invalid integral (OSP): "<<integral<<", nu: ("<<nuMin<<","<<nuMax<<"), nuOSP: ("<<nuMinOSPRed<<","<<nuMinOSPBlue<<","<<nuMaxOSP<<", sBFIntegrand("<<MAX(nuMinOSPBlue,nuMin)<<"): "<<integrand(MAX(nuMinOSPBlue,nuMin))<<", boundFreeS("<<MAX(nuMinOSPBlue,nuMin)<<"): "<<boundFreeS(MAX(nuMinOSPBlue,nuMin))<<", boundFreeKappa("<<MAX(nuMinOSPBlue,nuMin)<<"): "<<boundFreeAbsKappaCalc(MAX(nuMinOSPBlue,nuMin))<<", boundFreeEta("<<MAX(nuMinOSPBlue,nuMin)<<"): "<<boundFreeEta(MAX(nuMinOSPBlue,nuMin))<<"\n";

  return integral;
}

// Bound-free source function number derivative integrand
// Subcell: Works
// Containers: Not applicable
class DSdNIntegrand {
public:
  const NuIntegrand* integrand;
  Cell* cell;
  BState* bState;
  DSdNIntegrand(const NuIntegrand* _integrand, Cell* _cell, BState* _bState) : integrand(_integrand), cell(_cell), bState(_bState) {};
  /*double operator()(double nu) const { 
    double value=(*integrand)(nu)*cell->boundFreedSdN(nu,bState);
    if (!isnumber(value)) cout<<"DSdNIntegrand::operator(): Warning: invalid value: "<<value<<", integrand: "<<(*integrand)(nu)<<", boundFreedSdN: "<<cell->boundFreedSdN(nu,bState)<<", nu: "<<nu<<"\n";
    return value;
    }*/
  double operator()(double nu, EdgeType edgeType=noEdge) const { 
    double value=(*integrand)(nuEdge(nu,edgeType))*cell->boundFreedSdN(nu,bState,edgeType);
    if (!isnumber(value)) cout<<"DSdNIntegrand::operator(): Warning: invalid value: "<<value<<", integrand: "<<(*integrand)(nuEdge(nu,edgeType))<<", boundFreedSdN: "<<cell->boundFreedSdN(nu,bState,edgeType)<<", nu: "<<nu<<"\n";
    return value;
  }
  double operator()(FrequencyBinIterator nu, EdgeType edgeType=noEdge) const { return 0.0; }
};

// Integrate quantity over the mean intensity number derivative
// Subcells: Works
// Containers: Not applicable
double Cell::dJdNIntegrate(const NuIntegrand& integrand, BState* bState, double nuMin, double nuMax, int& nIter, const double& relTol, double absTol) {
  double integral=0,TBB,nuMinOSPRed,nuMinOSPBlue,nuMaxOSP;
  bool nuBinBBFound;
  double Jdnu,nuMean;
  int i,j,l;

  // Adjust integration range
  //if (radUpdated) {
  if (nuOld.size()>0) {
    nuMin=MAX(nuMin,nuOld[0].min);
    nuMax=MIN(nuMax,nuOld[nuOld.size()-1].max);
  }
  else {
    nuMin=MAX(nuMin,1e-3*k*MIN(pT,pTR)/h);
    nuMax=MAX(nuMin,MIN(nuMax,1e2*k*MAX(pT,pTR)/h));
  }

  // If no range to integrate return zero
  if (nuMin>=nuMax) return 0.0;

  // Calculate the on-the-spot range (overlap)
  nuMinOSPRed=onTheSpotNu().min*(1-0.5*config->boundFreeSTableEdgeWidth);
  nuMinOSPBlue=onTheSpotNu().min*(1+0.5*config->boundFreeSTableEdgeWidth);
  nuMaxOSP=onTheSpotNu().max;

  // If any on-the-spot range to integrate over
  if (MAX(nuMinOSPBlue,nuMin)<MIN(nuMaxOSP,nuMax)) {
    DSdNIntegrand dSdNIntegrand(&integrand,this,bState);
    // Integrate over the on-the-spot range using the bound-free sorce function
    if (nuOld.size()==0) integral+=Integrator<DSdNIntegrand>::romberg(dSdNIntegrand,MAX(nuMinOSPBlue,nuMin),MIN(nuMaxOSP,nuMax),nIter,relTol,absTol);
    else integral+=BFIntegrator<DSdNIntegrand>::trapezoidalPW(dSdNIntegrand,MAX(nuMinOSPBlue,nuMin),MIN(nuMaxOSP,nuMax),nuOld,nIter,relTol,absTol);
  }

  if (!isnumber(integral)) cout<<"Cell::dJdNIntegrate: cell: "<<index()<<", "<<bState->iState()->name()<<", Warning: Invalid integral (OSP): "<<integral<<", nu: ("<<nuMin<<","<<nuMax<<"), nuOSP: ("<<nuMinOSPRed<<","<<nuMinOSPBlue<<","<<nuMaxOSP<<"\n";

  return integral;
}

// Diluted blackbody field (net-rate) integrand
// Subcells: Works
// Containers: Not applicable
class DBBNetIntegrand {
public:
  const NuIntegrand* integrand1;
  const NuIntegrand* integrand2;
  const double TR;
  const double W;
  DBBNetIntegrand(const NuIntegrand* _integrand1, const NuIntegrand* _integrand2, const double& _TR, const double& _W) : integrand1(_integrand1), integrand2(_integrand2), TR(_TR), W(_W) {};
  double operator()(double nu, EdgeType edgeType=noEdge) const { return (*integrand1)(nuEdge(nu,edgeType))*BlackBody::B(nuEdge(nu,edgeType),TR)*W-(*integrand2)(nuEdge(nu,edgeType)); }
  double operator()(FrequencyBinIterator nu, EdgeType edgeType=noEdge) const { return (*integrand1)(nu,edgeType)*BlackBody::B(nuEdge(nu,edgeType),TR)*W-(*integrand2)(nu,edgeType); }
};

// Bound-free source-function (net-rate) integrand
// Subcells: Works
// Containers: Not applicable
class SBFNetIntegrand {
public:
  const NuIntegrand* integrand1;
  const NuIntegrand* integrand2;
  Cell* cell;
  SBFNetIntegrand(const NuIntegrand* _integrand1, const NuIntegrand* _integrand2, Cell* _cell) : integrand1(_integrand1), integrand2(_integrand2), cell(_cell) {};
  double operator()(double nu, EdgeType edgeType=noEdge) const {
    double value=(*integrand1)(nuEdge(nu,edgeType))*cell->boundFreeS(nu,edgeType)-(*integrand2)(nuEdge(nu,edgeType)); 
    if (!isnumber(value)) cout<<"SBFNetIntegrand::operator(): Warning: invalid value: "<<value<<", integrand1: "<<(*integrand1)(nuEdge(nu,edgeType))<<", integrand2: "<<(*integrand2)(nuEdge(nu,edgeType))<<", boundFreeS: "<<cell->boundFreeS(nu,edgeType)<<", nu: "<<nuEdge(nu,edgeType)<<"\n";
    return value; 
  }
  double operator()(FrequencyBinIterator nu, EdgeType edgeType=noEdge) const {
    double value=(*integrand1)(nu,edgeType)*cell->boundFreeS(nu,edgeType)-(*integrand2)(nu,edgeType); 
    if (!isnumber(value)) cout<<"SBFNetIntegrand::operator(): Warning: invalid value: "<<value<<", integrand1: "<<(*integrand1)(nu,edgeType)<<", integrand2: "<<(*integrand2)(nu,edgeType)<<", boundFreeS: "<<cell->boundFreeS(nu,edgeType)<<", nu: "<<nuEdge(nu,edgeType)<<"\n";
    return value; 
  }
};

// MC field (net-rate) integrand
class MCNetIntegrand {
public:
  const NuIntegrand* integrand1;
  const NuIntegrand* integrand2;
  Cell* cell;
  double TBB;
  MCNetIntegrand(const NuIntegrand* _integrand1, const NuIntegrand* _integrand2, Cell* _cell) : integrand1(_integrand1), integrand2(_integrand2), cell(_cell), TBB(0) {
    if (cell->config->continuumBB) {
      // Switch on temperature type
      switch(cell->config->continuumBBT) {
      case bbTCur : TBB=cell->T(); break;
      case bbTJ : TBB=cell->TJ(); break;
      case bbTJBB : TBB=cell->TJBB(); break;
      }      
    }
  };
  double operator()(double nu, EdgeType edgeType=noEdge) const { 
    int i;
    // If use continuum blackbody approximation
    if (cell->config->continuumBB) {
      // Find blackbody range
      bool nuBinBBFound=false;
      for (i=0;i<cell->nuBBOld.size();i++)
	if (nu>cell->nuBBOld[i].min and nu<=cell->nuBBOld[i].max) { nuBinBBFound=true; break; }
      if (nuBinBBFound) return (*integrand1)(nuEdge(nu,edgeType))*BlackBody::B(nuEdge(nu,edgeType),TBB)-(*integrand2)(nuEdge(nu,edgeType));
    }
    double Jnu=0;
    i=cell->nuOld.find(nu)-cell->nuOld.begin();
    // Prevent division by zero - Hack!!!
    if (i>0 and i<cell->nuOld.size()) Jnu=(cell->JnuOld[i-1]+cell->JnuOld[i])/MAX(cell->nuOld[i].max-cell->nuOld[i-1].min,1e-99);
    else if (i==0) Jnu=cell->JnuOld[i]/MAX(cell->nuOld[i].max-cell->nuOld[i].min,1e-99);
    return (*integrand1)(nuEdge(nu,edgeType))*Jnu-(*integrand2)(nuEdge(nu,edgeType));
  }
  double operator()(FrequencyBinIterator nu, EdgeType edgeType=noEdge) const { 
    int i;
    // If use continuum blackbody approximation
    if (cell->config->continuumBB) {
      // Find blackbody range
      bool nuBinBBFound=false;
      for (i=0;i<cell->nuBBOld.size();i++)
	if (nu->min>cell->nuBBOld[i].min and nu->min<=cell->nuBBOld[i].max) { nuBinBBFound=true; break; }
      if (nuBinBBFound) return (*integrand1)(nu,edgeType)*BlackBody::B(nuEdge(nu,edgeType),TBB)-(*integrand2)(nu,edgeType);
    }
    double Jnu=0;
    i=nu-cell->nuOld.begin();
    // Prevent division by zero - Hack!!!
    if (i>0 and i<cell->nuOld.size()) Jnu=(cell->JnuOld[i-1]+cell->JnuOld[i])/MAX(cell->nuOld[i].max-cell->nuOld[i-1].min,1e-99);
    else if (i==0) Jnu=cell->JnuOld[i]/MAX(cell->nuOld[i].max-cell->nuOld[i].min,1e-99);
    return (*integrand1)(nu,edgeType)*Jnu-(*integrand2)(nu,edgeType);
  }
};

// Integrate net radiative rate
// Using Lucy (2003) like estimators or a diluted blackbody field
// Subcells: Works
// Containers: Not applicable
double Cell::NetIntegrate(const NuIntegrand& integrand1, const NuIntegrand& integrand2, double nuMin, double nuMax, int& nIter, const double& relTol, double absTol, bool includeOSP, bool useIterator, bool onlyOSP) { // Testing!
  double integral=0,TBB,nuMinOSP,nuMinOSPRed,nuMinOSPBlue,nuMaxOSP;
  //int nIterMin=1,nIterMax=4;
  int nIterMinOSP=1,nIterMaxOSP=1; // New!
  int nIterMinDBB=1,nIterMaxDBB=4; // New!
  int nIterMinMC=1,nIterMaxMC=1; // New!
  int nBinMaxOSP=64,nBinMaxDBB=64,nBinMaxMC=16;
  int i,j,l,m;

  // Adjust integration range
  if (nuOld.size()>0) {
    nuMin=MAX(nuMin,nuOld[0].min);
    nuMax=MIN(nuMax,nuOld[nuOld.size()-1].max);
  }
  else {
    nuMin=MAX(nuMin,1e-3*k*MIN(pT,pTR)/h);
    nuMax=MAX(nuMin,MIN(nuMax,1e2*k*MAX(pT,pTR)/h));
  }

  // If no range to integrate return zero
  if (nuMin>=nuMax) return 0.0;
    
  // Calculate the on-the-spot range (overlap)
  nuMinOSP=onTheSpotNu().min;
  nuMinOSPRed=onTheSpotNu().min*(1-0.5*config->boundFreeSTableEdgeWidth);
  nuMinOSPBlue=onTheSpotNu().min*(1+0.5*config->boundFreeSTableEdgeWidth);
  nuMaxOSP=onTheSpotNu().max;
  
  // If use Lucy MC estimators and radiation field updated
  if (config->radEstimator==rfLucy and radUpdated) {

    // If part of the range does not overlap with the on-the-spot range
    if (nuMin<MIN(nuMax,nuMinOSPRed) and (not onlyOSP)) { // Testing!
      // Integrate ove this range using Lucy MC estimators
      MCNetIntegrand mCIntegrand(&integrand1,&integrand2,this);
      stringstream test; test.str("Cell::NetIntegrate: MC Integrate");
      integral+=BFIntegrator<MCNetIntegrand>::trapezoidal(mCIntegrand,nuMin,MIN(nuMax,nuMinOSPRed),nuOld,nIter,relTol,absTol/2,useIterator,"",nIterMinMC,nIterMaxMC,nBinMaxMC); // Changed!
    }
  }
  // Else - Integrate using strict or diluted blackbody field
  else {
    // If part of the range does not overlap with the on-the-spot range
    if (nuMin<MIN(nuMax,nuMinOSPRed) and (not onlyOSP)) { // Testing!
      // Integrate over this range using strict or diluted blackbody field
      //DBBNetIntegrand dBBIntegrand(&integrand1,&integrand2,pTR,pW);
      double TUse=(config->radEstimator==rfBB)?pTJ:pTR, WUse=(config->radEstimator==rfBB)?1.0:pW; // New!
      DBBNetIntegrand dBBIntegrand(&integrand1,&integrand2,TUse,WUse); // New!
      if (nuOld.size()==0) integral=Integrator<DBBNetIntegrand>::romberg(dBBIntegrand,nuMin,MIN(nuMax,nuMinOSPRed),nIter,relTol,absTol/2);
      else integral=BFIntegrator<DBBNetIntegrand>::trapezoidalPW(dBBIntegrand,nuMin,MIN(nuMax,nuMinOSPRed),nuOld,nIter,relTol,absTol/2,useIterator,"",nIterMinDBB,nIterMaxDBB,nBinMaxDBB); // Changed!
      if (nIter>nIterMaxDBB) cout<<"Cell::NetIntegrate: cell: "<<index()<<", Warning: maximum number of DBB integral iterations exceeded\n"; // Changed!
    }
  }

  // If include on-the-spot range
  if (includeOSP) {
    // If any on-the-spot range to integrate over
    if (MAX(nuMinOSPBlue,nuMin)<MIN(nuMaxOSP,nuMax)) {
      SBFNetIntegrand sBFIntegrand(&integrand1,&integrand2,this);
      // This should be safe, right?
      absTol=MAX(absTol/2,fabs(integral)*relTol);
      // Integrate over the on-the-spot range using the bound-free sorce function
      if (nuOld.size()==0) integral+=Integrator<SBFNetIntegrand>::romberg(sBFIntegrand,MAX(nuMinOSPBlue,nuMin),MIN(nuMaxOSP,nuMax),nIter,relTol,absTol);
      else integral+=BFIntegrator<SBFNetIntegrand>::trapezoidalPW(sBFIntegrand,MAX(nuMinOSP,nuMin),MIN(nuMaxOSP,nuMax),nuOld,nIter,relTol,absTol,useIterator,"",nIterMinOSP,nIterMaxOSP,nBinMaxOSP); // Changed!
      // Supress this warning - Testing!
      //if (nIter>nIterMaxOSP) cout<<"Cell::NetIntegrate: cell: "<<index()<<", Warning: maximum number of OSP integral iterations exceeded\n"; // Changed!
    }
  }

  if (!isnumber(integral)) cout<<"IState::NetIntegrate: cell: "<<index()<<", Warning: Invalid integral (OSP): "<<integral<<", nu: ("<<nuMin<<","<<nuMax<<"), nuOSP: ("<<nuMinOSPRed<<"\n";

  return integral;
}

// On-the-spot integrand
// Subcells: Works
// Containers: Not applicable
class OSPIntegrand {
public:
  const NuIntegrand* integrand1;
  const NuIntegrand* integrand2;
  Cell* cell;
  OSPIntegrand(const NuIntegrand* _integrand1, const NuIntegrand* _integrand2, Cell* _cell) : integrand1(_integrand1), integrand2(_integrand2), cell(_cell) {};
  double operator()(double nu, EdgeType edgeType=noEdge) const { return (*integrand1)(nuEdge(nu,edgeType))*cell->boundFreeS(nu,edgeType)-(*integrand2)(nuEdge(nu,edgeType)); }
  double operator()(FrequencyBinIterator nu, EdgeType edgeType=noEdge) const { return (*integrand1)(nu,edgeType)*cell->boundFreeS(nu,edgeType)-(*integrand2)(nu,edgeType); } // Changed!
};

// Integrate net rate over the on-the-spot region
// Subcells: Works
// Containers: Not applicable
double Cell::OSPIntegrate(const NuIntegrand& integrand1, const NuIntegrand& integrand2, double nuMin, double nuMax, const double& relTol, double absTol, bool useIterator) { // Changed!
  double integral;
  int nIter=0;
  int nIterMin=1,nIterMax=1,nBinMax=16; // New!
  int i,j,l;

  // Adjust integration limits
  if (nuOld.size()>0) {
    nuMin=MAX(MAX(nuMin,nuOld[0].min),onTheSpotNu().min*(1+0.5*config->boundFreeSTableEdgeWidth));
    nuMax=MIN(MIN(nuMax,nuOld[nuOld.size()-1].max),onTheSpotNu().max);
  }
  else {
    // These limits needs to be improved !!!
    nuMin=MAX(MAX(nuMin,1e-3*k*MIN(pT,pTR)/h),onTheSpotNu().min*(1+0.5*config->boundFreeSTableEdgeWidth));
    nuMax=MAX(nuMin,MIN(MIN(nuMax,1e2*k*MAX(pT,pTR)/h),onTheSpotNu().max));
  }

  // If no on-the-spot range to integrate - Return zero
  if (nuMin>=nuMax) return 0.0;

  OSPIntegrand oSPIntegrand(&integrand1,&integrand2,this);
  
  // Integrate net rate over the on-the-spot region
  if (nuOld.size()==0) integral=Integrator<OSPIntegrand>::romberg(oSPIntegrand,nuMin,nuMax,nIter,relTol,absTol);
  else integral=BFIntegrator<OSPIntegrand>::trapezoidalPW(oSPIntegrand,nuMin,nuMax,nuOld,nIter,relTol,absTol,useIterator,"",nIterMin,nIterMax,nBinMax); // Changed!
  // Supress this warning - Testing!
  //if (nIter>nIterMax) cout<<"Cell::OSPIntegrate: cell: "<<index()<<", Warning: maximum number of OSP integral iterations exceeded\n"; // New!
 
  if (!isnumber(integral)) cout<<"IState::OSPIntegrate: cell: "<<index()<<", Warning: Invalid integral: "<<integral<<", nu: ("<<nuMin<<","<<nuMax<<")\n";

  return integral;
}

// (OSP) net rate number derivative integrand
// Subcells: Works
// Containers: Not applicable
class DROSPdNIntegrand {
public:
  const NuDNIntegrand* integrand1;
  const NuDNIntegrand* integrand2;
  Cell* cell;
  BState* bState;
  DROSPdNIntegrand(const NuDNIntegrand* _integrand1, const NuDNIntegrand* _integrand2, Cell* _cell, BState* _bState) : integrand1(_integrand1), integrand2(_integrand2), cell(_cell), bState(_bState) {};
  double operator()(double nu, EdgeType edgeType=noEdge) const { return ((*integrand1).dFdN(nuEdge(nu,edgeType),bState)*cell->boundFreeS(nu,edgeType)+(*integrand1).F(nuEdge(nu,edgeType))*cell->boundFreedSdN(nu,bState,edgeType))-(*integrand2).dFdN(nuEdge(nu,edgeType),bState); }
  double operator()(FrequencyBinIterator nu, EdgeType edgeType=noEdge) const { return ((*integrand1).dFdN(nu,bState,edgeType)*cell->boundFreeS(nu,edgeType)+(*integrand1).F(nu,edgeType)*cell->boundFreedSdN(nu,bState,edgeType))-(*integrand2).dFdN(nu,bState,edgeType); } // Changed!
  //double operator()(FrequencyBinIterator nu, EdgeType edgeType=noEdge) const { return ((*integrand1).dFdN(nu,bState,edgeType)*cell->boundFreeS(nu,edgeType)+(*integrand1).F(nu,edgeType)*cell->boundFreedSdN(nuEdge(nu,edgeType),bState))-(*integrand2).dFdN(nu,bState,edgeType); } // Changed!
};

// Integrate (OSP) net rate number derivative
// Subcells: Works
// Containers: Not applicable
double Cell::dROSPdNIntegrate(const NuDNIntegrand& integrand1, const NuDNIntegrand& integrand2, BState* bState, double nuMin, double nuMax, const double& relTol, double absTol, bool useIterator) { // Changed!
  double integral;
  int nIter=0,nIterMin=1,nIterMax=4;
  // Testing
  int nBinMaxOSP=64;

  // Adjust integration limits
  if (nuOld.size()>0) {
    //nuMin=MAX(MAX(nuMin,nuOld[0].min),onTheSpotNu().min*(1+0.5*config->boundFreeSTableEdgeWidth));
    // Testing - Not good for romberg !!!
    nuMin=MAX(MAX(nuMin,nuOld[0].min),onTheSpotNu().min);
    nuMax=MIN(MIN(nuMax,nuOld[nuOld.size()-1].max),onTheSpotNu().max);
  }
  else {
    // These limits needs to be improved !!!
    nuMin=MAX(MAX(nuMin,1e-3*k*MIN(pT,pTR)/h),onTheSpotNu().min*(1+0.5*config->boundFreeSTableEdgeWidth));
    nuMax=MAX(nuMin,MIN(MIN(nuMax,1e2*k*MAX(pT,pTR)/h),onTheSpotNu().max));
  }

  // If no on-the-spot range to integrate - Return zero
  if (nuMin>=nuMax) return 0.0;

  DROSPdNIntegrand dROSPdNIntegrand(&integrand1,&integrand2,this,bState);
  
  // Integrate net rate over the on-the-spot region
  if (nuOld.size()==0) integral=Integrator<DROSPdNIntegrand>::romberg(dROSPdNIntegrand,nuMin,nuMax,nIter,relTol,absTol);
  else integral=BFIntegrator<DROSPdNIntegrand>::trapezoidalPW(dROSPdNIntegrand,nuMin,nuMax,nuOld,nIter,relTol,absTol,useIterator,"",nIterMin,nIterMax,nBinMaxOSP);

  if (nIter>nIterMax) cout<<"Cell::dROSPdNIntegrate: cell: "<<index()<<", Warning: maximum number of iterations exceeded\n";

  if (!isnumber(integral)) cout<<"Cell::dROSPdNIntegrate: cell: "<<index()<<", Warning: Invalid integral: "<<integral<<", nu: ("<<nuMin<<","<<nuMax<<")\n";

  return integral;
}

// (OSP) net rate number derivative integrand (ionization state version) - New!
// Subcells: Works
// Containers: Not applicable
class DROSPdNIIntegrand {
public:
  const NuDNIIntegrand* integrand1;
  const NuDNIIntegrand* integrand2;
  Cell* cell;
  IState* iState;
  DROSPdNIIntegrand(const NuDNIIntegrand* _integrand1, const NuDNIIntegrand* _integrand2, Cell* _cell, IState* _iState) : integrand1(_integrand1), integrand2(_integrand2), cell(_cell), iState(_iState) {};
  double operator()(double nu, EdgeType edgeType=noEdge) const { return ((*integrand1).dFdN(nuEdge(nu,edgeType),iState)*cell->boundFreeS(nu,edgeType)+(*integrand1).F(nuEdge(nu,edgeType))*cell->boundFreedSdN(nu,iState,edgeType))-(*integrand2).dFdN(nuEdge(nu,edgeType),iState); }
  //double operator()(FrequencyBinIterator nu, EdgeType edgeType=noEdge) const { return ((*integrand1).dFdN(nu,iState,edgeType)*cell->boundFreeS(nu,edgeType)+(*integrand1).F(nu,edgeType)*cell->boundFreedSdN(nu,iState,edgeType))-(*integrand2).dFdN(nu,iState,edgeType); } // Changed!
  double operator()(FrequencyBinIterator nu, EdgeType edgeType=noEdge) const { return ((*integrand1).dFdN(nu,iState,edgeType)*cell->boundFreeS(nu,edgeType)+(*integrand1).F(nu,edgeType)*cell->boundFreedSdN(nuEdge(nu,edgeType),iState))-(*integrand2).dFdN(nu,iState,edgeType); } // Changed!
};

// Integrate (OSP) net rate number derivative (ionization state version) - New!
// Subcells: Works
// Containers: Not applicable
double Cell::dROSPdNIntegrate(const NuDNIIntegrand& integrand1, const NuDNIIntegrand& integrand2, IState* iState, double nuMin, double nuMax, const double& relTol, double absTol, bool useIterator) { // Changed!
  double integral;
  int nIter=0,nIterMin=1,nIterMax=4;
  // Testing
  int nBinMaxOSP=64;

  // Adjust integration limits
  if (nuOld.size()>0) {
    //nuMin=MAX(MAX(nuMin,nuOld[0].min),onTheSpotNu().min*(1+0.5*config->boundFreeSTableEdgeWidth));
    // Testing - Not good for romberg !!!
    nuMin=MAX(MAX(nuMin,nuOld[0].min),onTheSpotNu().min);
    nuMax=MIN(MIN(nuMax,nuOld[nuOld.size()-1].max),onTheSpotNu().max);
  }
  else {
    // These limits needs to be improved !!!
    nuMin=MAX(MAX(nuMin,1e-3*k*MIN(pT,pTR)/h),onTheSpotNu().min*(1+0.5*config->boundFreeSTableEdgeWidth));
    nuMax=MAX(nuMin,MIN(MIN(nuMax,1e2*k*MAX(pT,pTR)/h),onTheSpotNu().max));
  }

  // If no on-the-spot range to integrate - Return zero
  if (nuMin>=nuMax) return 0.0;

  DROSPdNIIntegrand dROSPdNIIntegrand(&integrand1,&integrand2,this,iState);
  
  // Integrate net rate over the on-the-spot region
  if (nuOld.size()==0) integral=Integrator<DROSPdNIIntegrand>::romberg(dROSPdNIIntegrand,nuMin,nuMax,nIter,relTol,absTol);
  else integral=BFIntegrator<DROSPdNIIntegrand>::trapezoidalPW(dROSPdNIIntegrand,nuMin,nuMax,nuOld,nIter,relTol,absTol,useIterator,"",nIterMin,nIterMax,nBinMaxOSP);

  if (nIter>nIterMax) cout<<"Cell::dROSPdNIntegrate: cell: "<<index()<<", Warning: maximum number of iterations exceeded\n";

  if (!isnumber(integral)) cout<<"Cell::dROSPdNIntegrate: cell: "<<index()<<", Warning: Invalid integral: "<<integral<<", nu: ("<<nuMin<<","<<nuMax<<")\n";

  return integral;
}

// Update radiation state (could be overloaded by derived class)
// Subcells: Works
// Containers: Works
void Cell::updateRadiationState(const FrequencyBinList& _nu) {
  int i; // New!

  //if (master()) cout<<"Cell::updateRadiationState\n";

  // If container - Update radiation state for each subcell as well as the container and return - New!
  if (type()==cellContainer) { for (i=0;i<subCell.size();i++) subCell[i]->updateRadiationState(_nu); updateRadiationStateContainer(_nu); return; }

  //if (master()) cout<<"Cell::updateRadiationState: index: "<<index()<<"\n";

  // If update method is packet history
  if (config->updateMethod==urPacketHistory) {
    // Reset MC statistics
    resetMCStatistics(_nu);
    // Update MC statistics
    updateMCStatistics();
  }

  // If cluster run
  if (mpiCom!=NULL) {
    // Synchronize MC statistics
    syncMCStatistics();
    // Wait for all processes to reach this point
    mpiCom->barrier();
    if (master()) cout<<"Cell::updateRadiationState: index: "<<index()<<", MC statistics synchronized\n";
  }

  // Update mean intensity
  updateJ();
  // Update H and K 
  if (config->trackHK) updateHK();
  // Update (intensity weighted) mean frequeny
  updateNuMean();
  // Update diluted blackbody field
  updateDBBField();
  // Update blackbody field
  updateBBField();
  // Update opacity (per frequency bin) - New!
  updateKappaNu();

  // Mark radiation field as updated
  radUpdated=true;

  // Backup MC statistics
  nuOld=nu;
  muOld=mu;
  JnuOld=Jnu;
  InuOld=Inu;
  HnuOld=Hnu;
  KnuOld=Knu;
  etaNuOld=etaNu;
  kappaJNuOld=kappaJNu;
  kappaBFJNuOld=kappaBFJNu;
  kappaFFJNuOld=kappaFFJNu;
  kappaBBJNuOld=kappaBBJNu;
  kappaESJNuOld=kappaESJNu;
  kappaHNuOld=kappaHNu;
  kappaBFHNuOld=kappaBFHNu;
  kappaFFHNuOld=kappaFFHNu;
  kappaBBHNuOld=kappaBBHNu;
  kappaESHNuOld=kappaESHNu;
  /*lNuOld=lNu;
  nAbsNuOld=nAbsNu;
  nAbsBFNuOld=nAbsBFNu;
  nAbsFFNuOld=nAbsFFNu;
  nAbsBBNuOld=nAbsBBNu;
  nAbsESNuOld=nAbsESNu;*/
  nuMeanNuOld=nuMeanNu;
  JLineOld=JLine;
  nuLineOld=nuLine;
  nuBBOld=nuBB;
  peRadioOld=peRadio;
  nJOld=nJ;
  nJLineOld=nJLine;
  neRadioOld=neRadio; // New!

  // Make sure the non-thermal rates are allways updated - New!
  // This is really not the place to do this - Find a better way!
  nonThermalIonization(0);
  nonThermalExcitation(0);
  nonThermalHeating(MAX(eRadio()*rho(),1e99));

  // Mark frequency tabulators for update (as they contain frequency list iterators)
  bBFactorUpdate=true;
  bMFactorUpdate=true;
  boundFreeSTableUpdate=true;
}

// Update radiation state for container (could be overloaded by derived class) - New!
// Subcells: Not applicable
// Containers: Works
void Cell::updateRadiationStateContainer(const FrequencyBinList& _nu) {
  int i,j,k,jj;
  bool trackI=true,trackHK=true;

  //if (master()) cout<<"Cell::updateRadiationStateContainer: index: "<<index()<<"\n";

  // Determine trackI and trackHK from Inu, Hnu and Knu of the subcells (and not from config)
  // Hack, improve!!!
  for (i=0;i<subCell.size();i++) {
    if (subCell[i]->Inu.size()==0) trackI=false;
    if (subCell[i]->Hnu.size()==0) trackHK=false;
    if (subCell[i]->Knu.size()==0) trackHK=false;    
  }

  // If update method is packet history
  if (config->updateMethod==urPacketHistory) {
    // Reset MC statistics
    resetMCStatisticsContainer(_nu);
  }

  // For each subcell
  for (i=0;i<subCell.size();i++) {
    jj=0;
    for (j=0;j<subCell[i]->nu.size();j++) {
      if (jj>(nu.size()-1)) { cout<<"Cell::updateRadiationStateContainer: Error: nu["<<jj<<"] does not exist\n"; exit(-1); }
      // Volume-average Jnu
      Jnu[jj]+=subCell[i]->Jnu[j]*subCell[i]->fillFactor();
      // Volume-average Inu
      if (trackI) for (k=0;k<subCell[i]->mu.size();k++) Inu[jj][k]+=subCell[i]->Inu[j][k]*subCell[i]->fillFactor();
      // Volume-average Hnu
      if (trackHK) Hnu[jj]+=subCell[i]->Hnu[j]*subCell[i]->fillFactor();
      // Volume-average Knu
      if (trackHK) Knu[jj]+=subCell[i]->Knu[j]*subCell[i]->fillFactor();
      // Volume-average nuMeanNu
      nuMeanNu[jj]+=subCell[i]->nuMeanNu[j]*subCell[i]->fillFactor();
 
     // Volume-average kappaJNu - Changed! - Hack?
      if (kappaJNu.size()!=0 and subCell[i]->kappaJNu.size()!=0) kappaJNu[jj]+=subCell[i]->kappaJNu[j]*subCell[i]->fillFactor();
      // Volume-average kappaJNu - New!
      if (kappaBFJNu.size()!=0 and subCell[i]->kappaBFJNu.size()!=0) kappaBFJNu[jj]+=subCell[i]->kappaBFJNu[j]*subCell[i]->fillFactor();
      // Volume-average kappaJNu - New!
      if (kappaFFJNu.size()!=0 and subCell[i]->kappaFFJNu.size()!=0) kappaFFJNu[jj]+=subCell[i]->kappaFFJNu[j]*subCell[i]->fillFactor();
      // Volume-average kappaJNu - New!
      if (kappaBBJNu.size()!=0 and subCell[i]->kappaBBJNu.size()!=0) kappaBBJNu[jj]+=subCell[i]->kappaBBJNu[j]*subCell[i]->fillFactor();
      // Volume-average kappaJNu - New!
      if (kappaESJNu.size()!=0 and subCell[i]->kappaESJNu.size()!=0) kappaESJNu[jj]+=subCell[i]->kappaESJNu[j]*subCell[i]->fillFactor();
 
      // Volume-average kappaHNu - Changed! - Hack?
      if (kappaHNu.size()!=0 and subCell[i]->kappaHNu.size()!=0) kappaHNu[jj]+=subCell[i]->kappaHNu[j]*subCell[i]->fillFactor();
      // Volume-average kappaHNu - New!
      if (kappaBFHNu.size()!=0 and subCell[i]->kappaBFHNu.size()!=0) kappaBFHNu[jj]+=subCell[i]->kappaBFHNu[j]*subCell[i]->fillFactor();
      // Volume-average kappaHNu - New!
      if (kappaFFHNu.size()!=0 and subCell[i]->kappaFFHNu.size()!=0) kappaFFHNu[jj]+=subCell[i]->kappaFFHNu[j]*subCell[i]->fillFactor();
      // Volume-average kappaHNu - New!
      if (kappaBBHNu.size()!=0 and subCell[i]->kappaBBHNu.size()!=0) kappaBBHNu[jj]+=subCell[i]->kappaBBHNu[j]*subCell[i]->fillFactor();
      // Volume-average kappaHNu - New!
      if (kappaESHNu.size()!=0 and subCell[i]->kappaESHNu.size()!=0) kappaESHNu[jj]+=subCell[i]->kappaESHNu[j]*subCell[i]->fillFactor();
 
      // Sum nJ - New!
      if (nJ.size()!=0 and subCell[i]->nJ.size()!=0) nJ[jj]+=subCell[i]->nJ[j];
      if (j<(subCell[i]->nu.size()-1)) { if (not subCell[i]->nu[j+1].edge) jj++; }
      else jj++;
    }
    // Mass-average eRadio (step 1)
    peRadio+=subCell[i]->peRadio*subCell[i]->fillFactor()*subCell[i]->rho();
  }
  // Mass-average eRadio (step 2)
  peRadio=peRadio/rho();
  
  // Update mean intensity
  updateJ();
  // Update H and K 
  if (trackHK) updateHK();
  // Update (intensity weighted) mean frequeny
  updateNuMean();
  // Update diluted blackbody field
  updateDBBField();
  // Update blackbody field - New!
  updateBBField();
  // Update opacity (per frequency bin) - New!
  updateKappaNu();

  // Mark radiation field as updated
  radUpdated=true;

  // Backup MC statistics
  nuOld=nu;
  JnuOld=Jnu;
  InuOld=Inu;
  HnuOld=Hnu;
  KnuOld=Knu;
  nuMeanNuOld=nuMeanNu;
  kappaJNuOld=kappaJNu;
  kappaBFJNuOld=kappaBFJNu;
  kappaFFJNuOld=kappaFFJNu;
  kappaBBJNuOld=kappaBBJNu;
  kappaESJNuOld=kappaESJNu;
  kappaHNuOld=kappaHNu;
  kappaBFHNuOld=kappaBFHNu;
  kappaFFHNuOld=kappaFFHNu;
  kappaBBHNuOld=kappaBBHNu;
  kappaESHNuOld=kappaESHNu;
  /*lNuOld=lNu;
  nAbsNuOld=nAbsNu;
  nAbsBFNuOld=nAbsBFNu;
  nAbsFFNuOld=nAbsFFNu;
  nAbsBBNuOld=nAbsBBNu;
  nAbsESNuOld=nAbsESNu;*/
  peRadioOld=peRadio;
  nJOld=nJ;
}

// Update radioactive energy deposition
// Subcells: Works
// Containers: Works
void Cell::updateERadio() {
  int i; // New!

  //if (master()) cout<<"Cell::updateERadio: index: "<<index()<<"\n";

  // If container - Update radioactive energy deposition for each subcell as well as the container and return - New!
  if (type()==cellContainer) { for (i=0;i<subCell.size();i++) subCell[i]->updateERadio(); updateERadioContainer(); return; }

  // If update method is packet history
  if (config->updateMethod==urPacketHistory) {
    // Reset g-packet MC statistics
    resetGMCStatistics();
    // Update g-packet MC statistics
    updateGMCStatistics();
  }

  // If cluster run
  if (mpiCom!=NULL) {
    // Synchronize g-packet MC statistics
    syncGMCStatistics();
    // Wait for all processes to reach this point
    mpiCom->barrier();
    if (master()) cout<<"Cell::updateERadio: index: "<<index()<<", g-packet MC statistics synchronized\n";
  }

  // Backup radioactive energy deposition
  peRadioOld=peRadio;
  // Backup radioactive energy deposition event counter - New!
  neRadioOld=neRadio;

  // Make sure the non-thermal rates are allways updated - New!
  // This is really not the place to do this - Find a better way!
  nonThermalIonization(0);
  nonThermalExcitation(0);
  nonThermalHeating(MAX(eRadio()*rho(),1e99));
}

// Update radioactive energy deposition for container - New!
// Subcells: Not applicable
// Containers: Works
void Cell::updateERadioContainer() {
  int i;

  // If update method is packet history
  if (config->updateMethod==urPacketHistory) {
    // Reset g-packet MC statistics
    resetGMCStatistics();
  }

  // For each subcell
  for (i=0;i<subCell.size();i++) {
    // Mass-average eRadio (step 1)
    peRadio+=subCell[i]->peRadio*subCell[i]->fillFactor()*subCell[i]->rho();
  }
  // Mass-average eradio (step 2)
  peRadio=peRadio/rho();

  // Backup radioactive energy deposition
  peRadioOld=peRadio;
}

// Scale radiation field (with expansion factor)
// Subcells: Works
// Containers: Not applicable
void Cell::scaleRadiationField(const double& expFactor, bool expCooling) { // Changed!
  int exponent=(expCooling?4:3); // New!
  int i;

  // If container - Scale radiation field for each subcell as well as the container and return - New!
  if (type()==cellContainer) { for (i=0;i<subCell.size();i++) subCell[i]->scaleRadiationField(expFactor,expCooling); scaleRadiationFieldContainer(expFactor,expCooling); return; } // Changed!

  // Scale mean intensity with expansion factor
  for (i=0;i<Jnu.size();i++) Jnu[i]=Jnu[i]/pow(expFactor,exponent);
  for (i=0;i<JnuOld.size();i++) JnuOld[i]=JnuOld[i]/pow(expFactor,exponent);

  // Scale mean emissivity with expansion factor
  for (i=0;i<etaNu.size();i++) etaNu[i]=etaNu[i]/pow(expFactor,exponent);
  for (i=0;i<etaNuOld.size();i++) etaNuOld[i]=etaNuOld[i]/pow(expFactor,exponent);

  // Scale mean opacity-intensity product with expansion factor - New!
  for (i=0;i<kappaJNu.size();i++) kappaJNu[i]=kappaJNu[i]/pow(expFactor,exponent);
  for (i=0;i<kappaJNuOld.size();i++) kappaJNuOld[i]=kappaJNuOld[i]/pow(expFactor,exponent);

  // Scale the mean intensity weighted frequency
  for (i=0;i<nuMeanNu.size();i++) nuMeanNu[i]=nuMeanNu[i]/pow(expFactor,exponent);
  for (i=0;i<nuMeanNuOld.size();i++) nuMeanNuOld[i]=nuMeanNuOld[i]/pow(expFactor,exponent);
  
  // Scale mean line intensity with expansion factor
  for (i=0;i<JLine.size();i++) JLine[i]=JLine[i]/pow(expFactor,exponent);
  for (i=0;i<JLineOld.size();i++) JLineOld[i]=JLineOld[i]/pow(expFactor,exponent);

  // Update mean intensity
  updateJ();
  // Update (intensity weighted) mean frequeny
  updateNuMean();
  // Update diluted blackbody field
  updateDBBField();
  // Update blackbody field
  updateBBField();
  // Update opacity (per frequency bin) - New!
  updateKappaNu();
}

// Scale radiation field for container (with expansion factor) - New!
// Subcells: Not applicable
// Containers: Works
void Cell::scaleRadiationFieldContainer(const double& expFactor, bool expCooling) {
  int exponent=(expCooling?4:3); // New!
  int i;

  // Scale mean intensity with expansion factor
  for (i=0;i<Jnu.size();i++) Jnu[i]=Jnu[i]/pow(expFactor,exponent);
  for (i=0;i<JnuOld.size();i++) JnuOld[i]=JnuOld[i]/pow(expFactor,exponent);

  // Scale mean opacity-intensity product with expansion factor - New!
  for (i=0;i<kappaJNu.size();i++) kappaJNu[i]=kappaJNu[i]/pow(expFactor,exponent);
  for (i=0;i<kappaJNuOld.size();i++) kappaJNuOld[i]=kappaJNuOld[i]/pow(expFactor,exponent);

  // Scale the mean intensity weighted frequency
  for (i=0;i<nuMeanNu.size();i++) nuMeanNu[i]=nuMeanNu[i]/pow(expFactor,exponent);
  for (i=0;i<nuMeanNuOld.size();i++) nuMeanNuOld[i]=nuMeanNuOld[i]/pow(expFactor,exponent);
  
  // Update mean intensity
  updateJ();
  // Update (intensity weighted) mean frequeny
  updateNuMean();
  // Update diluted blackbody field
  updateDBBField();
  // Update opacity (per frequency bin) - New!
  updateKappaNu();
}

// Free-free optical depth equation (and its derivative)
// Subcells: May not work (see below)!
// Containers: Not applicable
class FFTauEq {
public:
  Cell* cell;
  const double dlognu;
  FFTauEq(Cell* _cell, const double& _dlognu=log10(0.01)) : cell(_cell), dlognu(_dlognu) {};
  // May not work for subcells (due to cell.size)
  double f(double nu) const { return cell->freeFreeAbsKappa(nu)*cell->rho()*cell->size()-cell->config->ffOnTheSpot.tauLim; }
  double dfdx(double nu) const { 
    double dnu=pow(10,dlognu)*nu; 
    return (f(nu+dnu)-f(nu))/dnu; 
  }
};

// Reset MC statistics
// Subcells: May not work (see below)!
// Containers: Works
void Cell::resetMCStatisticsOld(const FrequencyBinList& _nu) {
  int i,j,k,l;
  double tau;
  vector<double> nuWork;
  vector<double> muWork;
  vector<double> nuEdge;
  FFTauEq ffTauEq(this);
  double nuMin,nuMax,nuOnTheSpot=1e99;
  // Testing
  //double nuCheck,nuDiv=(c/(911.0*AA));

  // If container - Reset MC statistics for each subcell as well as for the container and return - New!
  if (type()==cellContainer) { for (i=0;i<subCell.size();i++) subCell[i]->resetMCStatistics(_nu); resetMCStatisticsContainer(_nu); return; }

  //if (master()) cout<<"Cell::resetMCStatistics: index: "<<index()<<"\n";

  // If Lucy (2003) estimators - Rebin 
  // Testing - Remove this - Use of initNu instead
  //if (config->radEstimator==rfLucy) { - Removed!
  // Allways rebin (but better use initNu instead) - New!
  if (true) {
    double nu0;
    //int nBinMin=1e4;
    // Testing
    // This needs to be configurable!!! Fix!!!
    int nBinMin=5e3;
    // Testing
    //int nBinMin=1e5;
    double dlognu=(log(_nu[_nu.size()-1].max)-log(_nu[0].min))/float(nBinMin);
    nuWork.resize(nBinMin);
    for (i=0;i<nuWork.size();i++) nuWork[i]=_nu[0].min*exp(i*dlognu);
    // Testing
    /*for (i=0;i<nBinMin;i++) {
      nuCheck=_nu[0].min*exp(i*dlognu);
      if ((nuCheck>nuDiv and i%4==0) or i==(nBinMin-1) or nuCheck<=nuDiv) nuWork.push_back(nuCheck);
      }*/
    // For each bound state
    for (i=0;i<atom.size();i++)
      for (j=0;j<atom[i].iState.size();j++)
	for (k=0;k<atom[i].iState[j].bState.size();k++)
	  // For each bound-free transition
	  for (l=0;l<atom[i].iState[j].bState[k].upTransBF.size();l++) {
	    // Add ionization edge frequency
	    nu0=atom[i].iState[j].bState[k].upTransBF[l]->nu();
	    if (nu0>=_nu[0].min and nu0<=_nu[_nu.size()-1].max) { nuWork.push_back(nu0); nuEdge.push_back(nu0); }
	  }
    // Sort frequencies
    sort(nuWork.begin(),nuWork.end());
    // Sort edge frequencies
    sort(nuEdge.begin(),nuEdge.end());
    //cout<<"Cell::resetMCStatistics: index: "<<index()<<", Mark edges, nu.size: "<<nu.size()<<", nuWork.size: "<<nuWork.size()<<", nuEdge.size: "<<nuEdge.size()<<"\n";
    // Update frequency bin
    nu.resize(0); nu.resize(nuWork.size()-1);
    for (i=0;i<nu.size();i++) nu[i].min=nuWork[i];
    for (i=0;i<nu.size();i++) nu[i].max=nuWork[i+1];
    // Testing
    int nEdge=0;
    // Set edge flags
    //for (i=0,j=0;i<nu.size();i++) {
    // Unclear if muliple initializers work - Fix!
    j=0; // New!
    for (i=0;i<nu.size() and j<nuEdge.size();i++) { // Changed!
      if (nuEdge[j]==nu[i].min) { 
	nu[i].edge=true; j++;
	// Testing
	nEdge++;
      }
      // Testing - Initilize to major (edge)
      nu[i].minorEdge=false;
    }
    // Testing
    //cout<<"Cell::resetMCStatistics: index: "<<index()<<", Marked "<<nEdge<<" edges, nu.size: "<<nu.size()<<", nuWork.size: "<<nuWork.size()<<", nuEdge.size: "<<nuEdge.size()<<"\n";
  }
  // Else - use provided binning
  else nu=_nu;

  // Mark frequency tabulators for update (as they contain frequency list iterators)
  bBFactorUpdate=true;
  bMFactorUpdate=true;
  boundFreeSTableUpdate=true;

  // If track intensity
  if (config->trackI) {
    // Setup angle bins
    int nBinMu=20;
    muWork.resize(nBinMu+1);
    for (i=0;i<muWork.size();i++) muWork[i]=cos(float(i)*pi/float(nBinMu));
    sort(muWork.begin(),muWork.end());
    muWork[0]=-1e99; muWork[muWork.size()-1]=1e99;
    mu.resize(muWork.size()-1);
    for (i=0;i<mu.size();i++) mu[i].min=muWork[i];
    for (i=0;i<mu.size();i++) mu[i].max=muWork[i+1];
  }
  // Else - No angle bins
  else mu.resize(0);

  // If use Lucy (2003) estimators - Setup line frequency bins
  if (config->radEstimatorBB==rfLucy) {
    //if (master()) cout<<"Cell::resetMCStatistics: Cell: "<<index()<<", Setup line frequency bins 1\n";
    nuWork.resize(0);
    for (i=0;i<atom.size();i++)
      for (j=0;j<atom[i].iState.size();j++)
	for (k=0;k<atom[i].iState[j].bState.size();k++)
	  for (l=0;l<atom[i].iState[j].bState[k].upTransBB.size();l++)
	    nuWork.push_back(atom[i].iState[j].bState[k].upTransBB[l]->nu());
    nuWork.push_back(nu[nu.size()-1].max);
    //if (master()) cout<<"Cell::resetMCStatistics: Cell: "<<index()<<", Setup line frequency bins 2\n";
    sort(nuWork.begin(),nuWork.end());
    //if (master()) cout<<"Cell::resetMCStatistics: Cell: "<<index()<<", Setup line frequency bins 3\n";
    nuLine.resize(nuWork.size()-1);
    for (i=0;i<nuLine.size();i++) nuLine[i].min=nuWork[i];
    for (i=0;i<nuLine.size();i++) nuLine[i].max=nuWork[i+1];
    //if (master()) cout<<"Cell::resetMCStatistics: Cell: "<<index()<<", Setup line frequency bins 4\n";
  }

  // Reset MC estimators
  Jnu.resize(0);
  Jnu.resize(nu.size(),0);
  Inu.resize(0);
  // If track intensity
  if (config->trackI) {
    Inu.resize(nu.size());
    for (i=0;i<Inu.size();i++) Inu[i].resize(mu.size(),0);
  }
  Hnu.resize(0);
  Knu.resize(0);
  // If track H and K
  if (config->trackHK) {
    Hnu.resize(nu.size(),0); // Changed!
    Knu.resize(nu.size(),0); // Changed!
  }
  etaNu.resize(0);
  etaNu.resize(nu.size(),0);
  kappaJNu.resize(0);
  kappaJNu.resize(nu.size(),0);
  kappaBFJNu.resize(0);
  kappaBFJNu.resize(nu.size(),0);
  kappaFFJNu.resize(0);
  kappaFFJNu.resize(nu.size(),0);
  kappaBBJNu.resize(0);
  kappaBBJNu.resize(nu.size(),0);
  kappaESJNu.resize(0);
  kappaESJNu.resize(nu.size(),0);
  kappaNu.resize(0);
  kappaNu.resize(nu.size(),0);
  kappaBFNu.resize(0);
  kappaBFNu.resize(nu.size(),0);
  kappaFFNu.resize(0);
  kappaFFNu.resize(nu.size(),0);
  kappaBBNu.resize(0);
  kappaBBNu.resize(nu.size(),0);
  kappaESNu.resize(0);
  kappaESNu.resize(nu.size(),0);
  kappaHNu.resize(0);
  kappaHNu.resize(nu.size(),0);
  kappaBFHNu.resize(0);
  kappaBFHNu.resize(nu.size(),0);
  kappaFFHNu.resize(0);
  kappaFFHNu.resize(nu.size(),0);
  kappaBBHNu.resize(0);
  kappaBBHNu.resize(nu.size(),0);
  kappaESHNu.resize(0);
  kappaESHNu.resize(nu.size(),0);
  /*lNu.resize(0);
  lNu.resize(nu.size(),0);
  nAbsNu.resize(0);
  nAbsNu.resize(nu.size(),0);
  nAbsBFNu.resize(0);
  nAbsBFNu.resize(nu.size(),0);
  nAbsFFNu.resize(0);
  nAbsFFNu.resize(nu.size(),0);
  nAbsBBNu.resize(0);
  nAbsBBNu.resize(nu.size(),0);
  nAbsESNu.resize(0);
  nAbsESNu.resize(nu.size(),0);*/
  nuMeanNu.resize(0);
  nuMeanNu.resize(nu.size(),0);
  JLine.resize(0);
  JLine.resize(nuLine.size(),0);
  peRadio=0;
  nJ.resize(0);
  nJ.resize(nu.size(),0);
  nJLine.resize(0);
  nJLine.resize(nuLine.size(),0);
  neRadio=0; // New!

  // Find region where on-the-spot approximation is used
  for (i=0;i<atom.size();i++)
    if (atom[i].onTheSpot())
      for (j=0;j<atom[i].iState.size();j++) 
	if (atom[i].iState[j].bState.size()>0)
	  for (k=0;k<atom[i].iState[j].bState[0].upTransBF.size();k++)
	    if (atom[i].iState[j].bState[0].upTransBF[k]->nu()<nuOnTheSpot) nuOnTheSpot=atom[i].iState[j].bState[0].upTransBF[k]->nu()*(1-0.5*config->boundFreeTableEdgeWidth);

  // Reset blackbody frequency bins
  nuBB.resize(0);
  // Loop through frequency bins
  for (i=0;i<nu.size() and nu[i].max<nuOnTheSpot and nu[i].max<onTheSpotNu().min;i++) {
    // Find blackbody range
    //for (j=i;j<nu.size();j++) {
    for (j=i;j<nu.size() and nu[j].max<nuOnTheSpot and nu[j].max<onTheSpotNu().min;j++) { // Changed!
      tau=0;
      // May not work for subcells (due to size)
      tau+=boundFreeAbsKappa((nu[j].min))*rho()*size();
      // May not work for subcells (due to size)
      tau+=freeFreeAbsKappa((nu[j].min))*rho()*size();
      if (tau<config->continuumBBTauLim) break;
    }
    // If blackbody range found
    if (j>i) {
      // Add blackbody frequency bin
      nuBB.resize(nuBB.size()+1);
      nuBB[nuBB.size()-1].min=nu[i].min;
      if (j<nu.size()) nuBB[nuBB.size()-1].max=nu[j].max;
      else nuBB[nuBB.size()-1].max=nu[nu.size()-1].max;
      // Select last frequency bin in the blackbody range
      i=j;
      //if (master()) cout<<"Cell::resetMCStatistics: Cell: "<<index()<<", Added blackbody range: lambda: ["<<(c/nuBB[nuBB.size()-1].max)/AA<<","<<(c/nuBB[nuBB.size()-1].min)/AA<<"], onTheSpotLambda: ["<<(c/onTheSpotNu().max)/AA<<","<<(c/onTheSpotNu().min)/AA<<"]\n";
    }
  }

  // If use free-free on-the-spot approximation
  if (config->ffOnTheSpot.apply) {
    if (radUpdated) { nuMin=nu[0].min; nuMax=nu[nu.size()-1].max; }
    // Need to set the lower limit > 0
    else { nuMin=c/(1e6*AA); nuMax=nuInf; }
    // If optical depth does not exceed the configured limit at the (minumum) frequency - Set this to zero
    if (ffTauEq.f(nuMin)<0) pFreeFreeOnTheSpotNu=0;
    // Else - Find the (minimum) frequency where the free-free optical depth exceeds the configured limit
    else pFreeFreeOnTheSpotNu=RootFinder<FFTauEq>::newtonRaphson(ffTauEq,nuMin,nuMin,nuMax,1e-2);
  }
  // Else - Set (minimum) frequency to zerp
  else pFreeFreeOnTheSpotNu=0;

  //if (master()) cout<<"Cell::resetMCStatistics: index: "<<index()<<", freeFreeOnTheSpotNu: "<<pFreeFreeOnTheSpotNu<<", freeFreeOnTheSpotLambda: "<<(c/pFreeFreeOnTheSpotNu)/AA<<", tau(freeFreeOneTheSpotNu): "<<freeFreeAbsKappa(pFreeFreeOnTheSpotNu)*rho()*size()<<"\n";
}

// Reset MC statistics
// Subcells: May not work (see below)!
// Containers: Works
void Cell::resetMCStatistics(const FrequencyBinList& _nu) {
  int i,j,k,l;
  double tau;
  vector<double> nuWork;
  vector<double> muWork;
  vector<double> nuEdge;
  FFTauEq ffTauEq(this);
  double nuMin,nuMax;

  // If container - Reset MC statistics for each subcell as well as for the container and return - New!
  if (type()==cellContainer) { for (i=0;i<subCell.size();i++) subCell[i]->resetMCStatistics(_nu); resetMCStatisticsContainer(_nu); return; }

  // Init frequency and angular binning
  initNu();
  initMu();

  // Reset edge flags
  //for (i=0;i<nu.size();i++) nu[i].minorEdge=false;

  // Reset MC estimators
  Jnu.resize(0);
  Jnu.resize(nu.size(),0);
  Inu.resize(0);
  // If track intensity
  if (config->trackI) {
    Inu.resize(nu.size());
    for (i=0;i<Inu.size();i++) Inu[i].resize(mu.size(),0);
  }
  Hnu.resize(0);
  Knu.resize(0);
  // If track H and K
  if (config->trackHK) {
    Hnu.resize(nu.size(),0); // Changed!
    Knu.resize(nu.size(),0); // Changed!
  }
  etaNu.resize(0);
  etaNu.resize(nu.size(),0);
  kappaJNu.resize(0);
  kappaJNu.resize(nu.size(),0);
  kappaBFJNu.resize(0);
  kappaBFJNu.resize(nu.size(),0);
  kappaFFJNu.resize(0);
  kappaFFJNu.resize(nu.size(),0);
  kappaBBJNu.resize(0);
  kappaBBJNu.resize(nu.size(),0);
  kappaESJNu.resize(0);
  kappaESJNu.resize(nu.size(),0);
  kappaNu.resize(0);
  kappaNu.resize(nu.size(),0);
  kappaBFNu.resize(0);
  kappaBFNu.resize(nu.size(),0);
  kappaFFNu.resize(0);
  kappaFFNu.resize(nu.size(),0);
  kappaBBNu.resize(0);
  kappaBBNu.resize(nu.size(),0);
  kappaESNu.resize(0);
  kappaESNu.resize(nu.size(),0);
  kappaHNu.resize(0);
  kappaHNu.resize(nu.size(),0);
  kappaBFHNu.resize(0);
  kappaBFHNu.resize(nu.size(),0);
  kappaFFHNu.resize(0);
  kappaFFHNu.resize(nu.size(),0);
  kappaBBHNu.resize(0);
  kappaBBHNu.resize(nu.size(),0);
  kappaESHNu.resize(0);
  kappaESHNu.resize(nu.size(),0);
  /*lNu.resize(0);
  lNu.resize(nu.size(),0);
  nAbsNu.resize(0);
  nAbsNu.resize(nu.size(),0);
  nAbsBFNu.resize(0);
  nAbsBFNu.resize(nu.size(),0);
  nAbsFFNu.resize(0);
  nAbsFFNu.resize(nu.size(),0);
  nAbsBBNu.resize(0);
  nAbsBBNu.resize(nu.size(),0);
  nAbsESNu.resize(0);
  nAbsESNu.resize(nu.size(),0);*/
  nuMeanNu.resize(0);
  nuMeanNu.resize(nu.size(),0);
  JLine.resize(0);
  JLine.resize(nuLine.size(),0);
  peRadio=0;
  nJ.resize(0);
  nJ.resize(nu.size(),0);
  nJLine.resize(0);
  nJLine.resize(nuLine.size(),0);
  neRadio=0; // New!

  if (master()) cout<<"Cell::resetMCStatistics: index: "<<index()<<", 1\n";

  // Update blackbody frequency bins
  updateNuBB();

  if (master()) cout<<"Cell::resetMCStatistics: index: "<<index()<<", 2\n";

  // If use free-free on-the-spot approximation
  if (config->ffOnTheSpot.apply) {
    if (radUpdated) { nuMin=nu[0].min; nuMax=nu[nu.size()-1].max; }
    // Need to set the lower limit > 0
    else { nuMin=c/(1e6*AA); nuMax=nuInf; }
    // If optical depth does not exceed the configured limit at the (minumum) frequency - Set this to zero
    if (ffTauEq.f(nuMin)<0) pFreeFreeOnTheSpotNu=0;
    // Else - Find the (minimum) frequency where the free-free optical depth exceeds the configured limit
    else pFreeFreeOnTheSpotNu=RootFinder<FFTauEq>::newtonRaphson(ffTauEq,nuMin,nuMin,nuMax,1e-2);
  }
  // Else - Set (minimum) frequency to zerp
  else pFreeFreeOnTheSpotNu=0;

  //if (master()) cout<<"Cell::resetMCStatistics: index: "<<index()<<", freeFreeOnTheSpotNu: "<<pFreeFreeOnTheSpotNu<<", freeFreeOnTheSpotLambda: "<<(c/pFreeFreeOnTheSpotNu)/AA<<", tau(freeFreeOneTheSpotNu): "<<freeFreeAbsKappa(pFreeFreeOnTheSpotNu)*rho()*size()<<"\n";
}

// Reset MC statistics for container
// Subcells: Not applicable
// Containers: Works
void Cell::resetMCStatisticsContainerOld(const FrequencyBinList& _nu) {
  vector<double> nuWork;
  vector<double> muWork;
  bool trackI=true,trackHK=true;
  int i;

  //if (master()) cout<<"Cell::resetMCStatisticsContainer: index: "<<index()<<"\n";

  // Determine trackI and trackHK from Inu, Hnu and Knu of the subcells (and not from config)
  // Hack, improve!!!
  for (i=0;i<subCell.size();i++) {
    if (subCell[i]->Inu.size()==0) trackI=false;
    if (subCell[i]->Hnu.size()==0) trackHK=false;
    if (subCell[i]->Knu.size()==0) trackHK=false;    
  }

  // If Lucy (2003) estimators - Rebin 
  //if (config->radEstimator==rfLucy) { - Removed!
  // Allways rebin (but better use initNu instead) - New!
  if (true) {
    // This needs to be configurable!!! Fix!!!
    int nBinMin=5e3;
    double dlognu=(log(_nu[_nu.size()-1].max)-log(_nu[0].min))/float(nBinMin);
    nuWork.resize(nBinMin);
    for (i=0;i<nuWork.size();i++) nuWork[i]=_nu[0].min*exp(i*dlognu);

    // Update frequency bin
    nu.resize(0); nu.resize(nuWork.size()-1);
    for (i=0;i<nu.size();i++) nu[i].min=nuWork[i];
    for (i=0;i<nu.size();i++) nu[i].max=nuWork[i+1];
  }
  // Else - use provided binning
  else nu=_nu;

  // If track intensity
  if (trackI) {
    // Setup angle bins
    int nBinMu=20;
    muWork.resize(nBinMu+1);
    for (i=0;i<muWork.size();i++) muWork[i]=cos(float(i)*pi/float(nBinMu));
    sort(muWork.begin(),muWork.end());
    muWork[0]=-1e99; muWork[muWork.size()-1]=1e99;
    mu.resize(muWork.size()-1);
    for (i=0;i<mu.size();i++) mu[i].min=muWork[i];
    for (i=0;i<mu.size();i++) mu[i].max=muWork[i+1];
  }
  // Else - No angle bins
  else mu.resize(0);

  // Reset MC estimators
  Jnu.resize(0);
  Jnu.resize(nu.size(),0);
  Inu.resize(0);
  // If track intensity
  if (trackI) {
    Inu.resize(nu.size());
    for (i=0;i<Inu.size();i++) Inu[i].resize(mu.size(),0);
  }
  Hnu.resize(0);
  Knu.resize(0);
  // If track H and K
  if (trackHK) {
    Hnu.resize(nu.size(),0);
    Knu.resize(nu.size(),0);
  }
  kappaJNu.resize(0);
  kappaJNu.resize(nu.size(),0);
  kappaBFJNu.resize(0);
  kappaBFJNu.resize(nu.size(),0);
  kappaFFJNu.resize(0);
  kappaFFJNu.resize(nu.size(),0);
  kappaBBJNu.resize(0);
  kappaBBJNu.resize(nu.size(),0);
  kappaESJNu.resize(0);
  kappaESJNu.resize(nu.size(),0);
  kappaNu.resize(0);
  kappaNu.resize(nu.size(),0);
  kappaBFNu.resize(0);
  kappaBFNu.resize(nu.size(),0);
  kappaFFNu.resize(0);
  kappaFFNu.resize(nu.size(),0);
  kappaBBNu.resize(0);
  kappaBBNu.resize(nu.size(),0);
  kappaESNu.resize(0);
  kappaESNu.resize(nu.size(),0);
  kappaHNu.resize(0);
  kappaHNu.resize(nu.size(),0);
  kappaBFHNu.resize(0);
  kappaBFHNu.resize(nu.size(),0);
  kappaFFHNu.resize(0);
  kappaFFHNu.resize(nu.size(),0);
  kappaBBHNu.resize(0);
  kappaBBHNu.resize(nu.size(),0);
  kappaESHNu.resize(0);
  kappaESHNu.resize(nu.size(),0);
  /*lNu.resize(0);
  lNu.resize(nu.size(),0);
  nAbsNu.resize(0);
  nAbsNu.resize(nu.size(),0);
  nAbsBFNu.resize(0);
  nAbsBFNu.resize(nu.size(),0);
  nAbsFFNu.resize(0);
  nAbsFFNu.resize(nu.size(),0);
  nAbsBBNu.resize(0);
  nAbsBBNu.resize(nu.size(),0);
  nAbsESNu.resize(0);
  nAbsESNu.resize(nu.size(),0);*/
  nuMeanNu.resize(0);
  nuMeanNu.resize(nu.size(),0);
  peRadio=0;
  nJ.resize(0); // New!
  nJ.resize(nu.size(),0); // New!
}

// Reset MC statistics for container
// Subcells: Not applicable
// Containers: Works
void Cell::resetMCStatisticsContainer(const FrequencyBinList& _nu) {
  vector<double> nuWork;
  vector<double> muWork;
  bool trackI=true,trackHK=true;
  int i;

  //if (master()) cout<<"Cell::resetMCStatisticsContainer: index: "<<index()<<"\n";

  // Determine trackI and trackHK from Inu, Hnu and Knu of the subcells (and not from config)
  // Hack, improve!!!
  for (i=0;i<subCell.size();i++) {
    if (subCell[i]->Inu.size()==0) trackI=false;
    if (subCell[i]->Hnu.size()==0) trackHK=false;
    if (subCell[i]->Knu.size()==0) trackHK=false;    
  }

  // Init frequency and angular binning
  initNuContainer();
  initMuContainer();

  // Reset MC estimators
  Jnu.resize(0);
  Jnu.resize(nu.size(),0);
  Inu.resize(0);
  // If track intensity
  if (trackI) {
    Inu.resize(nu.size());
    for (i=0;i<Inu.size();i++) Inu[i].resize(mu.size(),0);
  }
  Hnu.resize(0);
  Knu.resize(0);
  // If track H and K
  if (trackHK) {
    Hnu.resize(nu.size(),0);
    Knu.resize(nu.size(),0);
  }
  kappaJNu.resize(0);
  kappaJNu.resize(nu.size(),0);
  kappaBFJNu.resize(0);
  kappaBFJNu.resize(nu.size(),0);
  kappaFFJNu.resize(0);
  kappaFFJNu.resize(nu.size(),0);
  kappaBBJNu.resize(0);
  kappaBBJNu.resize(nu.size(),0);
  kappaESJNu.resize(0);
  kappaESJNu.resize(nu.size(),0);
  kappaNu.resize(0);
  kappaNu.resize(nu.size(),0);
  kappaBFNu.resize(0);
  kappaBFNu.resize(nu.size(),0);
  kappaFFNu.resize(0);
  kappaFFNu.resize(nu.size(),0);
  kappaBBNu.resize(0);
  kappaBBNu.resize(nu.size(),0);
  kappaESNu.resize(0);
  kappaESNu.resize(nu.size(),0);
  kappaHNu.resize(0);
  kappaHNu.resize(nu.size(),0);
  kappaBFHNu.resize(0);
  kappaBFHNu.resize(nu.size(),0);
  kappaFFHNu.resize(0);
  kappaFFHNu.resize(nu.size(),0);
  kappaBBHNu.resize(0);
  kappaBBHNu.resize(nu.size(),0);
  kappaESHNu.resize(0);
  kappaESHNu.resize(nu.size(),0);
  /*lNu.resize(0);
  lNu.resize(nu.size(),0);
  nAbsNu.resize(0);
  nAbsNu.resize(nu.size(),0);
  nAbsBFNu.resize(0);
  nAbsBFNu.resize(nu.size(),0);
  nAbsFFNu.resize(0);
  nAbsFFNu.resize(nu.size(),0);
  nAbsBBNu.resize(0);
  nAbsBBNu.resize(nu.size(),0);
  nAbsESNu.resize(0);
  nAbsESNu.resize(nu.size(),0);*/
  nuMeanNu.resize(0);
  nuMeanNu.resize(nu.size(),0);
  peRadio=0;
  nJ.resize(0); // New!
  nJ.resize(nu.size(),0); // New!
}

// Reset g-packet MC statistics
// Subcells: Works
// Containers: Works
void Cell::resetGMCStatistics() {
  int i; // New!

  // If container - Reset g-packet MC statistics for each subcell as well as for the container and return - New!
  if (type()==cellContainer) { for (i=0;i<subCell.size();i++) subCell[i]->resetGMCStatistics(); resetGMCStatisticsContainer(); return; }

  // Reset radioactive energy deposition
  peRadio=0;
  // Reset radioactive energy deposition event counter - New!
  neRadio=0;
}

// Reset g-packet MC statistics for container
// Subcells: Not applicable
// Containers: Works
void Cell::resetGMCStatisticsContainer() {

  // Reset radioactive energy deposition
  peRadio=0;
  // Reset radioactive energy deposition event counter - Add this?
  //neRadio=0;
}

class UnitIntegrandTest : public JIntegrand {
public:
  double operator () (double nu) const { return 1.0; }
  double operator()(FrequencyBinIterator nu, EdgeType edgeType=noEdge) const { return 0.0; };
};

// Synchronize MC statistics (MPI)
// Subcells: Works (but relies on the uniqueness of index - see Grid::load)
// Containers: Not applicable
void Cell::syncMCStatistics() {
  int nRequest=master()?(mpiCom->size()-1):1;
  boost::mpi::request request[nRequest];
  vector<MCStatMPI> collected(mpiCom->size()-1);
  MCStatMPI mCStat;
  int i;

  //if (master()) cout<<"Cell::synMCStatistics: index: "<<index()<<"\n";
  
  // Pack MC statistics
  mCStat.pack(this);

  // If slave - Deliver MC statistics to master (non-blocking)
  if (not master()) request[0]=mpiCom->isend(0,index(),mCStat);

  // If master - Collect MC statistics from slaves (non-blocking)
  if (master()) for (i=1;i<mpiCom->size();i++) request[i-1]=mpiCom->irecv(i,index(),collected[i-1]);

  // Wait for all MPI requests to complete
  boost::mpi::wait_all(request,request+nRequest);
 
  // Sum MC statistics
  if (master()) for (i=0;i<collected.size();i++) mCStat+=collected[i];

  // Broadcast MC statistics
  boost::mpi::broadcast(*mpiCom,mCStat,0);

  // Unpack MC statistics
  mCStat.unpack(this);
}

// Synchronize g-packet MC statistics (MPI)
// Subcells: Works (but relies on the uniqueness of index - see Grid::load)
// Containers: Not applicable
void Cell::syncGMCStatistics() {
  int nRequest=master()?(mpiCom->size()-1):1;
  boost::mpi::request request[nRequest];
  //vector<double> collected(mpiCom->size()-1);
  vector<GMCStatMPI> collected(mpiCom->size()-1); // Changed!
  GMCStatMPI gMCStat; // New!
  int i;

  // Pack g-packet MC statistics - New!
  gMCStat.pack(this);

  // If slave - Deliver g-packet MC statistics to master (non-blocking) - Changed!
  //if (not master()) request[0]=mpiCom->isend(0,index(),peRadio);
  if (not master()) request[0]=mpiCom->isend(0,index(),gMCStat);

  // If master - Collect g-packet MC statistics from slaves (non-blocking)
  if (master()) for (i=1;i<mpiCom->size();i++) request[i-1]=mpiCom->irecv(i,index(),collected[i-1]);

  // Wait for all MPI requests to complete
  boost::mpi::wait_all(request,request+nRequest);
 
  // Sum g-packet MC statistics - Changed!
  //if (master()) for (i=0;i<collected.size();i++) peRadio+=collected[i];
  if (master()) for (i=0;i<collected.size();i++) gMCStat+=collected[i];

  // Broadcast g-packet MC statistics - Changed!
  //boost::mpi::broadcast(*mpiCom,peRadio,0);
  boost::mpi::broadcast(*mpiCom,gMCStat,0);

  // Unpack g-packet MC statistics - New!
  gMCStat.unpack(this);
}

// Update MC statistics (using packet history)
// Subcells: Works
// Containers: Not applicable
void Cell::updateMCStatistics() {
  PacketEvent* startPoint;
  PacketEvent* endPoint;
  MCUpdateInfo updateInfo;
  int i;

  // For each ray (pair of packet events)
  for (i=1;i<packetHistory.size();i++) {
    // If the events belongs to the same packet
    if (packetHistory[i-1]->packetIndex==packetHistory[i]->packetIndex) {
      startPoint=packetHistory[i-1];
      endPoint=packetHistory[i];

      // Update MC statistics (using ray)
      updateMCStatistics(*startPoint,*endPoint,updateInfo);
    }
  }
}

// Update MC statistics (using a single ray)
// Subcells: Works
// Containers: Not applicable
void Cell::updateMCStatistics(const PacketEvent& startPoint, const PacketEvent& endPoint, MCUpdateInfo& updateInfo) {

  Vector3D ray;
  double ECMFLine,l,JnuPacket,etaNuPacket,kappaJNuPacket,dldnu,_t,muObs,muCMF; // Changed!
  FrequencyBinIterator nuBin,nuBinLine;
  AngleBinIterator muBin;
  double mprec=numeric_limits<double>::epsilon();

  // Exclude ray and return on invalid data
  if (!startPoint.valid() or !endPoint.valid()) { cout<<"Cell::updateMCStatistics: Warning: Invalid data, ray excluded\n"; return; }

  // If ray terminated by compton absorption/scatter
  if (endPoint.type==evComptonAbs or endPoint.type==evComptonScatter) {
    // Calculate radioactive energy deposition (per mass)
    #pragma omp atomic
    peRadio+=endPoint.ECMF/(M()*(ptMax-ptMin));
    // Increase packet counter
    #pragma omp atomic
    neRadio+=1;
    // Return
    return;
  }

  // Calculate the distance the ray has travelled
  ray=endPoint.position-startPoint.position;
  l=ray.norm()*pfExp;

  // Testing!
  //if (endPoint.nuCMF>c/(911*AA) and index()==79) cout<<"Cell::updateMCStatistics: index: "<<index()<<", l: "<<l<<"\n";

  // If distance larger than zero
  if (l>0) {

    // If transform ray
    if (config->transformRay) {
      // Transform ray length (which transforms as the frequency) to the comoving system
      l=l*(startPoint.nuCMF/startPoint.nu);
    }

    // If track I, H or K
    if (config->trackI or config->trackHK) {
      // Calculate (cosine of) polar angle
      muObs=(ray/ray.norm())*(startPoint.position/startPoint.position.norm());
      // Transform (cosine of) polar angle to the comoving frame
      muCMF=(muObs-(v(startPoint.position,startPoint.t)/c))/(1-muObs*(v(startPoint.position,startPoint.t)/c));
    }

    // If track I - find angle bin
    if (config->trackI) muBin=mu.find(MIN(MAX(muCMF,-1),1),updateInfo.muBin);

    // Find frequency bin
    nuBin=nu.find(startPoint.nuCMF,updateInfo.nuBin);
    // If matching frequency bin found
    if (nuBin!=nu.end()) {

      // Store frequency bin in update info
      updateInfo.nuBin=nuBin-nu.begin();
      // If track I - Store angle bin in update info
      if (config->trackI) updateInfo.muBin=muBin-mu.begin();

      // Calculate the mean intensity per bin (Jnu*dnu, see Lucy 2003) in the comoving frame
      if (config->radEstimatorExp) _t=startPoint.t; else _t=t();
      JnuPacket=(1/(4*pi))*(1/V(_t))*(startPoint.ECMF/(ptMax-ptMin))*l; // Changed!
      #pragma omp atomic
      Jnu[nuBin-nu.begin()]+=JnuPacket;
      // Testing!
      //if (endPoint.nuCMF>c/(911*AA) and index()==79) cout<<"Cell::updateMCStatistics: index: "<<index()<<", JnuPacket: "<<JnuPacket<<", Jnu: "<<Jnu[nuBin-nu.begin()]<<"\n";
      // If track intensity - Calculate intensity per bin in the comoving frame
      if (config->trackI) 
	#pragma omp atomic
	Inu[nuBin-nu.begin()][muBin-mu.begin()]+=JnuPacket;
      // If track H and K
      if (config->trackHK) {
	// Calculate H per bin in the comoving frame
	#pragma omp atomic
	Hnu[nuBin-nu.begin()]+=muCMF*JnuPacket;
	// Calculate K per bin in the comoving frame
	#pragma omp atomic
	Knu[nuBin-nu.begin()]+=pow(muCMF,2)*JnuPacket;
      }
      // Increase bin packet counter
      #pragma omp atomic
      nJ[nuBin-nu.begin()]+=1;
      // If export (true) emissivity
      if (config->exportEta) {
	// Calculate the mean emissivity per bin in the comoving frame
	if (isEmissionEvent(startPoint.type)) {
	  etaNuPacket=JnuPacket/l;
	  #pragma omp atomic
	  etaNu[nuBin-nu.begin()]+=etaNuPacket;
	}
      }
      // Calculate the mean frequency per bin (nu*Jnu*dnu) in the comoving frame
      #pragma omp atomic
      nuMeanNu[nuBin-nu.begin()]+=startPoint.nuCMF*JnuPacket;

      // Calculate the mean opacity-intensity product per bin in the comoving frame - New! - Testing!
      /*if (isAbsEvent(endPoint.type) or isScatterEvent(endPoint.type)) {
	kappaJNuPacket=JnuPacket/l;
	updateMCKappa(endPoint,nuBin,kappaJNuPacket);	  
	}*/
      // Update opacity MC estimators - Changed! - Testing!
      updateMCKappa(endPoint,nuBin,JnuPacket,l,muCMF);
    }
    // Store no frequency bin in update info
    else updateInfo.nuBin=noBin;

    // Find line frequency bin - Hack -> rewrite find !
    nuBinLine=nuLine.find(startPoint.nuCMF*(1-mprec),updateInfo.nuBinLine);
    // If matching bin found
    if (nuBinLine!=nuLine.end()) {

      // Store frequency bin in update info
      updateInfo.nuBinLine=nuBinLine-nuLine.begin();

      // While the end-point co-moving frequency smaller than (or equal to) the lower bound of the bin
      while ((*nuBinLine).min>=endPoint.nuCMF) {

	// Calculate dl/dnu
	dldnu=c*startPoint.t/startPoint.nu;
	// Calculate the (comoving frame) energy at the resonance point
	ECMFLine=startPoint.ECMF*(nuBinLine->min/startPoint.nu);
	// Calculate the mean intensity at the line frequency (see Lucy 2003)
	if (config->radEstimatorExp) _t=startPoint.t; else _t=t();
	#pragma omp atomic
	JLine[nuBinLine-nuLine.begin()]+=(1/(4*pi))*(1/V(_t))*(ECMFLine/(ptMax-ptMin))*dldnu; // Changed!
	// Increase bin packet counter
	#pragma omp atomic
	nJLine[nuBinLine-nuLine.begin()]+=1;
	if (nuBinLine==nuLine.begin()) break;
	else nuBinLine--;
      }
    }
    // Store no frequency bin in update info
    else updateInfo.nuBinLine=noBin;
  } 
}

// Update MC opacity - New!
//void Cell::updateMCKappa(const PacketEvent& endPoint, const FrequencyBinIterator& nuBin, const double& kappaJNuPacket) {
void Cell::updateMCKappa(const PacketEvent& endPoint, const FrequencyBinIterator& nuBin, const double& JnuPacket, const double& l, const double& muCMF) { // Changed!
  double kappaJNuPacket,kappaHNuPacket;

  //#pragma omp atomic
  //lNu[nuBin-nu.begin()]+=l;

  if (isAbsEvent(endPoint.type) or isScatterEvent(endPoint.type)) {

    kappaJNuPacket=JnuPacket/l; // New!
    if (config->trackHK) kappaHNuPacket=muCMF*JnuPacket/l; // New!
    
    #pragma omp atomic
    kappaJNu[nuBin-nu.begin()]+=kappaJNuPacket;
    // New!
    if (config->trackHK) {
      #pragma omp atomic
      kappaHNu[nuBin-nu.begin()]+=kappaHNuPacket;
    }
    //#pragma omp atomic
    //nAbsNu[nuBin-nu.begin()]++;
    
    if (endPoint.type==evBoundFreeAbs) {
      #pragma omp atomic
      kappaBFJNu[nuBin-nu.begin()]+=kappaJNuPacket;
      // New!
      if (config->trackHK) {
        #pragma omp atomic
	kappaBFHNu[nuBin-nu.begin()]+=kappaHNuPacket;
      }
      //#pragma omp atomic
      //nAbsBFNu[nuBin-nu.begin()]++;
    }
    else if (endPoint.type==evFreeFreeAbs) {
      #pragma omp atomic
      kappaFFJNu[nuBin-nu.begin()]+=kappaJNuPacket;
      // New!
      if (config->trackHK) {
        #pragma omp atomic
	kappaFFHNu[nuBin-nu.begin()]+=kappaHNuPacket;
      }
      //#pragma omp atomic
      //nAbsFFNu[nuBin-nu.begin()]++;
    }
    else if (endPoint.type==evLineAbs or endPoint.type==evLineScatter) {
      #pragma omp atomic
      kappaBBJNu[nuBin-nu.begin()]+=kappaJNuPacket;
      // New!
      if (config->trackHK) {
        #pragma omp atomic
	kappaBBHNu[nuBin-nu.begin()]+=kappaHNuPacket;
      }
      //#pragma omp atomic
      //nAbsBBNu[nuBin-nu.begin()]++;
    }
    else if (endPoint.type==evElectronScatter) {
      #pragma omp atomic
      kappaESJNu[nuBin-nu.begin()]+=kappaJNuPacket;
      // New!
      if (config->trackHK) {
        #pragma omp atomic
	kappaESHNu[nuBin-nu.begin()]+=kappaHNuPacket;
      }
      //#pragma omp atomic
      //nAbsESNu[nuBin-nu.begin()]++;
    }
  }
}

// Update g-packet MC statistics (using packet history)
// Subcells: Works
// Containers: Not applicable
void Cell::updateGMCStatistics() {
  PacketEvent* startPoint;
  PacketEvent* endPoint;
  int i;

  // For each ray (pair of packet events)
  for (i=1;i<packetHistory.size();i++) {
    // If the events belongs to the same packet
    if (packetHistory[i-1]->packetIndex==packetHistory[i]->packetIndex) {
      startPoint=packetHistory[i-1];
      endPoint=packetHistory[i];

      // Update radioactive energy deposition (using ray)
      updateGMCStatistics(*startPoint,*endPoint);
    }
  }
}

// Update g-packet MC Statistics (using a single ray)
// Subcells: Works
// Containers: Not applicable
void Cell::updateGMCStatistics(const PacketEvent& startPoint, const PacketEvent& endPoint) {

  // Exclude ray and return on invalid data
  if (!startPoint.valid() or !endPoint.valid()) { cout<<"Cell::updateGMCStatistics: Warning: Invalid data, ray excluded\n"; return; }

  // If ray terminated by compton absorption/scatter
  if (endPoint.type==evComptonAbs or endPoint.type==evComptonScatter) {
    // Calculate radioactive energy deposition (per mass)
    #pragma omp critical
    peRadio+=endPoint.ECMF/(M()*(ptMax-ptMin));
    // Increase packet counter
    #pragma omp atomic
    neRadio+=1;
    // Return
    return;
  }
}


// Update blackbody frequency bins - New!
// Subcells: Works
// Containers: Not applicable
void Cell::updateNuBB() {
  double tau,nuOnTheSpot=1e99;
  int i,j,k;

  // Reset blackbody frequency bins
  nuBB.resize(0);

  // If requested
  if (config->continuumBBTauLim!=1e99) {
    
    // Find region where on-the-spot approximation is used
    for (i=0;i<atom.size();i++)
      if (atom[i].onTheSpot())
	for (j=0;j<atom[i].iState.size();j++) 
	  if (atom[i].iState[j].bState.size()>0)
	    for (k=0;k<atom[i].iState[j].bState[0].upTransBF.size();k++)
	      if (atom[i].iState[j].bState[0].upTransBF[k]->nu()<nuOnTheSpot) nuOnTheSpot=atom[i].iState[j].bState[0].upTransBF[k]->nu()*(1-0.5*config->boundFreeTableEdgeWidth);

    // Loop through frequency bins
    for (i=0;i<nu.size() and nu[i].max<nuOnTheSpot and nu[i].max<onTheSpotNu().min;i++) {
      // Find blackbody range
      //for (j=i;j<nu.size();j++) {
      for (j=i;j<nu.size() and nu[j].max<nuOnTheSpot and nu[j].max<onTheSpotNu().min;j++) { // Changed!
	tau=0;
	// May not work for subcells (due to size)
	tau+=boundFreeAbsKappa((nu[j].min))*rho()*size();
	// May not work for subcells (due to size)
	tau+=freeFreeAbsKappa((nu[j].min))*rho()*size();
	if (tau<config->continuumBBTauLim) break;
      }
      // If blackbody range found
      if (j>i) {
	// Add blackbody frequency bin
	nuBB.resize(nuBB.size()+1);
	nuBB[nuBB.size()-1].min=nu[i].min;
	if (j<nu.size()) nuBB[nuBB.size()-1].max=nu[j].max;
	else nuBB[nuBB.size()-1].max=nu[nu.size()-1].max;
	if (master()) cout<<"Cell::updateNuBB: index: "<<index()<<", Added BB range: ["<<(c/nuBB[nuBB.size()-1].max)/AA<<","<<(c/nuBB[nuBB.size()-1].min)/AA<<"] AA\n";
	// Select last frequency bin in the blackbody range
	i=j;
      }
    }
  }
}

// Update mean intensity
// Subcells: Works
// Containers: Not applicable
void Cell::updateJ() {
  int i;

  // Calculate the mean intensity
  J=0;
  for (i=0;i<Jnu.size();i++) J+=Jnu[i];
  // Testing!
  //if (mpiCom!=NULL) cout<<"Cell::updateJ: index: "<<index()<<", Process: "<<mpiCom->rank()<<", J: "<<J<<", Jnu.size: "<<Jnu.size()<<"\n";
}

// Update H and K
// Subcells: Works
// Containers: Not applicable
void Cell::updateHK() {
  int i;

  // Calculate H and K
  H=0; K=0;
  for (i=0;i<Hnu.size();i++) H+=Hnu[i]; 
  for (i=0;i<Knu.size();i++) K+=Knu[i];
}

// Update opacity (per frequency bin)
// Subcells: Works
// Containers: Not applicable
void Cell::updateKappaNu() {
  int i;

  // Calculate opacity (per frequency bin)
  for (i=0;i<kappaJNu.size();i++) {
    if (Jnu[i]!=0) kappaNu[i]=kappaJNu[i]/(Jnu[i]*rho());
    else kappaNu[i]=0; // Hmm ...
    if (Jnu[i]!=0) kappaBFNu[i]=kappaBFJNu[i]/(Jnu[i]*rho()); // New!
    else kappaBFNu[i]=0; // Hmm ...
    if (Jnu[i]!=0) kappaFFNu[i]=kappaFFJNu[i]/(Jnu[i]*rho()); // New!
    else kappaFFNu[i]=0; // Hmm ...
    if (Jnu[i]!=0) kappaBBNu[i]=kappaBBJNu[i]/(Jnu[i]*rho()); // New!
    else kappaBBNu[i]=0; // Hmm ...
    if (Jnu[i]!=0) kappaESNu[i]=kappaESJNu[i]/(Jnu[i]*rho()); // New!
    else kappaESNu[i]=0; // Hmm ...
  }
}

// Update frequency mean
// Subcells: Works
// Containers: Not applicable
void Cell::updateNuMean() {
  int i;

  // Calculate the (intensity weighted) frequency mean
  nuMean=0;
  for (i=0;i<nuMeanNu.size();i++) nuMean+=nuMeanNu[i]/J;
}

// Update diluted blackbody radiation field
// Subcells: Works
// Containers: Not applicable
void Cell::updateDBBField() {
  int i;

  // Calculate the radiation temperature
  pTR=(h*nuMean)/(3.832*k);
  
  // Calculate the dilution factor
  pW=J*pi/(sigma*pow(pTR,4));

  if (master()) cout<<"Cell::updateDBBField: TR="<<pTR<<", W="<<pW<<", J: "<<J<<", sigma*pow(TR,4): "<<sigma*pow(pTR,4)<<"\n";
}

class BIntegrand {
public:
  const double T;
  BIntegrand(const double& _T) : T(_T) {}
  double operator () (double nu) const { return BlackBody::B(nu,T); }
};

// Calculate blackbody intensity in the blackbody regions
// Subcells: Works
// Containers: Not applicable
double Cell::BIntBB(const double& T, double tol) const {
  double B=0;
  BIntegrand integrand(T);
  int i;
  // Testing
  int nIter;

  // Sum blackbody intensity for each blackbody region
  for (i=0;i<nuBB.size();i++) B+=Integrator<BIntegrand>::romberg(integrand,nuBB[i].min,nuBB[i].max,nIter,tol);

  return B;
}

// Calculate mean intensity in the blackbody regions
// Subcells: Works
// Containers: Not applicable
double Cell::JIntBB() const {
  double J=0;
  int i,j;

  // For each blackbody region
  for (i=0;i<nuBB.size();i++) {
    // For each frequency bin within the region
    for (j=nu.find(nuBB[i].min)-nu.begin();j<nu.size() and nu[j].min<nuBB[i].max;j++) {
      // Sum mean intensity
      J+=Jnu[j];
    }
  }

  return J;
}

class BZero {
public:
  Cell* cell;
  double dT;
  double tol;
  double JIntBB;
  BZero(Cell* _cell, double _tol, double _dT) : cell(_cell), tol(_tol), dT(_dT) { JIntBB=cell->JIntBB(); }
  double f(double T) const { 
    return cell->BIntBB(T,tol) - JIntBB; 
  }
  double dfdx(double T) const { return (cell->BIntBB(T*(1+0.5*dT),tol)-cell->BIntBB(T*(1-0.5*dT),tol))/(T*dT); }
};

// Update blackbody field
// Subcells: Works
// Containers: Not applicable
double Cell::updateBBField() {
  double TMin=500, TMax=1e6, tol=1e-6, dT=1e-6;
  BZero bZero(this,tol,dT);

  // Calculate TJ based on J
  pTJ=pTR*pow(pW,1.0/4.0);

  // If any blackbody regions
  if (nuBB.size()>0) {
    // Calculate TJ based on J in the blackbody regions
    pTJBB=RootFinder<BZero>::newtonRaphson(bZero,T(),TMin,TMax,tol);
  }
  // Else - Set to TJ based on J
  else pTJBB=pTJ;

  if (master()) cout<<"Cell::updateBBField: TJ="<<pTJ<<", TJ(BB)="<<pTJBB<<"\n";
}

// De-excite via thermal pool (implements the macro-atom machinery)
// Subcells: Works
// Containers: Not applicable
BState* Cell::deExciteMarkovTableTherm() {
  double PTotal,z;
  double PMax=1;
  int i;

  // Reset total probability
  PTotal=0;

  // Pick a random number between 0 och PMax
  z=randomize(0,PMax);

  // For each Markov transition
  for (i=0; i<markovPListTherm.size(); i++) {
    
    // Increase cumulative transition probability
    PTotal+=markovPListTherm[i].P;

    // If drawn - Return next bound state
    if (z<=PTotal) return markovPListTherm[i].nextState;
  }

  cout<<"Cell::deExciteMarkovTableTherm: Error: No bound state drawn\n";
  cout<<"Cell::deExciteMarkovTable: z: "<<z<<", PTotal: "<<PTotal<<"\n";

  // This should not happen
  return NULL;
}

// De-excite via charge-transfer (implements the macro-atom machinery) - New!
// Subcells: Works
// Containers: Not applicable
BState* Cell::deExciteMarkovTableCT(CTReaction* _cTReaction, CTDirection cTDirection) {
  double PTotal,z;
  double PMax=1;
  int i,n;

  // Get charge-transfer reaction index
  n=_cTReaction->index();

  // Convert to Markov transition list index
  if (cTDirection==ctBackward) n+=ctReaction.size();

  // Reset total probability
  PTotal=0;

  // Pick a random number between 0 och PMax
  z=randomize(0,PMax);

  // For each Markov transition
  for (i=0; i<markovPListCT[n].size(); i++) {
    
    // Increase cumulative transition probability
    PTotal+=markovPListCT[n][i].P;

    // If drawn - Return next bound state
    if (z<=PTotal) return markovPListCT[n][i].nextState;
  }

  cout<<"Cell::deExciteMarkovTableCT: Error: No bound state drawn\n";
  cout<<"Cell::deExciteMarkovTableCT: z: "<<z<<", PTotal: "<<PTotal<<"\n";

  // This should not happen
  return NULL;
}

// Calculate Markov S matrix
// Subcells: Works
// Containers: Not applicable
vector<vector<double> > Cell::markovS(const vector<vector<vector<int> > >& matrixIndex) {
  vector<vector<double> > S;
  Mat_DP PT,SInv;
  Vec_DP SCol,RTot;
  Vec_INT index;
  DP d;
  BState* bState;
  CTReaction* cTReaction; // New!
  double P,PTot,PCT,totalCooling=0; // Changed!
  int i,j,k,l,m,ii,jj,kk,nStates=0,rowIndex,atomIndex,iStateIndex,bStateIndex; // Changed!
  bool boundFree,coll,nonThermal,twoPhoton,chargeTransfer; // Changed!
  bool useLTEGroup=config->LTEGroupMacro; // New!
  bool sumLTEGroup=useLTEGroup; // New!

  // Count total number of states - Removed!
  /*nStates=0;
  for (i=0;i<matrixIndex.size();i++)
  for (j=0;j<matrixIndex[i].size();j++) nStates+=matrixIndex[i][j].size();*/

  // Count total number of states - New!
  countBMatrixIndex(nStates);

  // Initialize
  PT=Mat_DP(0.0,nStates+1,nStates+1);
  SInv=Mat_DP(0.0,nStates+1,nStates+1);
  S.resize(nStates+1); for (i=0;i<S.size();i++) S[i].resize(nStates+1,0.0);
  index=Vec_INT(0.0,nStates+1);
  RTot=Vec_DP(0.0,nStates+1);

  // Get total cooling
  if (config->freeFreeMacro) totalCooling+=freeFreeCooling();
  if (config->boundFreeMacro) totalCooling+=boundFreeCoolingSP();
  if (config->collMacro) totalCooling+=collCooling();

  // For each atom
  for (i=0; i<atom.size(); i++) {

    // Get processes flags
    boundFree=config->boundFreeMacro;
    coll=config->collMacro;
    nonThermal=config->nonThermalMacro;
    twoPhoton=config->twoPhotonMacro; // New!
    chargeTransfer=config->chargeTransferMacro; // New!

    // For each ionization state
    for (j=0; j<atom[i].iState.size(); j++) {
      // For each bound state
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {

	// Set bound state pointer
	bState=&(atom[i].iState[j].bState[k]);

	// For each downward bound-bound transition
	for (l=0; l<bState->downTransBB.size(); l++) {

	  // If not (use LTE group and trans is internal to the group) - New!
	  if (not (useLTEGroup and bState->downTransBB[l]->isLTEGroupInternal())) {
      
	    // Calculate the probability for an internal transition and insert in matrix
	    P=bState->downTransBB[l]->RD(twoPhoton)*bState->downTransBB[l]->lowerState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	    if (coll) P+=bState->downTransBB[l]->CD()*bState->downTransBB[l]->lowerState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	    PT[matrixIndex[i][j][k]][matrixIndex[i][j][bState->downTransBB[l]->lowerState->index]]+=P; // Changed!
	  }

	  // Calculate (and add) the probability for a collisional de-excitation
	  if (coll) P=bState->downTransBB[l]->CD()*bState->downTransBB[l]->Xi()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	  else P=0;
	  PT[matrixIndex[i][j][k]][nStates]+=P;
	}
	
	// For each upward bound-bound transition
	for (l=0; l<bState->upTransBB.size(); l++) {

	  // If not (use LTE group and trans is internal to the group) - New!
	  if (not (useLTEGroup and bState->upTransBB[l]->isLTEGroupInternal())) {
      
	    // Calculate the probability for an internal transition and insert in matrix
	    P=bState->upTransBB[l]->RU()*bState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	    if (coll) P+=bState->upTransBB[l]->CU()*bState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	    if (nonThermal) P+=bState->upTransBB[l]->CNU()*bState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	    PT[matrixIndex[i][j][k]][matrixIndex[i][j][bState->upTransBB[l]->upperState->index]]+=P; // Changed!
	  }

	  // Calculate (and add) the probability for a collisional excitation
	  if (coll) P=bState->upTransBB[l]->CU()*bState->upTransBB[l]->Xi()/totalCooling;
	  else P=0;
	  PT[nStates][matrixIndex[i][j][bState->upTransBB[l]->upperState->index]]+=P;
	}
 
	// If bound-free processes included
	if (boundFree) {

	  // For each downward bound-free transition
	  for (l=0; l<bState->downTransBF.size(); l++) {

	    // If not (use LTE group and trans is internal to the group) - New!
	    if (not (useLTEGroup and bState->downTransBF[l]->isLTEGroupInternal())) {

	      // Calculate the probability for an internal transition and insert in matrix
	      P=bState->downTransBF[l]->RD()*bState->downTransBF[l]->lowerState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	      P+=bState->downTransBF[l]->RDAdd()*bState->downTransBF[l]->lowerState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // New!
	      if (coll) P+=bState->downTransBF[l]->CD()*bState->downTransBF[l]->lowerState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	      if (chargeTransfer) P+=bState->downTransBF[l]->CTD()*bState->downTransBF[l]->lowerState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // New!
	      PT[matrixIndex[i][j][k]][matrixIndex[i][j-1][bState->downTransBF[l]->lowerState->index]]+=P; // Changed!
	    }

	    // Calculate (and add) the probability for a collisional de-excitation
	    if (coll) P=bState->downTransBF[l]->CD()*bState->downTransBF[l]->Xi()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	    else P=0;
	    PT[matrixIndex[i][j][k]][nStates]+=P;

	    // If charge-transfer processes included - New!
	    if (chargeTransfer) {

	      // For each (downward) charge-transfer reaction
	      for (m=0; m<bState->downTransBF[l]->CTDReaction.size(); m++) {

		// Set charge-transfer reaction pointer
		cTReaction=bState->downTransBF[l]->CTDReaction[m];
		// Get atom, ionization and bound state indecis for the entry state
		ii=cTReaction->upTrans->upperState->iState()->atom()->index();
		jj=cTReaction->upTrans->upperState->iState()->index();
		kk=cTReaction->upTrans->upperState->index;

		// Calculate the probability for charge-transfer de-activation
		PCT=(cTReaction->forwardRate()*bState->downTransBF[l]->Xi())/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
		// Calculate (and add) the probability for charge-transfer re-activation
		PT[matrixIndex[i][j][k]][matrixIndex[ii][jj][kk]]+=(1-cTReaction->PHeating(ctForward))*PCT;
		// Calculate (and add) the probability for charge-transfer heating
		PT[matrixIndex[i][j][k]][nStates]+=cTReaction->PHeating(ctForward)*PCT;
	      }

	      // For each (upward) charge-transfer reaction
	      for (m=0; m<bState->downTransBF[l]->CTUReaction.size(); m++) {

		// Set charge-transfer reaction pointer
		cTReaction=bState->downTransBF[l]->CTUReaction[m];
		// Get atom, ionization and bound state indecis for the entry state
		ii=cTReaction->downTrans->upperState->iState()->atom()->index();
		jj=cTReaction->downTrans->upperState->iState()->index();
		kk=cTReaction->downTrans->upperState->index;

		// Calculate the probability for charge-transfer de-activation
		PCT=(cTReaction->backwardRate()*bState->downTransBF[l]->Xi())/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
		// Calculate (and add) the probability for charge-transfer re-activation
		PT[matrixIndex[i][j][k]][matrixIndex[ii][jj][kk]]+=(1-cTReaction->PHeating(ctBackward))*PCT;
		// Calculate (and add) the probability for charge-transfer heating
		PT[matrixIndex[i][j][k]][nStates]+=cTReaction->PHeating(ctBackward)*PCT;;
	      }
	    }
	  }

	  // For each upward bound-free transition
	  for (l=0; l<bState->upTransBF.size(); l++) {

	    // If not (use LTE group and trans is internal to the group) - New!
	    if (not (useLTEGroup and bState->upTransBF[l]->isLTEGroupInternal())) {
            
	      // Calculate the probability for an internal transition
	      P=bState->upTransBF[l]->RU()*bState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	      if (coll) P+=bState->upTransBF[l]->CU()*bState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	      if (nonThermal) P+=bState->upTransBF[l]->CNU()*bState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	      if (chargeTransfer) P+=bState->upTransBF[l]->CTU()*bState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	      PT[matrixIndex[i][j][k]][matrixIndex[i][j+1][bState->upTransBF[l]->upperState->index]]+=P; // Changed!
	    }

	    // Calculate (and add) the probability for a collisional excitation
	    if (coll) P=bState->upTransBF[l]->CU()*bState->upTransBF[l]->Xi()/totalCooling;
	    else P=0;
	    PT[nStates][matrixIndex[i][j+1][bState->upTransBF[l]->upperState->index]]+=P;

	    // If charge-transfer processes included - New!
	    if (chargeTransfer) {

	      // For each (upward) charge-transfer reaction
	      for (m=0; m<bState->upTransBF[l]->CTUReaction.size(); m++) {

		// Calculate (and add) the probability for a charge-transfer cooling
		P=bState->upTransBF[l]->CTUReaction[m]->forwardCooling()/totalCooling;
		PT[nStates][matrixIndex[i][j+1][bState->upTransBF[l]->upperState->index]]+=P;
	      }

	      // For each (downward) charge-transfer reaction
	      for (m=0; m<bState->downTransBF[l]->CTDReaction.size(); m++) {

		// Calculate (and add) the probability for a charge-transfer cooling
		P=bState->upTransBF[l]->CTDReaction[m]->backwardCooling()/totalCooling;
		PT[nStates][matrixIndex[i][j+1][bState->upTransBF[l]->upperState->index]]+=P;		
	      }
	    }
	  }
	}
      }
    }
  }

  // Calculate S^-1=(I-PT)
  for (i=0; i<nStates+1; i++) {
    for (j=0; j<nStates+1; j++) {
      if (i==j) SInv[i][j]=1-PT[i][j];
      else SInv[i][j]=0-PT[i][j];
    }
  }

  // Compose error info string - New!
  stringstream errorInfo;  errorInfo.str(""); errorInfo<<"Cell::markovS: index: "<<pIndex<<"ludcmp Error\n";

  // LU decompose S^-1
  ludcmp(SInv,index,d,errorInfo.str()); // Changed!

  // Calculate each column of S by back-substitution
  for (i=0; i<nStates+1; i++) {
    SCol=Vec_DP(0.0,nStates+1);
    SCol[i]=1;
    lubksb(SInv,index,SCol);
    for (j=0; j<nStates+1; j++) S[j][i]=SCol[j];
  }

  return S;
}

// Calculate cell Markov S matrix - New!
// Subcells: Works
// Containers: Not applicable
vector<vector<double> > Cell::markovSCell(const vector<vector<vector<double> > >& SAtom, const vector<vector<vector<int> > >& indexCell, const vector<vector<vector<int> > >& indexAtom) {
  vector<vector<double> > SCell;
  vector<double> PCA,PCDExit,PCD;
  vector<vector<double> > PCTDExit,PCTD;
  Mat_DP PT,SInv;
  Vec_DP SCol;
  Vec_INT index;
  DP d;
  BState* bState;
  CTReaction* cTReaction;
  double atomCooling,totalCooling=0,PCT;
  int i,j,k,l,m,n,jj,kk,nAtoms,nStates=0,nCTReactions;
  bool coll=true; // config->collMacro should be true
  bool freeFree=config->freeFreeMacro;
  bool boundFree=config->boundFreeMacro;
  bool nonThermal=config->nonThermalMacro;
  bool twoPhoton=config->twoPhotonMacro;
  bool chargeTransfer=config->chargeTransferMacro;
  bool useLTEGroup=config->LTEGroupMacro; // New!
  bool sumLTEGroup=useLTEGroup; // New!

  // Get total number of atoms
  nAtoms=atom.size();

  // Get total number of charge-transfer reactions
  if (boundFree and chargeTransfer) nCTReactions=ctReaction.size();
  else nCTReactions=0;

  // Get total number of states - Removed!
  /*nStates=0;
  for (i=0;i<indexCell.size();i++)
  for (j=0;j<indexCell[i].size();j++) nStates+=indexCell[i][j].size();*/

  // Get total number of states - New!
  countBMatrixIndex(nStates);
  
  // Initialize
  PT=Mat_DP(0.0,nAtoms+2*nCTReactions+1,nAtoms+2*nCTReactions+1);
  SInv=Mat_DP(0.0,nAtoms+2*nCTReactions+1,nAtoms+2*nCTReactions+1);
  SCell.resize(nAtoms+2*nCTReactions+1); for (i=0;i<SCell.size();i++) SCell[i].resize(nAtoms+2*nCTReactions+1,0.0);
  index=Vec_INT(0.0,nAtoms+2*nCTReactions+1);
  PCA.resize(nStates,0.0);
  PCDExit.resize(nStates,0.0);
  PCTDExit.resize(2*nCTReactions); for (i=0;i<PCTDExit.size();i++) PCTDExit[i].resize(nStates,0.0);
  PCD.resize(nStates,0.0);
  PCTD.resize(2*nCTReactions); for (i=0;i<PCTD.size();i++) PCTD[i].resize(nStates,0.0);

  if (master()) cout<<"Cell::markovSCell: index: "<<pIndex<<", Calculate transition probabilities\n";

  // Get total cooling
  totalCooling=collCooling(); // config->collMacro should be true
  if (freeFree) totalCooling+=freeFreeCooling();
  if (boundFree) totalCooling+=boundFreeCoolingSP();
  if (chargeTransfer) totalCooling+=CTCooling();

  // Testing!
  if (totalCooling==0) cout<<"Cell::markovSCell: index: "<<pIndex<<", Warning: zero total cooling\n";

  // For each atom
  for (i=0; i<atom.size(); i++) {
    
    atomCooling=atom[i].collCooling();
    if (chargeTransfer) atomCooling+=atom[i].CTCooling();

    // Testing!
    if (atomCooling==0) cout<<"Cell::markovSCell: index: "<<pIndex<<", "<<atom[i].name()<<", Warning: zero cooling\n";

    // For each entry state
    for (j=0; j<atom[i].iState.size(); j++) {
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {
	
	// Set bound state pointer
	bState=&(atom[i].iState[j].bState[k]);

	// For each downward bound-bound transition
	for (l=0; l<bState->downTransBB.size(); l++) {
	  // Sum collisional activation probability
	  PCA[indexCell[i][j][k]]+=(bState->downTransBB[l]->CU()*bState->downTransBB[l]->Xi())/atomCooling;
	}

	// If bound-free processes included
	if (boundFree) {
	  
	  // For each downward bound-free transition
	  for (l=0; l<bState->downTransBF.size(); l++) {
	    // Sum collisional activation probability
	    PCA[indexCell[i][j][k]]+=(bState->downTransBF[l]->CU()*bState->downTransBF[l]->Xi())/atomCooling;
	  }
	}

	// If charge-transfer processes included
	if (boundFree and chargeTransfer) {

	  // For each downward bound-free transition
	  for (l=0; l<bState->downTransBF.size(); l++) {

	    // For each upward charge-transfer reaction
	    for (m=0; m<bState->downTransBF[l]->CTUReaction.size(); m++) {
	      // Sum collisional activation probability
	      PCA[indexCell[i][j][k]]+=bState->downTransBF[l]->CTUReaction[m]->forwardCooling()/atomCooling;
	    }

	    // For each downward charge-transfer reaction
	    for (m=0; m<bState->downTransBF[l]->CTDReaction.size(); m++) {
	      // Sum collisional activation probability
	      PCA[indexCell[i][j][k]]+=bState->downTransBF[l]->CTDReaction[m]->backwardCooling()/atomCooling;
	    }
	  }
	}
      }
    }

    // For each exit state
    for (j=0; j<atom[i].iState.size(); j++) {
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {
		
	// Set bound state pointer
	bState=&(atom[i].iState[j].bState[k]);

	// For each downward bound-bound transition
	for (l=0; l<bState->downTransBB.size(); l++) {
	  // Sum collisional de-activation probability
	  PCDExit[indexCell[i][j][k]]+=(bState->downTransBB[l]->CD()*bState->downTransBB[l]->Xi())/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup);
	}

	// If bound-free processes included
	if (boundFree) {
	  
	  // For each downward bound-free transition
	  for (l=0; l<bState->downTransBF.size(); l++) {
	    // Sum collisional de-activation probability
	    PCDExit[indexCell[i][j][k]]+=(bState->downTransBF[l]->CD()*bState->downTransBF[l]->Xi())/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup);
	  }
	}
	
	// If charge-transfer processes included
	if (boundFree and chargeTransfer) {

	  // For each downward bound-free transition
	  for (l=0; l<bState->downTransBF.size(); l++) {

	    // For each downward charge-transfer reaction
	    for (m=0; m<bState->downTransBF[l]->CTDReaction.size(); m++) {
	      // Set charge-transfer reaction pointer
	      cTReaction=bState->downTransBF[l]->CTDReaction[m];
	      // Get charge-transfer reaction index
	      n=cTReaction->index();
	      // Calculate charge-transfer de-activation probability
	      PCT=(cTReaction->forwardRate()*bState->downTransBF[l]->Xi())/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup);
	      // Sum charge-transfer (ionization) de-activation probability
	      PCTDExit[n][indexCell[i][j][k]]+=(1-cTReaction->PHeating(ctForward))*PCT;
	      // Sum collisional de-activation probability
	      PCDExit[indexCell[i][j][k]]+=cTReaction->PHeating(ctForward)*PCT;
	    }

	    // For each upward charge-transfer reaction
	    for (m=0; m<bState->downTransBF[l]->CTUReaction.size(); m++) {
	      // Set charge-transfer reaction pointer
	      cTReaction=bState->downTransBF[l]->CTUReaction[m];
	      // Get charge-transfer reaction index
	      n=cTReaction->index();
	      // Calculate charge-transfer de-activation probability
	      PCT=(cTReaction->backwardRate()*bState->downTransBF[l]->Xi())/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup);
	      // Sum charge-transfer (ionization) de-activation probability
	      PCTDExit[nCTReactions+n][indexCell[i][j][k]]+=(1-cTReaction->PHeating(ctBackward))*PCT;
	      // Sum collisional de-activation probability
	      PCDExit[indexCell[i][j][k]]+=cTReaction->PHeating(ctBackward)*PCT;
	    }
	  }
	}
      }
    }    

    // For each entry state
    for (j=0; j<atom[i].iState.size(); j++) {
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {
	
	// If use LTE group and not master state - Skip and continue - New!
	if (useLTEGroup and atom[i].iState[j].bState[k].LTERefState!=NULL) continue;

	// For each exit state
	for (jj=0; jj<atom[i].iState.size(); jj++) {
	  for (kk=0; kk<atom[i].iState[jj].bState.size(); kk++) {  

	    // If use LTE group and not master state - Skip and continue - New!
	    if (useLTEGroup and atom[i].iState[jj].bState[kk].LTERefState!=NULL) continue;

	    // Sum collisional de-activation probabilities for this entry state
	    PCD[indexCell[i][j][k]]+=SAtom[i][indexAtom[i][j][k]][indexAtom[i][jj][kk]]*PCDExit[indexCell[i][jj][kk]];

	    // If charge-transfer processes included
	    if (boundFree and chargeTransfer) {

	      // For each (forward and backward) charge-transfer reaction
	      for (n=0; n<2*ctReaction.size(); n++) {
		// Sum charge-transfer de-activation probabilities for this entry state
		PCTD[n][indexCell[i][j][k]]+=SAtom[i][indexAtom[i][j][k]][indexAtom[i][jj][kk]]*PCTDExit[n][indexCell[i][jj][kk]];
	      }
	    }
	  }
	}
      }
    }
  }

  // For each atom
  for (i=0; i<atom.size(); i++) {

    // For each entry state
    for (j=0; j<atom[i].iState.size(); j++) {
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {

	// If use LTE group and not master state - Skip and continue - New!
	if (useLTEGroup and atom[i].iState[j].bState[k].LTERefState!=NULL) continue;

	// Sum collisional de-activation probability
	PT[i][nAtoms]+=PCA[indexCell[i][j][k]]*PCD[indexCell[i][j][k]];

	// If charge-transfer processes included
	if (boundFree and chargeTransfer) {

	  // For each (forward and backward) charge-transfer reaction
	  for (n=0; n<2*ctReaction.size(); n++) {
	    // Sum charge-transfer de-activation probability
	    PT[i][nAtoms+1+n]+=PCA[indexCell[i][j][k]]*PCTD[n][indexCell[i][j][k]];
	  }
	}
      }
    }

    // Calculate collisional activation probability
    PT[nAtoms][i]=atom[i].collCooling()/totalCooling;
    if (chargeTransfer) PT[nAtoms][i]+=atom[i].CTCooling()/totalCooling;
  }

  // If charge-transfer processes included
  if (boundFree and chargeTransfer) {

    // For each (forward) charge-transfer reaction
    for (n=0; n<ctReaction.size(); n++) {

      // Get index of the atom activated by the charge-transfer reaction
      i=ctReaction[n].upTrans->upperState->iState()->atom()->index();

      // Get ionization and bound state indecis for the entry state
      j=ctReaction[n].upTrans->upperState->iState()->index();
      k=ctReaction[n].upTrans->upperState->index;

      // Sum collisional de-activation probability
      PT[nAtoms+1+n][nAtoms]+=PCD[indexCell[i][j][k]];
	  
      // For each (forward and backward) charge-transfer reaction
      for (m=0; m<2*ctReaction.size(); m++) {
	// Sum charge-transfer de-activation probability
	PT[nAtoms+1+n][nAtoms+1+m]+=PCTD[m][indexCell[i][j][k]];
      }
    }

    // For each (backward) charge-transfer reaction
    for (n=0; n<ctReaction.size(); n++) {

      // Get index of the atom activated by the charge-transfer reaction
      i=ctReaction[n].downTrans->upperState->iState()->atom()->index();

      // Get ionization and bound state indecis for the entry state
      j=ctReaction[n].downTrans->upperState->iState()->index();
      k=ctReaction[n].downTrans->upperState->index;

      // Sum collisional de-activation probability
      PT[nAtoms+1+nCTReactions+n][nAtoms]+=PCD[indexCell[i][j][k]];
	  
      // For each (forward and backward) charge-transfer reaction
      for (m=0; m<2*ctReaction.size(); m++) {
	// Sum charge-transfer de-activation probability
	PT[nAtoms+1+nCTReactions+n][nAtoms+1+m]+=PCTD[m][indexCell[i][j][k]];
      }
    }
  }

  if (master()) cout<<"Cell::markovSCell: index: "<<pIndex<<", Calculate S Matrix\n";

  // Calculate S^-1=(I-PT)
  for (i=0; i<nAtoms+2*nCTReactions+1; i++) {
    for (j=0; j<nAtoms+2*nCTReactions+1; j++) {
      if (i==j) SInv[i][j]=1-PT[i][j];
      else SInv[i][j]=0-PT[i][j];
    }
  }
  
  // Compose error info string - New!
  stringstream errorInfo;  errorInfo.str(""); errorInfo<<"Cell::markovSCell: index: "<<pIndex<<"ludcmp Error\n";
  // Testing!
  for (i=0; i<SInv.nrows(); i++) { for (j=0; j<SInv.ncols(); j++) { errorInfo<<SInv[i][j]; if (j<SInv.nrows()-1) errorInfo<<", "; } errorInfo<<"\n"; }

  // LU decompose S^-1
  ludcmp(SInv,index,d,errorInfo.str()); //Changed!
  
  // Calculate each column of S by back-substitution
  for (i=0; i<nAtoms+2*nCTReactions+1; i++) {
    SCol=Vec_DP(0.0,nAtoms+2*nCTReactions+1);
    SCol[i]=1;
    lubksb(SInv,index,SCol);
    for (j=0; j<nAtoms+2*nCTReactions+1; j++) SCell[j][i]=SCol[j];
  }

  return SCell;
}

// Calculate thermal pool atom Markov S vector - New!
// Subcells: Works
// Containers: Not applicable
vector<vector<double> > Cell::markovSAtomTherm(const vector<vector<vector<double> > >& SAtom, const vector<vector<vector<int> > >& indexAtom) {
  vector<vector<double> > SAtomTherm;
  vector<vector<double> > PCA;
  bool boundFree=config->boundFreeMacro;
  bool chargeTransfer=config->chargeTransferMacro;
  double atomCooling;
  BState* bState;
  vector<int> nStatesAtom(atom.size(),0);
  int i,j,k,l,m,jj,kk,nAtoms;
  bool useLTEGroup=config->LTEGroupMacro; // New!
  bool sumLTEGroup=useLTEGroup; // New!

  // Get total number of atoms
  nAtoms=atom.size();

  // For each atom
  for (i=0;i<atom.size();i++) {
    // Get number of states - Removed!
    //for (j=0;j<indexAtom[i].size();j++) nStatesAtom[i]+=indexAtom[i][j].size();
    // Get number of states - New!
    atom[i].countBMatrixIndex(nStatesAtom[i]);
  }

  // Initialize
  PCA.resize(nAtoms); for (i=0;i<PCA.size();i++) PCA[i].resize(nStatesAtom[i],0.0);
  SAtomTherm.resize(nAtoms); for (i=0;i<SAtomTherm.size();i++) SAtomTherm[i].resize(nStatesAtom[i],0.0);

  // For each atom
  for (i=0; i<atom.size(); i++) {

    atomCooling=atom[i].collCooling();
    if (chargeTransfer) atomCooling+=atom[i].CTCooling();

    // For each entry state
    for (j=0; j<atom[i].iState.size(); j++) {
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {
	
	// Set bound state pointer
	bState=&(atom[i].iState[j].bState[k]);
	
	// For each downward bound-bound transition
	for (l=0; l<bState->downTransBB.size(); l++) {
	  // Sum collisional activation probability
	  PCA[i][indexAtom[i][j][k]]+=(bState->downTransBB[l]->CU()*bState->downTransBB[l]->Xi())/atomCooling;
	}
	
	// If bound-free processes included
	if (boundFree) {
	  
	  // For each downward bound-free transition
	  for (l=0; l<bState->downTransBF.size(); l++) {
	    // Sum collisional activation probability
	    PCA[i][indexAtom[i][j][k]]+=(bState->downTransBF[l]->CU()*bState->downTransBF[l]->Xi())/atomCooling;
	  }
	}

	// If charge-transfer processes included
	if (boundFree and chargeTransfer) {

	  // For each downward bound-free transition
	  for (l=0; l<bState->downTransBF.size(); l++) {

	    // For each upward charge-transfer reaction
	    for (m=0; m<bState->downTransBF[l]->CTUReaction.size(); m++) {
	      // Sum collisional activation probability
	      PCA[i][indexAtom[i][j][k]]+=bState->downTransBF[l]->CTUReaction[m]->forwardCooling()/atomCooling;
	    }

	    // For each downward charge-transfer reaction
	    for (m=0; m<bState->downTransBF[l]->CTDReaction.size(); m++) {
	      // Sum collisional activation probability
	      PCA[i][indexAtom[i][j][k]]+=bState->downTransBF[l]->CTDReaction[m]->backwardCooling()/atomCooling;
	    }
	  }
	}
      }
    }
  }

  // For each atom
  for (i=0; i<atom.size(); i++) {
    // For each entry state (of the atom)
    for (j=0; j<atom[i].iState.size(); j++) {
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {

	// If use LTE group and not master state - Skip and continue - New!
	if (useLTEGroup and atom[i].iState[j].bState[k].LTERefState!=NULL) continue;

	// For each exit state (of the atom)
	for (jj=0; jj<atom[i].iState.size(); jj++) {
	  for (kk=0; kk<atom[i].iState[jj].bState.size(); kk++) {

	    // If use LTE group and not master state - Skip and continue - New!
	    if (useLTEGroup and atom[i].iState[jj].bState[kk].LTERefState!=NULL) continue;

	    // Sum average time spent in this bound state
	    SAtomTherm[i][indexAtom[i][jj][kk]]+=PCA[i][indexAtom[i][j][k]]*SAtom[i][indexAtom[i][j][k]][indexAtom[i][jj][kk]];
	  }
	}
      }
    }
  }

  return SAtomTherm;
}

// Calculate thermal pool Markov S vector (original version)
// Subcells: Works
// Containers: Not applicable
vector<double> Cell::markovSTherm(const vector<vector<vector<double> > >& SAtom, const vector<vector<vector<int> > >& indexAtom, const vector<vector<vector<int> > >& indexCell) {
  vector<double> STherm;
  vector<double> PCA,PRDExit,PCDExit,PRD,PCD;
  Mat_DP PT,SInv,S;
  Vec_DP SCol;
  Vec_INT index;
  DP d;
  BState* bState;
  double P,PTot,atomCollCooling,totalCooling=0;
  int i,j,k,l,jj,kk,nAtoms,nStates=0,rowIndex; // Changed!
  bool boundFree,coll,nonThermal,twoPhoton,chargeTransfer; // Changed!
  bool useLTEGroup=config->LTEGroupMacro; // New!
  bool sumLTEGroup=useLTEGroup; // New!

  // Get total number of atoms
  nAtoms=atom.size();

  // Get total number of states - Removed!
  // Unclear if muliple initializers work - Fix!
  /*nStates=0; // New!
  for (i=0;i<indexCell.size();i++) // Changed!
  for (j=0;j<indexCell[i].size();j++) nStates+=indexCell[i][j].size();*/

  // Get total number of states - New!
  countBMatrixIndex(nStates);
  
  // Initialize
  PT=Mat_DP(0.0,nAtoms+1,nAtoms+1);
  SInv=Mat_DP(0.0,nAtoms+1,nAtoms+1);
  S=Mat_DP(0.0,nAtoms+1,nAtoms+1);
  index=Vec_INT(0.0,nAtoms+1);
  STherm.resize(nStates+1,0.0);
  PCA.resize(nStates,0.0);
  PRDExit.resize(nStates,0.0);
  PCDExit.resize(nStates,0.0);
  PRD.resize(nStates,0.0);
  PCD.resize(nStates,0.0);

  if (master()) cout<<"Cell::markovSTherm: index: "<<pIndex<<", Calculate transition probabilities\n";

  // Get total cooling
  totalCooling=collCooling(); // config->collMacro should be true
  if (config->freeFreeMacro) totalCooling+=freeFreeCooling();
  if (config->boundFreeMacro) totalCooling+=boundFreeCoolingSP();
  
  // For each atom
  for (i=0; i<atom.size(); i++) {

    // Get processes flags
    coll=true; // config->collMacro should be true
    boundFree=config->boundFreeMacro;
    nonThermal=config->nonThermalMacro; // New!
    twoPhoton=config->twoPhotonMacro; // New!
    chargeTransfer=config->chargeTransferMacro; // New!

    atomCollCooling=atom[i].collCooling();

    // For each entry state
    for (j=0; j<atom[i].iState.size(); j++) {
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {
	
	// Set bound state pointer
	bState=&(atom[i].iState[j].bState[k]);

	// For each downward bound-bound transition
	for (l=0; l<bState->downTransBB.size(); l++) {
	  // Sum collisional activation probability
	  PCA[indexCell[i][j][k]]+=(bState->downTransBB[l]->CU()*bState->downTransBB[l]->Xi())/atomCollCooling;
	}

	// If bound-free processes included
	if (boundFree) {
	  
	  // For each downward bound-free transition
	  for (l=0; l<bState->downTransBF.size(); l++) {
	    // Sum collisional activation probability
	    PCA[indexCell[i][j][k]]+=(bState->downTransBF[l]->CU()*bState->downTransBF[l]->Xi())/atomCollCooling;
	  }
	}
      }
    }

    // For each exit state
    for (j=0; j<atom[i].iState.size(); j++) {
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {
		
	// Set bound state pointer
	bState=&(atom[i].iState[j].bState[k]);

	// For each downward bound-bound transition
	for (l=0; l<bState->downTransBB.size(); l++) {
	  // Sum collisional de-activation probability
	  PCDExit[indexCell[i][j][k]]+=(bState->downTransBB[l]->CD()*bState->downTransBB[l]->Xi())/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	}
	
	// If bound-free processes included
	if (boundFree) {
	  
	  // For each downward bound-free transition
	  for (l=0; l<bState->downTransBF.size(); l++) {
	    // Sum collisional de-activation probability
	    PCDExit[indexCell[i][j][k]]+=(bState->downTransBF[l]->CD()*bState->downTransBF[l]->Xi())/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	  }
	}
      }
    }

    // For each entry state
    for (j=0; j<atom[i].iState.size(); j++) {
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {

	// If use LTE group and not master state - Skip and continue - New!
	if (useLTEGroup and atom[i].iState[j].bState[k].LTERefState!=NULL) continue;

	// For each exit state
	for (jj=0; jj<atom[i].iState.size(); jj++) {
	  for (kk=0; kk<atom[i].iState[jj].bState.size(); kk++) {  

	    // If use LTE group and not master state - Skip and continue - New!
	    if (useLTEGroup and atom[i].iState[jj].bState[kk].LTERefState!=NULL) continue;

	    // Sum collisional de-activation probabilities for this entry state
	    PCD[indexCell[i][j][k]]+=SAtom[i][indexAtom[i][j][k]][indexAtom[i][jj][kk]]*PCDExit[indexCell[i][jj][kk]];
	  }
	}
      }
    }
  }

  // For each atom
  for (i=0; i<atom.size(); i++) {

    // For each entry state
    for (j=0; j<atom[i].iState.size(); j++) {
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {

	// If use LTE group and not master state - Skip and continue - New!
	if (useLTEGroup and atom[i].iState[j].bState[k].LTERefState!=NULL) continue;

	// Sum collisional de-activation probability
	PT[i][nAtoms]+=PCA[indexCell[i][j][k]]*PCD[indexCell[i][j][k]];
      }
    }

    // Calculate collisional activation probability
    PT[nAtoms][i]=atom[i].collCooling()/totalCooling;
  }

  if (master()) cout<<"Cell::markovSTherm: index: "<<pIndex<<", Calculate S Matrix\n";

  // Calculate S^-1=(I-PT)
  for (i=0; i<nAtoms+1; i++) {
    for (j=0; j<nAtoms+1; j++) {
      if (i==j) SInv[i][j]=1-PT[i][j];
      else SInv[i][j]=0-PT[i][j];
    }
  }
  
  // Compose error info string - New!
  stringstream errorInfo;  errorInfo.str(""); errorInfo<<"Cell::markovSTherm: index: "<<pIndex<<"ludcmp Error\n";

  // LU decompose S^-1
  ludcmp(SInv,index,d,errorInfo.str());
  
  // Calculate each column of S by back-substitution
  for (i=0; i<nAtoms+1; i++) {
    SCol=Vec_DP(0.0,nAtoms+1);
    SCol[i]=1;
    lubksb(SInv,index,SCol);
    for (j=0; j<nAtoms+1; j++) S[j][i]=SCol[j];
  }

  // For each atom
  for (i=0; i<atom.size(); i++) {
    // For each bound state (of the atom)
    for (j=0; j<atom[i].iState.size(); j++) {
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {

	// If use LTE group and not master state - Skip and continue - New!
	if (useLTEGroup and atom[i].iState[j].bState[k].LTERefState!=NULL) continue;

	// For each bound state (of the atom)
	for (jj=0; jj<atom[i].iState.size(); jj++) {
	  for (kk=0; kk<atom[i].iState[jj].bState.size(); kk++) {

	    // If use LTE group and not master state - Skip and continue - New!
	    if (useLTEGroup and atom[i].iState[jj].bState[kk].LTERefState!=NULL) continue;

	    // Sum average time spent in this bound state
	    STherm[indexCell[i][jj][kk]]+=S[nAtoms][i]*PCA[indexCell[i][j][k]]*SAtom[i][indexAtom[i][j][k]][indexAtom[i][jj][kk]];
	  }
	}
      }
    }
  }

  // Get average time spent in the thermal pool
  STherm[nStates]=S[nAtoms][nAtoms];

  if (master()) cout<<"Cell::markovSTherm: index: "<<pIndex<<", Return\n";
  
  return STherm;
}

// Calculate thermal pool Markov S vector (new version) - New!
// Subcells: Works
// Containers: Not applicable
vector<double> Cell::markovSTherm(const vector<vector<double> >& SCell, const vector<vector<vector<double> > >& SAtom, const vector<vector<vector<int> > >& indexCell, const vector<vector<vector<int> > >& indexAtom) {
  vector<double> STherm;
  vector<vector<double> > SAtomTherm;
  bool boundFree=config->boundFreeMacro;
  bool chargeTransfer=config->chargeTransferMacro;
  int i,j,k,n,ii,jj,kk,nAtoms,nCTReactions,nStates=0;
  bool useLTEGroup=config->LTEGroupMacro; // New!
  bool sumLTEGroup=useLTEGroup; // New!

  // Get total number of atoms
  nAtoms=atom.size();

  // Get total number of charge-transfer reactions
  if (boundFree and chargeTransfer) nCTReactions=ctReaction.size();
  else nCTReactions=0;

  // Get total number of states - Removed!
  /*nStates=0;
  for (i=0;i<indexCell.size();i++)
  for (j=0;j<indexCell[i].size();j++) nStates+=indexCell[i][j].size();*/

  // Get total number of states
  countBMatrixIndex(nStates);

  // Initialize
  STherm.resize(nStates+1,0.0);

  // Get thermal pool atom S vectors
  SAtomTherm=markovSAtomTherm(SAtom,indexAtom);

  // For each atom
  for (i=0; i<atom.size(); i++) {
    // For each bound state (of the atom)
    for (j=0; j<atom[i].iState.size(); j++) {
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {

	// If use LTE group and not master state - Skip and continue - New!
	if (useLTEGroup and atom[i].iState[j].bState[k].LTERefState!=NULL) continue;

	// Sum average time spent in this bound state
	STherm[indexCell[i][j][k]]+=SCell[nAtoms][i]*SAtomTherm[i][indexAtom[i][j][k]];
      }
    }
  }

  // Get average time spent in the thermal pool
  STherm[nStates]=SCell[nAtoms][nAtoms];

  // If charge-transfer processed included
  if (boundFree and chargeTransfer) {

    // For each (forward) charge-transfer reaction
    for (n=0; n<ctReaction.size(); n++) {

      // Get index of the atom activated by the charge-transfer reaction
      ii=ctReaction[n].upTrans->upperState->iState()->atom()->index();

      // Get ionization and bound state indices for the entry state
      jj=ctReaction[n].upTrans->upperState->iState()->index();
      kk=ctReaction[n].upTrans->upperState->index;

      // For each exit state of the atom
      for (j=0; j<atom[ii].iState.size(); j++) {
	for (k=0; k<atom[ii].iState[j].bState.size(); k++) {

	  // If use LTE group and not master state - Skip and continue - New!
	  if (useLTEGroup and atom[ii].iState[j].bState[k].LTERefState!=NULL) continue;

	  // Sum average time spent in this bound state
	  STherm[indexCell[ii][j][k]]+=SCell[nAtoms][nAtoms+1+n]*SAtom[ii][indexAtom[ii][jj][kk]][indexAtom[ii][j][k]];
	}
      }
    }

    // For each (backward) charge-transfer reaction
    for (n=0; n<ctReaction.size(); n++) {

      // Get index of the atom activated by the charge-transfer reaction
      ii=ctReaction[n].downTrans->upperState->iState()->atom()->index();

      // Get ionization and bound state indices for the entry state
      jj=ctReaction[n].downTrans->upperState->iState()->index();
      kk=ctReaction[n].downTrans->upperState->index;

      // For each exit state of the atom
      for (j=0; j<atom[ii].iState.size(); j++) {
	for (k=0; k<atom[ii].iState[j].bState.size(); k++) {

	  // If use LTE group and not master state - Skip and continue - New!
	  if (useLTEGroup and atom[ii].iState[j].bState[k].LTERefState!=NULL) continue;

	  // Sum average time spent in this bound state
	  STherm[indexCell[ii][j][k]]+=SCell[nAtoms][nAtoms+1+nCTReactions+n]*SAtom[ii][indexAtom[ii][jj][kk]][indexAtom[ii][j][k]];
	}
      }
    }
  }

  return STherm;
}

// Calculate charge-transfer Markov S vector - New!
// Subcells: Works
// Containers: Not applicable
vector<vector<double> > Cell::markovSCT(const vector<vector<double> >& SCell, const vector<vector<vector<double> > >& SAtom, const vector<vector<vector<int> > >& indexCell, const vector<vector<vector<int> > >& indexAtom) {
  vector<vector<double> > SCT;
  vector<vector<double> > SAtomTherm;
  int i,j,k,ii,jj,kk,n,m,nAtoms,nCTReactions,nStates=0;
  bool useLTEGroup=config->LTEGroupMacro; // New!
  bool sumLTEGroup=useLTEGroup; // New!

  // Get total number of atoms
  nAtoms=atom.size();

  // Get total number of chargeTransfer reactions
  nCTReactions=ctReaction.size();

  // Get total number of states - Removed!
  /*nStates=0;
  for (i=0;i<indexCell.size();i++)
  for (j=0;j<indexCell[i].size();j++) nStates+=indexCell[i][j].size();*/

  // Get total number of states
  countBMatrixIndex(nStates);

  // Initialize
  SCT.resize(2*nCTReactions); for (i=0;i<SCT.size();i++) SCT[i].resize(nStates+1,0.0);

  // Get thermal pool atom S vectors
  SAtomTherm=markovSAtomTherm(SAtom,indexAtom);

  // For each (forward and backward) charge-transfer reaction
  for (n=0; n<2*ctReaction.size(); n++) {
      
    // For each atom
    for (i=0; i<atom.size(); i++) {
      // For each bound state (of the atom)
      for (j=0; j<atom[i].iState.size(); j++) {
	for (k=0; k<atom[i].iState[j].bState.size(); k++) {

	  // If use LTE group and not master state - Skip and continue - New!
	  if (useLTEGroup and atom[i].iState[j].bState[k].LTERefState!=NULL) continue;
	  	      
	  // Sum average time spent in this bound state
	  SCT[n][indexCell[i][j][k]]+=SCell[nAtoms+1+n][i]*SAtomTherm[i][indexAtom[i][j][k]];
	}
      }
    }
  
    // Get average time spent in the thermal pool
    SCT[n][nStates]=SCell[nAtoms+1+n][nAtoms];

    // For each (forward) charge-transfer reaction
    for (m=0; m<ctReaction.size(); m++) {
      
      // Get index of the atom activated by the charge-transfer reaction
      ii=ctReaction[m].upTrans->upperState->iState()->atom()->index();
      
      // Get ionization and bound state indices for the entry state
      jj=ctReaction[m].upTrans->upperState->iState()->index();
      kk=ctReaction[m].upTrans->upperState->index;
      
      // For each exit state of the atom
      for (j=0; j<atom[ii].iState.size(); j++) {
	for (k=0; k<atom[ii].iState[j].bState.size(); k++) {
	  
	  // If use LTE group and not master state - Skip and continue - New!
	  if (useLTEGroup and atom[ii].iState[j].bState[k].LTERefState!=NULL) continue;

	  // Sum average time spent in this bound state
	  SCT[n][indexCell[ii][j][k]]+=SCell[nAtoms+1+n][nAtoms+1+m]*SAtom[ii][indexAtom[ii][jj][kk]][indexAtom[ii][j][k]];
	}
      }
    }

    // For each (backward) charge-transfer reaction
    for (m=0; m<ctReaction.size(); m++) {
      
      // Get index of the atom activated by the charge-transfer reaction
      ii=ctReaction[m].downTrans->upperState->iState()->atom()->index();
      
      // Get ionization and bound state indices for the entry state
      jj=ctReaction[m].downTrans->upperState->iState()->index();
      kk=ctReaction[m].downTrans->upperState->index;
      
      // For each exit state of the atom
      for (j=0; j<atom[ii].iState.size(); j++) {
	for (k=0; k<atom[ii].iState[j].bState.size(); k++) {
	  
	  // If use LTE group and not master state - Skip and continue - New!
	  if (useLTEGroup and atom[ii].iState[j].bState[k].LTERefState!=NULL) continue;

	  // Sum average time spent in this bound state
	  SCT[n][indexCell[ii][j][k]]+=SCell[nAtoms+1+n][nAtoms+1+nCTReactions+m]*SAtom[ii][indexAtom[ii][jj][kk]][indexAtom[ii][j][k]];
	}
      }
    }
  }
  
  return SCT;
}

// Singular (SInv) matrix check - New!
bool Cell::singular(Mat_DP& SInv, const vector<vector<vector<int> > >& matrixIndex, int& rowIndex, int& atomIndex, int& iStateIndex, int& bStateIndex) {
  int i,j,ii,jj,kk,nZero;
  bool singular=false,found;

  for (i=0;i<SInv.nrows();i++) {
    nZero=0;
    for (j=0;j<SInv.ncols();j++) if (SInv[i][j]==0) nZero++;
    if (nZero==SInv.ncols()) {
      found=false;
      for (ii=0;ii<atom.size();ii++) {
	for (jj=0;jj<atom[ii].iState.size();jj++) {
	  for (kk=0;kk<atom[ii].iState[jj].bState.size();kk++) if (matrixIndex[ii][jj][kk]==i) { found=true; break; }
	  if (found) break;
	}
	if (found) break;
      }
      rowIndex=i; atomIndex=ii; iStateIndex=jj; bStateIndex=kk;
      singular=true;
      break;
    }
  }
  
  return singular;
}

// Singular (SThermInv) matrix check - New!
bool Cell::singularTherm(Mat_DP& SInv, int& rowIndex) {
  int i,j,nZero;
  bool singular=false,found;

  for (i=0;i<SInv.nrows();i++) {
    nZero=0;
    for (j=0;j<SInv.ncols();j++) if (SInv[i][j]==0) nZero++;
    if (nZero==SInv.ncols()) {
      singular=true;
      rowIndex=i;
      break;
    }
  }
  
  return singular;
}

// Setup bound state index mapping
vector<vector<vector<int> > > Cell::bMatrixIndex(int& nStates) {
  vector<vector<vector<int> > > matrixIndex(atom.size());
  int i;

  // Count total number of states and setup matrix index mapping
  for (i=0;i<atom.size();i++) matrixIndex[i]=atom[i].bMatrixIndex(nStates);

  return matrixIndex;
}

// Count number of unique bound state indeces
void Cell::countBMatrixIndex(int& nStates) {
  vector<vector<vector<int> > > matrixIndex=bMatrixIndex(nStates);
}

// Update transition probability list
// Subcells: Works
// Containers: Not applicable
void Cell::updateTransPList() {
  int i;
  if (config->markovTableExt) updateMarkovPList();
  else if (config->markovTableExtSplit) updateMarkovPListSplit();
  else for (i=0; i<atom.size(); i++) atom[i].updateTransPList();
}

// Update split Markov transition probability list
// Subcells: Works
// Containers: Not applicable 
void Cell::updateMarkovPListSplit() {
  vector<vector<vector<double> > > SAtom(atom.size());
  vector<vector<double> > SCell(atom.size()); // New!
  vector<vector<vector<int> > > indexAtom(atom.size());
  vector<vector<vector<int> > > indexCell(atom.size()); // New!
  bool boundFree=config->boundFreeMacro; // New!
  bool chargeTransfer=config->chargeTransferMacro; // New!
  long markovPMemSize,transPMemSize;
  vector<int> nStatesAtom(atom.size(),0); // New!
  int i,j,k,nStatesCell=0; // Changed!

  // Setup cell index mapping - New! - Removed!
  /*nStatesCell=0;
  for (i=0;i<atom.size();i++) {
    indexCell[i].resize(atom[i].iState.size());
    for (j=0;j<atom[i].iState.size();j++) {
      indexCell[i][j].resize(atom[i].iState[j].bState.size());
      for (k=0;k<atom[i].iState[j].bState.size();k++) {
	indexCell[i][j][k]=nStatesCell; nStatesCell++;
      }
    }
    }*/

  // Setup atom index mapping - Removed!
  /*for (i=0;i<atom.size();i++) {
    indexAtom[i].resize(atom[i].iState.size());
    // Unclear if muliple initializers work - Fix!
    nStatesAtom=0; // New!
    for (j=0;j<atom[i].iState.size();j++) { // Changed!
      indexAtom[i][j].resize(atom[i].iState[j].bState.size());
      for (k=0;k<atom[i].iState[j].bState.size();k++) {
	indexAtom[i][j][k]=nStatesAtom; nStatesAtom++;
      }
    }
    }*/

  // Setup cell index mapping - New!
  indexCell=bMatrixIndex(nStatesCell);

  // Setup atom index mapping - New!
  for (i=0;i<atom.size();i++) {
    //nStatesAtom=0; // Removed!
    indexAtom[i]=atom[i].bMatrixIndex(nStatesAtom[i]); // Changed!
  }

  // Calculate Markov S matrices for each atom
  for (i=0;i<atom.size();i++) {
    if (master()) cout<<"Cell::updateMarkovPListSplit: index: "<<index()<<", Calculate "<<atom[i].name()<<" "<<nStatesAtom[i]<<"x"<<nStatesAtom[i]<<" Markov S Matrix\n";
    SAtom[i]=atom[i].markovS(indexAtom[i]);
  }

  if (master()) cout<<"Cell::updateMarkovPListSplit: index: "<<index()<<", Update atom Markov probability lists\n";

  // Update Markov transition probability lists for each atom
  for (i=0;i<atom.size();i++) atom[i].updateMarkovPList(SAtom[i],indexAtom[i]);

  if (master()) cout<<"Cell::updateMarkovPListSplit: index: "<<index()<<", Calculate cell Markov S Matrix\n";

  // Calculate Markov S matrix for cell - New!
  SCell=markovSCell(SAtom,indexCell,indexAtom);
  
  if (master()) cout<<"Cell::updateMarkovPListSplit: index: "<<index()<<", Update thermal pool Markov probability lists\n";
  
  // Update thermal pool Markov transition probability list - Changed!
  updateMarkovPListTherm(SCell,SAtom,indexCell,indexAtom);
  
  if (master() and boundFree and chargeTransfer) cout<<"Cell::updateMarkovPListSplit: index: "<<index()<<", Update charge-transfer Markov probability lists\n";

  // Update charge-transfer Markov transition probability list - New!
  if (boundFree and chargeTransfer) updateMarkovPListCT(SCell,SAtom,indexCell,indexAtom);

  // Estimate allocated memory
  markovPMemSize=0,transPMemSize=0; // New!
  for (i=0;i<atom.size();i++) // Changed!
    for (j=0;j<atom[i].iState.size();j++) 
      for (k=0;k<atom[i].iState[j].bState.size();k++) {
	markovPMemSize+=atom[i].iState[j].bState[k].markovPList.size()*sizeof(MarkovP);
	transPMemSize+=atom[i].iState[j].bState[k].transPList.size()*sizeof(TransP);
      }
  markovPMemSize+=markovPListTherm.size()*sizeof(MarkovP);

  //if (master()) cout<<"Cell::updateMarkovPListSplit: index: "<<index()<<", "<<markovPMemSize/1024<<" kb (M) + "<<transPMemSize/1024<<" kb (T) = "<<(markovPMemSize+transPMemSize)/1024<<" kb allocated for Markov probability lists\n";

  if (master()) cout<<"Cell::updateMarkovPListSplit: index: "<<index()<<", Finished\n";
}

// Update thermal pool Markov transition probability list
// Subcells: Works
// Containers: Not applicable
void Cell::updateMarkovPListTherm(const vector<vector<double> >& SCell, const vector<vector<vector<double> > >& SAtom, const vector<vector<vector<int> > >& indexCell, const vector<vector<vector<int> > >& indexAtom) { // Changed!
  MarkovP markovP;
  MarkovPList markovPList;
  vector<double> PR;
  vector<double> STherm;
  BState* bState;
  //vector<vector<vector<int> > > indexCell; Removed!!
  double P,PTot,totalCooling=0;
  int i,j,k,l,n,m,nStates=0;
  bool boundFree,coll,nonThermal,twoPhoton,chargeTransfer; // Changed!
  bool chargeTransferEmit=config->chargeTransferEmit; // New!
  float PFloor=numeric_limits<float>::min(); // New! - Testing!
  bool useLTEGroup=config->LTEGroupMacro; // New!
  bool sumLTEGroup=useLTEGroup; // New!

  // Get total number of states - New! - Removed
  /*nStates=0;
  for (i=0;i<indexCell.size();i++)
  for (j=0;j<indexCell[i].size();j++) nStates+=indexCell[i][j].size();*/

  // Get total number of states - New!
  countBMatrixIndex(nStates);

  // Initialize (radiative) de-activation probability
  PR.resize(nStates+1,0.0);

  // Get total cooling
  totalCooling=collCooling(); // config->collMacro should be true
  if (config->freeFreeMacro) totalCooling+=freeFreeCooling();
  if (config->boundFreeMacro) totalCooling+=boundFreeCoolingSP();
  if (config->chargeTransferMacro) totalCooling+=CTCooling(); // New!

  // Get thermal pool Markov S matrix - Changed!
  STherm=markovSTherm(SCell,SAtom,indexCell,indexAtom);

  // Calculate the (radiative) de-activation probability from the thermal pool
  PR[nStates]=1-collCooling()/totalCooling; // config->collMarco should be true
  if (config->chargeTransferMacro) PR[nStates]-=CTCooling()/totalCooling; // New!

  // For each atom
  for (i=0; i<atom.size(); i++) {

    // Get processes flags
    boundFree=config->boundFreeMacro;
    coll=config->collMacro;
    nonThermal=config->nonThermalMacro;
    twoPhoton=config->twoPhotonMacro; // New!
    chargeTransfer=config->chargeTransferMacro; // New!

    // For each ionization state
    for (j=0; j<atom[i].iState.size(); j++) {
      // For each bound state
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {
	
	// Set bound state pointer
	bState=&(atom[i].iState[j].bState[k]);
		
	// For each downward bound-bound transition
	for (l=0; l<bState->downTransBB.size(); l++)
	  // Sum (radiative) deactivation probability
	  PR[indexCell[i][j][k]]+=(bState->downTransBB[l]->RD(twoPhoton)*bState->downTransBB[l]->Xi())/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	
	// If bound-free processes included
	if (boundFree) {
	  
	  // For each downward bound-free transition
	  for (l=0; l<bState->downTransBF.size(); l++) {
	    // Sum (radiative) deacivation probability
	    PR[indexCell[i][j][k]]+=(bState->downTransBF[l]->RD()*bState->downTransBF[l]->Xi())/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	    PR[indexCell[i][j][k]]+=(bState->downTransBF[l]->RDAdd()*bState->downTransBF[l]->Xi())/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // New!
	  }
	}
      }
    }
  }
   
  // Initialize Markov transition probability list
  markovPList.resize(0);
  markovPListTherm.resize(0);

  // For each atom
  for (i=0; i<atom.size(); i++) {
    // For each ionization state
    for (j=0; j<atom[i].iState.size(); j++) {
      // For each bound state
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {

	// If use LTE group and not master state - Skip and continue - New!
	if (useLTEGroup and atom[i].iState[j].bState[k].LTERefState!=NULL) continue;
		
	// Initialize Markov transition probability
	markovP.nextState=&(atom[i].iState[j].bState[k]);
	// Note: This may not work for LTE groups!
	if (atom[i].iState[j].bState[k].downTransBB.size()==0 and atom[i].iState[j].bState[k].downTransBF.size()==0) markovP.P=0.0;
	else markovP.P=STherm[indexCell[i][j][k]]*PR[indexCell[i][j][k]];
	
	// Add Markov transition probability list
	markovPList.push_back(markovP);
      }
    }
  }

  // Initialize Markov probability for a transition into the thermal pool
  markovP.nextState=NULL;
  markovP.P=STherm[nStates]*PR[nStates];
  
  // Add Markov transition probability list
  markovPList.push_back(markovP);

  // Set Markov transition probability floor to avoid division by zero in the normalization
  for (i=0; i<markovPList.size(); i++) markovPList[i].P=MAX(markovPList[i].P,PFloor); // New! - Testing!
  
  // Normalize Markov transition probability list
  PTot=0; for (i=0; i<markovPList.size(); i++) PTot+=markovPList[i].P; // Changed!
  for (i=0; i<markovPList.size(); i++) markovPList[i].P=markovPList[i].P/PTot;

  // If not boost mode - New!
  if (not config->boost) {

    // Sort out Markov transitions above limit
    for (i=0; i<markovPList.size(); i++) 
      if (markovPList[i].P>config->markovTableThermLim) markovPListTherm.push_back(markovPList[i]);
    
    // Renormalize Markov transition probability list
    PTot=0; for (i=0; i<markovPListTherm.size(); i++) PTot+=markovPListTherm[i].P; // Changed!
    for (i=0; i<markovPListTherm.size(); i++)  markovPListTherm[i].P=markovPListTherm[i].P/PTot;
    if (master() and PTot<0.99) cout<<"Cell::updateMarkovPListTherm: index: "<<index()<<", Warning: Total probability of transitions sorted out: "<<(1.0-PTot)<<", "<<markovPListTherm.size()<<" out of "<<markovPList.size()<<" transitions kept\n";;
  }
  // Else - Copy Markov transition probability list
  else markovPListTherm=markovPList;

  // Sort markov transition probability list in descending probability
  markovPListTherm.sort();
}

// Update charge-transfer Markov transition probability list - New!
// Subcells: Works
// Containers: Not applicable
void Cell::updateMarkovPListCT(const vector<vector<double> >& SCell, const vector<vector<vector<double> > >& SAtom, const vector<vector<vector<int> > >& indexCell, const vector<vector<vector<int> > >& indexAtom) {
  MarkovP markovP;
  MarkovPList markovPList;
  vector<double> PR;
  vector<vector<double> > SCT;
  BState* bState;
  double P,PTot,totalCooling=0;
  int i,j,k,l,n,nStates=0;
  bool freeFree=config->freeFreeMacro;
  bool boundFree=config->boundFreeMacro;
  bool coll=config->collMacro;
  bool nonThermal=config->nonThermalMacro;
  bool twoPhoton=config->twoPhotonMacro;
  bool chargeTransfer=config->chargeTransferMacro;
  float PFloor=numeric_limits<float>::min(); // New! - Testing!
  bool useLTEGroup=config->LTEGroupMacro; // New!
  bool sumLTEGroup=useLTEGroup; // New!

  // Get total number of states
  /*nStates=0;
  for (i=0;i<indexCell.size();i++)
  for (j=0;j<indexCell[i].size();j++) nStates+=indexCell[i][j].size();*/

  // Get total number of states - New!
  countBMatrixIndex(nStates);

  // Initialize (radiative) de-activation probability
  PR.resize(nStates+1,0.0);

  // Get total cooling
  totalCooling=collCooling(); // config->collMacro should be true
  if (freeFree) totalCooling+=freeFreeCooling();
  totalCooling+=boundFreeCoolingSP(); // config->boundFreeMacro should be true
  totalCooling+=CTCooling(); // config->chargeTransfer should be true

  // Get charge transfer Markov S matrix
  SCT=markovSCT(SCell,SAtom,indexCell,indexAtom);

  // Calculate the (radiative) de-activation probability from the thermal pool
  PR[nStates]=1-(collCooling()+CTCooling())/totalCooling; // config->collMarco and config->chargeTransfer should be true

  // For each atom
  for (i=0; i<atom.size(); i++) {
    
    // For each ionization state
    for (j=0; j<atom[i].iState.size(); j++) {
      // For each bound state
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {
	
	// Set bound state pointer
	bState=&(atom[i].iState[j].bState[k]);
		
	// For each downward bound-bound transition
	for (l=0; l<bState->downTransBB.size(); l++)
	  // Sum (radiative) deactivation probability
	  PR[indexCell[i][j][k]]+=(bState->downTransBB[l]->RD(twoPhoton)*bState->downTransBB[l]->Xi())/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
		  
	// For each downward bound-free transition - config->boundFreeMacro should be true
	for (l=0; l<bState->downTransBF.size(); l++) {
	  // Sum (radiative) deacivation probability
	  PR[indexCell[i][j][k]]+=(bState->downTransBF[l]->RD()*bState->downTransBF[l]->Xi())/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	  PR[indexCell[i][j][k]]+=(bState->downTransBF[l]->RDAdd()*bState->downTransBF[l]->Xi())/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	}
      }
    }
  }

  // Initialize Markov transition probability list
  markovPListCT.resize(2*ctReaction.size());

  // For each (forward and backward) charge-transfer reaction
  for (n=0; n<2*ctReaction.size(); n++) {
   
    // Initialize Markov transition probability list
    markovPList.resize(0);
    markovPListCT[n].resize(0);

    // For each atom
    for (i=0; i<atom.size(); i++) {
      // For each ionization state
      for (j=0; j<atom[i].iState.size(); j++) {
	// For each bound state
	for (k=0; k<atom[i].iState[j].bState.size(); k++) {

	  // If use LTE group and not master state - Skip and continue - New!
	  if (useLTEGroup and atom[i].iState[j].bState[k].LTERefState!=NULL) continue;
	  
	  // Initialize Markov transition probability
	  markovP.nextState=&(atom[i].iState[j].bState[k]);
	  if (atom[i].iState[j].bState[k].downTransBB.size()==0 and atom[i].iState[j].bState[k].downTransBF.size()==0) markovP.P=0.0;
	  else markovP.P=SCT[n][indexCell[i][j][k]]*PR[indexCell[i][j][k]];
	  
	  // Add Markov transition probability list
	  markovPList.push_back(markovP);
	}
      }
    }

    // Initialize Markov probability for a transition into the thermal pool
    markovP.nextState=NULL;
    markovP.P=SCT[n][nStates]*PR[nStates];
  
    // Add Markov transition probability list
    markovPList.push_back(markovP);

    // Set Markov transition probability floor to avoid division by zero in the normalization
    for (i=0; i<markovPList.size(); i++) markovPList[i].P=MAX(markovPList[i].P,PFloor); // New! - Testing!
  
    // Normalize Markov transition probability list
    PTot=0; for (i=0; i<markovPList.size(); i++) PTot+=markovPList[i].P;
    for (i=0; i<markovPList.size(); i++) markovPList[i].P=markovPList[i].P/PTot;

    // If not boost mode - New!
    if (not config->boost) {

      // Sort out Markov transitions above limit
      for (i=0; i<markovPList.size(); i++) 
	if (markovPList[i].P>config->markovTableCTLim) markovPListCT[n].push_back(markovPList[i]);
    
      // Renormalize Markov transition probability list
      PTot=0; for (i=0; i<markovPListCT[n].size(); i++) PTot+=markovPListCT[n][i].P;
      for (i=0; i<markovPListCT[n].size(); i++)  markovPListCT[n][i].P=markovPListCT[n][i].P/PTot;
      if (master() and PTot<0.99) cout<<"Cell::updateMarkovPListCT: index: "<<index()<<", CTIndex: "<<n<<", Warning: Total probability of transitions sorted out: "<<(1.0-PTot)<<", "<<markovPListCT[n].size()<<" out of "<<markovPList.size()<<" transitions kept\n";;
    }
    // Else - Copy Markov transition probability list
    else markovPListCT[n]=markovPList;
    
    // Sort markov transition probability list in descending probability
    markovPListCT[n].sort();
  }
}

// Update Markov transition probability list
// Subcells: Works
// Containers: Not applicable
void Cell::updateMarkovPList() {
  TransP transP;
  MarkovP markovP;
  MarkovPList markovPList;
  Mat_DP PT,SInv,S;
  Vec_DP SCol,RTot;
  Vec_INT index;
  DP d;
  BState* bState;
  BState* bStateMaster;
  CTReaction* cTReaction; // New!
  vector<vector<vector<int> > > matrixIndex;
  double P,PTot,PCT,totalCooling=0; // Changed!
  int i,j,k,l,n,m,ii,jj,kk,nStates=0; // Changed!
  bool boundFree,coll,nonThermal,twoPhoton,chargeTransfer; // Changed!
  bool chargeTransferEmit=config->chargeTransferEmit; // New!
  TransBF* upTransBF; // New!
  float PFloor=numeric_limits<float>::min(); // New! - Testing!
  bool useLTEGroup=config->LTEGroupMacro; // New!
  bool sumLTEGroup=useLTEGroup; // New!

  // Count total number of states and setup matrix index mapping - Removed!
  /*nStates=0;
  matrixIndex.resize(atom.size());
  for (i=0;i<atom.size();i++) {
    matrixIndex[i].resize(atom[i].iState.size());
    for (j=0;j<atom[i].iState.size();j++) {
      matrixIndex[i][j].resize(atom[i].iState[j].bState.size());
      for (k=0;k<atom[i].iState[j].bState.size();k++) {
	matrixIndex[i][j][k]=nStates;
	nStates++;
      }
    }
    }*/

  // Count total number of states and setup matrix index mapping  
  matrixIndex=bMatrixIndex(nStates);

  // Initialize
  PT=Mat_DP(0.0,nStates+1,nStates+1);
  SInv=Mat_DP(0.0,nStates+1,nStates+1);
  S=Mat_DP(0.0,nStates+1,nStates+1);
  index=Vec_INT(0.0,nStates+1);
  RTot=Vec_DP(0.0,nStates+1);

  // Get total cooling
  if (config->freeFreeMacro) totalCooling+=freeFreeCooling();
  if (config->boundFreeMacro) totalCooling+=boundFreeCoolingSP();
  if (config->collMacro) totalCooling+=collCooling();
  if (config->chargeTransferMacro) totalCooling+=CTCooling(); // New!

  // For each atom
  for (i=0; i<atom.size(); i++) {

    // Get processes flags
    boundFree=config->boundFreeMacro;
    coll=config->collMacro;
    nonThermal=config->nonThermalMacro;
    twoPhoton=config->twoPhotonMacro; // New!
    chargeTransfer=config->chargeTransferMacro; // New!

    // For each ionization state
    for (j=0; j<atom[i].iState.size(); j++) {
      // For each bound state
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {

	// Set bound state pointer
	bState=&(atom[i].iState[j].bState[k]);

	// For each downward bound-bound transition
	for (l=0; l<bState->downTransBB.size(); l++) {

	  // If not (use LTE group and trans is internal to the group) - New!
	  if (not (useLTEGroup and bState->downTransBB[l]->isLTEGroupInternal())) {
      
	    // Calculate the probability for an internal transition and insert in matrix
	    P=bState->downTransBB[l]->RD(twoPhoton)*bState->downTransBB[l]->lowerState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	    if (coll) P+=bState->downTransBB[l]->CD()*bState->downTransBB[l]->lowerState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	    PT[matrixIndex[i][j][k]][matrixIndex[i][j][bState->downTransBB[l]->lowerState->index]]+=P; // Changed!
	  }

	  // Calculate (and add) the probability for a collisional de-excitation
	  if (coll) P=bState->downTransBB[l]->CD()*bState->downTransBB[l]->Xi()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	  else P=0;
	  PT[matrixIndex[i][j][k]][nStates]+=P;
	}
	
	// For each upward bound-bound transition
	for (l=0; l<bState->upTransBB.size(); l++) {

	  // If not (use LTE group and trans is internal to the group) - New!
	  if (not (useLTEGroup and bState->upTransBB[l]->isLTEGroupInternal())) {
      
	    // Calculate the probability for an internal transition and insert in matrix
	    P=bState->upTransBB[l]->RU()*bState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	    if (coll) P+=bState->upTransBB[l]->CU()*bState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	    if (nonThermal) P+=bState->upTransBB[l]->CNU()*bState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	    PT[matrixIndex[i][j][k]][matrixIndex[i][j][bState->upTransBB[l]->upperState->index]]+=P; // Changed!
	  }

	  // Calculate (and add) the probability for a collisional excitation
	  if (coll) P=bState->upTransBB[l]->CU()*bState->upTransBB[l]->Xi()/totalCooling;
	  else P=0;
	  PT[nStates][matrixIndex[i][j][bState->upTransBB[l]->upperState->index]]+=P;
	}
 
	// If bound-free processes included
	if (boundFree) {

	  // For each downward bound-free transition
	  for (l=0; l<bState->downTransBF.size(); l++) {

	    // If not (use LTE group and trans is internal to the group) - New!
	    if (not (useLTEGroup and bState->downTransBF[l]->isLTEGroupInternal())) {

	      // Calculate the probability for an internal transition and insert in matrix
	      P=bState->downTransBF[l]->RD()*bState->downTransBF[l]->lowerState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	      P+=bState->downTransBF[l]->RDAdd()*bState->downTransBF[l]->lowerState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // New!
	      if (coll) P+=bState->downTransBF[l]->CD()*bState->downTransBF[l]->lowerState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	      if (chargeTransfer) P+=bState->downTransBF[l]->CTD()*bState->downTransBF[l]->lowerState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // New!
	      PT[matrixIndex[i][j][k]][matrixIndex[i][j-1][bState->downTransBF[l]->lowerState->index]]+=P; // Changed!
	    }

	    // Calculate (and add) the probability for a collisional de-excitation
	    if (coll) P=bState->downTransBF[l]->CD()*bState->downTransBF[l]->Xi()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	    else P=0;
	    PT[matrixIndex[i][j][k]][nStates]+=P;

	    // If charge-transfer processes included - New!
	    if (chargeTransfer) {

	      // For each (downward) charge-transfer reaction
	      for (m=0; m<bState->downTransBF[l]->CTDReaction.size(); m++) {

		// Set charge-transfer reaction pointer
		cTReaction=bState->downTransBF[l]->CTDReaction[m];
		// Get atom, ionization and bound state indecis for the entry state
		ii=cTReaction->upTrans->upperState->iState()->atom()->index();
		jj=cTReaction->upTrans->upperState->iState()->index();
		kk=cTReaction->upTrans->upperState->index;

		// Calculate the probability for charge-transfer de-activation
		PCT=(cTReaction->forwardRate()*bState->downTransBF[l]->Xi())/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
		// Calculate (and add) the probability for charge-transfer re-activation
		PT[matrixIndex[i][j][k]][matrixIndex[ii][jj][kk]]+=(1-cTReaction->PHeating(ctForward))*PCT;
		// Calculate (and add) the probability for charge-transfer heating
		PT[matrixIndex[i][j][k]][nStates]+=cTReaction->PHeating(ctForward)*PCT;
	      }

	      // For each (upward) charge-transfer reaction
	      for (m=0; m<bState->downTransBF[l]->CTUReaction.size(); m++) {

		// Set charge-transfer reaction pointer
		cTReaction=bState->downTransBF[l]->CTUReaction[m];
		// Get atom, ionization and bound state indecis for the entry state
		ii=cTReaction->downTrans->upperState->iState()->atom()->index();
		jj=cTReaction->downTrans->upperState->iState()->index();
		kk=cTReaction->downTrans->upperState->index;

		// Calculate the probability for charge-transfer de-activation
		PCT=(cTReaction->backwardRate()*bState->downTransBF[l]->Xi())/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
		// Calculate (and add) the probability for charge-transfer re-activation
		PT[matrixIndex[i][j][k]][matrixIndex[ii][jj][kk]]+=(1-cTReaction->PHeating(ctBackward))*PCT;
		// Calculate (and add) the probability for charge-transfer heating
		PT[matrixIndex[i][j][k]][nStates]+=cTReaction->PHeating(ctBackward)*PCT;
	      }
	    }
	  }

	  // For each upward bound-free transition
	  for (l=0; l<bState->upTransBF.size(); l++) {

	    // If not (use LTE group and trans is internal to the group) - New!
	    if (not (useLTEGroup and bState->upTransBF[l]->isLTEGroupInternal())) {
	    
	      // Calculate the probability for an internal transition
	      P=bState->upTransBF[l]->RU()*bState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	      if (coll) P+=bState->upTransBF[l]->CU()*bState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	      if (nonThermal) P+=bState->upTransBF[l]->CNU()*bState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	      if (chargeTransfer) P+=bState->upTransBF[l]->CTU()*bState->Etot()/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // New!
	      PT[matrixIndex[i][j][k]][matrixIndex[i][j+1][bState->upTransBF[l]->upperState->index]]+=P; // Changed!
	    }

	    // Calculate (and add) the probability for a collisional excitation
	    if (coll) P=bState->upTransBF[l]->CU()*bState->upTransBF[l]->Xi()/totalCooling;
	    else P=0;
	    PT[nStates][matrixIndex[i][j+1][bState->upTransBF[l]->upperState->index]]+=P;

	    // If charge-transfer processes included - New!
	    if (chargeTransfer) {

	      // For each (upward) charge-transfer reaction
	      for (m=0; m<bState->upTransBF[l]->CTUReaction.size(); m++) {

		// Calculate (and add) the probability for a charge-transfer cooling
		P=bState->upTransBF[l]->CTUReaction[m]->forwardCooling()/totalCooling;
		PT[nStates][matrixIndex[i][j+1][bState->upTransBF[l]->upperState->index]]+=P;
	      }

	      // For each (downward) charge-transfer reaction
	      for (m=0; m<bState->downTransBF[l]->CTDReaction.size(); m++) {

		// Calculate (and add) the probability for a charge-transfer cooling
		P=bState->upTransBF[l]->CTDReaction[m]->backwardCooling()/totalCooling;
		PT[nStates][matrixIndex[i][j+1][bState->upTransBF[l]->upperState->index]]+=P;		
	      }
	    }
	  }
	}
      }
    }
  }

  // Calculate S^-1=(I-PT)
  for (i=0; i<nStates+1; i++) {
    for (j=0; j<nStates+1; j++) {
      if (i==j) SInv[i][j]=1-PT[i][j];
      else SInv[i][j]=0-PT[i][j];
    }
  }

  // Compose error info string - New!
  stringstream errorInfo;  errorInfo.str(""); errorInfo<<"Cell::updateMarkovPList: index: "<<pIndex<<"ludcmp Error\n";

  // LU decompose S^-1
  ludcmp(SInv,index,d,errorInfo.str()); // Changed!

  // Calculate each column of S by back-substitution
  for (i=0; i<nStates+1; i++) {
    SCol=Vec_DP(0.0,nStates+1);
    SCol[i]=1;
    lubksb(SInv,index,SCol);
    for (j=0; j<nStates+1; j++) S[j][i]=SCol[j];
  }

  // Initialize transtion probability lists - Moved!
  for (i=0; i<atom.size(); i++)
    for (j=0; j<atom[i].iState.size(); j++)
       for (k=0; k<atom[i].iState[j].bState.size(); k++)
	 atom[i].iState[j].bState[k].transPList.resize(0);

  // For each atom
  for (i=0; i<atom.size(); i++) {
    // For each ionization state
    for (j=0; j<atom[i].iState.size(); j++) {
      // For each bound state
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {
	
	// Set bound state pointer
	bState=&(atom[i].iState[j].bState[k]);

	// Set master bound state (which differs in the case of LTE groups)
	if (useLTEGroup and bState->LTERefState!=NULL) bStateMaster=bState->LTERefState;
	else bStateMaster=bState;
	
	// Initialize transition probability list - Removed!
	//bState->transPList.resize(0);
	
	// For each downward bound-bound transition
	for (l=0; l<bState->downTransBB.size(); l++) {
	  
	  // Initialize radiative de-activation probability
	  transP.trans=bState->downTransBB[l];
	  transP.index=l; // New! - Removed!
	  transP.type=radiativeBB;
	  transP.upward=false; // New!
	  transP.P=(bState->downTransBB[l]->RD(twoPhoton)*bState->downTransBB[l]->Xi())/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	  
	  RTot[matrixIndex[i][j][k]]+=transP.P;
	  
	  // Add entry to list
	  bStateMaster->transPList.push_back(transP);
	}
	
	// If bound-free processes included
	if (boundFree) {
	  
	  // For each downward bound-free transition
	  for (l=0; l<bState->downTransBF.size(); l++) {
	    
	    // Initialize radiative de-activation probability
	    transP.trans=bState->downTransBF[l];
	    transP.index=l; // New! - Removed!
	    transP.type=radiativeBF;
	    transP.upward=false; // New!
	    transP.P=(bState->downTransBF[l]->RD()*bState->downTransBF[l]->Xi())/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // Changed!
	    transP.P+=(bState->downTransBF[l]->RDAdd()*bState->downTransBF[l]->Xi())/bState->D(boundFree,coll,nonThermal,twoPhoton,chargeTransfer,sumLTEGroup); // New!
	    
	    RTot[matrixIndex[i][j][k]]+=transP.P;
	    
	    // Add entry to list
	    bStateMaster->transPList.push_back(transP);
	  }
	}
      }
    }
  }

  // Calculate probability for a (radiative) de-activation from the thermal pool
  if (coll) RTot[nStates]=1-collCooling()/totalCooling;
  else RTot[nStates]=1;

  // For each bound state - New!
  for (i=0; i<atom.size(); i++)
    for (j=0; j<atom[i].iState.size(); j++)
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {
	// Initialize Markov probability lists
	atom[i].iState[j].bState[k].markovPList.resize(0);
	// Initialize total radiative and collisional de-activation probabilities
	atom[i].iState[j].bState[k].PRTot=0;
	atom[i].iState[j].bState[k].PCTot=0;
      }
  
  // For each atom
  for (i=0; i<atom.size(); i++) {
    // For each ionization state
    for (j=0; j<atom[i].iState.size(); j++) {
      // For each bound state
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {

	// If use LTE group and not master state - Skip and continue - New!
	if (useLTEGroup and atom[i].iState[j].bState[k].LTERefState!=NULL) continue;
	
	// Set bound state pointer
	bState=&(atom[i].iState[j].bState[k]);
	
	// Initialize Markov transition probability list
	//bState->markovPList.resize(0); // Removed!
	markovPList.resize(0);

	// For each atom
	for (l=0; l<atom.size(); l++) {
	  // For each ionization state
	  for (m=0; m<atom[l].iState.size(); m++) {
	    // For each bound state
	    for (n=0; n<atom[l].iState[m].bState.size(); n++) {

	      // If use LTE group and not master state - Skip and continue - New!
	      if (useLTEGroup and atom[l].iState[m].bState[n].LTERefState!=NULL) continue;

	      // Initialize Markov transition probability
	      markovP.nextState=&(atom[l].iState[m].bState[n]);
	      // Note: This may not work for LTE groups!
	      if (atom[l].iState[m].bState[n].downTransBB.size()==0 and atom[l].iState[m].bState[n].downTransBF.size()==0) markovP.P=0.0;
	      else markovP.P=S[matrixIndex[i][j][k]][matrixIndex[l][m][n]]*RTot[matrixIndex[l][m][n]];

	      // Add Markov transition probability list
	      markovPList.push_back(markovP);
	    }
	  }
	}

	// Initialize Markov probability for a transition into the thermal pool
	markovP.nextState=NULL;
	markovP.P=S[matrixIndex[i][j][k]][nStates]*RTot[nStates];
	  
	// Add Markov transition probability list
	markovPList.push_back(markovP);

	// Set transition probability floor to avoid division by zero in the normalization
	for (l=0; l<bState->transPList.size(); l++) bState->transPList[l].P=MAX(bState->transPList[l].P,PFloor); // New! - Testing!
	// Set Markov transition probability floor to avoid division by zero in the normalization
	for (l=0; l<markovPList.size(); l++) markovPList[l].P=MAX(markovPList[l].P,PFloor); // New! - Testing!

	// Normalize transition probability list
	PTot=0; for (l=0; l<bState->transPList.size(); l++) PTot+=bState->transPList[l].P; // Changed!
	for (l=0; l<bState->transPList.size(); l++) bState->transPList[l].P=bState->transPList[l].P/PTot;
      
	// Normalize Markov transition probability list
	PTot=0; for (l=0; l<markovPList.size(); l++) PTot+=markovPList[l].P; // Changed!
	for (l=0; l<markovPList.size(); l++) markovPList[l].P=markovPList[l].P/PTot;

	// If not boost mode - New!
	if (not config->boost){

	  // Sort out Markov transitions above limit
	  for (l=0; l<markovPList.size(); l++) 
	    if (markovPList[l].P>config->markovTableLim) bState->markovPList.push_back(markovPList[l]);
	
	  // Renormalize Markov transition probability list
	  PTot=0; for (l=0; l<bState->markovPList.size(); l++) PTot+=bState->markovPList[l].P; // Changed!
	  for (l=0; l<bState->markovPList.size(); l++)  bState->markovPList[l].P=bState->markovPList[l].P/PTot;
	  if (master() and PTot<0.99) cout<<"Cell::updateMarkovPList: index: "<<pIndex<<", Warning: Total probability of transitions sorted out: "<<(1.0-PTot)<<"\n";
	}
	// Else - Copy Markov transition probability list
	else bState->markovPList=markovPList;

	// Calculate total radiative and collisional de-activation probabilities
	//bState->PRTot=0; bState->PCTot=0; // New! - Moved!
	for (l=0; l<bState->transPList.size(); l++) // Changed!
	  if (bState->transPList[l].type==collisional) bState->PCTot+=bState->transPList[l].P;
	  else if (bState->transPList[l].type!=chargeTransferBF) bState->PRTot+=bState->transPList[l].P; // Changed!
 
	// Sort transition probability list in descending probability
	bState->transPList.sort();
      
	// Sort markov transition probability list in descending probability
	bState->markovPList.sort();      
      }
    }
  }
}

// Reset derived quantities (to be updated)
// Subcells: Works
// Containers: Works
//void Cell::reset(int dependence) {
void Cell::reset(int dependence, bool boundFreeCutOff) {
  int i;

  // Testing!
  if (master()) cout<<"Cell::reset: index: "<<index()<<"\n";

  // If container - Reset derived quantities for each subcell and return - New!
  if (type()==cellContainer) { for (i=0;i<subCell.size();i++) subCell[i]->reset(dependence,boundFreeCutOff); return; }

  for (i=0;i<atom.size();i++) atom[i].reset(dependence);
  if (dependence&(dpT|dpN|dpNe)) pFreeFreeCooling=update;
  if (dependence&(dpT|dpN|dpNe)) pBoundFreeCoolingSP=update;
  if (dependence&(dpT|dpN|dpNe)) pCollCooling=update;
  if (dependence&(dpT|dpN)) pCTCooling=update;
  if (config->boundFreeTable and dependence&(dpT|dpN|dpNe)) boundFreeTableUpdate=true;
  if (config->boundFreeSTable and dependence&(dpT|dpN|dpNe)) boundFreeSTableUpdate=true;
  if (dependence&(dpT)) bMFactorUpdate=true;
  // Is this the right place for this call?
  //if (dependence&(dpT|dpN|dpNe)) boundFreeCutOffUpdate=true;
  //if (boundFreeCutOff and dependence&(dpT|dpN|dpNe)) boundFreeCutOffUpdate=true;
  // Testing!
  if (boundFreeCutOff and dependence&dpT) boundFreeCutOffUpdate=true;
}

// Export statistics
// Deprecated!
void Cell::exportStatistics(ofstream& file, const double& tauLimit) {
  int i,j,k;
  Cell cellLTE;
  file<<"#\trho\tT\tne\tJ\n";
  file<<"\t"<<setprecision(2)<<prho;
  file<<"\t"<<setprecision(5)<<pT;
  file<<"\t"<<setprecision(2)<<pne;
  file<<"\t"<<setprecision(2)<<J;
  file<<"\n";
  file<<"# Ionization fractions\n";
  for (i=0;i<atom.size();i++) {
    file<<"#\t";
    for (j=0;j<atom[i].iState.size();j++) {
      file<<atom[i].iState[j].name();
      if (j<atom[i].iState.size()-1) file<<"\t";
      else file<<"\n";
    }
    file<<"\t";
    for (j=0;j<atom[i].iState.size();j++) {
      file<<setprecision(2)<<atom[i].iState[j].X();
      if (j<atom[i].iState.size()-1) file<<"\t";
      else file<<"\n";
    }
  }
  file<<"# Excitation fractions\n";
  for (i=0;i<atom.size();i++) {
    for (j=0;j<atom[i].iState.size();j++) {
      file<<"#\t"<<atom[i].iState[j].name()<<"\n";
      for (k=0;k<atom[i].iState[j].bState.size();k++) {
	file<<setprecision(2)<<atom[i].iState[j].bState[k].X();
	if (k<atom[i].iState[j].bState.size()-1) file<<"\t";
	else file<<"\n";
      }
    }
  }
  cellLTE=*this;
  mStateSolver->updateLTE(&cellLTE);
  cellLTE.setBackReference(grid());
  file<<"# Departure coefficients\n";
  for (i=0;i<atom.size();i++) {
    for (j=0;j<atom[i].iState.size();j++) {
      file<<"#\t"<<atom[i].iState[j].name()<<"\n";
      file<<setprecision(3)<<atom[i].iState[j].n()/cellLTE.atom[i].iState[j].n()<<"\t";
      for (k=0;k<atom[i].iState[j].bState.size();k++) {
	file<<setprecision(3)<<atom[i].iState[j].bState[k].n()/cellLTE.atom[i].iState[j].bState[k].n();
	if (k<atom[i].iState[j].bState.size()-1) file<<"\t";
	else file<<"\n";
      }
    }
  }  
  file<<"# Optically thick lines\n";
  k=0;
  for (i=0;i<line.size();i++) {
    if (lineTau(line.begin()+i)>tauLimit) {
      file<<"\t"<<line[i]->upperState->iState()->name();
      k++;
    }
  }
  if (k>0) file<<"\n";
  k=0;
  for (i=0;i<line.size();i++) {
    if (lineTau(line.begin()+i)>tauLimit) {
      file<<"\t"<<setprecision(5)<<(c/(line[i]->Xi()/h))/AA;
      k++;
    }
  }
  if (k>0) file<<"\n";
  k=0;
  for (i=0;i<line.size();i++) {
    if (lineTau(line.begin()+i)>tauLimit) {
      file<<"\t"<<setprecision(2)<<lineTau(line.begin()+i);
      k++;
    }
  }
  if (k>0) file<<"\n";
}

// Export mean intensity per wavelength
// Subcells: Works
// Containers: Not applicable
// Note: Changed to exclude edge bins! Fix for other (lambda) export functions as well?
void Cell::exportJlambda(const string& dataFile) {
  ofstream file;
  double lambda,Jlambda;
  int i;

  // Open file
  file.open(dataFile.c_str());
  if (file.fail()) {cerr<<"Cell::exportJlambda: Could not open "<<dataFile<<"\n"; return;}

  // Export mean intensity per wavelength in each frequency bin
  /*for (i=0;i<nu.size();i++) {
    if (nu[i].min!=nu[i].max) { // New!
      if (Jnu[i]>0) lambda=(c/(nuMeanNu[i]/Jnu[i]))/AA;
      else lambda=(c/((nu[i].min+nu[i].max)/2))/AA;
      Jlambda=Jnu[i]/((c/nu[i].min)/AA-(c/nu[i].max)/AA);
      file<<lambda<<" "<<Jlambda<<"\n";
    }
    }*/

  double JnuSum,nuMeanNuSum,nuMin=-1,nuMax=-1; // New!

  // Export mean intensity per wavelength in each frequency bin - Changed block!
  for (i=0;i<nu.size();i++) {
    // If edge bin
    if (nu[i].edge==true) {
      // Sum bin data
      JnuSum+=Jnu[i]; 
      nuMeanNuSum+=nuMeanNu[i];
      // Update upper frequency border
      nuMax=nu[i].max;
    }
    // Else
    else {
      // If frequency borders set
      if (nuMin!=-1 and nuMax!=-1) {
	// Export data
	if (JnuSum>0) lambda=(c/(nuMeanNuSum/JnuSum))/AA;
	else lambda=(c/((nuMin+nuMax)/2))/AA;
	Jlambda=JnuSum/((c/nuMin)/AA-(c/nuMax)/AA);
	file<<lambda<<" "<<Jlambda<<"\n";
      }
      // Get bin data
      JnuSum=Jnu[i]; 
      nuMeanNuSum=nuMeanNu[i];
      // Set frequency borders
      nuMin=nu[i].min;
      nuMax=nu[i].max;
    }
  }

  // Close file
  file.close();
}

// Export H and K per wavelength
// Subcells: Works
// Containers: Not applicable
void Cell::exportHKlambda(const string& dataFile) {
  ofstream file;
  double lambda,Hlambda,Klambda;
  int i;

  // If no data to export - Return
  if (Hnu.size()==0 or Knu.size()==0) { cout<<"Cell::exportHKlambda: Warning: No data to export\n"; return; }

  // Open file
  file.open(dataFile.c_str());
  if (file.fail()) {cerr<<"Cell::exportHKlambda: Could not open "<<dataFile<<"\n"; return;}

  // Export H and K per wavelength in each frequency bin
  for (i=0;i<nu.size();i++) {
    if (nu[i].min!=nu[i].max) { // New!
      if (Jnu[i]>0) lambda=(c/(nuMeanNu[i]/Jnu[i]))/AA;
      else lambda=(c/((nu[i].min+nu[i].max)/2))/AA;
      Hlambda=Hnu[i]/((c/nu[i].min)/AA-(c/nu[i].max)/AA);
      Klambda=Knu[i]/((c/nu[i].min)/AA-(c/nu[i].max)/AA);
      file<<lambda<<" "<<Hlambda<<" "<<Klambda<<"\n";
    }
  }

  // Close file
  file.close();
}

// Export mean intensity per frequency
// Subcells: Works
// Containers: Not applicable
void Cell::exportJnu(const string& dataFile) {
  ofstream file;
  int i;

  // Open file
  file.open(dataFile.c_str());
  if (file.fail()) {cerr<<"Cell::exportJnu: Could not open "<<dataFile<<"\n"; return;}

  // Export mean intensity per frequency in each frequency bin
  for (i=0;i<nu.size();i++) file<<nu[i].min<<" "<<nu[i].max<<" "<<Jnu[i]<<" "<<nJ[i]<<" "<<nuMeanNu[i]<<"\n";

  // Close file
  file.close();
}

// Load mean intensity per frequency
// Subcells: Works
// Containers: Not applicable
void Cell::loadJnu(const string& dataFile) {
  ifstream file;
  stringstream linestream;
  string line;
  // Hack
  double dummy;

  // Open file
  file.open(dataFile.c_str());
  if (file.fail()) {cerr<<"Cell::loadJnu: Could not open "<<dataFile<<"\n"; exit(-1);}

  // Initialize vectors
  // Hack - Assume that nu has been initiated
  //nu.resize(0);
  Jnu.resize(0);
  nJ.resize(0);
  nuMeanNu.resize(0);

  // Load mean intensity per frequency in each frequency bin
  while (not file.eof()) {
    // Get next line
    getline(file,line);
    if (file.fail())
      if (file.eof()) break; 
      else {cerr<<"Cell::loadJnu: Could not read file\n"; exit(1);}
    // Initialize linestream
    linestream.str(line);
    linestream.clear();
    // Resize vectors
    // Hack - Assume that nu has been initiated
    //nu.resize(nu.size()+1);
    Jnu.resize(Jnu.size()+1);
    nJ.resize(nJ.size()+1);
    nuMeanNu.resize(nuMeanNu.size()+1);
    // Read mean intensity per wavelength from linestream
    //linestream>>skipws>>nu[nu.size()-1].min;
    //linestream>>skipws>>nu[nu.size()-1].max;
    // Hack - Assume that nu has been initialized
    linestream>>skipws>>dummy;
    linestream>>skipws>>dummy;
    linestream>>skipws>>Jnu[Jnu.size()-1];
    linestream>>skipws>>nJ[nJ.size()-1];
    linestream>>skipws>>nuMeanNu[nuMeanNu.size()-1];
    if (linestream.fail()) {cerr<<"Cell::loadJnu: Could not read file\n"; exit(1);}
  }

  // Close file
  file.close();

  if (Jnu.size()!=nu.size()) cout<<"Cell::loadJNu: index: "<<index()<<", Warning: Length of Jnu ("<<Jnu.size()<<") and nu ("<<nu.size()<<" differs\n";

  // Mark frequency tabulators for update (as they contain frequency bin iterators)
  bBFactorUpdate=true;
  bMFactorUpdate=true;
  boundFreeSTableUpdate=true;

  // Testing!
  if (mpiCom!=NULL) cout<<"Cell::loadJnu: index: "<<index()<<", Process: "<<mpiCom->rank()<<", Jnu.size: "<<Jnu.size()<<"\n";
}

// Export intensity per frequency
// Subcells: Works
// Containers: Not applicable
void Cell::exportInu(const string& dataFile) {
  ofstream file;
  int i,j;

  // Open file
  file.open(dataFile.c_str());
  if (file.fail()) {cerr<<"Cell::exportInu: Could not open "<<dataFile<<"\n"; return;}

  // Export number of frequency and angle bins
  file<<nu.size()<<" "<<mu.size()<<"\n";

  // Export angle bins
  for (i=0;i<mu.size();i++) {
    if (i==0) file<<mu[i].min<<" "<<mu[i].max;
    else file<<mu[i].max;
    if (i<mu.size()-1) file<<" ";
    else file<<"\n";
  }

  // Export mean intensity per wavelength in each bin
  for (i=0;i<nu.size();i++) {
    file<<nu[i].min<<" "<<nu[i].max<<" ";
    for (j=0;j<mu.size();j++) {
      file<<Inu[i][j];
      if (j<mu.size()-1) file<<" ";
    }
    file<<"\n";
  }

  // Close file
  file.close();
}

// Load intensity per frequency
// Subcells: Works
// Containers: Not applicable
void Cell::loadInu(const string& dataFile) {
  ifstream file;
  stringstream linestream;
  string line;
  int i,j,nuSize,muSize;
  // Hack
  double dummy;

  // Open file
  file.open(dataFile.c_str());
  if (file.fail()) {cerr<<"Cell::loadInu: Could not open "<<dataFile<<"\n"; exit(-1);}

  // Get next line
  getline(file,line);
  if (file.fail()) {cerr<<"Cell::loadInu: Could not read file\n"; exit(1);}
  // Initialize linestream
  linestream.str(line); linestream.clear();
  // Read number of frequency bins
  linestream>>skipws>>nuSize;
  // Read number of angle bin
  linestream>>skipws>>muSize;

  // Initialize vectors
  if (nuSize!=nu.size()) {cerr<<"Cell::loadInu: Wrong number of frequency bins\n"; exit(1);}
  mu.resize(muSize);
  Inu.resize(nuSize);
  for (i=0;i<nu.size();i++) Inu[i].resize(muSize);

  // Get next line
  getline(file,line);
  if (file.fail()) {cerr<<"Cell::loadInu: Could not read file\n"; exit(1);}
  // Initialize linestream
  linestream.str(line); linestream.clear();
  // Read each angle bin
  for (i=0;i<mu.size();i++) {
    if (i==0) { linestream>>skipws>>mu[i].min; linestream>>skipws>>mu[i].max; }
    else { linestream>>skipws>>mu[i].max; mu[i].min=mu[i-1].max; }
  }
    
  // For each frequency bin
  for (i=0;i<nu.size();i++) {
    // Get next line
    getline(file,line);
    if (file.fail()) {cerr<<"Cell::loadInu: Could not read file\n"; exit(1);}
    // Initialize linestream
    linestream.str(line); linestream.clear();
    // Read frequency bin from linestream
    //linestream>>skipws>>nu[i].min;
    //linestream>>skipws>>nu[i].max;
    // Hack - Assume that nu has been initialized
    linestream>>skipws>>dummy;
    linestream>>skipws>>dummy;
    // Read intensity for each angle bin from linestream
    for (j=0;j<mu.size();j++) linestream>>skipws>>Inu[i][j];
    if (linestream.fail()) {cerr<<"Cell::loadInu: Could not read file\n"; exit(1);}
  }

  // Close file
  file.close();
}

// Export line intensity
// Subcells: Works
// Containers: Not applicable
void Cell::exportJLine(const string& dataFile) {
  ofstream file;
  int i;

  // Open file
  file.open(dataFile.c_str());
  if (file.fail()) {cerr<<"Cell::exportJLine: Could not open "<<dataFile<<"\n"; return;}

  // Export line intensity in each frequency bin
  for (i=0;i<nuLine.size();i++) file<<nuLine[i].min<<" "<<nuLine[i].max<<" "<<JLine[i]<<" "<<nJLine[i]<<"\n";

  // Close file
  file.close();
}

// Load line intensity
// Subcells: Works
// Containers: Not applicable
void Cell::loadJLine(const string& dataFile) {
  ifstream file;
  stringstream linestream;
  string line;

  // Open file
  file.open(dataFile.c_str());
  if (file.fail()) {cerr<<"Cell::loadJLine: Could not open "<<dataFile<<"\n"; exit(-1);}

  // Initialize vectors
  nuLine.resize(0);
  JLine.resize(0);
  nJLine.resize(0);

  // Load line intensity in each frequency bin
  while (not file.eof()) {
    // Get next line
    getline(file,line);
    if (file.fail())
      if (file.eof()) break;
      else {cerr<<"Cell::loadJLine: Could not read file\n"; exit(1);}
    // Initialize linestream
    linestream.str(line);
    linestream.clear();
    // Resize vectors
    nuLine.resize(nuLine.size()+1);
    JLine.resize(JLine.size()+1);
    nJLine.resize(nJLine.size()+1);
    // Read mean intensity per wavelength from linestream
    linestream>>skipws>>nuLine[nuLine.size()-1].min;
    linestream>>skipws>>nuLine[nuLine.size()-1].max;
    linestream>>skipws>>JLine[JLine.size()-1];
    linestream>>skipws>>nJLine[nJLine.size()-1];
    if (linestream.fail()) {cerr<<"Cell::loadJLine: Could not read file\n"; exit(1);}
  }

  // Close file
  file.close();
}

// Export mean emissivity per wavelength
// Subcells: Works
// Containers: Not applicable
void Cell::exportEtaLambda(const string& dataFile) {
  ofstream file;
  double lambda,etaLambda;
  int i;

  // If no data to export - Return
  if (etaNu.size()==0) { cout<<"Cell::exportEtaLambda: Warning: No data to export\n"; return; }

  // Open file
  file.open(dataFile.c_str());
  if (file.fail()) {cerr<<"Cell::exportEtaLambda: Could not open "<<dataFile<<"\n"; return;}

  // Export mean emissivity per wavelength in each frequency bin
  for (i=0;i<nu.size();i++) {
    if (nu[i].min!=nu[i].max) { // New!
      if (Jnu[i]>0) lambda=(c/(nuMeanNu[i]/Jnu[i]))/AA;
      else lambda=(c/((nu[i].min+nu[i].max)/2))/AA;
      etaLambda=etaNu[i]/((c/nu[i].min)/AA-(c/nu[i].max)/AA);
      file<<lambda<<" "<<etaLambda<<"\n";
    }
  }

  // Close file
  file.close();
}

// Export opacity (as a function of wavelength)
// Subcells: Works
// Containers: Not applicable
// Note: Use of macro-atom processes flags for export is a hack until this can be better configured
void Cell::exportKappaLambda(const string& dataFile) {
  ofstream file;
  double lambda,kappa,kappaBF,kappaFF,_nu; // Changed!
  int i;

  // Open file
  file.open(dataFile.c_str());
  if (file.fail()) {cerr<<"Cell::exportKappaLambda: Could not open "<<dataFile<<"\n"; return;}

  // Export opacity in each frequency bin
  for (i=0;i<nu.size()+1;i++) {
    if (i<nu.size()) _nu=nu[i].min;
    else _nu=nu[i-1].max;
    lambda=(c/_nu)/AA;
    // Changed!
    if (config->boundFreeMacro) kappaBF=contKappaNu(_nu,Processes(pBoundFree));
    else kappaBF=0;
    // Changed!
    if (config->freeFreeMacro) kappaFF=contKappaNu(_nu,Processes(pFreeFree));
    else kappaFF=0;
    kappa=kappaBF+kappaFF;
    file<<lambda<<" "<<kappa<<" "<<kappaBF<<" "<<kappaFF<<"\n"; // Changed!
  }

  // Close file
  file.close();
}

// Export MC-based opacity (as a function of wavelength)
// Subcells: Works
// Containers: Not applicable
void Cell::exportKappaMCLambda(const string& dataFile) {
  ofstream file;
  double lambda,kappaLambda,kappaBFLambda,kappaFFLambda,kappaBBLambda,kappaESLambda;
  int i;

  // If no data to export - Return
  if (kappaNu.size()==0) { cout<<"Cell::exportKappaMCLambda: Warning: No data to export\n"; return; }

  // Open file
  file.open(dataFile.c_str());
  if (file.fail()) {cerr<<"Cell::exportKappaMCLambda: Could not open "<<dataFile<<"\n"; return;}

  // Export MC-based opacity per wavelength in each frequency bin
  for (i=0;i<nu.size();i++) {
    if (nu[i].min!=nu[i].max) { // New!
      if (Jnu[i]>0) lambda=(c/(nuMeanNu[i]/Jnu[i]))/AA;
      else lambda=(c/((nu[i].min+nu[i].max)/2))/AA;
      kappaLambda=kappaNu[i];
      kappaBFLambda=kappaBFNu[i];
      kappaFFLambda=kappaFFNu[i];
      kappaBBLambda=kappaBBNu[i];
      kappaESLambda=kappaESNu[i];
      file<<lambda<<" "<<kappaLambda<<" "<<kappaBFLambda<<" "<<kappaFFLambda<<" "<<kappaBBLambda<<" "<<kappaESLambda<<"\n";
    }
  }

  // Close file
  file.close();
}

// Export bound-free source function (as a function of wavelength) - New!
// Subcells: Works
// Containers: Not applicable
void Cell::exportSBFLambda(const string& dataFile) {
  ofstream file;
  double lambda,SBF,_nu; // Changed!
  int i;

  // Open file
  file.open(dataFile.c_str());
  if (file.fail()) {cerr<<"Cell::exportSBFLambda: Could not open "<<dataFile<<"\n"; return;}

  // Export opacity in each frequency bin
  for (i=0;i<nu.size()+1;i++) {
    if (i<nu.size()) _nu=nu[i].min;
    else _nu=nu[i-1].max;
    lambda=(c/_nu)/AA;
    SBF=boundFreeS(_nu);
    file<<lambda<<" "<<SBF<<"\n"; // Changed!
  }

  // Close file
  file.close();
}

// Save boost factor - New!
// Subcells: Works
// Containers: Works
void Cell::saveBoost(const string& dataFile) {
  ofstream file;
  int i;

  // Open file
  file.open(dataFile.c_str());
  if (file.fail()) {cerr<<"Cell::saveBoost: Could not open "<<dataFile<<"\n"; return;}

  // Export mean intensity per frequency in each frequency bin
  for (i=0;i<nuBoost.size();i++) file<<nuBoost[i].min<<" "<<nuBoost[i].max<<" "<<boost[i]<<"\n";

  // Close file
  file.close();
}

// Load boost factor
// Subcells: Works
// Containers: Works
void Cell::loadBoost(const string& dataFile) {
  ifstream file;
  stringstream linestream;
  string line;

  // Open file
  file.open(dataFile.c_str());
  if (file.fail()) {cerr<<"Cell::loadBoost: Could not open "<<dataFile<<"\n"; exit(-1);}

  // Initialize vectors
  nuBoost.resize(0);
  boost.resize(0);

  // Load mean intensity per frequency in each frequency bin
  while (not file.eof()) {
    // Get next line
    getline(file,line);
    if (file.fail())
      if (file.eof()) break; 
      else {cerr<<"Cell::loadBoost: Could not read file\n"; exit(1);}
    // Initialize linestream
    linestream.str(line);
    linestream.clear();
    // Resize vectors
    nuBoost.resize(nuBoost.size()+1);
    boost.resize(boost.size()+1);
    // Read mean intensity per wavelength from linestream
    linestream>>skipws>>nuBoost[nuBoost.size()-1].min;
    linestream>>skipws>>nuBoost[nuBoost.size()-1].max;
    linestream>>skipws>>boost[boost.size()-1];
    if (linestream.fail()) {cerr<<"Cell::loadBoost: Could not read file\n"; exit(1);}
  }

  // Close file
  file.close();
}

// Export statistics
// Subcells: Works
// Containers: Works
// Note: Use of macro-atom processes flags for export is a hack until this can be better configured
void Cell::exportStat(YAML::Emitter& data, const double& tauLim, string prefix, bool close) {
  stringstream JlambdaFile,HKlambdaFile,etaLambdaFile,kappaLambdaFile,kappaMCLambdaFile,sBFLambdaFile; // Changed!
  int i;

  if (master()) cout<<"Cell::exportStat: Export cell "<<index()<<" statistics\n";

  // If container - Export statistics for container and subcells and return - New!
  if (type()==cellContainer) { exportStatContainer(data,tauLim,prefix,close); return; }

  // Testing!
  int allProcessesSpec=pEScatter|pBoundBound, contProcessesSpec=pEScatter;
  if (config->boundFreeMacro) { allProcessesSpec|=pBoundFree; contProcessesSpec|=pBoundFree; } // Bug fix!
  if (config->freeFreeMacro) { allProcessesSpec|=pFreeFree; contProcessesSpec|=pFreeFree; } // Bug fix!
  Processes allProcesses(allProcessesSpec), contProcesses(contProcessesSpec);

  // Create LTE cell
  Cell cellLTE=*this;
  mStateSolver->updateLTE(&cellLTE);
  cellLTE.setBackReference(grid());

  data<<YAML::BeginMap;

  // Export index
  data<<YAML::Key<<"index"<<YAML::Value<<index();

  // Export time borders
  data<<YAML::Key<<"tMin"<<YAML::Value<<tMin();
  data<<YAML::Key<<"tMax"<<YAML::Value<<tMax();

  // Export density
  data<<YAML::Key<<"rho"<<YAML::Value<<rho();

  // Export temperature
  data<<YAML::Key<<"T"<<YAML::Value<<T();

  // Export eletron density
  data<<YAML::Key<<"ne"<<YAML::Value<<ne();

  // Export eletron fraction
  data<<YAML::Key<<"xe"<<YAML::Value<<xe();

  // Export radiation temperature
  data<<YAML::Key<<"TR"<<YAML::Value<<TR();

  // Export dilution factor
  data<<YAML::Key<<"W"<<YAML::Value<<W();

  // Export free-free heating-cooling
  if (config->freeFreeMacro) {
    data<<YAML::Key<<"freeFree"<<YAML::Value<<YAML::BeginMap;
    data<<YAML::Key<<"H"<<YAML::Value<<freeFreeHeating();
    data<<YAML::Key<<"C"<<YAML::Value<<freeFreeCooling()<<YAML::EndMap;
  }

  // Export bound-free heating-cooling
  if (config->boundFreeMacro) {
    data<<YAML::Key<<"boundFree"<<YAML::Value<<YAML::BeginMap;
    data<<YAML::Key<<"H"<<YAML::Value<<boundFreeHeating();
    data<<YAML::Key<<"C"<<YAML::Value<<boundFreeCooling()<<YAML::EndMap;
  }

  // Export collisional heating-cooling
  if (config->collMacro) {
    data<<YAML::Key<<"coll"<<YAML::Value<<YAML::BeginMap;
    data<<YAML::Key<<"H"<<YAML::Value<<collHeating();
    data<<YAML::Key<<"C"<<YAML::Value<<collCooling()<<YAML::EndMap;
  }

  // Export non-thermal heating
  if (config->nonThermalMacro) {
    data<<YAML::Key<<"nonThermal"<<YAML::Value<<YAML::BeginMap;
    data<<YAML::Key<<"H"<<YAML::Value<<nonThermalHeating()<<YAML::EndMap;
  }

  // Export charge-transfer heating-cooling
  if (config->chargeTransferMacro) {
    data<<YAML::Key<<"chargeTransfer"<<YAML::Value<<YAML::BeginMap;
    data<<YAML::Key<<"H"<<YAML::Value<<CTHeating();
    data<<YAML::Key<<"C"<<YAML::Value<<CTCooling()<<YAML::EndMap;
  }

  if (master()) cout<<"Cell::exportStat: Export cell "<<index()<<" statistics, 1\n";

  // Export Rosseland mean (continuum) opacity
  //data<<YAML::Key<<"rossContKappa"<<YAML::Value<<rossContKappa(Processes(pEScatter|pBoundFree|pFreeFree));
  data<<YAML::Key<<"rossContKappa"<<YAML::Value<<rossContKappa(contProcesses);

  // Export Rosseland mean (bound-free) opacity
  if (config->boundFreeMacro) data<<YAML::Key<<"rossBFKappa"<<YAML::Value<<rossContKappa(Processes(pBoundFree));
    
  // Export Rosseland mean (free-free) opacity
  if (config->freeFreeMacro) data<<YAML::Key<<"rossFFKappa"<<YAML::Value<<rossContKappa(Processes(pFreeFree));

  if (master()) cout<<"Cell::exportStat: Export cell "<<index()<<" statistics, 2\n";
  
  // Export energy mean (continuum) opacity
  //if (radUpdated) data<<YAML::Key<<"energyContKappa"<<YAML::Value<<energyContKappa(Processes(pEScatter|pBoundFree|pFreeFree));
  if (radUpdated) data<<YAML::Key<<"energyContKappa"<<YAML::Value<<energyContKappa(contProcesses);

  if (master()) cout<<"Cell::exportStat: Export cell "<<index()<<" statistics, 3\n";

  // Export energy mean (total) opacity as estimated using MC statistics - New!
  if (radUpdated and kappaJNu.size()!=0) data<<YAML::Key<<"energyKappaMC"<<YAML::Value<<energyKappaMC(allProcesses);

  // Export energy mean (continuum) opacity as estimated using MC statistics - New!
  if (radUpdated and kappaJNu.size()!=0) data<<YAML::Key<<"energyContKappaMC"<<YAML::Value<<energyKappaMC(contProcesses);

  if (master()) cout<<"Cell::exportStat: Export cell "<<index()<<" statistics, 4\n";

  // Export flux mean (total) opacity as estimated using MC statistics - New!
  if (radUpdated and kappaHNu.size()!=0 and config->trackHK) data<<YAML::Key<<"fluxKappaMC"<<YAML::Value<<fluxKappaMC(allProcesses);

  // Export flux mean (continuum) opacity as estimated using MC statistics - New!
  if (radUpdated and kappaHNu.size()!=0 and config->trackHK) data<<YAML::Key<<"fluxContKappaMC"<<YAML::Value<<fluxKappaMC(contProcesses);

  if (master()) cout<<"Cell::exportStat: Export cell "<<index()<<" statistics, 5\n";

  // Export Rosseland mean (total) opacity as estimated using MC statistics - New!
  //if (radUpdated and kappaNu.size()!=0) data<<YAML::Key<<"rossKappaMC"<<YAML::Value<<rossKappaMC(Processes(pEScatter|pBoundFree|pFreeFree|pBoundBound));
  if (radUpdated and kappaNu.size()!=0) data<<YAML::Key<<"rossKappaMC"<<YAML::Value<<rossKappaMC(allProcesses);

  // Export Rosseland mean (continuum) opacity as estimated using MC statistics - New!
  //if (radUpdated and kappaNu.size()!=0) data<<YAML::Key<<"rossContKappaMC"<<YAML::Value<<rossKappaMC(Processes(pEScatter|pBoundFree|pFreeFree));
  if (radUpdated and kappaNu.size()!=0) data<<YAML::Key<<"rossContKappaMC"<<YAML::Value<<rossKappaMC(contProcesses);

  if (master()) cout<<"Cell::exportStat: Export cell "<<index()<<" statistics, 5\n";

  // Export Rosseland mean (total) opacity (Monte-Carlo version) - New! - Testing!
  if (config->exportKappaMC2) data<<YAML::Key<<"rossKappaMC2"<<YAML::Value<<rossKappaMC2(allProcesses,-1,-1,100000);

  // Export Rosseland mean (continuum) opacity (Monte-Carlo version) - New! - Testing!
  if (config->exportKappaMC2) data<<YAML::Key<<"rossContKappaMC2"<<YAML::Value<<rossKappaMC2(contProcesses,-1,-1,100000);

  if (master()) cout<<"Cell::exportStat: Export cell "<<index()<<" statistics, 6\n";

  // Export electrons scattering opacity
  data<<YAML::Key<<"eScatterKappa"<<YAML::Value<<electronScatterKappa();  

  // Export radioactive heating
  data<<YAML::Key<<"eRadio"<<YAML::Value<<eRadio();

  // If radiation field updated
  if (radUpdated) {

    // Export mean intensity
    data<<YAML::Key<<"J"<<YAML::Value<<J;

    // If track H and K
    if (config->trackHK) {

      // Export H
      data<<YAML::Key<<"H"<<YAML::Value<<H;

      // Export K
      data<<YAML::Key<<"K"<<YAML::Value<<K;

      // Construct H and K per wavelength file name
      HKlambdaFile<<prefix<<"-HK-"<<index()<<".dat";

      // Export H and K per wavelength file name
      data<<YAML::Key<<"HKlambda"<<YAML::Value<<HKlambdaFile.str();

      // Export H and K per wavelength to file
      exportHKlambda(HKlambdaFile.str());
    }
    
    // Construct mean intensity per wavelength file name
    JlambdaFile<<prefix<<"-spec-"<<index()<<".dat";

    // Export mean intensity per wavelength file name
    data<<YAML::Key<<"Jlambda"<<YAML::Value<<JlambdaFile.str();

    // Export mean intensity per wavelength to file
    exportJlambda(JlambdaFile.str());

    // If export emissivity
    if (config->exportEta) {

      // Construct mean emissivity per wavelength file name
      etaLambdaFile<<prefix<<"-eta-"<<index()<<".dat";

      // Export mean emissivity per wavelength file name
      data<<YAML::Key<<"etaLambda"<<YAML::Value<<etaLambdaFile.str();

      // Export mean emissivity per wavelength to file
      exportEtaLambda(etaLambdaFile.str());
    }

    // Construct MC-based opacity (as a function of wavelength) file name - New!
    kappaMCLambdaFile<<prefix<<"-kappa-MC-"<<index()<<".dat";
    
    // Export MC-based opacity (as a function of wavelength) file name - New!
    data<<YAML::Key<<"kappaMCLambda"<<YAML::Value<<kappaMCLambdaFile.str();
        
    // Export MC-based opacity (as a function of wavelength) to file - New!
    exportKappaMCLambda(kappaMCLambdaFile.str());
  }
  // Else (i.e. radiation field not updated)
  else {
    // Export mean intensity as estimated from DBB field
    data<<YAML::Key<<"J"<<YAML::Value<<W()*sigma*pow(TR(),4)/pi;
  }

  // Construct opacity (as a function of wavelength) file name
  kappaLambdaFile<<prefix<<"-kappa-"<<index()<<".dat";

  // Export opacity (as a function of wavelength) file name
  data<<YAML::Key<<"kappaLambda"<<YAML::Value<<kappaLambdaFile.str();

  // Export opacity (as a function of wavelength) to file
  exportKappaLambda(kappaLambdaFile.str());

  // If export bound-free source-function - New!
  if (config->exportSBF) {
    
    // Construct bound-free source-function (as a function of wavelength) file name - New!
    sBFLambdaFile<<prefix<<"-SBF-"<<index()<<".dat";

    // Export bound-free source-function (as a function of wavelength) file name - New!
    data<<YAML::Key<<"SBFLambda"<<YAML::Value<<sBFLambdaFile.str();

    // Export bound-free source-function (as a function of wavelength) to file - New!
    exportSBFLambda(sBFLambdaFile.str());
  }

  if (master()) cout<<"Cell::exportStat: Export cell "<<index()<<" statistics, 7\n";

  // Export data for each atom
  data<<YAML::Key<<"atom"<<YAML::Value<<YAML::BeginSeq;
  for (i=0;i<atom.size();i++) atom[i].exportStat(data,cellLTE.atom[i],tauLim);
  data<<YAML::EndSeq;

  if (master()) cout<<"Cell::exportStat: Export cell "<<index()<<" statistics, 8\n";

  // Close map if requested
  if (close) data<<YAML::EndMap;
}

// Export statistics for container - New!
// Subcells: Not applicable
// Containers: Works
// Note: Use of macro-atom processes flags for export is a hack until this can be better configured
void Cell::exportStatContainer(YAML::Emitter& data, const double& tauLim, string prefix, bool close) {
  stringstream JlambdaFile,HKlambdaFile,cellPrefix;
  int i;

  if (master()) cout<<"Cell::exportStat: Export cell "<<index()<<" statistics\n";

  // Testing!
  int allProcessesSpec=pEScatter|pBoundBound, contProcessesSpec=pEScatter;
  if (config->boundFreeMacro) { allProcessesSpec|=pBoundFree; contProcessesSpec|=pBoundFree; } // Bug fix!
  if (config->freeFreeMacro) { allProcessesSpec|=pFreeFree; contProcessesSpec|=pFreeFree; } // Bug fix!
  Processes allProcesses(allProcessesSpec), contProcesses(contProcessesSpec);

  data<<YAML::BeginMap;

  // Export index
  data<<YAML::Key<<"index"<<YAML::Value<<index();

  // Export time borders
  data<<YAML::Key<<"tMin"<<YAML::Value<<tMin();
  data<<YAML::Key<<"tMax"<<YAML::Value<<tMax();

  // Export density
  data<<YAML::Key<<"rho"<<YAML::Value<<rho();

  // Export temperature
  // Does not work with subcells
  data<<YAML::Key<<"T"<<YAML::Value<<T();

  // Export eletron density
  data<<YAML::Key<<"ne"<<YAML::Value<<ne();

  // Export eletron fraction
  data<<YAML::Key<<"xe"<<YAML::Value<<xe();

  // Export radiation temperature
  data<<YAML::Key<<"TR"<<YAML::Value<<TR();

  // Export dilution factor
  data<<YAML::Key<<"W"<<YAML::Value<<W();

  // Export free-free heating-cooling
  if (config->freeFreeMacro) {
    data<<YAML::Key<<"freeFree"<<YAML::Value<<YAML::BeginMap;
    data<<YAML::Key<<"H"<<YAML::Value<<freeFreeHeating();
    data<<YAML::Key<<"C"<<YAML::Value<<freeFreeCooling()<<YAML::EndMap;
  }

  // Export bound-free heating-cooling
  if (config->boundFreeMacro) {
    data<<YAML::Key<<"boundFree"<<YAML::Value<<YAML::BeginMap;
    data<<YAML::Key<<"H"<<YAML::Value<<boundFreeHeating();
    data<<YAML::Key<<"C"<<YAML::Value<<boundFreeCooling()<<YAML::EndMap;
  }

  // Export collisional heating-cooling
  if (config->collMacro) {
    data<<YAML::Key<<"coll"<<YAML::Value<<YAML::BeginMap;
    data<<YAML::Key<<"H"<<YAML::Value<<collHeating();
    data<<YAML::Key<<"C"<<YAML::Value<<collCooling()<<YAML::EndMap;
  }

  // Export non-thermal heating
  if (config->nonThermalMacro) {
    data<<YAML::Key<<"nonThermal"<<YAML::Value<<YAML::BeginMap;
    data<<YAML::Key<<"H"<<YAML::Value<<nonThermalHeating()<<YAML::EndMap;
  }

  // Export charge-transfer heating-cooling
  if (config->chargeTransferMacro) {
    data<<YAML::Key<<"chargeTransfer"<<YAML::Value<<YAML::BeginMap;
    data<<YAML::Key<<"H"<<YAML::Value<<CTHeating();
    data<<YAML::Key<<"C"<<YAML::Value<<CTCooling()<<YAML::EndMap;
  }

  // Export Rosseland mean (continuum) opacity
  //data<<YAML::Key<<"rossContKappa"<<YAML::Value<<rossContKappa(Processes(pEScatter|pBoundFree|pFreeFree));
  data<<YAML::Key<<"rossContKappa"<<YAML::Value<<rossContKappa(contProcesses);

  // Export Rosseland mean (bound-free) opacity
  if (config->boundFreeMacro) data<<YAML::Key<<"rossBFKappa"<<YAML::Value<<rossContKappa(Processes(pBoundFree));

  // Export Rosseland mean (free-free) opacity
  if (config->freeFreeMacro) data<<YAML::Key<<"rossFFKappa"<<YAML::Value<<rossContKappa(Processes(pFreeFree));
  
  // Export energy mean (continuum) opacity
  //if (radUpdated) data<<YAML::Key<<"energyContKappa"<<YAML::Value<<energyContKappa(Processes(pEScatter|pBoundFree|pFreeFree));
  if (radUpdated) data<<YAML::Key<<"energyContKappa"<<YAML::Value<<energyContKappa(contProcesses);

  // Export energy mean (total) opacity as estimated using MC statistics
  if (radUpdated and kappaJNu.size()!=0) data<<YAML::Key<<"energyKappaMC"<<YAML::Value<<energyKappaMC(allProcesses);

  // Export energy mean (continuum) opacity as estimated using MC statistics
  if (radUpdated and kappaJNu.size()!=0) data<<YAML::Key<<"energyContKappaMC"<<YAML::Value<<energyKappaMC(contProcesses);

  // Export flux mean (total) opacity as estimated using MC statistics
  if (radUpdated and kappaHNu.size()!=0 and config->trackHK) data<<YAML::Key<<"fluxKappaMC"<<YAML::Value<<fluxKappaMC(allProcesses);

  // Export flux mean (continuum) opacity as estimated using MC statistics
  if (radUpdated and kappaHNu.size()!=0 and config->trackHK) data<<YAML::Key<<"fluxContKappaMC"<<YAML::Value<<fluxKappaMC(contProcesses);

  // Export Rosseland mean (total) opacity as estimated using MC statistics - New!
  //if (radUpdated and kappaNu.size()!=0) data<<YAML::Key<<"rossKappaMC"<<YAML::Value<<rossKappaMC(Processes(pEScatter|pBoundFree|pFreeFree|pBoundBound));
  if (radUpdated and kappaNu.size()!=0) data<<YAML::Key<<"rossKappaMC"<<YAML::Value<<rossKappaMC(allProcesses);

  // Export Rosseland mean (continuum) opacity as estimated using MC statistics - New!
  //if (radUpdated and kappaNu.size()!=0) data<<YAML::Key<<"rossContKappaMC"<<YAML::Value<<rossKappaMC(Processes(pEScatter|pBoundFree|pFreeFree));
  if (radUpdated and kappaNu.size()!=0) data<<YAML::Key<<"rossContKappaMC"<<YAML::Value<<rossKappaMC(contProcesses);

  // Export Rosseland mean (total) opacity (Monte-Carlo version) - New! - Testing!
  if (config->exportKappaMC2) data<<YAML::Key<<"rossKappaMC2"<<YAML::Value<<rossKappaMC2(allProcesses,-1,-1,100000);

  // Export Rosseland mean (continuum) opacity (Monte-Carlo version) - New! - Testing!
  if (config->exportKappaMC2) data<<YAML::Key<<"rossContKappaMC2"<<YAML::Value<<rossKappaMC2(contProcesses,-1,-1,100000);

  // Export electrons scattering opacity
  data<<YAML::Key<<"eScatterKappa"<<YAML::Value<<electronScatterKappa();  

  // Export radioactive heating
  data<<YAML::Key<<"eRadio"<<YAML::Value<<eRadio();

  // If radiation field updated
  if (radUpdated) {

    // Export mean intensity
    data<<YAML::Key<<"J"<<YAML::Value<<J;

    // If track H and K
    if (config->trackHK) {

      // Export H
      data<<YAML::Key<<"H"<<YAML::Value<<H;

      // Export K
      data<<YAML::Key<<"K"<<YAML::Value<<K;

      // Construct H and K per wavelength file name
      HKlambdaFile<<prefix<<"-HK-"<<index()<<".dat";

      // Export H and K per wavelength file name
      data<<YAML::Key<<"HKlambda"<<YAML::Value<<HKlambdaFile.str();

      // Export H and K per wavelength to file
      exportHKlambda(HKlambdaFile.str());
    }
    
    // Construct mean intensity per wavelength file name
    JlambdaFile<<prefix<<"-spec-"<<index()<<".dat";

    // Export mean intensity per wavelength file name
    data<<YAML::Key<<"Jlambda"<<YAML::Value<<JlambdaFile.str();

    // Export mean intensity per wavelength to file
    exportJlambda(JlambdaFile.str());
  }
  // Else (i.e. radiation field not updated)
  else {
    // Export mean intensity as estimated from DBB field
    data<<YAML::Key<<"J"<<YAML::Value<<W()*sigma*pow(TR(),4)/pi;
  }

  // Construct cell prefix
  cellPrefix<<prefix<<"-"<<index();

  // Export statistics for each subcell
  data<<YAML::Key<<"cell"<<YAML::Value<<YAML::BeginSeq;
  for (i=0;i<subCell.size();i++) subCell[i]->exportStat(data,tauLim,cellPrefix.str());
  data<<YAML::EndSeq;

  // Close map if requested
  if (close) data<<YAML::EndMap;
}

// Load Cell data (could be overloaded by derived class)
// Subcells: Works
// Containers: Works
void Cell::load(pstring& cellPData, AtomDataList& atomDataList, GridFactory* gridFactory, TransBBSelector* transSelector, BStateSelector* bStateSelector) {
  string value,nonThermalDataFile;
  pstring atomPData,subCellPData;
  CTReaction ctReactionTry; // New!
  bool constructed; // New!
  int i,j,k,l,nAtoms,nSubCells;

  // Load type
  value=cellPData.getData("type");
  if (value=="container") pType=cellContainer;
  else if (value=="subcell") pType=cellSub;
  else pType=cellNormal;
  if (master()) cout<<"type="<<pType<<"\n";
  // Get ptMin
  value=cellPData.getData("tMin");
  ptMin=atof(value.c_str());
  // Error handling
  if (value.size()==0) {cout<<"Grid::load: Error: Could not get tMin\n"; return;}
  if (master()) cout<<"tMin="<<ptMin<<"\n";
  // Get ptMax
  value=cellPData.getData("tMax");
  ptMax=atof(value.c_str());
  // Error handling
  if (value.size()==0) {cout<<"Grid::load: Error: Could not get tMax\n"; return;}
  if (master()) cout<<"tMax="<<ptMax<<"\n";
  // Get expansion factor
  value=cellPData.getData("fExp");
  pfExp=atof(value.c_str());
  // Error handling
  if (value.size()==0) {cout<<"Grid::load: Error: Could not get fExp\n"; return;}
  if (master()) cout<<"pfExp="<<pfExp<<"\n";
  // If cell container
  if (pType==cellContainer) {
    // Get size of sub cell array
    nSubCells=cellPData.getSize("cell");
    // Error handling
    if (nSubCells<=0) {cout<<"Grid::load: Error: Sub cell list empty\n"; return;}  
    // Resize sub cell list
    subCell.resize(nSubCells);
    for (i=0;i<subCell.size();i++) {
      if (master()) cout<<"Read sub cell "<<i<<" data\n";
      // Get sub cell data
      subCellPData=cellPData.getData("cell",i);
      // Create sub cell
      subCell[i]=gridFactory->createCell(mStateSolver,eos,config,mpiCom); // Changed!
      // Load sub cell data
      subCell[i]->load(subCellPData,atomDataList,gridFactory,transSelector,bStateSelector);
      // Set sub cell index
      subCell[i]->pIndex=i;
    }
    // Normalize filling-factors if necessary - New!
    // Should we really enforce this? Changed because of troubles in diffSolver::updateMatterState.
    double fillFactorSum=0; for (i=0;i<subCell.size();i++) fillFactorSum+=subCell[i]->fillFactor();
    if (fillFactorSum!=1.0) {cout<<"Grid::load: Warning: Sum of filling-factors differ from 1 ("<<fillFactorSum<<"). Normalizing filling-factors.\n"; return;} 
  }
  // Else
  else {
    // Get number of (virtual) cells
    value=cellPData.getData("nVirtualCells");
    if (value.size()!=0) pNCells=atof(value.c_str());
    else pNCells=1;
    if (master()) cout<<"nCells="<<pNCells<<"\n";
    // Get filling factor
    value=cellPData.getData("fillFactor");
    if (value.size()!=0) pFillFactor=atof(value.c_str());
    else pFillFactor=1.0;
    if (master()) cout<<"fillFactor="<<pFillFactor<<"\n";
    // Get density
    value=cellPData.getData("rho");
    prho=atof(value.c_str());
    // Error handling
    if (value.size()==0) {cout<<"Grid::load: Error: Could not get rho\n"; return;}
    if (master()) cout<<"rho="<<prho<<"\n";
    // Get temperature (optional)
    value=cellPData.getData("T");
    pT=atof(value.c_str());
    // Get radiation temperature (optional) - New!
    value=cellPData.getData("TR");
    if (value.size()!=0) pTR=atof(value.c_str());
    // Get dilution factor (optional) - New!
    value=cellPData.getData("W");
    if (value.size()!=0) pW=atof(value.c_str());
    // Get grey scatter opacity (optional)- New!
    value=cellPData.getData("greyScatterKappa");
    if (value.size()!=0) pGreyScatterKappa=atof(value.c_str());
    else pGreyScatterKappa=0.0;
    // Get dust absorption opacity (optional)- New!
    value=cellPData.getData("dustKappa");
    if (value.size()!=0) pDustAbsKappa=atof(value.c_str());
    else pDustAbsKappa=0.0;
    // Get opacity floor (optional) - New!
    value=cellPData.getData("kappaFloor");
    if (value.size()!=0) pKappaFloor=atof(value.c_str());
    else pKappaFloor=0;
    // Get size of atom array
    nAtoms=cellPData.getSize("atom");
    // Error handling
    if (nAtoms<=0) {cout<<"Grid::load: Error: Atom list empty\n"; return;}  
    // Resize atom list
    atom.resize(nAtoms);
    for (i=0;i<atom.size();i++) {
      if (master()) cout<<"Read atom "<<i<<" data\n";
      // Get atom data
      atomPData=cellPData.getData("atom",i);
      // Load atom data
      atom[i].load(atomPData,atomDataList,transSelector,bStateSelector);
      // Set atom index - New!
      atom[i].pIndex=i;
    }
    // For each charge-transfer reaction - New!
    for (i=0;i<atomDataList.ctReaction.size();i++) {
      if (master()) cout<<"Construct charge-transfer reaction "<<i<<"\n";
      // Try to construct the reaction using the loaded atom
      constructed=ctReactionTry.construct(&(atomDataList.ctReaction[i]),atom);
      if (master() and constructed) cout<<"Charge-transfer reaction "<<i<<" constructed\n";
      if (master() and not constructed) cout<<"Charge-transfer reaction "<<i<<" not constructed\n";      
      // If constructed - Add to list
      if (constructed) ctReaction.push_back(ctReactionTry);
    }
    // For each constructed charge-transfer reaction - New!
    for (i=0;i<ctReaction.size();i++) {
      // Set reaction index
      ctReaction[i].pIndex=i;
      // Add reaction to corresponding bound-free transitions
      ctReaction[i].downTrans->CTDReaction.push_back(&(ctReaction[i]));
      ctReaction[i].upTrans->CTUReaction.push_back(&(ctReaction[i]));
    }
  }

  // Hack - Improve this!
  // Get non-thermal data file
  value=cellPData.getData("nonThermalDataFile");
  nonThermalDataFile=value;
  // If provided - Load non-thermal data
  if (value.size()!=0) mStateSolver->load(nonThermalDataFile);

  // Hack
  radUpdated=false;

  // Hack
  //updateEdgeList();

  long nAtom=0,nIState=0,nBState=0,nTransBB=0,nTransBF=0;
  for (i=0;i<atom.size();i++) {
    nAtom++;
    for (j=0;j<atom[i].iState.size();j++) {
      nIState++;
      for (k=0;k<atom[i].iState[j].bState.size();k++) {
	nBState++;
	nTransBB+=atom[i].iState[j].bState[k].upTransBB.size();
	nTransBF+=atom[i].iState[j].bState[k].upTransBF.size();
      }
    }
  }
      
  //if (master()) cout<<"Cell::load: index: "<<index()<<", loaded "<<nAtom<<" atoms, "<<nIState<<" ionization states, "<<nBState<<" bound states, "<<nTransBF<<" bound-free transitions and "<<nTransBB<<" bound-bound transitions\n";
  if (master()) cout<<"Cell::load: Loaded "<<nAtom<<" atoms, "<<nIState<<" ionization states, "<<nBState<<" bound states, "<<nTransBF<<" bound-free transitions and "<<nTransBB<<" bound-bound transitions\n";
  
  return;
}

// Reload bound-bound transitions
// Subcells: Works
// Containers: Not applicable
void Cell::reloadTransBB(TransBBSelector* transSelector) {
  int i,j,k;

  // Reload bound-bound transitions for each atom
  for (i=0;i<atom.size();i++) atom[i].reloadTransBB(transSelector);

  long nTransBB=0;
  for (i=0;i<atom.size();i++) {
    for (j=0;j<atom[i].iState.size();j++) {
      for (k=0;k<atom[i].iState[j].bState.size();k++) {
	nTransBB+=atom[i].iState[j].bState[k].upTransBB.size();
      }
    }
  }

  // Re-init frequeny binning (as lines and edges may have changed) - New!
  initNu();

  if (master()) cout<<"Cell::reloadTransBB: index: "<<index()<<", loaded "<<nTransBB<<" bound-bound transitions\n";

  return;
}

// Load Cell data (could be overloaded by derived class)
// Not used! Needs update!
void Cell::loadYAML(const YAML::Node& data, AtomDataList& atomDataList, GridFactory* gridFactory, TransBBSelector* transSelector, BStateSelector* bStateSelector) {
  // Move to Cell !!!
  string nonThermalDataFile;
  int i;

  // Get type (optional)
  if (data["type"]) pType=loadCellType(data["type"]);
  // Set default to normal in constructor !!!

  // Get tMin
  if (data["tMin"]) ptMin=data["tMin"].as<double>();
  else {cout<<"Cell::load: Error: Could not get tMin\n"; exit(-1);}

  // Get tMax
  if (data["tMax"]) ptMax=data["tMax"].as<double>();
  else {cout<<"Cell::load: Error: Could not get tMax\n"; exit(-1);}
  
  // Get expansion factor (optional)
  if (data["fExp"]) pfExp=data["fExp"].as<double>();
  // Set default to 1.0 in constructor !!!

  // If cell container
  if (pType==cellContainer) {

    // Resize sub-cell list
    if (data["cell"]) subCell.resize(data["cell"].size());
    else {cout<<"Cell::load: Error: Could not get subcell data\n"; exit(-1);}  

    // For each sub-cell
    for (i=0;i<subCell.size();i++) {
      // Create sub-cell
      subCell[i]=gridFactory->createCell(mStateSolver,eos,config);
      // Load sub-cell data
      subCell[i]->loadYAML(data["cell"][i],atomDataList,gridFactory,transSelector,bStateSelector);
      // Set sub-cell index
      subCell[i]->pIndex=i;
    }
  }
  // Else
  else {
    // Get number of (virtual) cells (optional)
    if (data["nVirtualCells"]) pNCells=data["nVirtualCells"].as<int>();
    // Set default to 1 in contructor !!!

    // Get filling factor (optional)
    if (data["fillFactor"]) pFillFactor=data["fillFactor"].as<double>();
    // Set default to 1 in constructor

    // Get density
    if (data["rho"]) prho=data["rho"].as<double>();
    else {cout<<"Cell::load: Error: Could not get rho\n"; exit(-1);}

    // Get temperature (optional)
    if (data["T"]) pT=data["T"].as<double>();
    // Set default to ?? in constructor !!!

    // Resize atom list
    if (data["atom"]) atom.resize(data["atom"].size());
    else {cout<<"Cell::load: Error: Could not get atom data\n"; exit(-1);}

    // Load data for each atom
    for (i=0;i<atom.size();i++) atom[i].loadYAML(data["atom"][i],atomDataList,transSelector,bStateSelector);
  }

  // Hack - Improve this!
  // Get non-thermal data file
  if (data["nonThermalDataFile"]) nonThermalDataFile=data["nonThermalDataFile"].as<string>();
  // Set default to empty string in constructor !!!

  // If provided - Load non-thermal data
  if (nonThermalDataFile.compare("")!=0) mStateSolver->load(nonThermalDataFile);

  // Hack
  radUpdated=false;

  // Hack
  //updateEdgeList();
  
  return;
}

// Load Cell state (could be overloaded by derived class)
// Subcells: Works
// Containers: Not applicable
void Cell::loadState(const YAML::Node& data, bool loadIState, bool loadBState, bool loadRState) {
  string boostFile; // New!
  int i;

  if (master()) cout<<"Cell::loadState: index: "<<index()<<"\n";

  // If container - Load state for container and subcells and return - New!
  if (type()==cellContainer) { loadStateContainer(data,loadIState,loadBState,loadRState); return; }

  // Get tMin
  if (data["tMin"]) ptMin=data["tMin"].as<double>();
  else {cout<<"Cell::loadState: Error: Could not get tMin\n"; exit(-1);}

  // Get tMax
  if (data["tMax"]) ptMax=data["tMax"].as<double>();
  else {cout<<"Cell::loadState: Error: Could not get tMax\n"; exit(-1);}

  // If provided - New!
  if (data["boost"]) {

    // Get boost (factor) file name
    boostFile=data["boost"].as<string>();

    // Load boost (factor) from file
    loadBoost(boostFile);
  }

  // Load matter state
  loadMatterState(data,loadIState,loadBState);

  // If requested - Load radiation state
  if (loadRState) loadRadiationState(data);

  // Removed this, Hack !!!

  // Update transition probability lists
  //if (config->transTable) { updateTransPList(); if (master()) cout<<"Cell::loadMatterState: Updated transition probability tables\n"; }
  // Update collisional excitation probability list
  //if (config->collExciteTable) { updateCollExcitePList(); if (master()) cout<<"Cell::loadMatterState: Updated collisional excitation probability table\n"; }
  // Update non-thermal excitation probability list
  //if (config->nonThermalExciteTable) { updateNonThermalExcitePList(); if (master()) cout<<"Cell::loadMatterState: Updated non-thermal excitation probability table\n"; }
  
  return;
}

// Load Cell state for container (could be overloaded by derived class) - New!
// Subcells: Not applicable
// Containers: Works
void Cell::loadStateContainer(const YAML::Node& data, bool loadIState, bool loadBState, bool loadRState) {
  bool subCellRadUpdated=true;
  string boostFile; // New!
  int i;

  if (master()) cout<<"Cell::loadStateContainer: index: "<<index()<<"\n";

  // Get tMin
  if (data["tMin"]) ptMin=data["tMin"].as<double>();
  else {cout<<"Cell::loadStateContainer: Error: Could not get tMin\n"; exit(-1);}

  // Get tMax
  if (data["tMax"]) ptMax=data["tMax"].as<double>();
  else {cout<<"Cell::loadStateContainer: Error: Could not get tMax\n"; exit(-1);}
  
  // If provided - New!
  if (data["boost"]) {

    // Get boost (factor) file name
    boostFile=data["boost"].as<string>();

    // Load boost (factor) from file
    loadBoost(boostFile);
  }

  // Load state for each subcell
  if (data["cell"]) 
    if (subCell.size()==data["cell"].size()) 
      for (i=0;i<subCell.size();i++) subCell[i]->loadState(data["cell"][i],loadIState,loadBState,loadRState);
    else {cout<<"Cell::loadStateContainer: Error: Wrong number of subcells\n"; exit(-1);}
  else {cout<<"Cell::loadStateContainer: Error: Could not get subcells\n"; exit(-1);}

  // Check if radiation state updated for subcells
  for (i=0;i<subCell.size();i++) if (not subCell[i]->radUpdated) subCellRadUpdated=false;

  // If radiation state updated for subcells
  if (subCellRadUpdated) {

    // Reset MC statistics for container - Hack?
    resetMCStatisticsContainer(nu);
    
    // Reset MC estimators - Hack?
    /*Jnu.resize(0); Jnu.resize(nu.size(),0); 
      if (config->trackI) {
      Inu.resize(nu.size());
      for (i=0;i<Inu.size();i++) Inu[i].resize(mu.size(),0);
      }
      if (config->trackHK) { Hnu.resize(0); Hnu.resize(nu.size(),0); }
      if (config->trackHK) { Knu.resize(0); Knu.resize(nu.size(),0); }
      nuMeanNu.resize(0); nuMeanNu.resize(nu.size(),0);*/
    
    // Update radiation state for container - Hack?
    updateRadiationStateContainer(nu);
  }
  // Else - New!
  else {

    // If diluted blackbody-field provided - Testing!
    /*if (data["TR"] and data["W"]) {

      // Get radiation temperature
      pTR=data["TR"].as<double>();
      // Get dilution factor
      pW=data["W"].as<double>();
      
    }
    else {*/

    // Assume blackbody radiation field att matter temperature
    TR(T());
    W(1.0);
    //}
  }
  
  return;
}

// Load matter state (could be overloaded by derived class)
// Subcells: Works
// Containers: Not applicable
void Cell::loadMatterState(const YAML::Node& data, bool loadIState, bool loadBState) {
  int i,j;

  if (master()) cout<<"Cell::loadMatterState: index: "<<index()<<"\n";

  // Get density
  if (data["rho"]) prho=data["rho"].as<double>();
  else {cout<<"Cell::loadMatterState: Error: Could not get rho\n"; exit(-1);}

  // Get temperature
  if (data["T"]) pT=data["T"].as<double>();
  else {cout<<"Cell::loadMatterState: Error: Could not get T\n"; exit(-1);}    

  // Get diffusion temperature - Testing!
  if (data["TDiff"]) pTDiff=data["TDiff"].as<double>();
  else pTDiff=noT;

  // Load state for each atom
  if (data["atom"])
    if (atom.size()==data["atom"].size()) for (i=0;i<atom.size();i++) atom[i].loadState(data["atom"][i],loadIState,loadBState);
    else {cout<<"Cell::loadMatterState: Error: Wrong number of atoms\n"; exit(-1);}
  else { cout<<"Cell::loadMatterState: Error: Could not get atoms\n"; exit(-1); }

  // Update electron density
  // Unclear if muliple initializers work - Fix!
  pne=0; // New!
  for (i=0;i<atom.size();i++) // Changed!
    for (j=0;j<atom[i].iState.size();j++) pne+=fabs(atom[i].iState[j].n()*atom[i].iState[j].C());

  // Update line list
  updateLineList();

  // Update ionization edge list (only needs to be done once - fix)
  updateEdgeList();

  // Reset derived quantities
  reset();

  // Backup temperature
  pTOld=pT;
  
  return;
}

// Load radiation state (could be overloaded by derived class)
// Subcells: Works
// Containers: Not applicable
void Cell::loadRadiationState(const YAML::Node& data) {
  string JnuFile,JLineFile,InuFile;
  int i,j;

  if (master()) cout<<"Cell::loadRadiationState: index: "<<index()<<"\n";

  // If provided
  if (data["Jnu"]) {

    // Get mean intensity per frequency file name
    JnuFile=data["Jnu"].as<string>();

    // Load mean intensity per frequency from file
    loadJnu(JnuFile);
  }

  // If provided
  if (data["JLine"]) {

    // Get line intensity file name
    JLineFile=data["JLine"].as<string>();

    // Load line intensity from file
    loadJLine(JLineFile);
  }

  // If provided
  if (data["Inu"]) {

    // Get intensity per frequency file name
    InuFile=data["Inu"].as<string>();

    // Load mean intensity per frequency from file
    loadInu(InuFile);
  }

  // Get radioactive heating
  if (data["eRadio"]) peRadio=data["eRadio"].as<double>();
  else {cout<<"Cell::loadRadiationState: Error: Could not get eRadio\n"; exit(-1);}    

  // If radiation state provided
  //if (data["Jnu"] and data["JLine"]) {
  if (data["Jnu"] and (data["JLine"] or config->radEstimatorBB!=rfLucy)) { // Changed!

    // Update mean intensity
    updateJ();
    // Update (intensity weighted) mean frequeny
    updateNuMean();
    // Update diluted blackbody field
    updateDBBField();
    // Update blackbody field
    updateBBField();

    // Mark radiation field as updated
    radUpdated=true;

    // Backup MC statistics
    nuOld=nu;
    muOld=mu;
    JnuOld=Jnu;
    InuOld=Inu;
    etaNuOld=etaNu;
    kappaJNuOld=kappaJNu;
    nuMeanNuOld=nuMeanNu;
    JLineOld=JLine;
    nuLineOld=nuLine;
    nuBBOld=nuBB;
    peRadioOld=peRadio;
    nJOld=nJ;
    nJLineOld=nJLine;

    // Mark frequency tabulators for update (as they contain frequency list iterators)
    bBFactorUpdate=true;
    bMFactorUpdate=true;
    boundFreeSTableUpdate=true;

    if (master()) cout<<"Cell::loadRadiationState: index: "<<index()<<", Radiation field updated\n";
  }
  // Else - New!
  else {

    // If diluted blackbody-field provided - Testing!
    /*if (data["TR"] and data["W"]) {

      // Get radiation temperature
      pTR=data["TR"].as<double>();
      // Get dilution factor
      pW=data["W"].as<double>();
      
    }
    else {*/

    // Assume blackbody radiation field att matter temperature
    TR(T());
    W(1.0);
    //}
  }
  
  return;
}

// Load grey scattering opacity (could be overloaded by derived class)
// Subcells: Works
// Containers: Not applicable
void Cell::loadGreyScatterKappa(const YAML::Node& data) {
  string JnuFile,JLineFile,InuFile;
  int i;

  if (master()) cout<<"Cell::loadGreyScatterKappa: index: "<<index()<<"\n";

  // If container - Load state for container and subcells and return - New!
  if (type()==cellContainer) { for (i=0;i<subCell.size();i++) subCell[i]->loadGreyScatterKappa(data); }

  // Get grey scattering opacity
  if (data["greyScatterKappa"]) pGreyScatterKappa=data["greyScatterKappa"].as<double>();
  else {cout<<"Cell::loadGreyScatterKappa: Error: Could not get greyScatterKappa\n"; exit(-1);}
  
  return;
}

// Save Cell data (could be overloaded by derived class)
// Not used!
void Cell::save(YAML::Emitter& data, bool close) const {
  // Move to Cell !!!
  string nonThermalDataFile;
  int i;
  
  // Begin cell map
  data<<YAML::BeginMap;

  // Save type
  data<<YAML::Key<<"type"<<YAML::Value<<saveCellType(pType);

  // Save tMin
  data<<YAML::Key<<"tMin"<<YAML::Value<<tMin();

  // Save tMax
  data<<YAML::Key<<"tMax"<<YAML::Value<<tMax();

  // Save expansion factor
  data<<YAML::Key<<"fExp"<<YAML::Value<<fExp();

  // If cell container
  if (pType==cellContainer) {

    // Begin sub-cell sequence
    data<<YAML::BeginMap<<"cell"<<YAML::Value<<YAML::BeginSeq;

    // Save data for each sub-cell
    for (i=0;i<subCell.size();i++) subCell[i]->save(data);

    // End sub-cell equence
    data<<YAML::EndSeq<<YAML::EndMap;
  }
  // Else
  else {

    // Save number of (virtual) cells
    data<<YAML::Key<<"nVirtualCells"<<YAML::Value<<pNCells;

    // Save filling factor
    data<<YAML::Key<<"fillFactor"<<YAML::Value<<pFillFactor;

    // Save density
    data<<YAML::Key<<"rho"<<YAML::Value<<prho;

    // Save temperature
    data<<YAML::Key<<"T"<<YAML::Value<<pT;

    // Begin atom sequence
    data<<YAML::BeginMap<<"atom"<<YAML::Value<<YAML::BeginSeq;

    // Save data for each atom
    for (i=0;i<atom.size();i++) atom[i].save(data);

    // End atom sequence
    data<<YAML::EndSeq<<YAML::EndMap;
  }

  // Save non-thermal data file
  data<<YAML::Key<<"nonThermalDataFile"<<nonThermalDataFile;

  // Close cell map if requested
  if (close) data<<YAML::EndMap;
}

// Save Cell state (could be overloaded by derived class)
// Subcells: Works
// Containers: Works
void Cell::saveState(YAML::Emitter& data, string prefix, bool close) {
  stringstream JnuFile,JLineFile,InuFile,boostFile; // Changed!
  int i;

  // If container - Save state for container and subcells and return - New!
  if (type()==cellContainer) { saveStateContainer(data,prefix,close); return; }

  // Begin cell map
  data<<YAML::BeginMap;

  // Save time borders
  data<<YAML::Key<<"tMin"<<YAML::Value<<tMin();
  data<<YAML::Key<<"tMax"<<YAML::Value<<tMax();

  // Save density
  data<<YAML::Key<<"rho"<<YAML::Value<<rho();

  // Save temperature
  data<<YAML::Key<<"T"<<YAML::Value<<T();

  // Save diffusion temperature - Testing!
  data<<YAML::Key<<"TDiff"<<YAML::Value<<TDiff();

  // Save radioactive heating
  data<<YAML::Key<<"eRadio"<<YAML::Value<<eRadio();

  // If boost (factor) defined - New!
  if (nuBoost.size()!=0) {

    // Construct boost (factor) file name
    boostFile<<prefix<<"-boost-"<<index()<<".dat";

    // Save boost (factor) file name
    data<<YAML::Key<<"boost"<<YAML::Value<<boostFile.str();

    // Save boost (factor) to file
    saveBoost(boostFile.str());
  }

  // If radiation field updated
  if (radUpdated) {

    // Construct mean intensity per frequency file name
    JnuFile<<prefix<<"-Jnu-"<<index()<<".dat";
    
    // Save mean intensity per frequency file name
    data<<YAML::Key<<"Jnu"<<YAML::Value<<JnuFile.str();

    // Save mean intensity per frequency to file
    exportJnu(JnuFile.str());

    // If use Lucy (2003) estimators - New!
    if (config->radEstimatorBB==rfLucy) {
   
      // Construct line intensity file name
      JLineFile<<prefix<<"-JLine-"<<index()<<".dat";

      // Save line intensity file name
      data<<YAML::Key<<"JLine"<<YAML::Value<<JLineFile.str();

      // Save line intensity to file
      exportJLine(JLineFile.str());
    }

    // If track intensity
    if (config->trackI) {

      // Construct intensity per frequency file name
      InuFile<<prefix<<"-Inu-"<<index()<<".dat";
    
      // Save intensity per frequency file name
      data<<YAML::Key<<"Inu"<<YAML::Value<<InuFile.str();

      // Save intensity to file
      exportInu(InuFile.str());
    }      
  }

  // Save state for each atom
  data<<YAML::Key<<"atom"<<YAML::Value<<YAML::BeginSeq;
  for (i=0;i<atom.size();i++) atom[i].saveState(data);
  data<<YAML::EndSeq;

  // Close map if requested
  if (close) data<<YAML::EndMap;
}

// Save Cell state for container and subcells (could be overloaded by derived class) - New!
// Subcells: Not applicable
// Containers: Works
void Cell::saveStateContainer(YAML::Emitter& data, string prefix, bool close) {
  stringstream cellPrefix,boostFile; // Changed!
  int i;

  // Begin cell map
  data<<YAML::BeginMap;

  // Save time borders
  data<<YAML::Key<<"tMin"<<YAML::Value<<tMin();
  data<<YAML::Key<<"tMax"<<YAML::Value<<tMax();

  // If boost (factor) defined - New!
  if (nuBoost.size()!=0) {

    // Construct boost (factor) file name
    boostFile<<prefix<<"-boost-"<<index()<<".dat";

    // Save boost (factor) file name
    data<<YAML::Key<<"boost"<<YAML::Value<<boostFile.str();

    // Save boost (factor) to file
    saveBoost(boostFile.str());
  }

  // Construct cell prefix
  cellPrefix<<prefix<<"-"<<index();

  // Save state for each subcell
  data<<YAML::Key<<"cell"<<YAML::Value<<YAML::BeginSeq;
  for (i=0;i<subCell.size();i++) subCell[i]->saveState(data,cellPrefix.str());
  data<<YAML::EndSeq;
 
  // Close map if requested
  if (close) data<<YAML::EndMap;
}

// Set back references
// Subcells: Works
// Containers: Works
void Cell::setBackReference(Grid* grid) {
  int i;

  // If cell container
  if (pType==cellContainer)
    // For each sub cell set back reference
    for (i=0;i<subCell.size();i++) subCell[i]->setBackReference(grid);
  // Else
  else {
    // Set grid back reference pointer
    // Hmm, should this not be set for a cell container as well?
    pGrid=grid;
    // For each atom set back references
    for (i=0;i<atom.size();i++) atom[i].setBackReference(this);
    // For each charge-transfer reaction set back references - New!
    for (i=0;i<ctReaction.size();i++) ctReaction[i].setBackReference(this);    
  }
}

// Evolve radioactive state of cell
// Subcells: Works
// Containers: Works
// Assumes the elements of the 56Ni, 56Co and 44Ti decay chains have been loaded - Fix this !!!
void Cell::evolveRadio(const double& t, const double& dt) {
  vector<Isotope>::iterator isotope56Ni,isotope56Co,isotope56Fe,isotope57Ni,isotope57Co,isotope57Fe,isotope44Ti,isotope44Ca;
  double X56Ni,X56Co,X56Fe,X57Ni,X57Co,X57Fe,X44Ti,X44Ca;
  int i,j;

  // If cell container
  if (type()==cellContainer) {
    // Evolve radioactive state of each sub cell
    for (i=0;i<subCell.size();i++) {
      subCell[i]->evolveRadio(t,dt);
    }
    // Return - New!
    return;
  }
  
  // For each atom
  for (i=0;i<atom.size();i++)
    // For each isotope
    for (j=0;j<atom[i].isotope.size();j++) {
      // Select the isotopes of the 56Ni, 57Ni and 44Ti decay chains
      if (atom[i].Z()==28 and atom[i].isotope[j].N()==28) isotope56Ni=atom[i].isotope.begin()+j;
      if (atom[i].Z()==27 and atom[i].isotope[j].N()==29) isotope56Co=atom[i].isotope.begin()+j;
      if (atom[i].Z()==26 and atom[i].isotope[j].N()==30) isotope56Fe=atom[i].isotope.begin()+j;
      if (atom[i].Z()==28 and atom[i].isotope[j].N()==29) isotope57Ni=atom[i].isotope.begin()+j;
      if (atom[i].Z()==27 and atom[i].isotope[j].N()==30) isotope57Co=atom[i].isotope.begin()+j;
      if (atom[i].Z()==26 and atom[i].isotope[j].N()==31) isotope57Fe=atom[i].isotope.begin()+j;
      if (atom[i].Z()==22 and atom[i].isotope[j].N()==22) isotope44Ti=atom[i].isotope.begin()+j;
      if (atom[i].Z()==20 and atom[i].isotope[j].N()==24) isotope44Ca=atom[i].isotope.begin()+j;
    }
  // Get mass fractions for the isotopes of the 56Ni, 57Ni and 44Ti decay chains
  X56Ni=isotope56Ni->X(); X56Co=isotope56Co->X(); X56Fe=isotope56Fe->X();
  X57Ni=isotope57Ni->X(); X57Co=isotope57Co->X(); X57Fe=isotope57Fe->X();
  X44Ti=isotope44Ti->X(); X44Ca=isotope44Ca->X();
  // Calculate new mass fraction for the isotopes of the 56Ni decay chain
  decay56Ni(X56Ni,X56Co,X56Fe,t,t+dt);
  // Calculate new mass fractions for the isotopes of the 57Ni decay chain
  decay57Ni(X57Ni,X57Co,X57Fe,t,t+dt);
  // Calculate new mass fractions for the isotopes of the 44Ti decay chain
  decay44Ti(X44Ti,X44Ca,t,t+dt);
  // Update mass fractions for the isotopes of the 56Ni, 57Ni and 44Ti decay chains
  isotope56Ni->X(X56Ni); isotope56Co->X(X56Co); isotope56Fe->X(X56Fe);
  isotope57Ni->X(X57Ni); isotope57Co->X(X57Co); isotope57Fe->X(X57Fe);
  isotope44Ti->X(X44Ti); isotope44Ca->X(X44Ca);
}

// Is master?
// Subcells: Works
// Containers: Works
bool Cell::master() const {
  bool _master=false;

  if (mpiCom==NULL) _master=true;
  else if (mpiCom->rank()==0) _master=true;

  return _master;
}

// Set on-the-spot range
// Subcells: Works
// Containers: Not applicable
void Cell::onTheSpotNu(const FrequencyBin& _onTheSpotNu) {
  pOnTheSpotNu=_onTheSpotNu;
}

// Get on-the-spot range
// Subcells: Works
// Containers: Not applicable
FrequencyBin Cell::onTheSpotNu() const {
  return pOnTheSpotNu;
}

// Init frequency binning
// Subcells: Works
// Containers: Not applicable
// Not syncronized with Cell::resetMCStatistics!!! Fix!!!
//void Cell::initNu(const double& nuMin, const double& nuMax, const int& nBin) {
void Cell::initNu(double nuMin, double nuMax, int nBin) { // Changed!
  int i,j,k,l;
  vector<double> nuWork;
  vector<double> nuEdge;
  double nu0;
  // Testing
  TransBF* trans;
  // Testing
  //double nuCheck,nuDiv=(c/(911.0*AA));

  // If container - Init frequency binning for each subcell as well as the container and return
  if (type()==cellContainer) { for (i=0;i<subCell.size();i++) subCell[i]->initNu(nuMin,nuMax,nBin); initNuContainer(nuMin,nuMax,nBin); return; }

  // If not provided - Get nuMin, nuMax and nBin from config
  if (nuMin==noNu) nuMin=config->nuMin;
  if (nuMax==noNu) nuMax=config->nuMax;
  if (nBin==noN) nBin=config->nNuBin;

  double dlognu=(log(nuMax)-log(nuMin))/float(nBin);
  nuWork.resize(nBin);
  for (i=0;i<nuWork.size();i++) nuWork[i]=nuMin*exp(i*dlognu);
  // Testing
  /*for (i=0;i<nBin;i++) {
    nuCheck=nuMin*exp(i*dlognu);
    if ((nuCheck>nuDiv and i%4==0) or i==(nBin-1) or nuCheck<=nuDiv) nuWork.push_back(nuCheck);
    }*/
  // For each bound state
  for (i=0;i<atom.size();i++) {
    for (j=0;j<atom[i].iState.size();j++) {
      for (k=0;k<atom[i].iState[j].bState.size();k++) {
	// For each bound-free transition
	for (l=0;l<atom[i].iState[j].bState[k].upTransBF.size();l++) {
	  // Add ionization edge frequency
	  nu0=atom[i].iState[j].bState[k].upTransBF[l]->nu();
	  //if (nu0>=nuWork[0] and nu0<=nuWork[nuWork.size()-1]) {
	  if (nu0>=nuMin and nu0<=nuMax) {
	    nuWork.push_back(nu0); nuEdge.push_back(nu0);
	    trans=atom[i].iState[j].bState[k].upTransBF[l];
	  }
	}
      }
    }
  }
  // Sort frequencies
  sort(nuWork.begin(),nuWork.end());
  // Sort edge frequencies
  sort(nuEdge.begin(),nuEdge.end());
  // Update frequency bin
  nu.resize(0); nu.resize(nuWork.size()-1);
  for (i=0;i<nu.size();i++) nu[i].min=nuWork[i];
  for (i=0;i<nu.size();i++) nu[i].max=nuWork[i+1];
  // Testing
  int nEdge=0;
  // Set edge flags
  //for (i=0,j=0;i<nu.size();i++) {
  // Unclear if muliple initializers work - Fix!
  j=0; // New!
  for (i=0;i<nu.size() and j<nuEdge.size();i++) { // Changed!
    if (nuEdge[j]==nu[i].min) { 
      nu[i].edge=true; j++; 
      // Testing
      nEdge++;
    }
    // Testing - Initilize to major (edge)
    nu[i].minorEdge=false;
  }
  // Testing
  //cout<<"Cell::initNu: index: "<<index()<<", Marked "<<nEdge<<" edges\n";

  // Backup frequency bins
  nuOld=nu;

  // Mark frequency tabulators for update (as they contain frequency bin iterators)
  bBFactorUpdate=true;
  bMFactorUpdate=true;
  boundFreeSTableUpdate=true;

  // If use Lucy (2003) estimators - Setup line frequency bins - New!
  if (config->radEstimatorBB==rfLucy) {
    nuWork.resize(0);
    for (i=0;i<atom.size();i++)
      for (j=0;j<atom[i].iState.size();j++)
	for (k=0;k<atom[i].iState[j].bState.size();k++)
	  for (l=0;l<atom[i].iState[j].bState[k].upTransBB.size();l++)
	    nuWork.push_back(atom[i].iState[j].bState[k].upTransBB[l]->nu());
    nuWork.push_back(nu[nu.size()-1].max);
    sort(nuWork.begin(),nuWork.end());
    nuLine.resize(nuWork.size()-1);
    for (i=0;i<nuLine.size();i++) nuLine[i].min=nuWork[i];
    for (i=0;i<nuLine.size();i++) nuLine[i].max=nuWork[i+1];
  }

  if (master()) cout<<"Cell::initNu: index: "<<index()<<", nuMin: "<<nuMin<<", nuMax: "<<nuMax<<", lambdaMin: "<<(c/nuMax)/AA<<", lambdaMax: "<<(c/nuMin)/AA<<", nBin: "<<nBin<<", nu.size: "<<nu.size()<<", nuLine.size: "<<nuLine.size()<<"\n";
}

// Init frequency binning for container
//void Cell::initNuContainer(const double& nuMin, const double& nuMax, const int& nBin) {
void Cell::initNuContainer(double nuMin, double nuMax, int nBin) { // Changed!
  int i;
  vector<double> nuWork;

  // If not provided - Get nuMin, nuMax and nBin from config
  if (nuMin==noNu) nuMin=config->nuMin;
  if (nuMax==noNu) nuMax=config->nuMax;
  if (nBin==noN) nBin=config->nNuBin;

  double dlognu=(log(nuMax)-log(nuMin))/float(nBin);
  nuWork.resize(nBin);
  for (i=0;i<nuWork.size();i++) nuWork[i]=nuMin*exp(i*dlognu);
  // Update frequency bin
  nu.resize(0); nu.resize(nuWork.size()-1);
  for (i=0;i<nu.size();i++) nu[i].min=nuWork[i];
  for (i=0;i<nu.size();i++) nu[i].max=nuWork[i+1];

  // Backup frequency bins
  nuOld=nu;

  // Mark frequency tabulators for update (as they contain frequency bin iterators)
  // Not needed, right?
  //bBFactorUpdate=true;
  //bMFactorUpdate=true;
  //boundFreeSTableUpdate=true;
}


// Init angular binning
// Subcells: Works
// Containers: Not applicable
void Cell::initMu(int nBin) {
  vector<double> muWork;
  int i;

  // If container - Init angular binning for each subcell as well as the container and return
  if (type()==cellContainer) { for (i=0;i<subCell.size();i++) subCell[i]->initMu(nBin); initMuContainer(nBin); return; }

  // If not provided - Get nBin from config
  if (nBin==noN) nBin=config->nMuBin;

  // If track intensity
  //if (config->trackI) {
  // Setup angle bins
  muWork.resize(nBin+1);
  for (i=0;i<muWork.size();i++) muWork[i]=cos(float(i)*pi/float(nBin));
  sort(muWork.begin(),muWork.end());
  muWork[0]=-1e99; muWork[muWork.size()-1]=1e99;
  mu.resize(muWork.size()-1);
  for (i=0;i<mu.size();i++) mu[i].min=muWork[i];
  for (i=0;i<mu.size();i++) mu[i].max=muWork[i+1];
  //}
  // Else - No angle bins
  //else mu.resize(0);
}

// Init angular binning for container
void Cell::initMuContainer(int nBin) {
  vector<double> muWork;
  int i;
  
  // If not provided - Get nBin from config
  if (nBin==noN) nBin=config->nMuBin;

  // If track intensity
  //if (config->trackI) {
  // Setup angle bins
  muWork.resize(nBin+1);
  for (i=0;i<muWork.size();i++) muWork[i]=cos(float(i)*pi/float(nBin));
  sort(muWork.begin(),muWork.end());
  muWork[0]=-1e99; muWork[muWork.size()-1]=1e99;
  mu.resize(muWork.size()-1);
  for (i=0;i<mu.size();i++) mu[i].min=muWork[i];
  for (i=0;i<mu.size();i++) mu[i].max=muWork[i+1];
  //}
  // Else - No angle bins
  //else mu.resize(0);
}

// Boost MC interactions - New!
// Subcells: Works
// Containers: Not applicable
void Cell::boostMC() {

  // Boost emission
  boostEta();

  // Boost radiative cooling
  boostRadiativeCooling();

  // Boost transition probabilities
  boostTransP();

  // Boost collisional cooling
  boostCollCooling();

  // Boost non-thermal rates
  boostNonThermal();

  // Boost opacity
  boostKappa();
}

// Boost emission - New!
// Subcells: Works
// Containers: Not applicable
void Cell::boostEta() {
  int i,j,k,l;

  // For each bound state
  for (i=0;i<atom.size();i++)
    for (j=0;j<atom[i].iState.size();j++)
      for (k=0;k<atom[i].iState[j].bState.size();k++) {

	// Boost bound-bound emission
	for (l=0;l<atom[i].iState[j].bState[k].downTransBB.size();l++) atom[i].iState[j].bState[k].downTransBB[l]->boostEta();

	// Boost bound-free emission
	for (l=0;l<atom[i].iState[j].bState[k].downTransBF.size();l++) atom[i].iState[j].bState[k].downTransBF[l]->boostEta();
      }

  // Boost free-free emission
  boostFreeFreeEta();
}

// Boost free-free emission - New!
// Subcells: Works
// Containers: Not applicable
void Cell::boostFreeFreeEta() {
  double nuMin,nuMax,PTot=0;
  int i;

  // Resize free-free emission probability vector
  freeFreeEtaP.resize(nuBoost.size());

  if (radUpdated) nuMin=MAX(freeFreeOnTheSpotNu(),nuOld[0].min);
  else nuMin=freeFreeOnTheSpotNu();

  if (radUpdated) nuMax=nuOld[nuOld.size()-1].max;
  else nuMax=nuInf;

  // For each boost bin
  for (i=0;i<nuBoost.size();i++) {
    // Calculate emission probability
    if (nuBoost[i].max>nuMin and nuBoost[i].min<nuMax) freeFreeEtaP[i]=exp(-h*MAX(nuBoost[i].min,nuMin)/(k*T()))-exp(-h*MIN(nuBoost[i].max,nuMax)/(k*T()));
    else freeFreeEtaP[i]=0;
    // Sum emission probability
    PTot+=freeFreeEtaP[i];
  }

  // Normalize emission probability
  for (i=0;i<nuBoost.size();i++) freeFreeEtaP[i]=freeFreeEtaP[i]/PTot;

  // Reset boost factor
  pFreeFreeEtaBoost=0;

  // Calculate boost factor
  for (i=0;i<nuBoost.size();i++) pFreeFreeEtaBoost+=freeFreeEtaP[i]*boost[i];

  //if (master()) cout<<"Cell::boostFreeFreeEta: index: "<<index()<<", pFreeFreeEtaBoost: "<<pFreeFreeEtaBoost<<"\n";

  // Adjust emission probability for each boost bin
  for (i=0;i<nuBoost.size();i++) freeFreeEtaP[i]=freeFreeEtaP[i]*boost[i]/freeFreeEtaBoost();

  //if (master()) for (i=0;i<nuBoost.size();i++) cout<<"Cell::boostFreeFreeEta: index: "<<index()<<", freeFreeEtaP["<<i<<"]: "<<freeFreeEtaP[i]<<"\n";
}

// Boost radiative cooling - New!
// Subcells: Works
// Containers: Not applicable
void Cell::boostRadiativeCooling() {
  double totalCooling,PBoundFree,PFreeFree;
  int i;

  // Boost bound-free cooling
  boostBoundFreeCooling();

  // Boost free-free cooling
  boostFreeFreeCooling();

  // Calculate total (radiative) cooling
  totalCooling=boundFreeCoolingSP()+freeFreeCooling();

  // Calculate bound-free and free cooling probabilities
  PBoundFree=boundFreeCoolingSP()/totalCooling;
  PFreeFree=freeFreeCooling()/totalCooling;

  // Calculate boost factor for (radiative) cooling
  pRadCoolingBoost=PBoundFree*boundFreeCoolingBoost()+PFreeFree*freeFreeCoolingBoost();

  // Testing
  //if (index()==36) 
  //cout<<"Cell::boostRadiativeCooling: index: "<<index()<<", boundFreeCoolingBoost: "<<boundFreeCoolingBoost()<<", freeFreeCoolingBoost: "<<freeFreeCoolingBoost()<<", boundFreeCoolingSP: "<<boundFreeCoolingSP()<<", freeFreeCooling: "<<freeFreeCooling()<<"\n";

  //if (master()) cout<<"Cell::boostRadiativeCooling: index: "<<index()<<", pRadCoolingBoost: "<<pRadCoolingBoost<<"\n";
}

// Boost bound-free cooling - New!
// Subcells: Works
// Containers: Not applicable
void Cell::boostBoundFreeCooling() {
  double totalCooling,P;
  int i,j,k,l;

  // Get total bound-free cooling
  totalCooling=boundFreeCoolingSP();

  // Reset boost factor
  pBoundFreeCoolingBoost=0;

  // For each atom
  for (i=0; i<atom.size(); i++) {
    // For each ionization state
    for (j=0; j<atom[i].iState.size(); j++) {
      // For each bound state
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {
	// For each (downward) bound-free transition
	for (l=0; l<atom[i].iState[j].bState[k].downTransBF.size(); l++) {
	  
	  // Calculate transition probability
	  P=atom[i].iState[j].bState[k].downTransBF[l]->coolingSP()/totalCooling;
	  
	  // Adjust and add to boost factor
	  pBoundFreeCoolingBoost+=P*atom[i].iState[j].bState[k].downTransBF[l]->etaBoost();
	  // Testing!!!
	  //if (index()==36) 
	  //cout<<"BState::boostBoundFreeCooling: index: "<<index()<<",trans: "<<atom[i].iState[j].bState[k].downTransBF[l]->upperState->iState()->name()<<":"<<atom[i].iState[j].bState[k].downTransBF[l]->upperState->getIndex()<<"->"<<atom[i].iState[j].bState[k].downTransBF[l]->lowerState->iState()->name()<<":"<<atom[i].iState[j].bState[k].downTransBF[l]->lowerState->getIndex()<<", coolingSP: "<<atom[i].iState[j].bState[k].downTransBF[l]->coolingSP()<<", etaBoost: "<<atom[i].iState[j].bState[k].downTransBF[l]->etaBoost()<<", totalCooling: "<<totalCooling<<", pBoundFreeCoolingBoost: "<<pBoundFreeCoolingBoost<<"\n";
	}
      }
    }
  }

  //if (master()) cout<<"Cell::boostBoundFreeCooling: index: "<<index()<<", pBoundFreeCoolingBoost: "<<pBoundFreeCoolingBoost<<"\n";
}

// Boost free-free cooling - New!
// Subcells: Works
// Containers: Not applicable
void Cell::boostFreeFreeCooling() {

  // Set free-free cooling boost factor
  pFreeFreeCoolingBoost=freeFreeEtaBoost();
}

// Boost collisional cooling - New!
// Subcells: Works
// Containers: Not applicable
void Cell::boostCollCooling() {
  double totalCooling,bStateCooling,P,PBoundFree,PFreeFree,PColl;
  BState* bState;
  int i,j,k,l;

  // Get total collisional cooling
  totalCooling=collCooling();

  // Reset boost factor
  pCollCoolingBoost=0;

  // For each atom
  for (i=0; i<atom.size(); i++) {
    // For each ionization state
    for (j=0; j<atom[i].iState.size(); j++) {
      // For each bound state
      for (k=0; k<atom[i].iState[j].bState.size(); k++) {
	
	// Initialize bound state cooling
	bStateCooling=0;
	
	// Set bound state pointer
	bState=&(atom[i].iState[j].bState[k]);
	
	// Sum collisional cooling for bound-bound transition
	for (l=0;l<bState->downTransBB.size();l++) bStateCooling+=bState->downTransBB[l]->CU()*bState->downTransBB[l]->Xi();
	
	// Sum collisional cooling for bound-free transition
	for (l=0;l<bState->downTransBF.size();l++) bStateCooling+=bState->downTransBF[l]->CU()*bState->downTransBF[l]->Xi();
	
	// Calculate (total) transition probability
	P=bStateCooling/totalCooling;
	
	// Adjust and add to emission boost factor
	pCollCoolingBoost+=P*bState->markovPBoost();

	//if (master() and index()==30) cout<<"Cell::boostCollCooling: index: "<<index()<<", "<<atom[i].iState[j].name()<<":"<<atom[i].iState[j].bState[k].getIndex()<<", totalCooling: "<<totalCooling<<", bStateCooling: "<<bStateCooling<<", P: "<<P<<", bState->markovPBoost(): "<<bState->markovPBoost()<<"\n";
      }
    }
  }

  //if (master()) cout<<"Cell::boostCollCooling: index: "<<index()<<", pCollCoolingBoost: "<<pCollCoolingBoost<<"\n";

  // Calculate total cooling
  totalCooling=boundFreeCoolingSP()+freeFreeCooling()+collCooling();

  // Calculate bound-free, free-free and collisional cooling probabilities
  PBoundFree=boundFreeCoolingSP()/totalCooling;
  PFreeFree=freeFreeCooling()/totalCooling;
  PColl=collCooling()/totalCooling;

  // Calculate boost factor for cooling
  pCoolingBoost=PBoundFree*boundFreeCoolingBoost()+PFreeFree*freeFreeCoolingBoost()+PColl*collCoolingBoost();

  //if (master()) cout<<"Cell::boostCollCooling: index: "<<index()<<", pCoolingBoost: "<<pCoolingBoost<<"\n";
}

// Boost non-thermal rates - New!
// Subcells: Works
// Containers: Not applicable
void Cell::boostNonThermal() {
  double totalExc,totalIon,totalHeating,totalDeposition,bStateExc,bStateIon,PExc,PIon,PExcIon,PHeating;
  BState* bState;
  int i,j,k,l;

  // Get total gamma-ray/lepton energy deposition
  totalExc=nonThermalExcitation();
  totalIon=nonThermalIonization();
  totalHeating=nonThermalHeating();
  totalDeposition=totalHeating+totalExc+totalIon;

  // Reset boost factors
  pNonThermalExcBoost=0; 
  pNonThermalIonBoost=0; 
  pNonThermalExcIonBoost=0;
  pNonThermalBoost=0;

  // If non-thermal processes
  if (config->nonThermalMacro) {

    // For each atom
    for (i=0; i<atom.size(); i++) {
      // For each ionization state
      for (j=0; j<atom[i].iState.size(); j++) {
	// For each bound state
	for (k=0; k<atom[i].iState[j].bState.size(); k++) {
	  
	  // Initialize non-thermal rates
	  bStateExc=0;
	  bStateIon=0;
	  
	  // Set bound state pointer
	  bState=&(atom[i].iState[j].bState[k]);
	  
	  // Sum non-thermal excitation rate
	  for (l=0;l<bState->downTransBB.size();l++) bStateExc+=bState->downTransBB[l]->CNU()*bState->downTransBB[l]->Xi();
	  
	  // Sum non-thermal ionization rate
	  for (l=0;l<bState->downTransBF.size();l++) bStateIon+=bState->downTransBF[l]->CNU()*bState->downTransBF[l]->Xi();
	  
	  // Calculate (total) excitation/ionization probability
	  PExc=bStateExc/totalExc;
	  PIon=bStateIon/totalIon;
	  PExcIon=(bStateExc+bStateIon)/(totalExc+totalIon);
	  
	  // Adjust and add to boost factors
	  pNonThermalExcBoost+=PExc*bState->markovPBoost();
	  pNonThermalIonBoost+=PIon*bState->markovPBoost();
	  pNonThermalExcIonBoost+=PExcIon*bState->markovPBoost();
	}
      }
    }
  }
  // Else - Set excitation/ionization boost factors to one
  else { pNonThermalExcBoost=1.0; pNonThermalIonBoost=1.0; pNonThermalExcIonBoost=1.0; }

  // Get non-thermal heating boost factor
  pNonThermalHeatingBoost=coolingBoost();

  // If non-thermal processes - Calculate non-thermal excitation/ionization probability
  if (config->nonThermalMacro) PExcIon=(totalExc+totalIon)/totalDeposition;
  // Else - Set non-thermal excitation/ionization probability to zero
  else PExcIon=0;

  // Calculate non-thermal heating probability
  PHeating=totalHeating/totalDeposition;

  // Calculate boost factor for (total) non-thermal deposition
  pNonThermalBoost=PExcIon*nonThermalExcIonBoost()+PHeating*nonThermalHeatingBoost();

  if (master() and index()==36) cout<<"Cell::boostNonThermal: cell: "<<index()<<", pNonThermalExcBoost: "<<pNonThermalExcBoost<<", pNonThermalIonBoost: "<<pNonThermalIonBoost<<", pNonThermalExcIonBoost: "<<pNonThermalExcIonBoost<<", pNonThermalBoost: "<<pNonThermalBoost<<", PExcIon: "<<PExcIon<<", PHeating: "<<PHeating<<"\n";

  //if (master()) cout<<"Cell::boostNonThermal: cell: "<<index()<<", pNonThermalExcBoost: "<<pNonThermalExcBoost<<", pNonThermalIonBoost: "<<pNonThermalIonBoost<<", pNonThermalExcIonBoost: "<<pNonThermalExcIonBoost<<", pNonThermalBoost: "<<pNonThermalBoost<<"\n";
}

// Boost transition probabilities - New!
// Subcells: Works
// Containers: Not applicable
void Cell::boostTransP() {
  int i,j,k;

  // If extended Markov list not used - Return
  if (not (config->markovTableExt or config->markovTableExtSplit)) { cout<<"Cell::boostTransPList: Warning: Ignored - Boost only allowed when using extended Markov table"; return; }

  // If split extended Markov table used
  if (config->markovTableExtSplit) {
    
    // For each bound state
    for (i=0;i<atom.size();i++)
      for (j=0;j<atom[i].iState.size();j++)
	for (k=0;k<atom[i].iState[j].bState.size();k++)
	  // Boost radiative transition probabilies
	  atom[i].iState[j].bState[k].boostTransPR();

    // Boost thermal pool Markov transition probabilities
    boostMarkovPTherm();

    // Boost charge-transfer Markov transition probabilities    
    if (config->boundFreeMacro and config->chargeTransferMacro) boostMarkovPCT();

    // For each bound state
    for (i=0;i<atom.size();i++)
      for (j=0;j<atom[i].iState.size();j++)
	for (k=0;k<atom[i].iState[j].bState.size();k++)
	  // Boost collisional transition probabilies
	  atom[i].iState[j].bState[k].boostTransPC();
    
    // For each bound state
    for (i=0;i<atom.size();i++)
      for (j=0;j<atom[i].iState.size();j++)
	for (k=0;k<atom[i].iState[j].bState.size();k++)
	  // Boost Markov transition probabilities
	  atom[i].iState[j].bState[k].boostMarkovP();

  }
  // Else
  else {

    // For each bound state
    for (i=0;i<atom.size();i++)
      for (j=0;j<atom[i].iState.size();j++)
	for (k=0;k<atom[i].iState[j].bState.size();k++)
	  // Boost transition probabilities
	  atom[i].iState[j].bState[k].boostTransP();

    // For each bound state
    for (i=0;i<atom.size();i++)
      for (j=0;j<atom[i].iState.size();j++)
	for (k=0;k<atom[i].iState[j].bState.size();k++)
	  // Boost Markov transition probabilities
	  atom[i].iState[j].bState[k].boostMarkovP();    
  }
}

// Boost thermal pool Markov transition probabilities
// Subcells: Works
// Containers: Not applicable
void Cell::boostMarkovPTherm() {
  double PTot;
  MarkovPList markovPListWork;
  int i;

  // Reset boost factor
  pMarkovPThermBoost=0;

  // Calculate boost factor
  for (i=0;i<markovPListTherm.size();i++) {
    if (markovPListTherm[i].nextState!=NULL) pMarkovPThermBoost+=markovPListTherm[i].P*markovPListTherm[i].nextState->transPRBoost();
    else pMarkovPThermBoost+=markovPListTherm[i].P*radCoolingBoost();
    // Testing!
    //if (index()==36)
    //if (markovPListTherm[i].nextState!=NULL) cout<<"Cell::boostMarkovPTherm: index: "<<index()<<", markovPListTherm["<<i<<"].P: "<<markovPListTherm[i].P<<",nextState: "<<markovPListTherm[i].nextState->iState()->name()<<":"<<markovPListTherm[i].nextState->getIndex()<<", transPRBoost: "<<markovPListTherm[i].nextState->transPRBoost()<<", pMarkovPThermBoost: "<<pMarkovPThermBoost<<"\n";
    //else cout<<"Cell::boostMarkovPTherm: index: "<<index()<<", markovPListTherm["<<i<<"].P: "<<markovPListTherm[i].P<<", radCoolingBoost: "<<radCoolingBoost()<<", pMarkovPThermBoost: "<<pMarkovPThermBoost<<"\n";
  }

  //if (master()) cout<<"Cell::boostMarkovPTherm: index: "<<index()<<", pMarkovPThermBoost: "<<pMarkovPThermBoost<<"\n";

  // For each Markov transition
  for (i=0;i<markovPListTherm.size();i++) {
    // Calculate adjusted Markov transition probability
    if (markovPListTherm[i].nextState!=NULL) markovPListTherm[i].P=markovPListTherm[i].P*markovPListTherm[i].nextState->transPRBoost()/markovPThermBoost();
    else markovPListTherm[i].P=markovPListTherm[i].P*radCoolingBoost()/markovPThermBoost();
  }

  // Sort out Markov transitions above limit
  // Note, we should also correct the boost factor for this - Fix!!!
  markovPListWork=markovPListTherm; markovPListTherm.resize(0);
  for (i=0; i<markovPListWork.size(); i++) 
    if (markovPListWork[i].P>config->markovTableThermLim) markovPListTherm.push_back(markovPListWork[i]);
    
  // Renormalize Markov transition probability list
  PTot=0;
  for (i=0; i<markovPListTherm.size(); i++) PTot+=markovPListTherm[i].P;
  for (i=0; i<markovPListTherm.size(); i++)  markovPListTherm[i].P=markovPListTherm[i].P/PTot;
  if (master() and PTot<0.99) cout<<"Cell::boostMarkovPTherm: index: "<<index()<<", Warning: Total probability of transitions sorted out: "<<(1.0-PTot)<<", "<<markovPListTherm.size()<<" out of "<<markovPListWork.size()<<" transitions kept\n";;

  // Sort thermal Markov transition probability list in descending probability
  markovPListTherm.sort();
}

// Boost charge-transfer Markov transition probabilities
// Subcells: Works
// Containers: Not applicable
void Cell::boostMarkovPCT() {
  double PTot;
  MarkovPList markovPListWork;
  int i,j;

  // Reset boost factor
  markovPCTBoost.resize(0);
  markovPCTBoost.resize(2*ctReaction.size(),0);

  // For each (forward and backward) charge.transfer reaction
  for (i=0;i<markovPListCT.size();i++) {

    // Calculate boost factor
    for (j=0;j<markovPListCT[i].size();j++) {
      if (markovPListCT[i][j].nextState!=NULL) markovPCTBoost[i]+=markovPListCT[i][j].P*markovPListCT[i][j].nextState->transPRBoost();
      else markovPCTBoost[i]+=markovPListCT[i][j].P*radCoolingBoost();
    }

    //if (master()) cout<<"Cell::boostMarkovPCT: index: "<<index()<<", markovPCTBoost["<<i<<"]: "<<markovPCTBoost[i]<<"\n";
    
    // For each Markov transition
    for (j=0;i<markovPListCT[i].size();j++) {
      // Calculate adjusted Markov transition probability
      if (markovPListCT[i][j].nextState!=NULL) markovPListCT[i][j].P=markovPListCT[i][j].P*markovPListCT[i][j].nextState->transPRBoost()/markovPCTBoost[i];
      else markovPListCT[i][j].P=markovPListCT[i][j].P*radCoolingBoost()/markovPCTBoost[i];
    }

    // Sort out Markov transitions above limit
    // Note, we should also correct the boost factor for this - Fix!!!
    markovPListWork=markovPListCT[i]; markovPListCT[i].resize(0);
    for (j=0; j<markovPListWork.size(); j++) 
      if (markovPListWork[j].P>config->markovTableCTLim) markovPListCT[i].push_back(markovPListWork[j]);
    
    // Renormalize Markov transition probability list
    PTot=0;
    for (j=0; j<markovPListCT[i].size(); j++) PTot+=markovPListCT[i][j].P;
    for (j=0; j<markovPListCT[i].size(); j++) markovPListCT[i][j].P=markovPListCT[i][j].P/PTot;
    if (master() and PTot<0.99) cout<<"Cell::boostMarkovPCT: index: "<<index()<<", Warning: Total probability of transitions sorted out: "<<(1.0-PTot)<<", "<<markovPListCT[i].size()<<" out of "<<markovPListWork.size()<<" transitions kept\n";;
    
    // Sort thermal Markov transition probability list in descending probability
    markovPListCT[i].sort();
  }
}

// Boost opacity - New!
// Subcells: Works
// Containers: Not applicable
void Cell::boostKappa() {
  int i,j,k,l;

  // Boost bound-bound kappa
  boostBoundBoundKappa();

  // Boost bound-free opacity
  boostBoundFreeKappa();
  
  // Boost free-free opacity
  boostFreeFreeKappa();

  // Boost compton opacity
  boostComptonKappa();
}

// Boost bound-bound opacity - New!
// Subcells: Works
// Containers: Not applicable
void Cell::boostBoundBoundKappa() {
  int i,j,k,l;

  // For each bound state
  for (i=0;i<atom.size();i++)
    for (j=0;j<atom[i].iState.size();j++)
      for (k=0;k<atom[i].iState[j].bState.size();k++) {

	// Boost bound-bound opacity - Note: Does nothing - remove?
	for (l=0;l<atom[i].iState[j].bState[k].upTransBB.size();l++) atom[i].iState[j].bState[k].upTransBB[l]->boostKappa();
      }
}

// Boost bound-free opacity - New!
// Subcells: Works
// Containers: Not applicable
void Cell::boostBoundFreeKappa() {
  int i,j,k,l;

  // For each bound state
  for (i=0;i<atom.size();i++)
    for (j=0;j<atom[i].iState.size();j++)
      for (k=0;k<atom[i].iState[j].bState.size();k++) {

	// Boost bound-free opacity
	for (l=0;l<atom[i].iState[j].bState[k].upTransBF.size();l++) atom[i].iState[j].bState[k].upTransBF[l]->boostKappa();
      }

  // Update bound-free opacity boost factor table
  boundFreeKappaBoostTable();
}

// Boost free-free opacity - New!
// Subcells: Works
// Containers: Not applicable
void Cell::boostFreeFreeKappa() {

  // Set free-free opacity boost factor
  pFreeFreeKappaBoost=coolingBoost();

  //if (master()) cout<<"Cell::boostFreeFreeKappa: cell: "<<index()<<", pFreeFreeKappaBoost: "<<pFreeFreeKappaBoost<<"\n";
}

// Boost Compton opacity - New!
// Subcells: Works
// Containers: Not applicable
void Cell::boostComptonKappa() {

  // Set compton opacity boost factor
  pComptonKappaBoost=nonThermalBoost();

  //if (master()) cout<<"Cell::boostComptonKappa: cell: "<<index()<<", pComptonKappaBoost: "<<pComptonKappaBoost<<"\n";
}

// Get boost factor
// Subcells: Works
// Containers: Not applicable
double Cell::boostFactor(const double& _nu) {

  // Find boost bin
  FrequencyBinIterator nuBin=nuBoost.find(_nu);

  // If not found return a boost factor of 1
  if (nuBin==nuBoost.end()) return 1.0;

  // Calculate bin index
  int nuIndex=nuBin-nuBoost.begin();

  // Return boost factor
  return boost[nuIndex];
}

// Get free-free emissivity boost factor - New!
// Subcells: Works
// Containers: Not applicable
double Cell::freeFreeEtaBoost() { return pFreeFreeEtaBoost; }

// Get free-free opacity boost factor - New!
// Subcells: Works
// Containers: Not applicable
double Cell::freeFreeKappaBoost() { return pFreeFreeKappaBoost; }

// Get bound-free opacity boost factor - New!
// Subcells: Works
// Containers: Not applicable
double Cell::boundFreeKappaBoost(const double& _nu, EdgeType edgeType) {
  double kappaBoost=0;
  double nuMinTable=(nu.size()>0)?nu[0].min:nuInf,nuMaxTable=(nu.size()>0)?nu[nu.size()-1].max:0.0;

  // If within boost factor table range
  if (_nu>=nuMinTable and _nu<=nuMaxTable) {
    // Interpolate tabulated boost factor
    kappaBoost=pBoundFreeKappaBoostTable(nuEdge(_nu,edgeType));
  }
  // Else - Calculate boost factor
  else kappaBoost=boundFreeKappaBoostCalc(nuEdge(_nu,edgeType));
  
  return kappaBoost;
}

// Calculate bound-free opacity boost factor - New!
// Subcells: Works
// Containers: Not applicable
double Cell::boundFreeKappaBoostCalc(const double& _nu) {
  double P,PTot=0,kappaBoost=0;
  int i,j,k,l;

  // For each bound state
  for (i=0;i<atom.size();i++)
    for (j=0;j<atom[i].iState.size();j++)
      for (k=0;k<atom[i].iState[j].bState.size();k++) {
	// For each upward bound-free transition
	for (l=0;l<atom[i].iState[j].bState[k].upTransBF.size();l++) {

	  // Calculate (un-normalized) transition probability
	  P=atom[i].iState[j].bState[k].upTransBF[l]->kappa(_nu);

	  // Sum (un-normalized) transition probability
	  PTot+=P;

	  // Adjust and add to boost factor
	  kappaBoost+=P*atom[i].iState[j].bState[k].upTransBF[l]->kappaBoost();
	}
      }

  // Normalize boost factor
  if (PTot!=0) kappaBoost=kappaBoost/PTot;
  else kappaBoost=1.0;
 
  return kappaBoost;
}

// Create bound-free opacity boost factor table - New!
// Subcells: Works
// Containers: Not applicable
void Cell::boundFreeKappaBoostTable() {
  vector<double> nuWork;
  vector<FunctionValue> table(0);
  int i;

  // If no sampling frequencies - Reset table and return
  if (nu.size()==0) { pBoundFreeKappaBoostTable.init(table); return; }  
  
  // For each sampling frequency
  for (i=0; i<nu.size(); i++) {
    // If edge
    if (nu[i].edge) {
      // If major edge
      if (not nu[i].minorEdge) {
	// Add sampling frequencies on each side of the edge
	nuWork.push_back(nuEdge(nu[i].min,redEdge));
	nuWork.push_back(nuEdge(nu[i].min,blueEdge));
      }
    }
    // Else - add the sampling frequency
    else nuWork.push_back(nu[i].min);
  }

  // Add the last sampling frequency
  nuWork.push_back(nu[nu.size()-1].max);

  // Sort the sampling frequencies (to be on the safe side)
  sort(nuWork.begin(),nuWork.end());

  // Resize the opacity boost factor table
  table.resize(nuWork.size());

  // Calculate the bound-free opacity boost factors at the sampling frequencies
  for (i=0; i<nuWork.size(); i++) {
    table[i].x=nuWork[i];
    table[i].f=boundFreeKappaBoostCalc(nuWork[i]);
    //if (master() and index()==60) cout<<"Cell::boundFreeKappaBoostTable: index: "<<index()<<", lambda["<<i<<"]: "<<(c/table[i].x)/AA<<", kappaBoost["<<i<<"]: "<<table[i].f<<"\n";
  }
  
  // Create the bound-free opacity boost factor table
  pBoundFreeKappaBoostTable.init(table);
}

// Get compton opacity boost factor - New!
// Subcells: Works
// Containers: Not applicable
double Cell::comptonKappaBoost() { return pComptonKappaBoost; }

// Get bound-free cooling boost factor - New!
// Subcells: Works
// Containers: Not applicable
double Cell::boundFreeCoolingBoost() { return pBoundFreeCoolingBoost; }

// Get free-free cooling boost factor - New!
// Subcells: Works
// Containers: Not applicable
double Cell::freeFreeCoolingBoost() { return pFreeFreeCoolingBoost; }

// Get collisional cooling boost factor - New!
// Subcells: Works
// Containers: Not applicable
double Cell::collCoolingBoost() { return pCollCoolingBoost; }

// Get radiative cooling boost factor - New!
// Subcells: Works
// Containers: Not applicable
double Cell::radCoolingBoost() { return pRadCoolingBoost; }

// Get cooling boost factor - New!
// Subcells: Works
// Containers: Not applicable
double Cell::coolingBoost() { return pCoolingBoost; }

// Get non-thermal heating boost factor - New!
// Subcells: Works
// Containers: Not applicable
double Cell::nonThermalHeatingBoost() { return pNonThermalHeatingBoost; }

// Get non-thermal excitation boost factor - New!
// Subcells: Works
// Containers: Not applicable
double Cell::nonThermalExcBoost() { return pNonThermalExcBoost; }

// Get non-thermal ionization boost factor - New!
// Subcells: Works
// Containers: Not applicable
double Cell::nonThermalIonBoost() { return pNonThermalIonBoost; }

// Get non-thermal excitation/ionization boost factor - New!
// Subcells: Works
// Containers: Not applicable
double Cell::nonThermalExcIonBoost() { return pNonThermalExcIonBoost; }

// Get non-thermal deposition boost factor - New!
// Subcells: Works
// Containers: Not applicable
double Cell::nonThermalBoost() { return pNonThermalBoost; }

// Get thermal pool Markov transition probability boost factor - New!
// Subcells: Works
// Containers: Not applicable
double Cell::markovPThermBoost() { return pMarkovPThermBoost; }

// Draw cooling MC channel - New!
// Subcells: Works
// Containers: Not applicable
MCChannel Cell::coolingChannel(bool deActivate) {
  double totalCooling=0,totalCoolingBoost,z,P,PTot=0;

  // Pick random number between 0 and 1
  z=randomize(0,1);

  // Get total cooling
  if (config->freeFreeMacro) totalCooling+=freeFreeCooling();
  if (config->boundFreeMacro) totalCooling+=boundFreeCoolingSP();
  if (config->collMacro and (not deActivate)) totalCooling+=collCooling();
  if (config->chargeTransferMacro and (not deActivate)) totalCooling+=CTCooling();

  // Get cooling boost factor
  if (not deActivate) totalCoolingBoost=coolingBoost();
  else totalCoolingBoost=radCoolingBoost();

  // If free-free processes included
  if (config->freeFreeMacro) {

    // Calculate free-free cooling probability
    P=freeFreeCooling()/totalCooling;

    // If boost mode - Adjust free-free cooling probability
    if (config->boost) P=P*freeFreeCoolingBoost()/totalCoolingBoost;

    // If free-free cooling drawn
    if (z<=PTot+P) return cFreeFree;
    else PTot+=P;
  }

  // If bound-free processes included
  if (config->boundFreeMacro) {

    // Calculate (spontaneous) bound-free cooling probabily
    P=boundFreeCoolingSP()/totalCooling;

    // If boost mode - Adjust bound-free cooling probability
    if (config->boost) P=P*boundFreeCoolingBoost()/totalCoolingBoost;

    // If bound-free cooling drawn
    if (z<=PTot+P) return cBoundFree;
    else PTot+=P;
  }

  // If collisional processes included and no de-activation
  if (config->collMacro and (not deActivate)) {

    // Calculate collisional cooling probability
    P=collCooling()/totalCooling;

    // If boost mode - Adjust collisional cooling probability
    if (config->boost) P=P*collCoolingBoost()/totalCoolingBoost;

    // If collisional cooling drawn
    if (z<=PTot+P) return cCollisional;
    else PTot+=P;
  }

  // If charge-transfer processes included and no de-activation
  if (config->chargeTransferMacro and (not deActivate)) {

    // Calculate charge-transfer cooling probability
    P=CTCooling()/totalCooling;

    // If boost mode - Adjust charge-transfer cooling probability
    // Boost does not work with charge-transfer yet! Fix!
    //if (config->boost) P=P*CTCoolingBoost()/totalCoolingBoost;

    // If charge-transfer cooling drawn
    if (z<=PTot+P) return cChargeTransfer;
    else PTot+=P;
  }

  cout<<"Cell::coolingChannel: index: "<<index()<<", Error: No transition drawn\n";
  cout<<"Cell::coolingChannel: z: "<<z<<", PTot: "<<PTot<<"\n";

  // This should not happen!
  return cNone;
}

// Draw non-thermal MC channel - New!
// Subcells: Works
// Containers: Not applicable
MCChannel Cell::nonThermalChannel() {
  double totalDeposition=0,z,P,PTot=0;

  // Pick random number between 0 and 1
  z=randomize(0,1);

  // Get total gamma-ray/lepton energy deposition
  if (config->nonThermalMacro) totalDeposition+=nonThermalHeating();
  if (config->nonThermalMacro) totalDeposition+=nonThermalExcitation();
  if (config->nonThermalMacro) totalDeposition+=nonThermalIonization();

  // If non-thermal processes included and non-zero energy deposition
  if (config->nonThermalMacro and totalDeposition!=0) {

    // Calculate non-thermal heating probability
    P=nonThermalHeating()/totalDeposition;

    // If boost mode - Adjust non-thermal heating probability
    // Testing!
    if (config->boost) P=P*nonThermalHeatingBoost()/nonThermalBoost();

    // If non-thermal heating drawn
    if (z<=PTot+P) return cHeating;
    else PTot+=P;

    // Calculate non-thermal excitation probability
    P=nonThermalIonization()/totalDeposition;

    // If boost mode - Adjust non-thermal ionization probability
    // Testing!
    if (config->boost) P=P*nonThermalIonBoost()/nonThermalBoost();
    
    // If non-thermal ionization drawn
    if (z<=PTot+P) return cIonization;
    else PTot+=P;

    // Calculate non-thermal excitation probability
    P=nonThermalExcitation()/totalDeposition;

    // If boost mode - Adjust non-thermal heating probability
    // Testing!
    if (config->boost) P=P*nonThermalExcBoost()/nonThermalBoost();
    
    // If non-thermal excitation drawn
    if (z<=PTot+P) return cExcitation;
    else PTot+=P;
  }
  // Else - Force heating
  else return cHeating;

  cout<<"Cell::nonThermalChannel: index: "<<index()<<", Error: No transition drawn\n";
  cout<<"Cell::nonThermalChannel: z: "<<z<<", PTot: "<<PTot<<"\n";

  // This should not happen
  return cNone;
}

// Get memory allocated - New!
double Cell::mem() const {
  double _mem=sizeof(*this);
  int i,j;

  // Add memory allocated for each atom
  for (i=0;i<atom.size();i++) _mem+=atom[i].mem();

  // Add memory allocated for each charge-transfer reaction
  for (i=0;i<ctReaction.size();i++) _mem+=ctReaction[i].mem();

  // Add memory allocated for each subcell
  for (i=0;i<subCell.size();i++) _mem+=subCell[i]->mem();

  _mem+=pBoundFreeAbsKappaTable.mem();
  _mem+=pBoundFreeSTable.mem();
  _mem+=pBBFactorTable.mem();
  _mem+=pBMFactorTable.mem();

  // Ignore JInterpol - Not used

  _mem+=collExcitePList.mem();
  _mem+=CTExcitePList.mem();
  _mem+=nonThermalExcitePList.mem();
  _mem+=markovPListTherm.mem();
  for (i=0;i<markovPListCT.size();i++) _mem+=markovPListCT[i].mem();
  _mem+=pBoundFreeKappaBoostTable.mem();

  for (i=0;i<markovPCTBoost.size();i++) _mem+=sizeof(double);
  for (i=0;i<freeFreeEtaP.size();i++) _mem+=sizeof(double);
  for (i=0;i<majorEdge.size();i++) _mem+=sizeof(double);
  for (i=0;i<line.size();i++) _mem+=sizeof(TransBB*);
  for (i=0;i<edge.size();i++) _mem+=sizeof(TransBF*);

  // Ignore packetHistory - Not used

  for (i=0;i<nu.size();i++) _mem+=sizeof(FrequencyBin);
  for (i=0;i<mu.size();i++) _mem+=sizeof(AngleBin);
  for (i=0;i<Jnu.size();i++) _mem+=sizeof(double);
  for (i=0;i<Hnu.size();i++) _mem+=sizeof(double);
  for (i=0;i<Knu.size();i++) _mem+=sizeof(double);
  for (i=0;i<Inu.size();i++) for (j=0;j<Inu[i].size();j++) _mem+=sizeof(double);
  for (i=0;i<etaNu.size();i++) _mem+=sizeof(double);
  for (i=0;i<kappaJNu.size();i++) _mem+=sizeof(double);
  for (i=0;i<kappaNu.size();i++) _mem+=sizeof(double);
  for (i=0;i<nuMeanNu.size();i++) _mem+=sizeof(double);
  for (i=0;i<nuLine.size();i++) _mem+=sizeof(FrequencyBin);
  for (i=0;i<JLine.size();i++) _mem+=sizeof(double);
  for (i=0;i<nuBB.size();i++) _mem+=sizeof(FrequencyBin);
  for (i=0;i<nJ.size();i++) _mem+=sizeof(uint64_t);
  for (i=0;i<nJLine.size();i++) _mem+=sizeof(uint64_t);

  for (i=0;i<nuOld.size();i++) _mem+=sizeof(FrequencyBin);
  for (i=0;i<muOld.size();i++) _mem+=sizeof(AngleBin);
  for (i=0;i<JnuOld.size();i++) _mem+=sizeof(double);
  for (i=0;i<HnuOld.size();i++) _mem+=sizeof(double);
  for (i=0;i<KnuOld.size();i++) _mem+=sizeof(double);
  for (i=0;i<InuOld.size();i++) for (j=0;j<InuOld[i].size();j++) _mem+=sizeof(double);
  for (i=0;i<etaNuOld.size();i++) _mem+=sizeof(double);
  for (i=0;i<kappaJNuOld.size();i++) _mem+=sizeof(double);
  for (i=0;i<nuMeanNuOld.size();i++) _mem+=sizeof(double);
  for (i=0;i<nuLineOld.size();i++) _mem+=sizeof(FrequencyBin);
  for (i=0;i<JLineOld.size();i++) _mem+=sizeof(double);
  for (i=0;i<nuBBOld.size();i++) _mem+=sizeof(FrequencyBin);
  for (i=0;i<nJOld.size();i++) _mem+=sizeof(uint64_t);
  for (i=0;i<nJLineOld.size();i++) _mem+=sizeof(uint64_t);

  for (i=0;i<nuBoost.size();i++) _mem+=sizeof(FrequencyBin);
  for (i=0;i<boost.size();i++) _mem+=sizeof(double);

  return _mem;
}

// Get memory allocated for probability lists - New!
double Cell::memPList() const {
  double _mem=0;
  int i;

  // For each subcell - Add memory allocated for probability lists
  for (i=0;i<subCell.size();i++) _mem+=subCell[i]->memPList();

  // For each atom
  for (i=0;i<atom.size();i++) {
    // Add memory allocated for probability lists
    _mem+=atom[i].memPList();
  }  

  // Add memory allocated for cell probability lists
  _mem+=collExcitePList.mem();
  _mem+=CTExcitePList.mem();
  _mem+=nonThermalExcitePList.mem();
  _mem+=markovPListTherm.mem();
  for (i=0;i<markovPListCT.size();i++) _mem+=markovPListCT[i].mem();
  
  return _mem;
}

// Get memory allocated for bound-bound transitions - New!
double Cell::memTransBB() const {
  double _mem=0;
  int i;

  // For each subcell - Add memory allocated for bound-bound transitions
  for (i=0;i<subCell.size();i++) _mem+=subCell[i]->memTransBB();

  // For each atom
  for (i=0;i<atom.size();i++) {
    // Add memory allocated for bound-bound transitions
    _mem+=atom[i].memTransBB();
  }  

  return _mem;
}

// Get memory allocated for bound-free transition - New!
double Cell::memTransBF() const {
  double _mem=0;
  int i;

  // For each subcell - Add memory allocated for probability lists
  for (i=0;i<subCell.size();i++) _mem+=subCell[i]->memTransBF();

  // For each atom
  for (i=0;i<atom.size();i++) {
    // Add memory allocated for bound-free transitions
    _mem+=atom[i].memTransBF();
  }  

  return _mem;
}

// Update ARTIS (re-normalization) factors - New!
/*void updateArtisFactors() {
  RadEstimator radEstimator;
  vector <vector<double> > RL(atom.size());
  vector <vector<double> > HL(atom.size());
  vector <vector<double> > RDBB(atom.size());
  vector <vector<double> > HDBB(atom.size());
  double RFactor,HFactor,transNu;
  int i,j;

  // Backup radiation field estimator
  radEstimator=config.radEstimator;

  // Set radiation field estimator to Lucy
  config.radEstimator=rfLucy;

  // Reset!

  // For each ion ground state
  for (i=0;i<atom.size();i++) {
    // Resize vectors
    RL[i].resize(atom[i].iState.size());
    HL[i].resize(atom[i].iState.size());
    for (j=0;j<atom[i].iState.size();j++) {
      // Store upward bound-free transition and heating rate
      RL[i][j]=atom[i].iState[j].bState[0].upTansBF[0].R();
      HL[i][j]=atom[i].iState[j].bState[0].heating();
    }
  }

  // Set radiation field estimator to DBB
  config.radEstimator=rfDBB;

  // For each ion ground state
  for (i=0;i<atom.size();i++) {
    // Resize vectors
    RDBB[i].resize(atom[i].iState.size());
    HDBB[i].resize(atom[i].iState.size());
    for (j=0;j<atom[i].iState.size();j++) {
      // Store upward bound-free transition and heating rate      
      RDBB[i][j]=atom[i].iState[j].bState[0].upTansBF[0].R();
      HDBB[i][j]=atom[i].iState[j].bState[0].heating();
    }
  }

  // Reset!

  // For each ion ground state
  for (i=0;i<atom.size();i++) 
    for (j=0;j<atom[i].iState.size();j++) {
      // Calculate ARTIS re-normalization factors
      RFactor=RL[i][j]/RDBB[i][j];
      HFactor=HL[i][j]/HDBB[i][j];
      // Get transition frequency
      transNu=atom[i].iState[j].bState[0].upTansBF[0].nu();
      // Insert ARTIS re-normalization factors in lists
      artisRFactorList.insert(RFactor,transNu);
      artisHFactorList.insert(HFactor,transNu);
    }  

  // Restore radiation estimator
  config.radEstimator=radEstimator;
  }*/

// Constructor
CellSS::CellSS(MStateSolver* _mStateSolver, EOS* _eos, CellConfig* _config, boost::mpi::communicator* _mpiCom) : pFBack(0), pFFront(0), pFObsBack(0), pFObsFront(0), Cell(_mStateSolver,_eos,_config,_mpiCom) { // Changed!
}

// Copy constructor
CellSS::CellSS(const CellSS& cell) : prMin(cell.prMin), prMax(cell.prMax), pFBack(cell.pFBack), pFFront(cell.pFFront), pFObsBack(cell.pFObsBack), pFObsFront(cell.pFObsFront), Cell(cell) { 
  //cout<<"CellSS::CellSS, index: "<<index()<<"\n";
}

// Assigment operator
CellSS& CellSS::operator=(const CellSS& cell) {
  if (&cell!=this) {
    Cell::operator=(cell);
    prMin=cell.prMin;
    prMax=cell.prMax;
    pFBack=cell.pFBack;
    pFFront=cell.pFFront;
    pFObsBack=cell.pFObsBack;
    pFObsFront=cell.pFObsFront;
  }
}

// Destructor
CellSS::~CellSS() {
}

// Get inner border
// Containers: Works
// Subcells: Works
double CellSS::rMin() const {
  return prMin;
}

// Get inner border
// Containers: Works
// Subcells: Works
double CellSS::rMinV(bool virtualCell) {
  if (virtualCell) return 0.0;
  else return prMin;
}

// Get inner border (time-dependet version) - Changed!
// Containers: Works
// Subcells: Works
double CellSS::rMinT(double _t, bool virtualCell) {
  double expFactor=(config->steadyState or _t==noTime)?1.0:_t/t();
  return rMinV(virtualCell)*expFactor;
}

// Set inner border
// Containers: Works
// Subcells: Works
void CellSS::rMin(const double& _rMin) {
  prMin=_rMin;
}

// Get outer border - Changed!
// Containers: Works
// Subcells: Works
double CellSS::rMax() const {
  return prMax;
}

// Get outer border - Changed!
// Containers: Works
// Subcells: Works
double CellSS::rMaxV(bool virtualCell) {
  if (virtualCell) return pow(V()/((4.0/3.0)*pi*nCells()),1.0/3.0);
  else return prMax;
}

// Get outer border (time-dependet version) - Changed!
// Containers: Works
// Subcells: Works
double CellSS::rMaxT(double _t, bool virtualCell) {
  double expFactor=(config->steadyState or _t==noTime)?1.0:_t/t();
  return rMaxV(virtualCell)*expFactor;
}

// Set outer border
// Containers: Works
// Subcells: Works
void CellSS::rMax(const double& _rMax) {
  prMax=_rMax;
}

// Get flux at inner border
// Containers: Works
// Subcells: Works
double CellSS::FBack() const {
  // Testing!
  //if (master()) cout<<"CellSS::FBack(get): index: "<<index()<<", F: "<<pFBack<<"\n";
  return pFBack;
}

// Set flux at inner border
// Containers: Works
// Subcells: Works
void CellSS::FBack(const double& _FBack) {
  pFBack=_FBack;
  // Testing!
  //if (master()) cout<<"CellSS::FBack(set): index: "<<index()<<", F: "<<pFBack<<"\n";
}

// Get flux at outer border
// Containers: Works
// Subcells: Works
double CellSS::FFront() const {
  // Testing!
  //if (master()) cout<<"CellSS::FFront(get): index: "<<index()<<", F: "<<pFFront<<"\n";
  return pFFront;
}

// Set flux at outer border
// Containers: Works
// Subcells: Works
void CellSS::FFront(const double& _FFront) {
  pFFront=_FFront;
  // Testing!
  //if (master()) cout<<"CellSS::FFront(set): index: "<<index()<<", F: "<<pFFront<<"\n";
}

// Get observed flux at inner border
// Containers: Works
// Subcells: Works
double CellSS::FObsBack() const {
  return pFObsBack;
}

// Set observed flux at inner border
// Containers: Works
// Subcells: Works
void CellSS::FObsBack(const double& _FObsBack) {
  pFObsBack=_FObsBack;
}

// Get observed flux at outer border
// Containers: Works
// Subcells: Works
double CellSS::FObsFront() const {
  return pFObsFront;
}

// Set observed flux at outer border
// Containers: Works
// Subcells: Works
void CellSS::FObsFront(const double& _FObsFront) {
  pFObsFront=_FObsFront;
}

// Get luminosity at inner border
// Containers: Works
// Subcells: Works
double CellSS::LBack() const {
  // Testing!
  if (master()) cout<<"CellSS::LBack: index: "<<index()<<", L: "<<4*pi*pow(rMin(),2)*pow(fillFactor(),2.0/3.0)*FBack()<<", r: "<<rMin()<<", fillFactor: "<<fillFactor()<<"\n";
  return 4*pi*pow(rMin(),2)*pow(fillFactor(),2.0/3.0)*FBack(); // Changed!
}

// Get luminosity at outer border
// Containers: Works
// Subcells: Works
double CellSS::LFront() const {
  // Testing!
  if (master()) cout<<"CellSS::LFront: index: "<<index()<<", L: "<<4*pi*pow(rMax(),2)*pow(fillFactor(),2.0/3.0)*FFront()<<", r: "<<rMax()<<", fillFactor: "<<fillFactor()<<"\n";
  return 4*pi*pow(rMax(),2)*pow(fillFactor(),2.0/3.0)*FFront(); // Changed!
}

// In cell (overloaded) - Changed!
// Containers: Works
// Subcells: Works
bool CellSS::inCell(const Vector3D& position, double _t, bool virtualCell) {
  double r=position.norm();
  if (r>=rMinT(_t,virtualCell) && r<=rMaxT(_t,virtualCell) && _t>=ptMin && _t<=ptMax) return true; // Changed!
  return false;
}

// Calculate distance to cell border (overloaded) - Changed!
// Containers: Works
// Subcells: Works
double CellSS::borderDistance(const Vector3D& position, const Vector3D& direction, BorderType& borderType, double _t, bool virtualCell, bool log) {
  if (config->steadyState or _t==noTime) return borderDistanceSteady(position,direction,borderType,virtualCell,log);
  else return borderDistanceTime(position,direction,borderType,_t,virtualCell,log);
}

// Calculate distance to cell border (steady-state version) - Changed!
// Containers: Works
// Subcells: Works
double CellSS::borderDistanceSteady(const Vector3D& position, const Vector3D& direction, BorderType& borderType, bool virtualCell, bool log) {
  double mu, muMax, rootMin, rootMax, dMax, dMin, d;

  // Testing!!!
  //if (index()==6) cout<<"CellSS::borderDistanceSteady: index: "<<index()<<"\n";

  // Calculate cosine of polar angle (about inward radius vector)
  mu=(direction*(-position))/position.norm();
  // Calculate cosine of maximum polar angle (about inward radius vector) to cross inner border
  muMax=sqrt(1-pow(rMinV(virtualCell)/position.norm(),2)); // Changed!
  //if (log) cout<<"CellSS::borderDistanceSteady: mu: "<<mu<<", muMax: "<<muMax<<"\n";
  // If inner border crossed
  if (mu>muMax) {
    // Calculate distance to inner border
    root_2p(direction*direction,2*(position*direction),(position*position)-pow(rMinV(virtualCell),2),rootMin,rootMax); // Changed!
    d=rootMin*pfExp;
    // Set border type - New!
    if (type()==cellSub) borderType=btSubCellBorder;
    else borderType=btCellBorderInner;
  }
  // If outer bundary crossed
  else {
    // Calculate distance to outer border
    root_2p(direction*direction,2*(position*direction),(position*position)-pow(rMaxV(virtualCell),2),rootMin,rootMax); // Changed!
    d=rootMax*pfExp;
    // Set border type - New!
    if (type()==cellSub) borderType=btSubCellBorder;
    else borderType=btCellBorderOuter;
  }

  return d;
}

// Calculate distance to cell border (time-dependent version) - Changed! - Removed! - Testing!!! - Back in use! - Testing!!!
// This function need to be tested properly !!!
// Containers: Works
// Subcells: Works
double CellSS::borderDistanceTime(const Vector3D& position, const Vector3D& direction, BorderType& borderType, double _t, bool virtualCell, bool log) {
  double rd,r,mu,muMax,vMin,vMax,rootMin,rootMax,d;

  // Calculate scalar product of position and distance;
  rd=(position*direction);
  // Calculate norm of position
  r=position.norm();
  // Calculate cosine of polar angle (about inward radius vector)
  mu=-rd/r;
  // Calculate velocities at cell borders (assuming homologous expansion)
  vMin=rMinV(virtualCell)/t(); // Changed!
  vMax=rMaxV(virtualCell)/t(); // Changed!
  // Calculate cosine of maximum polar angle (about inward radius vector) to cross inner border
  root_2p_fast_2(pow(c,2)+pow(vMin,2),2*pow(vMin,2)*_t,pow(vMin*_t,2)-pow(r,2),rootMin,rootMax);
  muMax=c*rootMax/r;
  //if (log) cout<<"CellSS::borderDistanceTime: mu: "<<mu<<", muMax: "<<muMax<<", c*rootMin/r: "<<c*rootMin/r<<"\n";
  // If inner border crossed
  if (mu>muMax) {
    // Calculate distance to inner border
    root_2p_fast_2(pow(c,2)-pow(vMin,2),2*c*rd-2*pow(vMin,2)*_t,pow(r,2)-pow(vMin*_t,2),rootMin,rootMax);
    d=c*rootMin*pfExp;
    //if (log) cout<<"CellSS:borderDistanceTime: d: "<<d<<", c*rootMax: "<<c*rootMax<<"\n";
    // Set border type - New!
    if (type()==cellSub) borderType=btSubCellBorder;
    else borderType=btCellBorderInner;
  }
  // If outer bundary crossed
  else {
    // Calculate distance to outer border
    root_2p_fast_2(pow(c,2)-pow(vMax,2),2*c*rd-2*pow(vMax,2)*_t,pow(r,2)-pow(vMax*_t,2),rootMin,rootMax);
    d=c*rootMax*pfExp;
    //if (log) cout<<"CellSS:borderDistanceTime: d: "<<d<<", c*rootMin: "<<c*rootMin<<"\n";
    // Set border type - New!
    if (type()==cellSub) borderType=btSubCellBorder;
    else borderType=btCellBorderOuter;
  }
  // If not steady state
  if (!config->steadyState) 
    // If temporal border crossed
    if (c*(ptMax-_t)<d) {
      d=c*(ptMax-_t);
      // Set border type - New!
      borderType=btTimeBorder;
      }

  // Testing!!!
  /*if ((index()==6 or index()==700 or index()==701) and master() and omp_get_thread_num()==0) {
    Vector3D step=direction*d;
    Vector3D newPosition=position+step;
    cout<<"CellSS::borderDistanceTime: index: "<<index()<<", r: "<<r<<", mu: "<<(-mu)<<", rNew: "<<newPosition.norm()<<", rMin: "<<rMinT(_t,virtualCell)<<", rMax: "<<rMaxT(_t,virtualCell)<<", t: "<<_t<<", borderType: "<<borderType<<"\n";
    }*/
  
  return d;
}

// Calculate distance to cell border (time-dependent version) - New version! - Testing!!! - Removed! - Testing!!!
// This function need to be tested properly !!!
// Containers: Works
// Subcells: Works
/*double CellSS::borderDistanceTime(const Vector3D& position, const Vector3D& direction, BorderType& borderType, double _t, bool virtualCell, bool log) {
  double rd,r,vMin,vMax,vMin2,vMax2,c2,r2,t2,rootMin,rootMax,aa,bb,cc,d,dt=1e99;

  // Calculate scalar product of position and distance;
  rd=(position*direction);
  // Calculate norm of position
  r=position.norm();
  // Calculate velocity (and power of it) at outer cell border (assuming homologous expansion)
  vMax=rMaxV(virtualCell)/t(); vMax2=vMax*vMax; 
  // If outside cell - Set border-type and return zero distance
  if (r<vMin*_t or r>vMax*_t) { borderType=virtualCell?btSubCellBorder:btCellBorder; return 0.0; }
  // Calculate powers of other quantities used
  c2=c*c; r2=r*r; t2=_t*_t;
  // Calculate outer-border-crossing equation coefficients
  aa=c2-vMax2; bb=2*(c*rd-vMax2*_t); cc=r2-vMax2*t2;
  // Solve outer-border-crossing equation
  root_2p_fast_2(aa,bb,cc,rootMin,rootMax);
  // Select smallest non-negative solution
  if (rootMin<dt and rootMin>=0) { dt=rootMin; borderType=virtualCell?btSubCellBorder:btCellBorderOuter; }
  if (rootMax<dt and rootMax>=0) { dt=rootMax; borderType=virtualCell?btSubCellBorder:btCellBorderOuter; }
  // If not virtual cell
  if (not virtualCell) {
    // Calculate velocity (and power of it) at inner cell border (assuming homologous expansion)
    vMin=rMinV(virtualCell)/t(); vMin2=vMin*vMin;
    // Calculate polynomial coefficients
    aa=c2-vMin2; bb=2*(c*rd-vMin2*_t); cc=r2-vMin2*t2;
    // If (real) solution exist
    if (bb*bb>=4*aa*cc) {
      // Calculate time to cross inner border
      root_2p_fast_2(aa,bb,cc,rootMin,rootMax);
      // Select smallest non-negative solution
      if (rootMin<dt and rootMin>=0) { dt=rootMin; borderType=btCellBorderInner; }
      if (rootMax<dt and rootMax>=0) { dt=rootMax; borderType=btCellBorderInner; }
    }
  }
  // Calculate distance to border
  d=c*dt*pfExp;
  // If not steady state
  if (!config->steadyState) 
    // If temporal border crossed
    if (c*(ptMax-_t)<d) {
      d=c*(ptMax-_t);
      // Set border type - New!
      borderType=btTimeBorder;
    }

  return d;
  }*/

// Get volume (overloaded)
// Containers: Works
// Subcells: Works
double CellSS::V(double _t) {
  return (4.0/3.0)*pi*(pow(rMaxT(_t),3)-pow(rMinT(_t),3))*fillFactor(); // Changed!
}

// Get random direction
// Containers: Works
// Subcells: Works
Vector3D CellSS::randomDirection(const CellLocation& cellLocation) {
  double theta,phi;

 // Switch on cell location
  switch (cellLocation) {
  case cellBorder :
    // Select a random polar angle
    theta=acos(2*randomize(0,1)-1);
    // Select a random equatorial angle
    phi=pi/2+pi*randomize(0,1);
    // Break
    break;
  case cellInterior :
    // Select a random polar angle
    theta=acos(2*randomize(0,1)-1);
    // Select a random equatorial angle for the virtual direction
    phi=2*pi*randomize(0,1);
    // Break
    break;
  }

  return Vector3D(1,theta,phi,spherical);
}

// Get random position - Changed!
// Containers: Works
// Subcells: Works
Vector3D CellSS::randomPosition(const CellLocation& cellLocation, double _t, bool virtualCell) {
  double r,theta,phi,p; // Changed!
  double mu; // Testing!
  double small=1e-10;
  bool critical=false;

  // Switch on cell location
  switch (cellLocation) {
  case cellBorder : // Changed!
    // Select random impact paramter
    p=pow(randomize(0,1),1.0/2.0);
    // Calculate polar angle
    theta=pi-asin(p);
    // Select a random polar angle - Following Jerkstrand et al. 2011 - Testing!!
    //mu=randomize(0,1);
    //theta=pi-acos(mu);
    // Select a random equatorial angle
    phi=2*pi*randomize(0,1);
    // Set the radius
    r=rMaxT(_t,virtualCell)*(1.0-small); // Changed!
    // Break
    break;
  case cellInterior :
    // Select a random polar angle
    theta=acos(2*randomize(0,1)-1);
    // Select a random equatorial angle for the virtual direction
    phi=2*pi*randomize(0,1);
    // Select a random radius
    r=pow(pow(rMinT(_t,virtualCell),3)+(pow(rMaxT(_t,virtualCell),3)-pow(rMinT(_t,virtualCell),3))*randomize(0,1),1.0/3.0); // Changed!
    // Break
    break;
  }

  return Vector3D(r,theta,phi,spherical);
}

// Get typical size of cell
// Containers: Works
// Subcells: Works (but see below)
double CellSS::size() {
  // Note: This power of the filling-factor (1) is only appropriate for a thin shell - Improve!
  return (rMax()-rMin())*fillFactor();
}

// Update radiation state for container (overloaded) - New!
// Subcells: Not applicable
// Containers: Works
void CellSS::updateRadiationStateContainer(const FrequencyBinList& _nu) {
  int i,j,jj;

  // Update base class radiation state
  Cell::updateRadiationStateContainer(_nu);

  // For each subcell
  for (i=0;i<subCell.size();i++) {
    // Area-average flux
    pFBack+=((CellSS*) subCell[i])->FBack()*pow(subCell[i]->fillFactor(),2.0/3.0);
    pFFront+=((CellSS*) subCell[i])->FFront()*pow(subCell[i]->fillFactor(),2.0/3.0);
    pFObsBack+=((CellSS*) subCell[i])->FObsBack()*pow(subCell[i]->fillFactor(),2.0/3.0);
    pFObsFront+=((CellSS*) subCell[i])->FObsFront()*pow(subCell[i]->fillFactor(),2.0/3.0);
  }
}

// Scale radiation field (with expansion factor)
// Containers: Works
// Subcells: Works
void CellSS::scaleRadiationField(const double& expFactor, bool expCooling) { // Changed!
  int exponent=(expCooling?3:2); // New!

  // Scale base class radiation field
  Cell::scaleRadiationField(expFactor);

  // Scale flux with expansion factor
  pFBack=pFBack/pow(expFactor,exponent);
  pFFront=pFFront/pow(expFactor,exponent);
  pFObsBack=pFObsBack/pow(expFactor,exponent);
  pFObsFront=pFObsFront/pow(expFactor,exponent);
}

// Reset MC statistics
// Containers: Works
// Subcells: works
void CellSS::resetMCStatistics(const FrequencyBinList& _nu) {

  //if (master()) cout<<"CellSS::resetMCStatistics: index: "<<index()<<"\n";

  // Reset base class MC statistics
  Cell::resetMCStatistics(_nu);

  pFBack=0;
  pFFront=0;
  pFObsBack=0;
  pFObsFront=0;
}

// Update MC statistics (using a single ray) - Changed!
// Containers: Not applicable
// Subcells: Works
void CellSS::updateMCStatistics(const PacketEvent& startPoint, const PacketEvent& endPoint, MCUpdateInfo& updateInfo) {
  double _t,sign;

  // Update base class MC statistics
  Cell::updateMCStatistics(startPoint,endPoint,updateInfo);

  // Note: No check for packet type done (as this is not possible). Is this ok?

  // If endpoint inner border crossing
  if (endPoint.type==evCellCrossingInner) {
    // Get flux sign
    sign=(startPoint.type==evCellCrossingOuter and startPoint.cellIndex!=endPoint.cellIndex)?1.0:-1.0; // Changed!
    // Update inner border flux
    if (config->radEstimatorExp) _t=endPoint.t; else _t=t();
    pFBack+=sign*endPoint.ECMF/(4*pi*pow(rMinT(_t),2)*pow(fillFactor(),2.0/3.0)*(ptMax-ptMin)); // Changed!
    pFObsBack+=sign*endPoint.E/(4*pi*pow(rMinT(_t),2)*pow(fillFactor(),2.0/3.0)*(ptMax-ptMin)); // Changed!
  }
  
  // If endpoint outer border crossing
  if (endPoint.type==evCellCrossingOuter) {
    // Get flux sign
    sign=(startPoint.type==evCellCrossingInner and startPoint.cellIndex!=endPoint.cellIndex)?-1.0:1.0; // Changed!
    // Update outer border flux
    if (config->radEstimatorExp) _t=endPoint.t; else _t=t();
    pFFront+=sign*endPoint.ECMF/(4*pi*pow(rMaxT(_t),2)*pow(fillFactor(),2.0/3.0)*(ptMax-ptMin)); // Changed!
    pFObsFront+=sign*endPoint.E/(4*pi*pow(rMaxT(_t),2)*pow(fillFactor(),2.0/3.0)*(ptMax-ptMin)); // Changed!
  }

  // If startpoint inner bounday crossing
  if (startPoint.type==evBoundaryCrossing) {
    // Update inner border flux
    if (config->radEstimatorExp) _t=startPoint.t; else _t=t();
    pFBack+=startPoint.ECMF/(4*pi*pow(rMinT(_t),2)*pow(fillFactor(),2.0/3.0)*(ptMax-ptMin)); // Changed!
    pFObsBack+=startPoint.E/(4*pi*pow(rMinT(_t),2)*pow(fillFactor(),2.0/3.0)*(ptMax-ptMin)); // Changed!
  }
}

// Synchronize MC statistics (MPI)
// Subcells: Works
// Containers: Not applicable
void CellSS::syncMCStatistics() {
  boost::mpi::request request[2*(mpiCom->size()-1)];
  vector<MCStatMPISS> collected(mpiCom->size()-1);
  MCStatMPISS mCStat;
  int i,j=0,k=0;

  // Synchronize base class MC statistics
  Cell::syncMCStatistics();

  // Pack MC statistics
  mCStat.FBack=pFBack;
  mCStat.FFront=pFFront;
  mCStat.FObsBack=pFObsBack;
  mCStat.FObsFront=pFObsFront;

  // For each process
  for (i=0;i<mpiCom->size();i++) {
    // If not self
    if (i!=mpiCom->rank()) {
      // Deliver MC statistics (non-blocking)
      request[j]=mpiCom->isend(i,mCellSSMCStat,mCStat);
      j++;
    }
  }

  // For each process
  for (i=0;i<mpiCom->size();i++) {
    // If not self
    if (i!=mpiCom->rank()) {
      // Collect MC statistics (non-blocking)
      request[j]=mpiCom->irecv(i,mCellSSMCStat,collected[k]);
      j++; k++;
    }
  }

  // Wait for all MPI requests to complete
  boost::mpi::wait_all(request,request+2*(mpiCom->size()-1));

  // Unpack and sum MC statistics
  for (i=0;i<collected.size();i++) {
    pFBack+=collected[i].FBack;
    pFFront+=collected[i].FFront;
    pFObsBack+=collected[i].FObsBack;
    pFObsFront+=collected[i].FObsFront;
  }
}

// Export statistics
// Subcells: Works
// Containers: Works
void CellSS::exportStat(YAML::Emitter& data, const double& tauLim, string prefix, bool close) {

  // Export base class data (whithout closing the map)
  Cell::exportStat(data,tauLim,prefix,false);

  // Export rMin
  data<<YAML::Key<<"rMin"<<YAML::Value<<rMin();

  // Export rMax
  data<<YAML::Key<<"rMax"<<YAML::Value<<rMax();
  
  // Export flux at inner border
  data<<YAML::Key<<"FBack"<<YAML::Value<<FBack();

  // Export flux at outer border
  data<<YAML::Key<<"FFront"<<YAML::Value<<FFront();

  // Export observed flux at inner border
  data<<YAML::Key<<"FObsBack"<<YAML::Value<<FObsBack();

  // Export observed flux at outer border
  data<<YAML::Key<<"FObsFront"<<YAML::Value<<FObsFront();

  // Close map if requested
  if (close) data<<YAML::EndMap;
}

// Deprecated!
void CellSS::exportStatistics(ofstream& file, const double& tauLimit) {
  file<<"#";
  file<<"\trMin\trMax";
  file<<"\n";
  file<<"\t"<<setprecision(10)<<prMin;
  file<<"\t"<<setprecision(10)<<prMax;
  file<<"\n";

  Cell::exportStatistics(file,tauLimit);
}

// Load Cell data (overloaded)
// Subcells: Not applicable
// Containers: Works
void CellSS::load(pstring& cellPData, AtomDataList& atomDataList, GridFactory* gridFactory, TransBBSelector* transSelector, BStateSelector* bStateSelector) {
  string value;
  pstring atomPData,subCellPData;
  double VSubCell;
  int i,nAtoms,nSubCells;

  // Load base class data
  Cell::load(cellPData, atomDataList, gridFactory, transSelector, bStateSelector);

  // If normal cell or cell container
  if (pType==cellNormal or pType==cellContainer) {
    // Get prMin
    value=cellPData.getData("rMin");
    prMin=atof(value.c_str());
    // Error handling
    if (value.size()==0) {cout<<"CellSS::load: Error: Could not get rMin\n"; return;}
    if (master()) cout<<"rMin="<<prMin<<"\n";
    // Get prMax
    value=cellPData.getData("rMax");
    prMax=atof(value.c_str());
    // Error handling
    if (value.size()==0) {cout<<"CellSS::load: Error: Could not get rMax\n"; return;}
    if (master()) cout<<"rMax="<<prMax<<"\n";
    // If cell container
    if (pType==cellContainer) {
      // For each sub cell
      for (i=0;i<subCell.size();i++) {
	// Set sub cell rMin - Changed!
	((CellSS*) subCell[i])->prMin=prMin;
	// Set sub cell rMax - Changed!
	((CellSS*) subCell[i])->prMax=prMax;
      }
    }
  }
  
  return;
}

// Load Cell data (overloaded)
// Not used!
void CellSS::loadYAML(const YAML::Node& data, AtomDataList& atomDataList, GridFactory* gridFactory, TransBBSelector* transSelector, BStateSelector* bStateSelector) {
  double VSubCell;
  int i;

  // Load base class data
  Cell::loadYAML(data, atomDataList, gridFactory, transSelector, bStateSelector);

  // If normal cell or cell container
  if (pType==cellNormal or pType==cellContainer) {

    // Get rMin
    if (data["rMin"]) prMin=data["rMin"].as<double>();
    else {cout<<"CellSS::load: Error: Could not get rMin\n"; exit(-1);}

    // Get rMax
    if (data["rMax"]) prMin=data["rMax"].as<double>();
    else {cout<<"CellSS::load: Error: Could not get rMax\n"; exit(-1);}

    // If cell container
    if (pType==cellContainer) {

      // For each sub cell
      for (i=0;i<subCell.size();i++) {
	// Set sub cell rMin - Changed!
	((CellSS*) subCell[i])->prMin=prMin;
	// Set sub cell rMax - Changed!
	((CellSS*) subCell[i])->prMax=prMax;
      }
    }
  }
  
  return;
}

// Load Cell state (overloaded)
// Subcells: Works
// Containers: Works
void CellSS::loadState(const YAML::Node& data, bool loadIState, bool loadBState, bool loadRState) {

  // Get rMin
  if (data["rMin"]) prMin=data["rMin"].as<double>();
  else {cout<<"CellSS::loadState: Error: Could not get rMin\n"; exit(-1);}
  
  // Get rMax
  if (data["rMax"]) prMax=data["rMax"].as<double>();
  else {cout<<"CellSS::loadState: Error: Could not get rMax\n"; exit(-1);}

  // Load base class state
  Cell::loadState(data,loadIState,loadBState,loadRState);

  return;
}

// Load Cell state (overloaded)
// Subcells: Works
// Containers: Not applicable
void CellSS::loadStateContainer(const YAML::Node& data, bool loadIState, bool loadBState, bool loadRState) {

  // Load base class radiation state
  Cell::loadStateContainer(data,loadIState,loadBState,loadRState);

  // If container border fluxes provided - Use these! - Kind of a hack!

  // If provided - Get flux at inner border
  if (data["FBack"]) pFBack=data["FBack"].as<double>();
  
  // If provided - Get flux at outer border
  if (data["FFront"]) pFFront=data["FFront"].as<double>();

  // If provided - Get observed flux at inner border
  if (data["FObsBack"]) pFObsBack=data["FObsBack"].as<double>();
  
  // If provided - Get observed flux at outer border
  if (data["FObsFront"]) pFObsFront=data["FObsFront"].as<double>();
  
  return;
}

// Load Cell state (overloaded)
// Subcells: Works
// Containers: Not applicable
void CellSS::loadRadiationState(const YAML::Node& data) {

  // Get flux at inner border
  if (data["FBack"]) pFBack=data["FBack"].as<double>();
  else {cout<<"CellSS::loadRadiationState: Error: Could not get FBack\n"; exit(-1);}
  
  // Get flux at outer border
  if (data["FFront"]) pFFront=data["FFront"].as<double>();
  else {cout<<"CellSS::loadRadiationState: Error: Could not get FFront\n"; exit(-1);}

  // Get observed flux at inner border
  if (data["FObsBack"]) pFObsBack=data["FObsBack"].as<double>();
  
  // Get observed flux at outer border
  if (data["FObsFront"]) pFObsFront=data["FObsFront"].as<double>();

  // Load base class radiation state
  Cell::loadRadiationState(data);
  
  return;
}

// Save Cell data (overloaded)
// Not used!
void CellSS::save(YAML::Emitter& data, bool close) const {

  // Save base class data (without closing the map)
  Cell::save(data,false);

  // If normal cell or cell container
  if (pType==cellNormal or pType==cellContainer) {

    // Save rMin
    data<<YAML::Key<<"rMin"<<YAML::Value<<rMin();

    // Save rMax
    data<<YAML::Key<<"rMax"<<YAML::Value<<rMax();
  } 

  // Close cell map if requested
  if (close) data<<YAML::EndMap;
}

// Save Cell state (overloaded)
// Subcells: Works
// Containers: Works
void CellSS::saveState(YAML::Emitter& data, string prefix, bool close) {

  // If container - Save state for container and subcells and return - New!
  if (type()==cellContainer) { saveStateContainer(data,prefix,close); return; }

  // Save base class data (whithout closing the map)
  Cell::saveState(data,prefix,false);

  // Save rMin
  data<<YAML::Key<<"rMin"<<YAML::Value<<rMin();

  // Save rMax
  data<<YAML::Key<<"rMax"<<YAML::Value<<rMax();
  
  // Save flux at inner border
  data<<YAML::Key<<"FBack"<<YAML::Value<<FBack();

  // Save flux at outer border
  data<<YAML::Key<<"FFront"<<YAML::Value<<FFront();

  // Save observed flux at inner border
  data<<YAML::Key<<"FObsBack"<<YAML::Value<<FObsBack();

  // Save observed flux at outer border
  data<<YAML::Key<<"FObsFront"<<YAML::Value<<FObsFront();

  // Close map if requested
  if (close) data<<YAML::EndMap;
}

// Save Cell state for container (overloaded)
// Subcells: Not applicable
// Containers: Works
void CellSS::saveStateContainer(YAML::Emitter& data, string prefix, bool close) {

  // Save base class data (whithout closing the map)
  Cell::saveStateContainer(data,prefix,false);

  // Save rMin
  data<<YAML::Key<<"rMin"<<YAML::Value<<rMin();

  // Save rMax
  data<<YAML::Key<<"rMax"<<YAML::Value<<rMax();

  // Save container border fluxes - Kind of a hack!

  // Save flux at inner border 
  data<<YAML::Key<<"FBack"<<YAML::Value<<FBack();

  // Save flux at outer border
  data<<YAML::Key<<"FFront"<<YAML::Value<<FFront();

  // Save observed flux at inner border
  data<<YAML::Key<<"FObsBack"<<YAML::Value<<FObsBack();

  // Save observed flux at outer border
  data<<YAML::Key<<"FObsFront"<<YAML::Value<<FObsFront();

  // Close map if requested
  if (close) data<<YAML::EndMap;
}

// Create new cell object
Cell* GridFactory::createCell(MStateSolver* mStateSolver, EOS* eos, CellConfig* config, boost::mpi::communicator* mpiCom) {
  cout<<"GridFactory::createCell: mpiCom: "<<mpiCom<<"\n";
  return new Cell(mStateSolver,eos,config,mpiCom);
}

// Copy cell object
Cell* GridFactory::copyCell(Cell* cell) {
  return new Cell(*cell);
}

// Copy grid factory
GridFactory* GridFactory::copy() {
  return new GridFactory(*this);
}

// Constructor 
BStateSelector::BStateSelector() { }

// Use bound state
bool BStateSelector::use(const BStateData& bState) {
  return true;
}

// Constructors
TransBBSelector::TransBBSelector() : nu(0,1e99) { }
TransBBSelector::TransBBSelector(const FrequencyBin& _nu) : nu(_nu) { } 

// Use transition
bool TransBBSelector::use(TransBBData* trans) {
  // Removed A-value criteria - can not be used in NLTE mode - Fix in a better way !
  //if (trans->Xi/h>=nu.min && trans->Xi/h<=nu.max && trans->A!=0) return true;
  //if (trans->Xi/h>=nu.min && trans->Xi/h<=nu.max) return true;
  //else cout<<"TransBBSelector::use, Excluded, w: "<<((c*h)/trans->Xi)/AA<<" AA\n";
  //return false;
  // Removed selection for the moment - collisional transitions should probably be kept in NLTE mode - Hmm ...
  return true;
}

// Constructors
GridConfig::GridConfig() : cell(NULL), bStateSelector(new BStateSelector), transSelector(new TransBBSelector), updateMethod(urPacketHistory), matterDerivedMPI(false), loadIStateData(true) { }
GridConfig::GridConfig(CellConfig* _cell, BStateSelector* _bStateSelector, TransBBSelector* _transSelector, const UpdateMethod& _updateMethod, const bool& _matterDerivedMPI, const bool& _loadIStateData) : cell(_cell), bStateSelector(_bStateSelector), transSelector(_transSelector), updateMethod(_updateMethod), matterDerivedMPI(_matterDerivedMPI), loadIStateData(_loadIStateData) { }

// Constructor
Grid::Grid(MStateSolver* _mStateSolver, EOS* _eos, GridConfig* _config, boost::mpi::communicator* _mpiCom) {
  factory=new GridFactory();
  if (_config==NULL) config = new GridConfig;
  else config=_config;
  mStateSolver=_mStateSolver;
  eos=_eos;
  mpiCom=_mpiCom;
}

// Constructor
Grid::Grid(const string& dataFile, MStateSolver* _mStateSolver, EOS* _eos, GridConfig* _config, boost::mpi::communicator* _mpiCom) {
  factory=new GridFactory();
  if (_config==NULL) config = new GridConfig;
  else config=_config;
  mStateSolver=_mStateSolver;
  eos=_eos;
  mpiCom=_mpiCom;
  load(dataFile);
}

// Copy constructor
// config is currently not owned by grid so only copy pointer
// mStateSolver and eos is currently not owned by grid so only copy pointer
// Note: Now works with subcells
Grid::Grid(const Grid& grid) : config(grid.config), factory(grid.factory), atomData(grid.atomData), mStateSolver(grid.mStateSolver), eos(grid.eos), mpiCom(grid.mpiCom), ptMin(grid.ptMin), ptMax(grid.ptMax), cell(grid.cell) {
  int i,j,k,l,m;
  Atom* atom;

  // Copy factory object
  factory = grid.factory->copy();
  // Copy cell objects
  for (i=0;i<cell.size();i++) {
     cell[i]=factory->copyCell(grid.cell[i]);
     // Copy subcell objects - New!
     for (j=0;j<cell[i]->subCell.size();j++) cell[i]->subCell[j]=factory->copyCell(grid.cell[i]->subCell[j]);
  }
  // Set back references
  for (i=0;i<cell.size();i++) cell[i]->setBackReference(this);
  // Set atom data references
  for (i=0;i<cell.size();i++) cell[i]->setAtomDataReferences(atomData,grid.cell[i]);
  // Set cell neighbour references
  for (i=0;i<cell.size();i++) for (j=0;j<cell[i]->cellNeighbour.size();j++) cell[i]->cellNeighbour[j]=cell.begin()+(*(grid.cell[i]->cellNeighbour[j]))->index();
  // Update line lists - Changed!
  for (i=0;i<cell.size();i++)
    if (cell[i]->type()==cellContainer) for (j=0;j<cell[i]->subCell.size();j++) cell[i]->subCell[j]->updateLineList();
    else cell[i]->updateLineList();
  // Update edge lists - Changed!
  for (i=0;i<cell.size();i++)
    if (cell[i]->type()==cellContainer) for (j=0;j<cell[i]->subCell.size();j++) cell[i]->subCell[j]->updateEdgeList();
    else cell[i]->updateEdgeList();
  // Removed these updates - need to be done elsewhere !!!
  // Update collisional excitation probability list
  //for (i=0;i<cell.size();i++) if (cell[i]->config->collExciteTable) cell[i]->updateCollExcitePList();
  // Update non-thermal excitation probability list
  //for (i=0;i<cell.size();i++) if (cell[i]->config->nonThermalExciteTable) cell[i]->updateNonThermalExcitePList();
}

// Asigment operator
// config is currently not owned by grid so only copy pointer
// mStateSolver and eos is currently not owned by grid so only copy pointer
// Note: Now works with subcells
Grid& Grid::operator=(const Grid& grid) {
  int i,j,k,l,m;
  Atom* atom;

  config=grid.config;
  atomData=grid.atomData;
  mStateSolver=grid.mStateSolver;
  eos=grid.eos;
  mpiCom=grid.mpiCom;
  ptMin=grid.ptMin;
  ptMax=grid.ptMax;
  // Delete cell list objects
  for (i=0;i<cell.size();i++) delete cell[i];
  // Copy cell list
  cell=grid.cell;
  // Copy factory object
  factory = grid.factory->copy();
  // Copy cell objects
  for (i=0;i<cell.size();i++) {
    cell[i]=factory->copyCell(grid.cell[i]);
    // Copy subcell objects - New!
    for (j=0;j<cell[i]->subCell.size();j++) cell[i]->subCell[j]=factory->copyCell(grid.cell[i]->subCell[j]);
  }
  // Set back references
  for (i=0;i<cell.size();i++) cell[i]->setBackReference(this);
  // Set atom data references
  for (i=0;i<cell.size();i++) cell[i]->setAtomDataReferences(atomData,grid.cell[i]);
  // Set cell neighbour references
  for (i=0;i<cell.size();i++) for (j=0;j<cell[i]->cellNeighbour.size();j++) cell[i]->cellNeighbour[j]=cell.begin()+(*(grid.cell[i]->cellNeighbour[j]))->index();
  // Update line lists - Changed!
  for (i=0;i<cell.size();i++)
    if (cell[i]->type()==cellContainer) for (j=0;j<cell[i]->subCell.size();j++) cell[i]->subCell[j]->updateLineList();
    else cell[i]->updateLineList(); 
  // Update edge lists - Changed!
  for (i=0;i<cell.size();i++)
    if (cell[i]->type()==cellContainer) for (j=0;j<cell[i]->subCell.size();j++) cell[i]->subCell[j]->updateEdgeList();
    else cell[i]->updateEdgeList(); 
  // Removed these updates - need to be done elsewhere !!!
  // Update collisional excitation probability list
  //for (i=0;i<cell.size();i++) if (cell[i]->config->collExciteTable) cell[i]->updateCollExcitePList();
  // Update non-thermal excitation probability list
  //for (i=0;i<cell.size();i++) if (cell[i]->config->nonThermalExciteTable) cell[i]->updateNonThermalExcitePList();
}

// Destructor
Grid::~Grid() {
  int i;

  // Delete cells
  for (i=0;i<cell.size();i++) {
    delete(cell[i]);
  }
}

// Get minimum time
double Grid::tMin() const {
  return ptMin;
}

// Set minimum time
void Grid::tMin(const double& _tMin) {
  ptMin=_tMin;
}

// Get maximum time
double Grid::tMax() const {
  return ptMax;
}

// Set maximum time
void Grid::tMax(const double& _tMax) {
  ptMax=_tMax;
}

// Get (centered) time
double Grid::t() const {
  return (ptMin+ptMax)/2;
}

// Select cell (based on position, direction and time)
CellBase* Grid::selectCell(const Vector3D& position, const Vector3D& direction, const double& t) {
  int i;

  // For each cell
  for (i=0;i<cell.size();i++) {
    //cout<<"Grid::selectCell: i: "<<i<<"\n";
    // If in cell - Select cell (which may be a virtual subcell) and return
    //if (cell[i]->inCell(position,t)) return cell[i]->selectCell(position,direction);
    if (cell[i]->inCell(position,t)) return cell[i]->selectCell(position,direction,t); // Changed!
  }
  return NULL;
}

// Select cell (based on virtual cell state)
CellBase* Grid::selectCell(CellVirtualState* cellVirtualState) {
  int i,j;

  // For each cell
  for (i=0;i<cell.size();i++) {
    // If matching cell index found
    if (cell[i]->index()==cellVirtualState->index) {
      // For each subcell
      for (j=0;j<cell[i]->subCell.size();j++) {
	// If matching subcell index found
	if (cell[i]->subCell[j]->index()==cellVirtualState->subIndex) {
	  // Return virtual cell
	  return new CellVirtual(cell[i],cell[i]->subCell[j],cellVirtualState->positionOffset);
	}
      }
    }
  }
  return NULL;
}

// Load grid data (could be overloaded by derived class)
void Grid::load(const string& dataFile) {
  pstring data,gridPData,cellPData;
  string value,atomDataFile;
  AtomDataFormat atomDataFormat;
  double splitFactor;
  TransBF* transBF;
  FrequencyBin onTheSpotNu;
  vector<Cell*> cellWork; // New!
  int i,j,k,l,m,nCells;

  // Load data
  if (master()) cout<<"Grid::load: Load data file\n";
  data.load(dataFile);
  if (data.size()==0) {cout<<"Grid::load: Error: Data file empty\n"; return;}

  // Get grid data
  gridPData=data.getData("grid");
  // Error handling
  if (gridPData.size()==0) {cout<<"Grid::load: Error: Could not get grid data\n"; return;}
  // Get atom data file
  value=gridPData.getData("atomDataFile");
  atomDataFile=value;
  // Error handling
  if (value.size()==0) {cout<<"Grid::load: Error: Could not get atom data file\n"; return;}
  if (master()) cout<<"atom data file="<<atomDataFile<<"\n";
  // Get atom data format
  value=gridPData.getData("atomDataFormat");
  if (value.compare("aJ")==0) atomDataFormat=aJ;
  else if (value.compare("yAML")==0) atomDataFormat=yAML;
  else atomDataFormat=aJ;
  // Error handling
  if (value.size()==0) {cout<<"Grid::load: Error: Could not get atom data format\n"; return;}
  // Load atom data
  if (master()) cout<<"Grid::load: Load atom data\n";
  atomData.load(atomDataFile,atomDataFormat,config->loadIStateData);
  // Get size of cell array
  nCells=gridPData.getSize("cell");
  // Error handling
  if (nCells<=0) {cout<<"Grid::load: Error: Cell list empty\n"; return;}
  // Resize cell list
  cell.resize(nCells);
  for (i=0;i<cell.size();i++) {
    if (master()) cout<<"Grid::load: Read cell "<<i<<" data\n";
    // Get cell data
    cellPData=gridPData.getData("cell",i);
    // Create cell
    cell[i]=factory->createCell(mStateSolver,eos,config->cell,mpiCom);
    // Load cell data
    cell[i]->load(cellPData,atomData,factory,config->transSelector,config->bStateSelector);
    // Set cell index
    cell[i]->pIndex=i;
    // Hack to give subcells unique index - Improve - New!
    for (j=0;j<cell[i]->subCell.size();j++) cell[i]->subCell[j]->pIndex=(i+1)*100+j;
  }

  // Set time borders to that of the innermost cell - Should be loaded !
  ptMin=cell[0]->tMin();
  ptMax=cell[0]->tMax();

  // Set back references
  for (i=0;i<cell.size();i++) cell[i]->setBackReference(this);

  // Create work list of cells and subcells - New!
  for (i=0;i<cell.size();i++) {
    if (cell[i]->type()==cellContainer) {
      for (j=0;j<cell[i]->subCell.size();j++) {
	cellWork.push_back(cell[i]->subCell[j]);
      }
    }
    else cellWork.push_back(cell[i]);
  }

  // For each cell - Changed (cell replaced with cellWork here and below)!
  for (i=0;i<cellWork.size();i++) {
    // Reset on-the-spot (new) range
    onTheSpotNu.min=nuInf; onTheSpotNu.max=nuInf;
    // For each atom
    for (j=0;j<cellWork[i]->atom.size();j++) {
      // Set on-the-spot flag
      if (cellWork[i]->config->onTheSpot(cellWork[i]->atom[j])) cellWork[i]->atom[j].onTheSpot(true);
      else cellWork[i]->atom[j].onTheSpot(false);
      // For each ionization state
      for (k=0;k<cellWork[i]->atom[j].iState.size();k++) {
	// For each bound state
	for (l=0;l<cellWork[i]->atom[j].iState[k].bState.size();l++) {
	  // For each bound-free transition
	  for (m=0;m<cellWork[i]->atom[j].iState[k].bState[l].upTransBF.size();m++) {
	    transBF=cellWork[i]->atom[j].iState[k].bState[l].upTransBF[m];
	    // If on-the-spot (new) requested
	    if (cellWork[i]->config->onTheSpotNew(transBF)) {
	      // Set on-the-spot (new) flag to true
	      transBF->onTheSpotNew(true);
	      // If necessary - Adjust on-the-spot range
	      if (transBF->nu()<onTheSpotNu.min) onTheSpotNu.min=transBF->nu();
	    }
	    // Else - Set on-the-spot flag to false
	    else transBF->onTheSpotNew(false);
	  }
	}
      }
    }
    // Adjust on-the-spot (new) range
    //onTheSpotNu.min=onTheSpotNu.min*(1+0.5*cell[i]->config->boundFreeTableEdgeWidth);
    // Set on-the-spot (new) range
    cellWork[i]->onTheSpotNu(onTheSpotNu);
  }

  // Testing!
  /*int ii,jj,kk,ll,mm;
  for (i=0;i<cell.size();i++) {
    for (j=0;j<cell[i]->ctReaction.size();j++) {
      
      cout<<"Grid::load, cell: "<<i<<", CTReaction "<<j<<" loaded, downTrans: "<<cell[i]->ctReaction[j].downTrans->upperState->iState()->name()<<":"<<cell[i]->ctReaction[j].downTrans->upperState->getIndex()<<"->"<<cell[i]->ctReaction[j].downTrans->lowerState->iState()->name()<<":"<<cell[i]->ctReaction[j].downTrans->lowerState->getIndex()<<", upTrans: "<<cell[i]->ctReaction[j].upTrans->lowerState->iState()->name()<<":"<<cell[i]->ctReaction[j].upTrans->lowerState->getIndex()<<"->"<<cell[i]->ctReaction[j].upTrans->upperState->iState()->name()<<":"<<cell[i]->ctReaction[j].upTrans->lowerState->getIndex()<<"\n";

      cout<<"Grid::load, cell: "<<i<<", CTReaction "<<j<<" data, downTrans: "<<cell[i]->ctReaction[j].data->downTrans.upperIState->index<<":"<<cell[i]->ctReaction[j].data->downTrans.upperBState->index<<"->"<<cell[i]->ctReaction[j].data->downTrans.lowerIState->index<<":"<<cell[i]->ctReaction[j].data->downTrans.lowerBState->index<<", upTrans: "<<cell[i]->ctReaction[j].data->upTrans.lowerIState->index<<":"<<cell[i]->ctReaction[j].data->upTrans.lowerBState->index<<"->"<<cell[i]->ctReaction[j].data->upTrans.upperIState->index<<":"<<cell[i]->ctReaction[j].data->upTrans.lowerBState->index<<"\n";
    }

    for (ii=0;ii<cell[i]->atom.size();ii++)
      for (jj=0;jj<cell[i]->atom[ii].iState.size();jj++)
	for (kk=0;kk<cell[i]->atom[ii].iState[jj].bState.size();kk++)
	  for (ll=0;ll<cell[i]->atom[ii].iState[jj].bState[kk].upTransBF.size();ll++) {
	    for (mm=0;mm<cell[i]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->CTDReaction.size();mm++)
	      cout<<"Grid::load, cell: "<<i<<", "<<cell[i]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->upperState->iState()->name()<<":"<<cell[i]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->upperState->getIndex()<<"->"<<cell[i]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->lowerState->iState()->name()<<":"<<cell[i]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->lowerState->getIndex()<<", CTDReaction "<<mm<<"-> CTReaction: "<<cell[i]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->CTDReaction[m]->index()<<"\n";
	    for (mm=0;mm<cell[i]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->CTUReaction.size();mm++)
	      cout<<"Grid::load, cell: "<<i<<", "<<cell[i]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->upperState->iState()->name()<<":"<<cell[i]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->upperState->getIndex()<<"->"<<cell[i]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->lowerState->iState()->name()<<":"<<cell[i]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->lowerState->getIndex()<<", CTUReaction "<<mm<<"-> CTReaction: "<<cell[i]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->CTUReaction[mm]->index()<<"\n";
	  }

    for (j=0;j<cell[i]->subCell.size();j++) {
      for (k=0;k<cell[i]->subCell[j]->ctReaction.size();k++) {
	
	cout<<"Grid::load, cell: "<<i<<", subCell: "<<j<<", CTReaction "<<k<<" loaded, downTrans: "<<cell[i]->subCell[j]->ctReaction[k].downTrans->upperState->iState()->name()<<":"<<cell[i]->subCell[j]->ctReaction[k].downTrans->upperState->getIndex()<<"->"<<cell[i]->subCell[j]->ctReaction[k].downTrans->lowerState->iState()->name()<<":"<<cell[i]->subCell[j]->ctReaction[k].downTrans->lowerState->getIndex()<<", upTrans: "<<cell[i]->subCell[j]->ctReaction[k].upTrans->lowerState->iState()->name()<<":"<<cell[i]->subCell[j]->ctReaction[k].upTrans->lowerState->getIndex()<<"->"<<cell[i]->subCell[j]->ctReaction[k].upTrans->upperState->iState()->name()<<":"<<cell[i]->subCell[j]->ctReaction[k].upTrans->lowerState->getIndex()<<"\n";
      
	cout<<"Grid::load, cell: "<<i<<", subCell: "<<j<<", CTReaction "<<k<<" data, downTrans: "<<cell[i]->subCell[j]->ctReaction[k].data->downTrans.upperIState->index<<":"<<cell[i]->subCell[j]->ctReaction[k].data->downTrans.upperBState->index<<"->"<<cell[i]->subCell[j]->ctReaction[k].data->downTrans.lowerIState->index<<":"<<cell[i]->subCell[j]->ctReaction[k].data->downTrans.lowerBState->index<<", upTrans: "<<cell[i]->subCell[j]->ctReaction[k].data->upTrans.lowerIState->index<<":"<<cell[i]->subCell[j]->ctReaction[k].data->upTrans.lowerBState->index<<"->"<<cell[i]->subCell[j]->ctReaction[k].data->upTrans.upperIState->index<<":"<<cell[i]->subCell[j]->ctReaction[k].data->upTrans.lowerBState->index<<"\n";
      }

      for (ii=0;ii<cell[i]->subCell[j]->atom.size();ii++)
	for (jj=0;jj<cell[i]->subCell[j]->atom[ii].iState.size();jj++)
	  for (kk=0;kk<cell[i]->subCell[j]->atom[ii].iState[jj].bState.size();kk++)
	    for (ll=0;ll<cell[i]->subCell[j]->atom[ii].iState[jj].bState[kk].upTransBF.size();ll++) {
	      for (mm=0;mm<cell[i]->subCell[j]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->CTDReaction.size();mm++)
		cout<<"Grid::load, cell: "<<i<<", subCell: "<<j<<", "<<cell[i]->subCell[j]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->upperState->iState()->name()<<":"<<cell[i]->subCell[j]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->upperState->getIndex()<<"->"<<cell[i]->subCell[j]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->lowerState->iState()->name()<<":"<<cell[i]->subCell[j]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->lowerState->getIndex()<<", CTDReaction "<<mm<<"-> CTReaction: "<<cell[i]->subCell[j]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->CTDReaction[m]->index()<<"\n";
	      for (mm=0;mm<cell[i]->subCell[j]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->CTUReaction.size();mm++)
		cout<<"Grid::load, cell: "<<i<<", subCell: "<<j<<", "<<cell[i]->subCell[j]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->upperState->iState()->name()<<":"<<cell[i]->subCell[j]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->upperState->getIndex()<<"->"<<cell[i]->subCell[j]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->lowerState->iState()->name()<<":"<<cell[i]->subCell[j]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->lowerState->getIndex()<<", CTUReaction "<<mm<<"-> CTReaction: "<<cell[i]->subCell[j]->atom[ii].iState[jj].bState[kk].upTransBF[ll]->CTUReaction[mm]->index()<<"\n";
	    }
    }
    }*/
  
  return;
}

// Load Grid data (could be overloaded by derived class)
// Not used!
void Grid::loadYAML(const string& dataFile) {
  // Move to Grid !!!
  string atomDataFile;
  YAML::Node data;
  AtomDataFormat atomDataFormat;
  double splitFactor;
  int i,j,k,l,m;

  // Load data
  if (master()) cout<<"Grid::load: Load data file\n";
  data=YAML::LoadFile(dataFile);
  // Error handling ?

  // Get grid data
  if (data["grid"]) data=data["grid"];
  else { cerr<<"Grid::load, Error: Could not get grid data\n"; exit(-1); }  

  // Get atom data file
  if (data["atomDataFile"]) atomDataFile=data["atomDataFile"].as<string>();
  else { cerr<<"Grid::load, Error: Could not get atom data file\n"; exit(-1); }  

  // Set atom data format to YAML (AJ obsolete)
  atomDataFormat=yAML;

  // Load atom data
  atomData.load(atomDataFile,atomDataFormat,config->loadIStateData);

  // Resize cell list
  if (data["cell"]) cell.resize(data["cell"].size());
  else { cerr<<"Grid::load, Error: Could not get cell data\n"; exit(-1); }  

  // For each cell
  for (i=0;i<cell.size();i++) {
    // Create cell
    cell[i]=factory->createCell(mStateSolver,eos,config->cell,mpiCom);
    // Load cell data
    cell[i]->loadYAML(data["cell"][i],atomData,factory,config->transSelector,config->bStateSelector);
    // Set cell index
    cell[i]->pIndex=i;
  }

  // Set time borders to that of the innermost cell - Should be loaded !
  ptMin=cell[0]->tMin();
  ptMax=cell[0]->tMax();

  // Set back references
  for (i=0;i<cell.size();i++) cell[i]->setBackReference(this);

  // For each cell
  for (i=0;i<cell.size();i++) {
    // For each atom
    for (j=0;j<cell[i]->atom.size();j++) {
      // Set on-the-spot flag
      if (cell[i]->config->onTheSpot(cell[i]->atom[j])) cell[i]->atom[j].onTheSpot(true);
      else cell[i]->atom[j].onTheSpot(false);
    }
  }
  
  return;
}

// Load Grid state (could be overloaded by derived class)
void Grid::loadState(const string& dataFile, bool loadIState, bool loadBState, bool loadRState) {
  YAML::Node data;
  int i;

  // Load data
  if (master()) cout<<"Grid::loadState: Load data file\n";
  data=YAML::LoadFile(dataFile);
  // Error handling ?

  // Get grid data
  if (data["grid"]) data=data["grid"];
  else { cerr<<"Grid::loadState, Error: Could not get grid data\n"; exit(-1); }  

  // Get tMin
  if (data["tMin"]) ptMin=data["tMin"].as<double>();
  else {cout<<"Grid::loadState: Error: Could not get tMin\n"; exit(-1);}

  // Get tMax
  if (data["tMax"]) ptMax=data["tMax"].as<double>();
  else {cout<<"Grid::loadState: Error: Could not get tMax\n"; exit(-1);}

  // Load data for each cell
  if (data["cell"])
    if (cell.size()==data["cell"].size()) {
      #pragma omp parallel for
      for (i=0;i<cell.size();i++) cell[i]->loadState(data["cell"][i],loadIState,loadBState,loadRState);
    }
    else { cerr<<"Grid::loadState, Error: Wrong number of cells\n"; exit(-1); }    
  else { cerr<<"Grid::loadState, Error: Could not get cell data\n"; exit(-1); }  
  
  return;
}

// Load grey scattering opacity
void Grid::loadGreyScatterKappa(const string& dataFile) {
  YAML::Node data;
  int i;

  // Load data
  if (master()) cout<<"Grid::loadGreyScatterKappa: Load data file\n";
  data=YAML::LoadFile(dataFile);
  // Error handling ?

  // Get grid data
  if (data["grid"]) data=data["grid"];
  else { cerr<<"Grid::loadGreyScatterKappa, Error: Could not get grid data\n"; exit(-1); }  

  // Load grey scattering opacity for each cell
  if (data["cell"])
    if (cell.size()==data["cell"].size()) {
      #pragma omp parallel for
      for (i=0;i<cell.size();i++) cell[i]->loadGreyScatterKappa(data["cell"][i]);
    }
    else { cerr<<"Grid::loadGreyScatterKappa, Error: Wrong number of cells\n"; exit(-1); }    
  else { cerr<<"Grid::loadGreyScatterKappa, Error: Could not get cell data\n"; exit(-1); }  
  
  return;
}

// Save Grid data (could be overloaded by derived class)
// Not used!
void Grid::save(const string& dataFile) const {
  // Move to Grid !!!
  string atomDataFile;
  ofstream file;
  YAML::Emitter data;
  int i;

  // Begin document
  data<<YAML::BeginMap;

  // Begin grid map
  data<<YAML::Key<<"grid"<<YAML::Value<<YAML::BeginMap;

  // Save atom-data file
  data<<YAML::Key<<"atomDataFile"<<atomDataFile;

  // Begin cell sequence
  data<<YAML::Key<<"cell"<<YAML::Value<<YAML::BeginSeq;

  // Save data for each cell
  for (i=0;i<cell.size();i++) cell[i]->save(data);

  // Close cell sequence
  data<<YAML::EndSeq;

  // Close grid map
  data<<YAML::EndMap;

  // Close document
  data<<YAML::EndMap;

  // Open file
  file.open(dataFile.c_str());
  if (file.fail()) {cerr<<"Grid::save: Could not open "<<dataFile<<"\n"; return;}

  // Write data to file
  file<<data.c_str();

  // Close file
  file.close();
}

// Save Grid state (could be overloaded by derived class)
void Grid::saveState(const string& dataFile) {
  ofstream file;
  string prefix,outData;
  YAML::Emitter data;
  vector<YAML::Emitter*> cellData(cell.size());
  size_t startPos=0,midPos,endPos;
  int i;

  // Create cell YAML emitters
  for (i=0;i<cell.size();i++) cellData[i] = new YAML::Emitter;

  // Construct prefix from file name
  prefix=dataFile.substr(0,dataFile.find_last_of("."));

  data<<YAML::BeginMap;
  data<<YAML::Key<<"grid"<<YAML::Value<<YAML::BeginMap;

  // Save time borders
  data<<YAML::Key<<"tMin"<<YAML::Value<<tMin();
  data<<YAML::Key<<"tMax"<<YAML::Value<<tMax();

  // Save state for each cell
  data<<YAML::Key<<"cell"<<YAML::Value<<YAML::BeginSeq;
  //for (i=0;i<cell.size();i++) cell[i]->saveState(data,prefix);
  #pragma omp parallel for
  for (i=0;i<cell.size();i++) cell[i]->saveState(*(cellData[i]),prefix);
  // Workaround - Use literal string format for cell data
  for (i=0;i<cell.size();i++) { data.SetStringFormat(YAML::Literal); data<<cellData[i]->c_str(); data.SetStringFormat(YAML::DoubleQuoted); }
  data<<YAML::EndSeq;

  data<<YAML::EndMap;
  data<<YAML::EndMap;

  // Workaround - remove YAML literal string marker
  outData=data.c_str();
  // Note that this replace may take some time - Try to find a more efficient way
  while ((startPos=outData.find("|\n",startPos)) != std::string::npos) { 
    midPos=outData.find_first_not_of(" ",startPos+3); endPos=outData.find("\n",midPos);
    outData.replace(startPos, endPos-startPos, outData.substr(midPos,(endPos-midPos)));
    startPos=endPos;
  }

  // Open file
  file.open(dataFile.c_str());
  if (file.fail()) {cerr<<"Grid::saveState: Could not open "<<dataFile<<"\n"; return;}

  // Write data to file
  file<<outData;

  // Close file
  file.close();

  // Delete cell YAML emitters
  for (i=0;i<cell.size();i++) delete cellData[i];

  return;
}

// Update matter state (all cells) - Changed!
/*void Grid::updateMatterState(bool initiate, bool initiateState) {
  updateMatterState(0,cell.size()-1,initiate,initiateState);
  }*/
void Grid::updateMatterState(bool initiate, bool initiateState, bool updateMCDerived) {
  updateMatterState(0,cell.size()-1,initiate,initiateState,updateMCDerived);
}

// Update matter state (range of cells) - Changed!
/*void Grid::updateMatterState(int iMin, int iMax, bool initiate, bool initiateState) {
  // If MPI communicator provided - Run on cluster using MPI
  if (mpiCom!=NULL) updateMatterStateCluster(iMin,iMax,initiate,initiateState);
  // Else - Run on a single computer
  else updateMatterStateSingle(iMin,iMax,initiate,initiateState);
  }*/
void Grid::updateMatterState(int iMin, int iMax, bool initiate, bool initiateState, bool updateMCDerived) {
  // If MPI communicator provided - Run on cluster using MPI
  if (mpiCom!=NULL) updateMatterStateCluster(iMin,iMax,initiate,initiateState,updateMCDerived);
  // Else - Run on a single computer
  else updateMatterStateSingle(iMin,iMax,initiate,initiateState,updateMCDerived);
}

// Update matter state (on a single computer)
//void Grid::updateMatterStateSingle(int iMin, int iMax, bool initiate, bool initiateState) {
void Grid::updateMatterStateSingle(int iMin, int iMax, bool initiate, bool initiateState, bool updateMCDerived) { // Changed!
  int i,j;
  vector<Cell*> cellWork(0); // New!

  // Prevent faulty cell range
  iMin=(iMin>=0)?iMin:0; iMax=(iMax<=(cell.size()-1))?iMax:(cell.size()-1);

  // Create work list of cells and subcells - New!
  for (i=iMin;i<=iMax;i++) {
    if (cell[i]->type()==cellContainer) {
      for (j=0;j<cell[i]->subCell.size();j++) {
	cellWork.push_back(cell[i]->subCell[j]);
      }
    }
    else cellWork.push_back(cell[i]);
  }

  #pragma omp parallel for
  for (i=0;i<cellWork.size();i++) {
    //cout<<"Grid::updateMatterState: Update cell "<<cellWork[i]->index()<<" matter state\n";
    cellWork[i]->updateMatterState(initiate,initiateState,updateMCDerived); // Changed!
  }
}

// Update matter state (on a cluster using MPI)
//void Grid::updateMatterStateCluster(int iMin, int iMax, bool initiate, bool initiateState) {
void Grid::updateMatterStateCluster(int iMin, int iMax, bool initiate, bool initiateState, bool updateMCDerived) { // Changed!
  int i,j;
  int nResponsible=0; // New!
  vector<Cell*> cellWork(0); // New!

  // Prevent faulty cell range
  iMin=(iMin>=0)?iMin:0; iMax=(iMax<=(cell.size()-1))?iMax:(cell.size()-1);

  // Create work list of cells and subcells - New!
  for (i=iMin;i<=iMax;i++) {
    if (cell[i]->type()==cellContainer) {
      for (j=0;j<cell[i]->subCell.size();j++) {
	cellWork.push_back(cell[i]->subCell[j]);
      }
    }
    else cellWork.push_back(cell[i]);
  }
 
  // Determine which processes are responsible for the cells - Changed!
  //for (i=0;i<cellWork.size();i++) cellWork[i]->responsible=i%mpiCom->size();
  // Note: This new (non-optimal) method prevents changes of the responsible processes - Find a better solution!
  for (i=0;i<cellWork.size();i++) cellWork[i]->responsible=cellWork[i]->index()%mpiCom->size();

  // Count number of cells the process is responsible for - New!
  for (i=0;i<cellWork.size();i++) if (cellWork[i]->responsible==mpiCom->rank()) nResponsible++;

  // Update matter state for the cells the process are responsible for - Changed!
  #pragma omp parallel for
  for (i=0;i<cellWork.size();i++) {
    if (master()) cout<<"Grid::updateMatterStateCluster: Update cell "<<cellWork[i]->index()<<" matter state\n";
    if (cellWork[i]->responsible==mpiCom->rank()) {
      // Set number of threads to use in nested omp parallelization - New!
      //cout<<"Grid::updateMatterStateCluster: cell "<<cellWork[i]->index()<<", process: "<<mpiCom->rank()<<", thread_num: "<<omp_get_thread_num()<<", num_threads: "<<omp_get_num_threads()<<", nResponsible: "<<nResponsible<<"\n";
      omp_set_num_threads((omp_get_num_threads()-1)/nResponsible+1);
      cellWork[i]->updateMatterState(initiate,initiateState,updateMCDerived); // Changed!
    }
  }

  //cout<<"Grid::updateMatterStateCluster: Process: "<<mpiCom->rank()<<", 1\n";

  // Wait for all processes to reach this point
  mpiCom->barrier();

  //cout<<"Grid::updateMatterStateCluster: Process: "<<mpiCom->rank()<<", 2\n";

  // Synchronize matter state for each cell - Changed!
  for (i=0;i<cellWork.size();i++) {
    if (master()) cout<<"Grid::updateMatterStateCluster: Synchronize cell "<<cellWork[i]->index()<<" matter state\n";
    cellWork[i]->syncMatterState();
  }

  // Wait for all processes to reach this point
  mpiCom->barrier();

  // If MPI processing of derived matter quantities - New!
  if (config->matterDerivedMPI) {
    // Synchronize derived matter quantities for each cell
    for (i=0;i<cellWork.size();i++) {
      if (master()) cout<<"Grid::updateMatterStateCluster: Synchronize cell "<<cellWork[i]->index()<<" derived matter quantities\n";
      cellWork[i]->syncMatterDerived(updateMCDerived);
    }
  }
  // Else
  else {
    // Update derived matter quantities for the cells the process are not responsible for - Changed!
    #pragma omp parallel for
    for (i=0;i<cellWork.size();i++) {
      if (master()) cout<<"Grid::updateMatterStateCluster: Update cell "<<cellWork[i]->index()<<" derived matter quantities\n";
      if (cellWork[i]->responsible!=mpiCom->rank()) cellWork[i]->updateMatterDerived(updateMCDerived); // Changed!
    }
  }
}

// Update derived matter state quantities (all cells) - New!
void Grid::updateMatterDerived(bool updateMCDerived) {
  updateMatterDerived(0,cell.size()-1,updateMCDerived);
}

// Update derived matter state quantities (range of cells) - New!
void Grid::updateMatterDerived(int iMin, int iMax, bool updateMCDerived) {
  // If MPI communicator provided and MPI processing configured - Run on cluster using MPI
  if (mpiCom!=NULL and config->matterDerivedMPI) updateMatterDerivedCluster(iMin,iMax,updateMCDerived);
  // Else - Run on a single computer
  else updateMatterDerivedSingle(iMin,iMax,updateMCDerived);
}

// Update derived matter state quantities (on a single computer) - New!
void Grid::updateMatterDerivedSingle(int iMin, int iMax, bool updateMCDerived) {
  int i,j;
  vector<Cell*> cellWork(0); // New!

  // Prevent faulty cell range
  iMin=(iMin>=0)?iMin:0; iMax=(iMax<=(cell.size()-1))?iMax:(cell.size()-1);

  // Create work list of cells and subcells - New!
  for (i=iMin;i<=iMax;i++) {
    if (cell[i]->type()==cellContainer) {
      for (j=0;j<cell[i]->subCell.size();j++) {
	cellWork.push_back(cell[i]->subCell[j]);
      }
    }
    else cellWork.push_back(cell[i]);
  }

  // Update derived matter quantities for each cell - Changed!
  #pragma omp parallel for
  for (i=0;i<cellWork.size();i++) {
    if (master()) cout<<"Grid::updateMatterDerivedSingle: Update cell "<<cellWork[i]->index()<<" derived matter quantities\n";
    cellWork[i]->updateMatterDerived(updateMCDerived);
  }
}

// Update derived matter state quantities (on a cluster using MPI) - New!
void Grid::updateMatterDerivedCluster(int iMin, int iMax, bool updateMCDerived) {
  int i,j;
  int nResponsible=0;
  vector<Cell*> cellWork(0);

  // Prevent faulty cell range
  iMin=(iMin>=0)?iMin:0; iMax=(iMax<=(cell.size()-1))?iMax:(cell.size()-1);

  // Create work list of cells and subcells
  for (i=iMin;i<=iMax;i++) {
    if (cell[i]->type()==cellContainer) {
      for (j=0;j<cell[i]->subCell.size();j++) {
	cellWork.push_back(cell[i]->subCell[j]);
      }
    }
    else cellWork.push_back(cell[i]);
  }

  // Determine which processes are responsible for the cells
  // Note: This(non-optimal) method prevents changes of the responsible processes - Find a better solution!
  for (i=0;i<cellWork.size();i++) cellWork[i]->responsible=cellWork[i]->index()%mpiCom->size();

  // Count number of cells the process is responsible for
  for (i=0;i<cellWork.size();i++) if (cellWork[i]->responsible==mpiCom->rank()) nResponsible++;

  // Update derived matter quantities for the cells the process are responsible for
  #pragma omp parallel for
  for (i=0;i<cellWork.size();i++) {
    if (master()) cout<<"Grid::updateMatterDerivedCluster: Update cell "<<cellWork[i]->index()<<" derived matter quantities\n";
    if (cellWork[i]->responsible==mpiCom->rank()) {
      // Set number of threads to use in nested omp parallelization
      omp_set_num_threads((omp_get_num_threads()-1)/nResponsible+1);
      cellWork[i]->updateMatterDerived(updateMCDerived);
    }
  }

  // Synchronize derived matter quantities for each cell
  for (i=0;i<cellWork.size();i++) {
    if (master()) cout<<"Grid::updateMatterDerivedCluster: Synchronize cell "<<cellWork[i]->index()<<" derived matter quantities\n";
    cellWork[i]->syncMatterDerived(updateMCDerived);
  }
}

// Update radiation state (all cells)
void Grid::updateRadiationState(MCExperiment& mCExperiment) {
  updateRadiationState(0,cell.size()-1,mCExperiment);
}

// Update radiation state (range of cells)
void Grid::updateRadiationState(int iMin, int iMax, MCExperiment& mCExperiment) {
  PacketEvent* packetEvent=NULL;
  int i,j,k,l;

  // Prevent faulty cell range
  iMin=(iMin>=0)?iMin:0; iMax=(iMax<=(cell.size()-1))?iMax:(cell.size()-1);

  if (config->updateMethod==urPacketHistory) {

    // Reset cell packet histories
    for (i=iMin;i<=iMax;i++)
      if (cell[i]->type()==cellContainer) for (j=0;j<cell[i]->subCell.size();j++) cell[i]->subCell[j]->packetHistory.resize(0);
      else cell[i]->packetHistory.resize(0);

    // Removed parallization of this part since the order of events
    // in the packet history is not garuanteed
    // For each packet
    for (i=0;i<mCExperiment.packet.size();i++) {
      // For each event
      for (j=0;j<mCExperiment.packet[i].history.size();j++) {
	// Set packet event pointer
	packetEvent=&(mCExperiment.packet[i].history[j]);
	// Get cell index
	k=packetEvent->cellIndex;
	// Get subcell index
	l=packetEvent->subCellIndex;
	// If not a cell crossing
	if (packetEvent->type!=evCellCrossing)
	  // If withing specified cell range
	  if (k>=iMin and k<=iMax) {
	    // Add event to cell history
	    if (cell[k]->type()==cellContainer) cell[k]->subCell[l]->packetHistory.push_back(packetEvent);
	    else cell[k]->packetHistory.push_back(packetEvent);
	  }
	// Else
	else {
	  // If on grid
	  if (packetEvent->cellIndex!=noCell)
	    // If withing specified cell range
	    if (k>=iMin and k<=iMax) {
	      // Add event to cell history
	      if (cell[k]->type()==cellContainer) cell[k]->subCell[l]->packetHistory.push_back(packetEvent);
	      else cell[k]->packetHistory.push_back(packetEvent);
	    }
	  // Get previous cell index
	  k=mCExperiment.packet[i].history[j-1].cellIndex;
	  // Get previous sub cell index
	  l=mCExperiment.packet[i].history[j-1].subCellIndex;
	  // If withing specified cell range
	  if (k>=iMin and k<=iMax) {
	    // Add event to previous cell history
	    if (cell[k]->type()==cellContainer) cell[k]->subCell[l]->packetHistory.push_back(packetEvent);
	    else cell[k]->packetHistory.push_back(packetEvent);
	  }
	}	
      }
    }
  }

  // For each cell
  for (i=iMin;i<=iMax;i++) {
    // Update radiation state
    if (master()) cout<<"Grid::updateRadiationState: Update cell "<<i<<" radiation state\n";
    cell[i]->updateRadiationState(mCExperiment.nu); // Changed!
  }

  // If cluster - Wait for all processes to reach this point
  if (mpiCom!=NULL) mpiCom->barrier();
}

// Scale radiation field with expansion factor (all cells)
void Grid::scaleRadiationField(const double& expFactor, bool expCooling) { // Changed!
  scaleRadiationField(expFactor,0,cell.size()-1,expCooling);
}

// Scale radiation field with expansion factor (range of cells)
void Grid::scaleRadiationField(const double& expFactor, int iMin, int iMax, bool expCooling) { // Changed!
  int i,j;

  // Prevent faulty cell range
  iMin=(iMin>=0)?iMin:0; iMax=(iMax<=(cell.size()-1))?iMax:(cell.size()-1);

  // For each cell
  #pragma omp parallel for private(j)
  for (i=iMin;i<=iMax;i++) {
    // Scale radiation field
    cell[i]->scaleRadiationField(expFactor,expCooling); // Changed!
  }
}

// Reset MC statistics (all cells)
void Grid::resetMCStatistics(const FrequencyBinList& nu) {
  resetMCStatistics(0,cell.size()-1,nu);
}

// Reset MC statistics (range of cells)
void Grid::resetMCStatistics(int iMin, int iMax, const FrequencyBinList& nu) {
  int i,j;

  // Prevent faulty cell range
  iMin=(iMin>=0)?iMin:0; iMax=(iMax<=(cell.size()-1))?iMax:(cell.size()-1);

  // For each cell
  #pragma omp parallel for private(j)
  for (i=iMin;i<=iMax;i++) {
    // Reset MC statistics
    cell[i]->resetMCStatistics(nu); // Changed!
  }
}

// Reset derived quantities (to be updated)
void Grid::reset(int dependence) {
  int i,j,k;

  // For each cell
  for (i=0;i<cell.size();i++) {
    // Reset derived quantities
    cell[i]->reset(dependence);
    // Hack - should be placed elsewhere - Changed!
    if (cell[i]->type()==cellContainer)
      for (j=0;j<cell[i]->subCell.size();j++) {
	// Update transition probability lists
	if (cell[i]->config->transTable) for (k=0;k<cell[i]->subCell[j]->atom.size();k++) cell[i]->subCell[j]->atom[k].updateTransPList();
	// Update collisional excitation probability list
	if (cell[i]->config->collExciteTable) cell[i]->subCell[j]->updateCollExcitePList();
      }
    else {
      // Update transition probability lists
      if (cell[i]->config->transTable) for (j=0;j<cell[i]->atom.size();j++) cell[i]->atom[j].updateTransPList();
      // Update collisional excitation probability list
      if (cell[i]->config->collExciteTable) cell[i]->updateCollExcitePList();
    }
  }
}

// Export grid statistics
// Deprecated!
void Grid::exportStatistics(const string& statFile, const double& tauLimit) {
  ofstream file;
  int i;

  // Open file
  file.open(statFile.c_str());
  if (file.fail()) {cerr<<"Grid::exportStatistics: Could not open "<<statFile<<"\n"; return;}

  file<<"# Grid statistics\n";
  for (i=0;i<cell.size();i++) {
    file<<"# Cell "<<i<<" statistics\n";
    cell[i]->exportStatistics(file,tauLimit);
  }
  return;
}

// Export statistics
void Grid::exportStat(const string& statFile, const double& tauLim) {
  ofstream file;
  string prefix,outData;
  YAML::Emitter data;
  vector<YAML::Emitter*> cellData(cell.size());
  size_t startPos=0,midPos,endPos;
  int i;

  // Create cell YAML emitters
  for (i=0;i<cell.size();i++) cellData[i] = new YAML::Emitter;

  // Construct prefix from file name
  prefix=statFile.substr(0,statFile.find_last_of("."));

  data<<YAML::BeginMap;
  data<<YAML::Key<<"grid"<<YAML::Value<<YAML::BeginMap;

  // Export statistics for each cell
  data<<YAML::Key<<"cell"<<YAML::Value<<YAML::BeginSeq;
  //for (i=0;i<cell.size();i++) cell[i]->exportStat(data,tauLim,prefix);
  #pragma omp parallel for
  for (i=0;i<cell.size();i++) cell[i]->exportStat(*(cellData[i]),tauLim,prefix);
  // Workaround - Use literal string format for cell data
  for (i=0;i<cell.size();i++) { data.SetStringFormat(YAML::Literal); data<<cellData[i]->c_str(); data.SetStringFormat(YAML::DoubleQuoted); }
  data<<YAML::EndSeq;

  data<<YAML::EndMap;
  data<<YAML::EndMap;

  // Workaround - remove YAML literal string marker
  outData=data.c_str();
  // Note that this replace may take some time - Try to find a more efficient way
  while ((startPos=outData.find("|\n",startPos)) != std::string::npos) { 
    midPos=outData.find_first_not_of(" ",startPos+3); endPos=outData.find("\n",midPos);
    outData.replace(startPos, endPos-startPos, outData.substr(midPos,(endPos-midPos)));
    startPos=endPos;
  }

  // Open file
  file.open(statFile.c_str());
  if (file.fail()) {cerr<<"Grid::exportStat: Could not open "<<statFile<<"\n"; return;}

  // Write data to file
  file<<outData;

  // Close file
  file.close();

  // Delete YAML emitters
  for (i=0;i<cell.size();i++) delete cellData[i];

  return;
}

// Is master?
bool Grid::master() const {
  bool _master=false;

  if (mpiCom==NULL) _master=true;
  else if (mpiCom->rank()==0) _master=true;

  return _master;
}

// Init frequency binning
//void Grid::initNu(const double& nuMin, const double& nuMax, const int& nBin) {
void Grid::initNu(double nuMin, double nuMax, int nBin) { // Changed!
  int i;

  // Init frequency binning for each cell
  for (i=0;i<cell.size();i++) cell[i]->initNu(nuMin,nuMax,nBin);
}

// Init frequency binning
void Grid::initMu(int nBin) {
  int i;

  // Init frequency binning for each cell
  for (i=0;i<cell.size();i++) cell[i]->initMu(nBin);
}

// Get memory allocated - New!
double Grid::mem() const {
  double _mem=sizeof(*this);
  int i;

  // Add memory allocated for each cell
  for (i=0;i<cell.size();i++) _mem+=cell[i]->mem();

  // Get memory allocated for atomic data
  _mem+=atomData.mem();

  return _mem;
}

// Get memory allcoated for probability lists
double Grid::memPList() const {
  double _mem=0;
  int i;

  // For each cell
  for (i=0;i<cell.size();i++) {
    // Add memory allocated for probability lists
    _mem+=cell[i]->memPList();
  }  

  return _mem;
}

// Get memory allocated for bound-bound transitions - New!
double Grid::memTransBB() const {
  double _mem=0;
  int i;

  // For each cell
  for (i=0;i<cell.size();i++) {
    // Add memory allocated for bound-bound transitions
    _mem+=cell[i]->memTransBB();
  }  

  return _mem;
}

// Get memory allocated for bound-free transition - New!
double Grid::memTransBF() const {
  double _mem=0;
  int i;

  // For each cell
  for (i=0;i<cell.size();i++) {
    // Add memory allocated for bound-free transitions
    _mem+=cell[i]->memTransBF();
  }  

  return _mem;
}

// Create new cell object (overloaded)
Cell* GridSSFactory::createCell(MStateSolver* mStateSolver, EOS* eos, CellConfig* config, boost::mpi::communicator* mpiCom) {
  return new CellSS(mStateSolver,eos,config,mpiCom);
}

// Copy cell object (overloaded)
Cell* GridSSFactory::copyCell(Cell* cell) {
  return new CellSS(*((CellSS*) cell));
}

// Copy grid factory (overloaded)
GridFactory* GridSSFactory::copy() {
  return new GridSSFactory(*this);
}

// Constructor
GridSS::GridSS(MStateSolver* _mStateSolver, EOS* _eos, GridConfig* _config, boost::mpi::communicator* _mpiCom) {
  factory=new GridSSFactory();
  if (_config==NULL) config = new GridConfig();
  else config=_config;
  mStateSolver=_mStateSolver;
  eos=_eos;
  mpiCom=_mpiCom;
  return;
}

// Constructor
GridSS::GridSS(const string& dataFile, MStateSolver* _mStateSolver, EOS* _eos, GridConfig* _config, boost::mpi::communicator* _mpiCom) {
  factory=new GridSSFactory();
  load(dataFile);
  if (_config==NULL) config = new GridConfig();
  else config=_config;
  mStateSolver=_mStateSolver;
  eos=_eos;
  mpiCom=_mpiCom;
  return;
}

// Copy constructor
GridSS::GridSS(const GridSS& grid) : Grid(grid) { }

// Assigment operator
GridSS& GridSS::operator=(const GridSS& grid) {
  if (&grid!=this) Grid::operator=(grid);
}

// Destructor
GridSS::~GridSS() {
}

// Load grid data (overloaded)
void GridSS::load(const string& dataFile) {
  pstring data,gridPData,cellPData;
  string value;
  CellSS* cellSS;
  int i,j;

  // Load base class data
  Grid::load(dataFile);

  // Load data
  if (master()) cout<<"GridSS::load: Load data file\n";
  data.load(dataFile);
  if (data.size()==0) {cout<<"GridSS::load: Error: Data file empty\n"; return;}

  // Get grid data
  gridPData=data.getData("grid");
  // Error handling
  if (gridPData.size()==0) {cout<<"GridSS::load: Could not get grid data\n"; return;}

  // Insert cell (iterators) into cell neighbour list
  for (i=0;i<cell.size();i++)
    for (j=0;j<cell.size();j++) {
      if (((CellSS*) cell[i])->prMax==((CellSS*) cell[j])->prMin || ((CellSS*) cell[i])->prMin==((CellSS*) cell[j])->prMax)
	((CellSS*) cell[i])->cellNeighbour.push_back(cell.begin()+j);
      else if (((CellSS*) cell[i])->pType==cellContainer and i==j) ((CellSS*) cell[i])->cellNeighbour.push_back(cell.begin()+j);
    }
    
  return;
}

// Load grid data (and initialize radiation field)
void GridSS::load(const string& dataFile, const double& Rph, const double& Lph) {
  CellSS* cellSS;
  int i,j;

  // Load grid data
  load(dataFile);

  // For each cell
  for (i=0;i<cell.size();i++) {

    cellSS = (CellSS*) cell[i];

    // Set initial radiation temperature
    cellSS->pTR=pow(Lph/(4*pi*pow(Rph,2)*sigma),1.0/4.0);

    // Set initial dilution factor
    cellSS->pW=0.5*(1-pow(1-pow(Rph/((cellSS->prMin+cellSS->prMax)/2),2),0.5));

    // Reset all derived quantities to be updated
    cellSS->reset();

    cout<<"GridSS::load: TR="<<cellSS->pTR<<", W="<<cellSS->pW<<"\n";
  }
}

void GridSS::processGridTemplate(const string& gridTemplateFile, const string& gridFile) {
  ofstream file;
  int i,j,k,l,m,nCells,nAtoms,xnAtoms,nIsotopes,xnIsotopes;
  double rho,rhoCoeff,rMin,rMax,cellrMin,cellrMax,cellrho,dlogr,dr;
  pstring value,data,rhoData,xData,gridTemplatePData,gridRhoPData,gridXPData,atomDataFile,rhoFile,xFile,rhocellPData,xcellPData,isotopePData,xisotopePData,iStatePData,xiStatePData,atomDataFormat,atomPData,xatomPData,tMin,tMax,fExp,Z,xZ,N,xN,X;
  CellSpacing cellSpacing;

  // Load data
  data.load(gridTemplateFile);
  if (data.size()==0) {cout<<"GridSS::processGridTemplate: Error1\n"; return;}

  // Get grid template data
  gridTemplatePData=data.getData("grid");
  // Error handling
  if (gridTemplatePData.size()==0) {cout<<"GridSS::processGridTemplate: Error2\n"; return;}

  // Get atom data file
  atomDataFile=gridTemplatePData.getData("atomDataFile");
  // Error handling
  if (atomDataFile.size()==0) {cout<<"GridSS::processGridTemplate: Error3\n"; return;}

  // Get atom data format
  atomDataFormat=gridTemplatePData.getData("atomDataFormat");
  // Error handling
  if (atomDataFormat.size()==0) {cout<<"GridSS::processGridTemplate: Error4\n"; return;}

  // Get minimum time
  tMin=gridTemplatePData.getData("tMin");
  // Error handling
  if (tMin.size()==0) {cout<<"GridSS::processGridTemplate: Error5\n"; return;}

  // Get maximum time
  tMax=gridTemplatePData.getData("tMax");
  // Error handling
  if (tMax.size()==0) {cout<<"GridSS::processGridTemplate: Error6\n"; return;}

  // Get expansion factor
  fExp=gridTemplatePData.getData("fExp");
  // Error handling
  if (fExp.size()==0) {cout<<"GridSS::processGridTemplate: Error7\n"; return;}

  // Get number of cells
  value=gridTemplatePData.getData("nCells");
  nCells=atof(value.c_str());
  // Error handling
  if (value.size()==0) {cout<<"GridSS::processGridTemplate: Error5\n"; return;}

  // Get cell spacing
  value=gridTemplatePData.getData("cellSpacing");
  if (value.compare("linear")==0) cellSpacing=csLinear;
  else cellSpacing=csLog;

  // Get density from file
  rhoFile=gridTemplatePData.getData("rhoFile");
  //cout<<"rhoFile: "<<rhoFile<<"\n";
  if (rhoFile.size()!=0){
    rhoData.load(rhoFile);
    if (rhoData.size()==0) {cout<<"GridSS::processGridTemplate: Error8\n"; return;}

    // Get grid rho data
    gridRhoPData=rhoData.getData("grid");
    // Error handling
    if (gridRhoPData.size()==0) {cout<<"GridSS::processGridTemplate: Error9\n"; return;}
  }
  else {
    // Get density at inner border
    value=gridTemplatePData.getData("rho");
    rho=atof(value.c_str());
    // Error handling
    if (value.size()==0) {cout<<"GridSS::processGridTemplate: Error9.1\n"; return;}

    // Get density power law coefficient
    value=gridTemplatePData.getData("rhoCoeff");
    rhoCoeff=atof(value.c_str());
    // Error handling
    if (value.size()==0) {cout<<"GridSS::processGridTemplate: Error10\n"; return;}
  }

  // Get abundance from file
  xFile=gridTemplatePData.getData("xFile");
  if (xFile.size()!=0){
    xData.load(xFile);
    if (xData.size()==0) {cout<<"GridSS::processGridTemplate: Error11\n"; return;}

    // Get grid abundance data
    gridXPData=xData.getData("grid");
    // Error handling
    if (gridXPData.size()==0) {cout<<"GridSS::processGridTemplate: Error12\n"; return;}
  }

  // Get inner border
  value=gridTemplatePData.getData("rMin");
  rMin=atof(value.c_str());
  // Error handling
  if (value.size()==0) {cout<<"GridSS::processGridTemplate: Error13\n"; return;}

  // Get outer border
  value=gridTemplatePData.getData("rMax");
  rMax=atof(value.c_str());
  // Error handling
  if (value.size()==0) {cout<<"GridSS::processGridTemplate: Error14\n"; return;}

  // Open grid data file
  file.open(gridFile.c_str());
  // Error handling
  if (file.fail()) {cerr<<"GridSS::processGridTemplate: Error15\n"; return;}

  // Write processed data to grid file
  file<<"grid=\n";
  file<<"{\n";
  file<<"atomDataFile="<<atomDataFile<<", ";
  file<<"atomDataFormat="<<atomDataFormat<<", ";
  file<<"cell=\n";
  file<<"[\n";

  if (cellSpacing==csLinear) dr=(rMax-rMin)/double(nCells);
  else dlogr=log10(rMax/rMin)/double(nCells);
  cellrMin=rMin;
  if (cellSpacing==csLinear) cellrMax=cellrMin+dr;
  else cellrMax=cellrMin*pow(10,dlogr);

  for (i=0; i<nCells; i++) {

    // If rho data file
    if (rhoFile.size()!=0) {
      // Get cell data
      rhocellPData=gridRhoPData.getData("cell",i);
      // Error handling
      if (rhocellPData.size()==0) {cout<<"GridSS::processGridTemplate: Error16\n"; return;}      
    }

    // If abundance data file
    if (xFile.size()!=0) {
      // Get cell data
      xcellPData=gridXPData.getData("cell",i);
      // Error handling
      if (xcellPData.size()==0) {cout<<"GridSS::processGridTemplate: Error17\n"; return;}      
    }

    file<<"{";
    file<<"rMin="<<cellrMin<<", ";
    file<<"rMax="<<cellrMax<<", ";
    file<<"tMin="<<tMin<<", ";
    file<<"tMax="<<tMax<<", ";
    file<<"fExp="<<fExp<<", ";

    // If no rho data file
    if (rhoFile.size()==0) {
      cellrho=rho*pow(0.5*(cellrMin+cellrMax)/rMin,rhoCoeff);
    }
    // Else
    else {
      value=rhocellPData.getData("rho");
      cellrho=atof(value.c_str());
      // Error handling
      if (value.size()==0) {cerr<<"GridSS::processGridTemplate: Error18\n"; return;}
    }

    file<<"rho="<<cellrho<<",\n";
    file<<"atom=";
    file<<"[";

    // Get number of atoms
    nAtoms=gridTemplatePData.getSize("atom");
    // Error handling
    if (nAtoms<=0) {cout<<"GridSS::processGridTemplate: Error19\n"; return;}

    for (j=0;j<nAtoms;j++) {

      file<<"{";

      // Get atom data
      atomPData=gridTemplatePData.getData("atom",j);
      // Error handling
      if (atomPData.size()==0) {cout<<"GridSS::processGridTemplate: Error20\n"; return;}

      // Get Z
      Z=atomPData.getData("Z");
      // Error handling
      if (Z.size()==0) {cout<<"GridSS::processGridTemplate: Error21\n"; return;}

      file<<"Z="<<Z;

      // Get number of isotopes
      nIsotopes=atomPData.getSize("isotope");
      // Error handling
      if (nIsotopes<=0) {cout<<"GridSS::processGridTemplate: Error22\n"; return;}

      file<<",isotope=[";

      for (k=0;k<nIsotopes;k++) {
	// Get isotope
	isotopePData=atomPData.getData("isotope",k);
	// Error handling
	if (isotopePData.size()==0) {cout<<"GridSS::processGridTemplate: Error23\n"; return;}      

	file<<"{";

	// Get N
	N=isotopePData.getData("N");
	// Error handling
	if (N.size()==0) {cout<<"GridSS::processGridTemplate: Error24\n"; return;}          

	file<<"N="<<N;

      	// Get X
	X=isotopePData.getData("X");
	// If X not supplied
	if (X.size()==0) {
	  // Search the abundance data
	  // Get number of atoms
	  xnAtoms=xcellPData.getSize("atom");
	  // Error handling
	  if (xnAtoms<=0) {cout<<"GridSS::processGridTemplate: Error25\n"; return;}

	  for (l=0;l<xnAtoms;l++) {
	    // Get atom data
	    xatomPData=xcellPData.getData("atom",l);
	    // Error handling
	    if (xatomPData.size()==0) {cout<<"GridSS::processGridTemplate: Error26\n"; return;}

	    // Get Z
	    xZ=xatomPData.getData("Z");
	    // Error handling
	    if (xZ.size()==0) {cout<<"GridSS::processGridTemplate: Error27\n"; return;}

	    // If match
	    cout<<Z<<","<<xZ<<"\n";
	    if (Z.compare(xZ)==0) {
	      cout<<Z<<"\n";

	      // Get number of isotopes
	      xnIsotopes=xatomPData.getSize("isotope");
	      // Error handling
	      if (xnIsotopes<=0) {cout<<"GridSS::processGridTemplate: Error28\n"; return;}

	      for (m=0;m<xnIsotopes;m++) {

		// Get isotope
		xisotopePData=xatomPData.getData("isotope",m);
		// Error handling
		if (xisotopePData.size()==0) {cout<<"GridSS::processGridTemplate: Error29\n"; return;}      

		// Get N
		xN=xisotopePData.getData("N");
		// Error handling
		if (xN.size()==0) {cout<<"GridSS::processGridTemplate: Error30\n"; return;}    

		// If match
		if (N.compare(xN)==0) {
		  cout<<N<<"\n";

		  // Get X
		  X=xisotopePData.getData("X");
		}
	      }
	    }
	  }
	}
	// Error handling
	if (X.size()==0) {cout<<"GridSS::processGridTemplate: Z="<<Z<<", N="<<N<<", Error31\n"; return;}

	file<<",X="<<X;
	file<<"}";
	if (k<nIsotopes-1) file<<",";
      }
      file<<"]";

      // Get ionization state
      iStatePData=atomPData.getData("iState");
      // Error handling
      if (iStatePData.size()==0) {cout<<"GridSS::processGridTemplate: Error32\n"; return;}  

      file<<",iState="<<iStatePData;
      file<<"}";
      if (j<nAtoms-1) file<<",";
    }
    file<<"]";
    file<<"}";
    if (i<nCells-1) file<<",\n";
    else file<<"\n";
    cellrMin=cellrMax;
    if (cellSpacing==csLinear) cellrMax=cellrMin+dr;
    else cellrMax=cellrMin*pow(10,dlogr);
  }
  file<<"]\n";
  file<<"}\n";
  
  return;
}
